<?php

/* 
 * aribu systems - Version 1.0.1
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   26.10.2005
 * @update: 05.06.2018 
 */

# Headers
header("Content-Type: text/html; charset=utf-8");

/*
 * Error Reporting
 *
 */
error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED ^ E_WARNING);
ini_set('display_errors', 1);

# Redirect to installation, if config file not exists
if(!file_exists($_SERVER['DOCUMENT_ROOT']."/sys/sys.conf.php")) {
    header('Location: /install/index.php');
    exit();
}

/*
 * Caches the Output
 */
ob_start();
define('GPO_ON', true); 
define('SYS_CONF', $_SERVER['DOCUMENT_ROOT'] . '/sys/sys.conf.php');

# Autoload classes
function aribuAutoload($classname) {
    
    $classname = str_replace("\\", "/", $classname);
    $classname = explode("/", $classname);
    
    $classname_file = end($classname);
    $classname_file_path = '/class.' . $classname_file . '.php';
    array_pop($classname);
    $classname_path = '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . $classname_file_path;
    if (file_exists(DOC_ROOT . strtolower($classname_path))) {
        require_once(DOC_ROOT . strtolower($classname_path));
    } elseif(file_exists(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  $classname_file.".php")) {
        require_once(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  $classname_file . ".php");
    } elseif(file_exists(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  strtolower($classname_file) . ".php")) {
        require_once(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  strtolower($classname_file) . ".php");
    }
}

spl_autoload_register('aribuAutoload');

/*
 * Here starts the requiring-level
 */
require_once(SYS_CONF);
require_once(REGISTRY);
require_once(PHPMAILER);
require_once(SMTP);

/*
 * HttpRequest
 * @var object
 */
require_once (DOC_ROOT . '/lib/class.http_request.php');
$http = new HttpRequest();
\lib\Registry::setObj('http', $http);

require_once(SYS_FUNCTION);
require_once(DB_FUNCTION);
require_once(BE_MENU);
require_once(TT);

$GLOBALS['LANGUAGE'] = SYS_LANGUAGE;

# PHP Version
if (!defined('PHP_VERSION_ID')) {
    $version = explode('.', PHP_VERSION);
    define('PHP_VERSION_ID', ($version[0] * 10000 + $version[1] * 100 + $version[2]));
}
if(PHP_VERSION_ID < 70200) {
    echo \lib\Functions::readfiles(ARIBU_SYSTEMS_SFOLDER . '/_templates/php_version_error.html');
    exit();
}

/**
 * Mandant
 */
$mandant_folder_explode = explode(".", $_SERVER['HTTP_HOST']);
$mandant_array_count    = count($mandant_folder_explode);
if($mandant_array_count == 4 || $mandant_array_count == 3) {
    $mandant = $mandant_folder_explode[1];
} elseif($mandant_array_count == 2 || $mandant_array_count == 1) {
    $mandant = $mandant_folder_explode[0];
} 

$client = new lib\Client($db);
lib\Registry::setObj('client', $client);
$client_name = str_replace("/", "", $mandant);
$client->SetConstantAndGlobalOfClient($client_name);


/*
 * Date Timezone set
 */
date_default_timezone_set(TIMEZONE);

/*
 * Redirect to URL_HOST
 *
 */
if ($_SERVER['HTTP_HOST'] != URL_HOST) {
    header("HTTP/1.1 301 Moved Permanently");
    if (defined('URL_PROTOCOL')) {
        $protocol = URL_PROTOCOL;
    } else {
        $protocol = 'http';
    }
    header("Location: " . $protocol . "://" . URL_HOST . $_SERVER['REQUEST_URI']);
    exit;
}

/*
 * Weiterleitung http:// --> https://
 *
 */
if (defined('URL_PROTOCOL')) {
    if (URL_PROTOCOL == 'https' && !isset($_SERVER['HTTPS'])) {
        header("HTTP/1.1 301 Moved Permanently");
        header("Location: https://" . URL_HOST . $_SERVER['REQUEST_URI']);
        exit;
    }
}

$Template = clone $TT;



/*
/*
 * Dot.Session Management
 */ 
$Session = new \lib\session\backend\Session();
$Session->SessionID = SESSION_ID;

# Session started
if ($Session->initBESession()) {
    
    $dot = $Session->handleBESession($_SESSION['sess_id'], 'be_');
    
    # Client ID handle
    
    if(!isset($_SESSION['sess_client_id']) || ($_SESSION['sess_client_id'] != $http->_post('client_id') && $http->issetPost('client_id') === true)) {
        
        if ($http->issetPost('client_id') === true) {
            $_SESSION['sess_client_id'] = $http->_post('client_id');
            $_SESSION['sess_client_template_folder'] = $client->GetOneClientData('client_name', $http->_post('client_id')).'/';
        } elseif (isset($GLOBALS['CLIENT_ID']) && $http->issetPost('client_id') === false) {
            $_SESSION['sess_client_id'] = $GLOBALS['CLIENT_ID'];
            $_SESSION['sess_client_template_folder'] = $GLOBALS['CLIENT_TEMPLATE_FOLDER'];
        } else {
            $_SESSION['sess_client_id'] = 0;
        } 
        $Session->Update($_SESSION['sess_id'], $_SESSION['sess_client_id']);
        $Session->handleBESession($_SESSION['sess_id'], 'be_');
    }
    
      
    # BE-Logout
    if ($http->issetPost('logout') === true) {
        $Session->deleteSession($_SESSION['sess_uid'], 'be_');
        $lData = $http->issetPost('lData') === true ? "?lData=".$http->_post('lData') : "";
        $rData = $http->issetPost('rData') === true ? base64_decode($http->_post('rData')) : "";
        $redirect = "/". ARIBU_SYSTEMS . $lData.$rData;
        header("Location: " . $redirect);
        exit;
    }

    if (!$dot && $pagename != 'error') {
        header("Location: ".ARIBU_SYSTEMS_URL."/");
        exit;
    }
    
} else {
    
    # Checks BE-Login
    if ($http->issetPost('login') === true && $http->issetPost('error') === false) {
        if (empty($_POST['login_pw']) || empty($_POST['login_un'])) {
            $login_error = '<div class="alert alert-danger"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> <b>Fehler:</b> Login fehlgeschlagen: Der/das angegebene Nutzername oder Passwort ist ungültig. Bitte versuchen Sie es erneut.</div>';
            $login = false;
        } else {
            $login = true;
        }
    } else {
        if ($http->_post('error') == "pw") {
            $login_error = '<div class="alert alert-danger"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> <b>Fehler:</b> Login fehlgeschlagen: Der/das angegebene Nutzername oder Passwort ist ungültig. Bitte versuchen Sie es erneut.</div>';
        }
        $login = false;
    }
    
    # Login
    if ($http->issetPost('login_pw') === true && $http->issetPost('login_un') === true && $login == true) {
        $pw = trim($http->_post('login_pw'));
        $pw = md5($pw);
        $user = \lib\Functions::avUser($http->_post('login_un'));
        $db->TablePreName = 'be_';
        $db->Select('*')
           ->From('user')
           ->WhereColName('username')
           ->WhereColValue($user)
           ->Andd("AND disable != :disabled")
           ->Parameter(array('disabled' => 1))
           ->doSelect();
        
        $row = $db->SelectPuffer;
        if ($row['password'] != $pw) {
            # Check if is a fe user with be login
            $db->TablePreName = 'fe_';
            $db->Select('uc.user_id, '
                    . 'uc.username, '
                    . 'uc.user_password, '
                    . 'uc.user_rights, '
                    . 'uc.user_ban, '
                    . 'uc.user_active, '
                    . 'uc.user_tarif, '
                    . 'uc.user_confirm, '
                    . 'uc.user_last_visit, '
                    . 'uc.user_email_code, '
                    . 'uc.user_area, '
                    . 'uc.user_land, '
                    . 'uc.user_regdate, '
                    . 'uc.user_gender, '
                    . 'uc.user_image, '
                    . 'uc.user_firstname, '
                    . 'uc.user_lastname, '
                    . 'uc.user_group, '
                    . 'uc.user_be_rights, '
                    . 'uc.user_be_area, '
                    . 'uc.client_id, '
                    . 'br.rights as be_rights, '
                    . 'user_image.file_path AS user_image_path, user_image.name AS user_image_name, user_image.id AS user_image_id, cag.address_group_id ')
              ->From('user_accounts uc')
              ->noWhere(1)
              ->Andd("LEFT JOIN be_rights br ON uc.user_be_rights = br.rid "
                    . "LEFT JOIN dms user_image ON uc.user_id = user_image.tags AND user_image.type_title = 'Ansprechpartner_Foto_1' "
                    . "LEFT JOIN customers c ON c.customers_user_id = uc.user_id "
                    . "LEFT JOIN customers_address_group cag ON c.customers_id = cag.customer_id "
                    . "WHERE uc.username = :username AND uc.user_be_login = 1")
              ->Parameter(array('username' => $user))
              ->doSelect();
            $num = $db->Rows;
            
            $userData = $db->SelectPuffer;
            
            if ($num) {
                if ($userData['user_ban'] != 1) {
                    if ($userData['user_active'] == 1 && $userData['user_confirm'] == 1) {
                        $username = trim(strip_tags($http->_post('login_un')));
                        $password = trim($http->_post('login_pw'));
                        $password = md5($username . $password);
                        
                        if ($password == $userData['user_password']) {
                            $country = $userData['user_land'] != '' ? $userData['user_land'] : 'de';
                            $user_image = $userData['user_image_path'] != null ? $userData['user_image_path'].$userData['user_image_name'] : '';
                            $beuserdata = serialize(array(  "BE_Rights"                     => $userData['user_be_rights'],
                                                            "last_login"                    => $userData['user_last_visit'],
                                                            "sess_username"                 => $userData['username'],
                                                            "sess_user_email"               => $userData['user_email'],
                                                            "sess_uid"                      => $userData['user_id'],
                                                            "sess_id"                       => SESSION_ID,
                                                            "sess_language"                 => $country,
                                                            "Usergroup"                     => $userData['usergroup'],
                                                            "sess_user_rights"              => $userData['user_rights'], 
                                                            "sess_user_id"                  => $userData['user_id'],
                                                            "sess_rights"                   => unserialize($userData['be_rights']),
                                                            "sess_full_name"                => $userData['user_firstname'].' '.$userData['user_lastname'],
                                                            "sess_user_firstname"           => $userData['user_firstname'],
                                                            "sess_user_lastname"            => $userData['user_lastname'],
                                                            "sess_user_image"               => $user_image,
                                                            "sess_user_client_id"           => $userData['client_id'],
                                                            "sess_user_address_group_id"    => $userData['address_group_id'],
                                                            "sess_user_type"                => 'fe'));
                            
                            $Session->initBESession($userData['user_id'], $beuserdata);
                            if($userData['user_be_area'] == '') {
                                $jumpurl = $http->issetPost('lData') === true ? base64_decode($http->_post('lData')) : URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_URL . SYS_LANGUAGE . "/home";
                            } else {
                               if(intval($userData['user_be_area']) != 0) {
                                   $jumpurl = URL_PROTOCOL .'://'. URL_HOST . \lib\Functions::dotLinkBE($userData['user_be_area'], $country);
                               } else {
                                   
                               }
                            }
                            $user_client_id = $userData['client_id'] > 1 ? "?client_id=".$userData['client_id'] : "";
                            
                            header("Location: " . $jumpurl.$user_client_id);
                            exit;
                            
                        } else {         
                            header("Location: " . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_URL . "/?login=false&error=pw");
                            exit;
                        }
                    } else {
                        header("Location: " . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_URL . "/?login=false&error=not_active");
                        exit;
                    }
                } else {
                    header("Location: " . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_URL . "/?login=false&error=ban");
                    exit; 
                }
            } else {
                header("Location: " . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_URL . "/?login=false&error=pw" );
                exit;
            }
            $db->TablePreName = 'be_';
        } else {
            $user_image = $row['user_image'] != '' ? '/fileadmin/backend/user/thumbs/'.$row['user_image'] : '';
            $beuserdata = serialize(array(  "BE_Rights"         => $row['admin'],
                                            "last_login"        => $row['last_login'],
                                            "sess_username"     => $row['username'],
                                            "sess_user_email"   => $row['email'],
                                            "sess_uid"          => $row['uid'],
                                            "sess_id"           => SESSION_ID,
                                            "sess_language"     => $row['lang'],
                                            "Usergroup"         => $row['usergroup'],
                                            "sess_user_rights"  => $row['fe_user_rights'], 
                                            "sess_user_id"      => $row['uid'],
                                            "sess_rights"       => unserialize($row['be_rights']),
                                            "sess_full_name"    => $row['full_name'],
                                            "sess_user_image"   => $user_image,
                                            "sess_user_type"    => "be"));
            $Session->initBESession($row['uid'], $beuserdata);
            
            header("Location: " . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_URL . $GLOBALS['LANGUAGE'] . "/home");
            exit;
        }
    } else {
        if (!isset($_SESSION['sess_id'])) {
            $Template->setMC('LOGO_OBEN',               '<img src="' . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_SFOLDER . '/fileadmin/img/logos/aribu_logo.jpg" style="margin-left:8px;" alt="aribu.systems" border="0">')
                     ->setMC('LOGOIMAGE',               '<img src="' . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_SFOLDER . '/fileadmin/img/login_image.jpg" border="0">')
                     ->setMC('LOGIN_ERROR',             $login_error != '' ? $login_error : '')
                     ->setMC('LOGO_UNTEN',              '<img src="' . URL_PROTOCOL .'://'. URL_HOST . ARIBU_SYSTEMS_SFOLDER . '/fileadmin/img/logos/login_logo.jpg" style="margin-right:0px" alt="aribu.systems" border="0">')
                     ->setMC('COPYRIGHT_YEAR',          date("Y", time()))
                     ->setMC('COPYRIGHTS_ARIBU',        ARIBU_COPYRIGHTS)
                     ->setMC('LANG',                    $GLOBALS['LANGUAGE'])
                     ->setMC('CLIENT',                  CLIENT);
        }
    }
}


# DFE starts
$DFE = new \lib\Backend();
\lib\Registry::setObj('DFE', $DFE);
if ($DFE->PageGlobals()) {
       
    if (isset($_SESSION['sess_username']) && ($DFE->RequestURI == "/" || $DFE->RequestURI == "/".$GLOBALS['LANGUAGE']."/")) {
        $user_client_id = $_SESSION['sess_user_client_id'] > 1 ? "?client_id=".$_SESSION['sess_user_client_id'] : "";
        if(defined(HTTP)) {
            header("Location: " . HTTP . ARIBU_SYSTEMS . $GLOBALS['LANGUAGE'] . "/home".$user_client_id);
        } else {
            header("Location: /".ARIBU_SYSTEMS . $GLOBALS['LANGUAGE'] . "/home".$user_client_id);
        }
        exit;
    } 
    
    if (!isset($_SESSION['sess_username']) && $DFE->RequestURI != "/" && $DFE->RequestURI != "/".$GLOBALS['LANGUAGE']."/install" && $DFE->RequestURI != "/".$GLOBALS['LANGUAGE']."/login/passwort-vergessen" ) {
        header("Location: ".ARIBU_SYSTEMS_URL."/");
        exit;
    }
    
    # Backend und Frontend Variablen
    require_once(DOC_ROOT. ARIBU_SYSTEMS_SFOLDER . '/scripts/be_fe.var.php');
    
    if (isset($_SESSION['sess_id'])) {
        # Language
        $GLOBALS['LANGUAGE'] = \lib\Functions::langExplode("/", $_SERVER['REQUEST_URI']) != '' && $DFE->RequestURI != "/" ? \lib\Functions::langExplode("/", $_SERVER['REQUEST_URI']) : SYS_LANGUAGE;
             
                       
        # Check language is set and comes from url
        if($GLOBALS['LANGUAGE'] != SYS_LANGUAGE) {
            $db->Select('config_id')
               ->From('system_config')
               ->noWhere(1) 
               ->Andd("WHERE config_title = 'BE_LANGUAGES' AND config_key = '".$GLOBALS['LANGUAGE']."' AND config_lang = '".SYS_LANGUAGE."' AND config_hidden != 1 AND client_id = :client_id")
               ->Parameter(array('client_id' => $GLOBALS['CLIENT_ID']))
               ->doSelect();
            $numl = $db->Rows;
            if(!$numl) {
                header("HTTP/1.1 301 Moved Permanently");
                header("Location: " . URL_PROTOCOL . "://" . URL_HOST . \lib\Functions::dotLinkBE($GLOBALS['PageConfig']['UID'], SYS_LANGUAGE));
                exit();
            }               
        }
        
                
        if(isset($GLOBALS['CLIENT']) && is_array($GLOBALS['CLIENT'])) {
            $GLOBALS['CLIENT_ID'] = array_search(str_replace("/", "", $mandant), $GLOBALS['CLIENT']);
        } else {
            $GLOBALS['CLIENT_ID'] = 0;
        }
        
        $db->TablePreName = 'be_';

        # Language packages
        if($_SESSION['sess_language'] != '') {
            require_once(DOC_ROOT. "/" .ARIBU_SYSTEMS_FOLDER .  "scripts/home/lang/" . $_SESSION['sess_language'] . ".php");
        } 

        # Select language	
        if (SYS_LANGUAGE != $GLOBALS['LANGUAGE']) {
            $uid = $DFE->RID;
            $db->Select('rid')
               ->From('pages_language')
               ->WhereColName('uid')
               ->WhereColValue($uid)
               ->Andd("AND lang = :lang ")
               ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
               ->doSelect();
            $be_rid = $db->SelectPuffer['rid'];
        } else {
            $be_rid = $DFE->RID;
        }

        if (isset($_SERVER['QUERY_STRING'])) {
            $query_string_arr = explode("&", $_SERVER['QUERY_STRING']);
            $key_changeLang = array_search("changeLang=1", $query_string_arr);
            $key_lastLang = array_search("lastLang=" . $_GET['lastLang'], $query_string_arr);
            if (!empty($key_changeLang)) {
                unset($query_string_arr[$key_changeLang]);
            }
            if (!empty($key_lastLang)) {
                unset($query_string_arr[$key_lastLang]);
            }
            $server_qs = implode("&", $query_string_arr);
        }
        $query_string = isset($_SERVER['QUERY_STRING']) ? "?" . $server_qs . "&changeLang=1&lastLang=" . $GLOBALS['LANGUAGE'] : "";

        if(isset($GLOBALS['BE_LANGUAGES'])) {
            foreach ($GLOBALS['BE_LANGUAGES'] as $lang_key => $lang_val) {
                $selected = $GLOBALS['LANGUAGE'] == $lang_key ? "selected" : "";
                $be_id = $DFE->RID;
                $lang = "";
                if ($DFE->SystemLanguage != $lang_key && $DFE->SystemLanguage == $GLOBALS['LANGUAGE']) {
                    
                    $db->Select('uid')
                       ->From('pages_language')
                       ->WhereColName('rid')
                       ->WhereColValue($be_id)
                       ->Andd("AND lang = :lang ")
                       ->Parameter(array('lang' => $lang_key))
                       ->doSelect();
                    $be_id = $db->SelectPuffer['uid'];
                } else {
                    if ($DFE->SystemLanguage == $lang_key) {
                        $be_id = $be_rid;
                        $lang = $DFE->SystemLanguage;
                    } else {
                        
                        $db->Select('uid')
                           ->From('pages_language')
                           ->WhereColName('rid')
                           ->WhereColValue($be_rid)
                           ->Andd("AND lang = :lang ")
                           ->Parameter(array('lang' => $lang_key))
                           ->doSelect();
                        $be_id = $db->SelectPuffer['uid'];
                    }
                }
                $be_link = lib\Functions::dotLinkBE($be_id, $lang_key);
                $lang_options .= '<option value="/'. ARIBU_SYSTEMS . $lang . $be_link . $query_string . '" ' . $selected . '>' . $lang_val . '</option>';
            }
        }
        
        # Client urls
        if(isset($GLOBALS['CLIENT_URL_HOST'])) {
            foreach($GLOBALS['CLIENT_URL_HOST'] as $ckey => $cval) {             
                $client_urls .= '<a href="?client_id='.$ckey.'"><i class="fa fa-play-circle inverse" aria-hidden="true"></i> '.$cval.'</a><br>';
            }
        }
        $client_js = '<script type="text/javascript"> $(function() { $(\'i.ico-c\').popover({html:true, content: \''.$client_urls.'\'}); }); </script>';
        
        $Template->BlockMarker['client'] = $_SESSION['BE_Rights'] <= 2 ? 1 : 0; 
        
        # Last Login
        $last_login = $date . $at . $time;

        # Define the marker
        $Template->setMC("LANGUAGE_OPTIONS",    $lang_options)
                 ->setMC("LANGUAGE_HREF",       $language_href)
                 ->setMC("LOGGEDINAS",          $logged_in_as)
                 ->setMC("LL_TEXT",             $last_login_text)
                 ->setMC("LANGUAGE",            $language)
                 ->setMC("MANDANT",             '<h4 class="inverse"><i class="fa fa-building-o inverse ico-c cursor-pointer" aria-hidden="true" data-container="body" data-toggle="popover" data-placement="bottom" data-original-title="Klienten" title=""></i> '. CLIENT . ' <img src="/aribu.systems/fileadmin/img/icons/countries/' . $GLOBALS['LANGUAGE'] . '.gif" border="0" alt="Language"></h4>'.$client_js)
                 ->setMC("XML_LANG",            $GLOBALS['LANGUAGE'])
                 ->setMC("LOGIN_RIGHTS",        $GLOBALS['BE_USER_RIGHTS'][$_SESSION['BE_Rights']])
                 ->setMC("BESESS_UID",          $_SESSION['sess_uid'])
                 ->setMC("BE_LOGOUT",           "/aribu.sys?logout=true")
                 ->setMC("LAST_LOGIN",          $last_login)
                 ->setMC("CLIENT_OPTIONS",      $client_options)
                 ->setMC("CLIENTS",             "Mandantenauswahl")
                 ->setMC('YEAR',                date('Y', time()))
                 ->setMC('USERNAME',            $_SESSION['sess_full_name'])
                 ->setMC('USER_IMAGE',          $_SESSION['sess_user_image'] != '' ? $_SESSION['sess_user_image'] : ARIBU_SYSTEMS_SFOLDER.'/fileadmin/img/aribu-dummy.jpg');
    }

    $db->TablePreName = 'be_';
    $DFE->Menu();
    $DFE->Content();
    $DFE->HTMLHeader();
    $DFE->Elements();
    #echo $DFE;
    
    # Template output 
    if (!$DFE->TemplatePage) {
        $tmp = NOTEMPLATE;
    } else {
        $tmp = $DFE->TemplatePage;
    }
    
    if($DFE->Error != 1) {
        if(is_array($DFE->TemplateAssignArray)) {
            foreach($DFE->TemplateAssignArray as $tkey => $tval) {
                $Template->setMC(str_replace("#", "", $tkey), $tval);
            }
        }
        
        echo $Template->getFilledTemplate($tmp, 1);
    } else {
        echo $Template->getFilledTemplate(NOTEMPLATE, 1);
    }
    
    
    # Reduce HTML-Code
    $html = ob_get_contents();
    ob_end_clean();

    
    # Intigrate own PHP-Code
    
    if ($DFE->PHPTag != 1) {
        echo $html;
    } else {

        foreach ($DFE->PHPMarkerPath as $sc_marker => $sc_path) {
            ob_start();
            
            $sc_method = $GLOBALS['PHPMethod'][$sc_marker];
            
            if (!empty($sc_method) && preg_match('#\(#ism', $sc_method, $hits)) {
                $sc_method_param = str_replace("(", "|", $sc_method);
                $sc_method_param = str_replace(")", "", $sc_method_param);
                $sc_method_param = explode("|", $sc_method_param); # Script Parameter hier als Array
                $GLOBALS['PHPMethod'][0] = $sc_method_param[0];
                $class_parameter = $sc_method_param[1];
            } else {
                $GLOBALS['PHPMethod'][0] = $sc_method;
            }
            
            if(file_exists($sc_path)) {
                include($sc_path);
            } else {
                echo "Die PHP-Datei kann nich eingebunden werden: ".$sc_path;
            }
            $php_content = ob_get_contents();

            ob_end_clean();

            # Module ersetzen
            if (!empty($DFE->ModulContent)) {
                foreach ($DFE->ModulMarker as $mkey => $mval) {
                    $php_content = str_replace($DFE->ModulMarker[$mkey], $DFE->ModulContent[$mkey], $php_content);
                }
            }
            $html = str_replace($sc_marker, $php_content, $html);
        }
        if (!empty($DFE->BrowserTitle)) {
            if (preg_match('#<title>(.*?)</title>#is', $html, $title)) {
                $html = str_replace($title[0], "<title>" . $DFE->BrowserTitle . " - " . $GLOBALS['PageConfig']['TITLE'] . "</title>", $html);
            }
        }

        if (!empty($DFE->Description)) {
            preg_match('#<meta\s*name="description"\s*content="(.*?)["](.*?)>#ism', $html, $description);   
            $html = str_replace($description[1], substr($DFE->Description . " " . $GLOBALS['PageConfig']['DESCRIPTION'], 0, 160), $html);
        } elseif (!empty($GLOBALS['PageConfig']['DESCRIPTION'])) {
            preg_match('#<meta\s*name="description"\s*content="(.*?)["](.*?)>#ism', $html, $description);
            $html = str_replace($description[1], substr($GLOBALS['PageConfig']['DESCRIPTION'], 0, 160), $html);
        }

        if ($DFE->IndexFollow == 0) {
            if (preg_match('#<meta\s*name="robots"\s*content="(.*?)["](.*?)>#is', $html, $indexfollow)) {
                $html = str_replace($indexfollow[0], "<meta name=\"robots\" content=\"noindex, nofollow\">", $html);
            }
        }
        echo $html;
    }
} else {
    if ($DFE->Error == 1) {
        ob_start();
        header("Status: 404");
        echo $Template->getFilledTemplate($DFE->TemplatePage);
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    } else {
        echo $html = $DFE->CachedContent;
    }
}



# Debug-Modus
if ($GLOBALS['DEBUG_BE']['STATUS'] == 1 && ($GLOBALS['DEBUG_BE']['IP'] == $_SERVER['REMOTE_ADDR'] || $GLOBALS['DEBUG_BE']['IP'] == "127.0.0.1")) {

    switch ($GLOBALS['DEBUG_BE']['VAR']) {
        case "post":
            echo '<pre style="display:none; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; right:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($_POST, true);
            echo htmlspecialchars($debug);
            echo '<br><hr><br>';
            echo '<strong>Datenbank-Abfragen:</strong><br>';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;"></div>';
            echo '<br style="clear:both;">';
            echo '</pre>';
            break;

        case "get":
            echo '<pre style="display:none; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; right:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($_GET, true);
            echo htmlspecialchars($debug);
            echo '<br><hr><br>';
            echo '<strong>Datenbank-Abfragen:</strong><br>';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;"></div>';
            echo '<br style="clear:both;">';
            echo '</pre>';
            break;

        case "dfe":
            echo '<pre style="display:none; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; right:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($DFE, true);
            echo htmlspecialchars($debug);
            echo '<br><hr><br>';
            echo '<strong>Datenbank-Abfragen:</strong><br>';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;"></div>';
            echo '<br style="clear:both;">';
            echo '</pre>';
            break;

        case "globals":
            echo '<pre style="display:none; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; right:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($GLOBALS, true);
            echo htmlspecialchars($debug);
            echo '<br><hr><br>';
            echo '<strong>Datenbank-Abfragen:</strong><br>';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;"></div>';
            echo '<br style="clear:both;">';
            echo '</pre>';
            break;

        case "module":
            echo '<pre style="display:none; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; right:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($GLOBALS['MODULE_DEBUG'], true);
            echo htmlspecialchars($debug);
            echo '<br><hr><br>';
            echo '<strong>Datenbank-Abfragen:</strong><br>';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;"></div>';
            echo '<br style="clear:both;">';
            echo '</pre>';
            break;

        case "class":
            echo '<pre style="display:none; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; right:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($GLOBALS[$GLOBALS['DEBUG']['CLASS']], true);
            echo htmlspecialchars($debug);
            echo '<br><hr><br>';
            echo '<strong>Datenbank-Abfragen:</strong><br>';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;"></div>';
            echo '<br style="clear:both;">';
            echo '</pre>';
            break;

        case "session":
            echo '<pre style="display:none; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; right:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($_SESSION, true);
            echo htmlspecialchars($debug);
            echo '<br><hr><br>';
            echo '<strong>Datenbank-Abfragen:</strong><br>';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;"></div>';
            echo '<br style="clear:both;">';
            echo '</pre>';
            break;
    }
    echo '        
<script type="text/javascript">
$(document).ready(function() {
console.log($("pre.debug-pre").text());
});
</script>';
}