<?php
namespace aribu\scripts\abstracts;
/* 
 * aribu system - Version 7.0.0
 *  
 * Copyright (C) 2018  Sascha Momcilovic
 *  
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   http://aribu.systems
 * @date:   02.05.2018
 *  
 */

abstract class Abstracts {
    
    public $FB = 'fe_';
    public $BE = '';

    public function __construct($DFE) {
        if(is_object($DFE)) {
            $this->DFE = $DFE; 
        }
        if($this->DFE->http->issetPost('FB') === true && $this->DFE->http->_post('FB') == 'be_') {
            $this->FB = 'be_';
            $this->FBup = 'BE';
            $this->BE = 'BE';
        }
    }
    
    abstract public function dmethod();
    
    /*
     * Set backend language
     * @var array
     * 
     */

    public function setTemplateLanguage($be_language) {
        $this->be_language = $be_language;
    }
    
    
    public function PrepareLanguage($be_language) {
        if(is_array($be_language)) {
            foreach($be_language as $key => $value) {
                $this->DFE->TT->setMC($key, $value);
            }
        }
    }
    
    public function SetFB() {
        $this->DFE->db->TablePreName = $this->FB;
        $this->FBup = strtoupper(str_replace("_", "", $this->FB));
        $this->BE = $this->FB == 'be_' ? 'BE' : '';
    }
    
    public function __toString() {
        $class_vars = get_class_vars(get_class($this));
        
        $string = '';
        $string .= '<script type="text/javascript">
	$(document).ready(function() {
	var winheight = $("html").innerHeight();
 	$("div#debug-div").css("height", winheight+"px");
        $("#dragable").draggable();
	});
	</script>';
        $string .= '<pre style="display:block; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" id="dragable">';
        $string .= '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
           
        $string .= "Class: \n";
        foreach($class_vars as $key => $val) {
            $values = !is_object($this->{$key}) ? print_r($this->{$key}, true) : 'Object';
            $string .= $key.': '.$values."\n";
        }
        $string .= '</div></pre>';
        return $string;
    }
}