<?php

namespace aribu\scripts\content\lib;

/* 
 * aribu.systems 6.0
 * aribu.systems is registered and licensed under our definitions.

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   24.04.2016
 *  
 */

class Blocks {
    
    /**
     * DFE object
     * @param object $DFE
     */
    public $DFE;
    private $FB;
    private $FBup;
    private $BE;
    
    private $Query;
    
    public function __construct($DFE, $FB, $FBup, $BE) {
        $this->DFE = $DFE;
        $this->FB = $FB;
        $this->FBup = $FBup;
        $this->BE = $BE;
        $this->Query = $this->FB == 'be_' ? '&FB=be_' : '';
    }
    
    public function GetBlocks($colP, $col_position) {
        $TT = clone $this->DFE->TT;
        $this->DFE->db->TablePreName = $this->FB;
        $this->DFE->db->Select('cont.*, pages.nav_title')
                      ->From("content cont, " . $this->FB . $this->DFE->Pages . " pages")
                      ->WhereColName('cont.pid')
                      ->WhereColValue($this->DFE->http->_post('uid'))
                      ->Andd("AND cont.pid = pages.uid AND cont.colP = ".$colP." " . str_replace("%%%n%%%", "pages.", $this->DFE->and_lang) . "AND cont.lang = :contlang ")
                      ->Order("ORDER BY cont.sorting")
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE'], 'contlang' => $GLOBALS['LANGUAGE']) : array('contlang' => $GLOBALS['LANGUAGE']))
                      ->SelectMethod(1)
                      ->doSelect();
        
        $num = $this->DFE->db->Rows;
        if ($num) {
            # Schleife
            $row = $this->DFE->db->SelectPuffer;
            
            for ($i = 0; $i < $num; $i++) {
                # Move Icons
                # Be Rights Move Content
                if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][29] == 1 || $_SESSION['BE_Rights'] == 1) {
                    $move_content_down = '<a href="?ac=ContentOverview&uid=' . $this->DFE->http->_post('uid') . '&sorting=' . $row[$i]['sorting'] . '&mode=movedown&cid=' . $row[$i]['uid'] .  '&colP=' . $colP . $this->Query . '" title="'.$this->DFE->TT->getMC('_move_down').'"><i class="fa fa-arrow-down inverse" aria-hidden="true"></i></a>';
                    $move_content_up = '<a href=\"?ac=ContentOverview&uid=' . $this->DFE->http->_post('uid') . '&sorting=' . $row[$i]['sorting'] . '&mode=moveup&cid=' . $row[$i]['uid'] . '&colP=' . $colP . $this->Query .'" title="'.$this->DFE->TT->getMC('_move_up').'"><i class="fa fa-arrow-up inverse" aria-hidden="true"></i></a>';
                } else {
                    $move_content_down = 'data-toggle="tooltip" data-placement="top" title="'.$this->DFE->TT->getMC('_rights_move').'"'; 
                    $move_content_up = 'data-toggle="tooltip" data-placement="top" title="'.$this->DFE->TT->getMC('_rights_move').'"';
                }
                $move_content = $i > 0 ? $move_content_down . $move_content_up : $move_content_down;
                $move_content = $i + 1 == $num ? $move_content_up : $move_content;
                $move_content = $num == 1 ? "" : $move_content;

                # Be Rights Del Content
                if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][25] == 1 || $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_username'] == $row[$i]['author']) {
                    $del_content = '<a href="javascrip:void(0);" onclick="javascript: confirmDelContent(\'?ac=ContentOverview&uid=' . $this->DFE->http->_post('uid') . '&sorting=' . $row[$i]['sorting'] . '&mode=del&colP=' . $colP . '&cid=' . $row[$i]['uid'] . $this->Query .'\'); return false;" title="'.$this->DFE->TT->getMC('_del_content_title').'"><i class="fa fa-trash inverse" aria-hidden="true"></i></a>';
                } else {
                    $del_content = 'data-toggle="tooltip" data-placement="top" title="'.$this->DFE->TT->getMC('_rights_del_content').'"'; 
                }

                # Be Rights Publish Content
                if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][28] == 1 || $_SESSION['BE_Rights'] == 1) {
                    $content_hidden = $row[$i]['hidden'] == 1 ? '<a href="javascript:void(0);" class="hide-show-button" data-action="show" data-ajax="&mode=public&cid=' . $row[$i]['uid'].'" title="'.$this->DFE->TT->getMC('_publish_content').'"><i class="fa fa-globe aribu" aria-hidden="true"></i></a>' : '<a href="javascript:void(0);" data-action="hide" data-ajax="&mode=notpublic&cid=' . $row[$i]['uid'] .'" title="'.$this->DFE->TT->getMC('_hide_content').'" class="hide-show-button"><i class="fa fa-globe inverse" aria-hidden="true"></i></a>';
                } else {
                    $content_hidden = $row[$i]['hidden'] == 1 ? 'data-toggle="tooltip" data-placement="top" title="'.$this->DFE->TT->getMC('_rights_publish_content').'"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->DFE->TT->getMC('_rights_hide_content').'"';
                }

                # Zeitschaltung
                if ($row[$i]['starttime'] != 0 && $row[$i]['starttime'] != 0) {
                    if ($GLOBALS['LANGUAGE'] == "de") {
                        $timeset = '<div style="padding-top:2px"><b>Zeitschaltung:</b></div>Start: <em>' . date("d.m.Y - H:i", $row[$i]['starttime']) . ' Uhr</em><br>Ende: <em>' . date("d.m.Y - H:i", $row[$i]['endtime']) . ' Uhr</em><br><br>';
                    } else {
                        $start_time = strftime("%D", $row[$i]['starttime']) . strftime(" - %T %p", $row[$i]['starttime']);
                        $end_time = strftime("%D", $row[$i]['endtime']) . strftime(" - %T %p", $row[$i]['endtime']);

                        $timeset = '<div style=\"padding-top:2px\"><b>' . $this->DFE->TT->getMC('_time_setting') . ':</b></div>' . $this->DFE->TT->getMC('_start') . ': <em>" . $start_time . " </em><br>' . $this->DFE->TT->getMC('_end') . ': <em>' . $end_time . '</em><br><br>';
                    }
                } else {
                    $timeset = '<b>' . $this->DFE->TT->getMC('_time_setting') . ':</b> <em>' . $this->DFE->TT->getMC('_none') . '</em><br>';
                }

                # Be Rights Move content blocks
                if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][30] == 1 || $_SESSION['BE_Rights'] == 1) {
                    $move_cols = '<a href="?ac=MoveCols&uid=' . $this->DFE->http->_post('uid') . '&colP=' . $colP . '&cid=' . $row[$i]['uid'] . '&sorting=' . $row[$i]['sorting'] . $this->Query .'" title="' . $this->DFE->TT->getMC('_move_content_in_rows') . '"><i class="fa fa-arrows inverse" aria-hidden="true"></i></a>';
                } else {
                    $move_cols = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['rights_lock_group'].'"'; 
                }

                switch ($row[$i]['CType']) {
                    case "PHP":
                        $css_lock = "display:none;";
                        $content_lock = "";

                        $body_content = \lib\Functions::readFiles("/aribu.systems/_templates/content/php_code.html");
                        $checkbox = '<div class="checkbox checkbox-default"><input type="checkbox" name="ContentBlock[]" value="' . $row[$i]['uid'] . '"><label></label></div>';
                        if ($GLOBALS['LANGUAGE'] == "de") {
                            $update = $row[$i]['lastUpdated'] == 0 ? date("d.m.Y - H:i", $row[$i]['tstamp']) : date("d.m.Y - H:i", $row[$i]['lastUpdated']);
                            $created = date("d.m.Y - H:i", $row[$i]['tstamp']);
                        } else {
                            $update = $row[$i]['lastUpdated'] == 0 ? strftime("%D - %T %p", $row[$i]['tstamp']) : strftime("%D - %T %p", $row[$i]['lastUpdated']);
                            $created = strftime("%D - %T %p", $row[$i]['tstamp']);
                        }

                        $infos = '<b>' . $this->DFE->TT->getMC('_content_name') . '</b> <em>' . $row[$i]['content_name'] . '</em><br><b>Type:</b> <em>' . $row[$i]['CType'] . '</em><br> <b>' . $this->DFE->TT->getMC('_position') . '</b> <span class=\"posi\">' . $row[$i]['sorting'] . '</span><br>' . $this->DFE->TT->getMC('_path') . ': <em><a title="/scripts/' . $row[$i]['script_path'] . '" style="cursor:pointer;">/scripts/' . substr($row[$i]['script_path'], 0, 20) . '...</a></em><div style="padding-top:4px">' . $this->DFE->TT->getMC('_created') . ' <em>' . $created . ' ' . $this->DFE->TT->getMC('_clock') . '</em><br>' . $this->DFE->TT->getMC('_updated') . ' <em>' . $update . ' ' . $this->DFE->TT->getMC('_clock') . '</em></div><br>' . $timeset . '<b>' . $this->DFE->TT->getMC('_language') . '</b> ' . $GLOBALS['BE_LANGUAGES'][$row[$i]['lang']] . '<br><strong>' . $this->DFE->TT->getMC('_author') . ':</strong> <em>' . $row[$i]['author'] . '</em><input type="hidden" name="content_block[]" value="' . $row[$i]['uid'] . '" />';

                        # Be Rights Edit Content
                        if (($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][24] == 1 && $_SESSION['sess_username'] == $row[$i]['author']) || $_SESSION['BE_Rights'] == 1 || $_SESSION['BE_Rights'] == 2 || $_SESSION['BE_Rights'] == 3) {
                            $edit_content = '<a href="?ac=' . $row[$i]['CType'] . '&uid=' . $this->DFE->http->_post('uid') . '&sorting=' . $row[$i]['sorting'] . '&action=edit&cid=' . $row[$i]['uid'] . '&colP=' . $colP . $this->Query .'" title="'.$this->DFE->TT->getMC('_edit_php').'"><i class="fa fa-pencil inverse" aria-hidden="true"></i></a>';
                        } else {
                            $edit_content = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['rights_lock_group'].'"';
                        }

                        # Be Rights Copy Content
                        if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][26] == 1 || $_SESSION['BE_Rights'] == 1) {
                            $copy_content = '<a href="?ac=CopyContent&uid=' . $this->DFE->http->_post('uid') . '&sorting=' . $row[$i]['sorting'] . '&action=copy&cid=' . $row[$i]['uid'] . '&colP=' . $colp . $this->Query .'" title="'.$this->DFE->TT->getMC('_copy_content_title').'"><i class="fa fa-copy inverse" aria-hidden="true"></i></a>';
                        } else {
                            $copy_content = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['rights_lock_group'].'"'; 
                        }

                        $get_cid = "method=GetPHPBlockView&class=/aribu/scripts/content/lib/Content&classname=Content&fb=".$this->FB."&cid=" . $row[$i]['uid'] . "&lang=" . $GLOBALS['LANGUAGE'];
                        $body_content = str_replace("###PHP_CODE###", $get_cid, $body_content);
                        $body_content = str_replace('###lang###', $GLOBALS['LANGUAGE'], $body_content);
                        break;

                    
                    default:
                        # Content lock 
                        $this->DFE->db->Select('*')
                                      ->From('content_lock')
                                      ->WhereColName('cid')
                                      ->WhereColValue($row[$i]['uid'])
                                      ->Andd("AND colP = " . $colP)
                                      ->doSelect();
                        $num_lock = $this->DFE->db->Rows;
                        $row_lock = $this->DFE->db->SelectPuffer;
                        if ($num_lock && $row_lock['updater_id'] != $_SESSION['sess_uid']) {
                            $this->DFE->db->TablePreName = "be_";
                            $this->DFE->db->Select('session_deleted')
                                          ->From('session')
                                          ->WhereColName('session_user_id')
                                          ->WhereColValue($row_lock['updater_id'])
                                          ->doSelect();
                            $rows = $this->DFE->db->SelectPuffer;
                            $nums = $this->DFE->db->Rows;
                            $this->DFE->db->TablePreName = $this->FB;
                            if ($rows['session_deleted'] != 1 && $nums) {
                                $css_lock = "display:block; cursor:pointer;";
                                $content_lock = str_replace("###updater###", $row_lock['updater'], $this->DFE->TT->getMC('_content_lock'));
                            } else {
                                $this->DFE->db->Delete('content_lock')
                                              ->WhereColName('cid')
                                              ->WhereColValue($row[$i]['uid'])
                                              ->doDelete();

                                $css_lock = "display:none;";
                                $content_lock = "";
                                $checkbox = '<div class="checkbox checkbox-default"><input type="checkbox" name="ContentBlock[]" value="' . $row[$i]['uid'] . '"><label></label></div>';
                            }
                        } else {
                            $css_lock = "display:none;";
                            $content_lock = "";
                            $checkbox = '<div class="checkbox checkbox-default"><input type="checkbox" name="ContentBlock[]" value="' . $row[$i]['uid'] . '"><label></label></div>';
                        }

                        $body_content = \lib\Functions::readFiles("/aribu.systems/_templates/content/html_code.html");


                        if ($GLOBALS['LANGUAGE'] == "de") {
                            $update = $row[$i]['lastUpdated'] == 0 ? date("d.m.Y - H:i", $row[$i]['tstamp']) : date("d.m.Y - H:i", $row[$i]['lastUpdated']);
                            $created = date("d.m.Y - H:i", $row[$i]['tstamp']);
                        } else {
                            $update = $row[$i]['lastUpdated'] == 0 ? strftime("%D - %T %p", $row[$i]['tstamp']) : strftime("%D - %T %p", $row[$i]['lastUpdated']);
                            $created = strftime("%D - %T %p", $row[$i]['tstamp']);
                        }

                        $infos = '<b>' . $this->DFE->TT->getMC('_content_name') . ':</b> <em>' . $row[$i]['content_name'] . '</em>'
                                . '<br><b>' . $this->DFE->TT->getMC('_position') . '</b> <span class="posi">' . $row[$i]['sorting'] . '</span> | '
                                . '<b>Type:</b> <em>' . $row[$i]['CType'] . '</em> | '
                                . '<b>UID:</b> <em>' . $row[$i]['uid'] . '</em>'                      
                                . '<br>' . $timeset . ' '
                                . '<strong>' . $this->DFE->TT->getMC('_author') . ':</strong> <em>' . $row[$i]['author'] . '</em>'
                                . '<div style="padding-top:4px"><small>' . $this->DFE->TT->getMC('_created') . ' <em>' . $created . ' ' . $this->DFE->TT->getMC('_clock') . '</em>'
                                . ' | ' . $this->DFE->TT->getMC('_updated') . ' <em>' . $update . ' ' . $this->DFE->TT->getMC('_clock') . '</em></small></div>'
                                . '<input type="hidden" name="content_block[]" value="' . $row[$i]['uid'] . '" />';

                        # Be Rights Edit Content
                        if (($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][24] == 1 && $_SESSION['sess_username'] == $row[$i]['author']) || $_SESSION['BE_Rights'] == 1 || $_SESSION['BE_Rights'] == 2 || $_SESSION['BE_Rights'] == 3) {
                            $edit_content = '<a href="?ac=' . $row[$i]['CType'] . '&uid=' . $this->DFE->http->_post('uid') . '&sorting=' . $row[$i]['sorting'] . '&action=edit&cid=' . $row[$i]['uid'] . '&colP=' . $colP . $this->Query .'" title="' . $this->DFE->TT->getMC('_edit_content') . '"><i class="fa fa-pencil inverse" aria-hidden="true"></i></a>';
                        } else {
                            $edit_content = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_edit_content'].'"'; 
                        }

                        # Be Rights Copy Content
                        if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][26] == 1 || $_SESSION['BE_Rights'] == 1) {
                            $copy_content = '<a href="?ac=CopyContent&uid=' . $this->DFE->http->_post('uid') . '&sorting=' . $row[$i]['sorting'] . '&action=copy&cid=' . $row[$i]['uid'] . '&colP=' . $colP . $this->Query .'&plugin=PageBrowser"><i class="fa fa-copy inverse" aria-hidden="true"></i></a>';
                        } else {
                            $copy_content = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_copy_content'].'"';
                        }

                        $get_cid = "method=GetHTMLBlockView&class=/aribu/scripts/content/lib/Content&classname=Content&FB=".$this->FB."&cid=" . $row[$i]['uid'] . "&lang=" . $GLOBALS['LANGUAGE'];
                        $body_content = str_replace("###HTML_CODE###", $get_cid, $body_content);
                        $body_content = str_replace('###lang###', $GLOBALS['LANGUAGE'], $body_content);
                }

                $block_infos = $infos;
                $block_checkbox = $checkbox;
                $block_actions = $content_hidden . $del_content . $edit_content . $copy_content . $move_content . $move_cols;
                $block_preview = $body_content;

                $TT->setIMC($i, 'css_lock', $css_lock)
                   ->setIMC($i, 'block_infos', $block_infos)
                   ->setIMC($i, 'block_checkbox', $block_checkbox)
                   ->setIMC($i, 'block_actions', $block_actions)
                   ->setIMC($i, 'block_preview', $block_preview);
                
            } # Schleife ende
        } else {
            # Content lock 
            $this->DFE->db->Select('*')
                          ->From('content_lock')
                          ->WhereColName('cid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Andd("AND colP = " . $colP)
                          ->doSelect();
            $num_lock = $this->DFE->db->Rows;
            $row_lock = $this->DFE->db->SelectPuffer;
            if ($num_lock) {
                $css_lock = "display:block; cursor:pointer;";
                $content_lock = str_replace("###updater###", $row_lock['updater'], $this->DFE->TT->getMC('_content_lock'));
            } else {
                $css_lock = "display:none;";
                $content_lock = "";
            }

            $this->DFE->db->Select('nav_title')
                          ->From($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            
            
            # Kein Block vorhanden
            $TT->BlockMarker['block'] = 0;
            $TT->setIMC(0, 'css_lock', $css_lock)
               ->setIMC(0, 'content_lock', $content_lock);    
        }  
        
        $TT->setMC('colp',          $colP)
           ->setMC('col_position',  $col_position)
           ->setMC('new_content',   'javascript: location.href=\'?ac=NewContent&colP='.$colP.'&uid=' . $this->DFE->http->_post('uid') . $action_query . "'");
        
        
        
        return $TT->getFilledTemplate('/aribu.systems/_templates/content/blocks.html', NULL, 1);
    }
    
    
}