<?php

namespace aribu\scripts\content\lib;

/* 
 * aribu system - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   04.11.2005
 *  
 */

class Content extends \aribu\scripts\abstracts\Abstracts {

    public $chields         = array();
    public $RGT             = array();
    public $BL              = array();
    public $CLevel          = array();
    
    /**
     * DFE object
     * @var object
     */
    public $DFE;
    
    /**
     * BE Language
     * @var array
     */
    public $BELanguage = array();
    
    
    public $FB = "fe_";
    public $FBup = 'FE';
    public $BE = '';

    /**
     * Constructer
     * @param type $DFE
     */
    public function __construct($DFE) {
        parent::__construct($DFE);
    }
    
    
    
    /**
     * New content
     * @return string
     */
    public function NewContent() {
        
        $this->DFE->TT->BlockMarker[1] = 0;
        $this->DFE->TT->BlockMarker[2] = 0;
        $this->DFE->TT->BlockMarker[3] = 0;
        $this->DFE->db->TablePreName = 'fe_';
        
        $fb = $this->FB == 'be_' ? "&FB=be_" : '';
        foreach ($GLOBALS['CONTENT_MODULE'] as $key => $val) {
            
            $this->DFE->db->Select('config_description')
                          ->From('system_config')
                          ->WhereColName('config_lang')
                          ->WhereColValue($_SESSION['sess_language'])
                          ->Andd("AND config_key = '" . $key . "' AND config_title = 'CONTENT_MODULE'")
                          ->doSelect();
            $desc = str_replace("###" . strtolower($key) . "###", "?ac=" . $key . "&uid=" . $this->DFE->http->_post('uid') . "&colP=" . $this->DFE->http->_post('colP') . "&jid=" . $this->DFE->http->_post('jid') . $fb, stripslashes($this->DFE->db->SelectPuffer['config_description']));

            $desc_arr = explode("\n", $desc);
            foreach ($desc_arr as $z => $zval) {
                $zarr = explode(" : ", $zval);
                $content_modul_arr[$val][$key][$zarr[0]] = $zarr[1];
            }
        }
        $this->DFE->db->TablePreName = $this->FB;
        ksort($content_modul_arr);
        foreach ($content_modul_arr as $cmkey => $cmval) {
            $content_modul = "";
            $a = 0;
            
            foreach ($cmval as $cm_key => $cm_val) {
                $content_modul = "<a href=\"?ac=" . $cm_key . "&uid=" . $this->DFE->http->_post('uid') . "&colP=" . $this->DFE->http->_post('colP') . "&jid=" . $this->DFE->http->_post('jid') . $fb . "\">" . str_replace("dot.orange", "aribu.systems", stripslashes($cm_val['image'])) . "</a>";
                $content_modul .= $cm_val['content'];

                $cm = "250_" . $cm_key;
                                
                $this->DFE->TT->setIMC($a, 'content_modul', $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][$cm] == 1 || $_SESSION['BE_Rights'] == 1 ? $content_modul : '', $cmkey);
                $a++;        
            }
            
            $this->DFE->TT->BlockMarker[$cmkey] = $this->DFE->TT->getIMC(0, 'content_modul', $cmkey) != '' ? 1 : 0;
            
        }

        $this->DFE->db->Select('nav_title')
                      ->From($this->DFE->Pages)
                      ->WhereColName('uid')
                      ->WhereColValue($this->DFE->http->_post('uid'))
                      ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();
        $row = $this->DFE->db->SelectPuffer;
        $this->DFE->TT->setMC('page', stripslashes($row['nav_title']));

        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/content/new_content.html', NULL, 1, 3);
    }

    /**
     * Content Overview
     * @return string
     */
    public function ContentOverview($template='/aribu.systems/_templates/content/overview.html') {
        if($this->FB == 'fe_') {
            require_once FE_MENU;
        } else {
            require_once BE_MENU;
        }

        if ($this->DFE->http->issetPost('changeLang') === true) {
            if ($this->SystemLanguage != $GLOBALS['LANGUAGE']) {
                $this->DFE->db->Select('uid')
                              ->From('pages_language')
                              ->WhereColName('rid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd("AND lang = :lang ")
                              ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                              ->doSelect();
                $uid = $this->DFE->db->SelectPuffer['uid'];
                header("Location: ?ac=ContentOverview&uid=" . $uid . "&colP=" . $this->DFE->http->_post('colP'));
                exit;
            } else {
                $this->DFE->db->Select('uid')
                              ->From('pages_language')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd("AND lang = :lang ")
                              ->Parameter(array('lang' => $this->DFE->http->_post('lastLang')))
                              ->doSelect();
                $rid = $this->DFE->db->SelectPuffer['rid'];
                header("Location: ?ac=ContentOverview&uid=" . $rid . "&colP=" . $this->DFE->http->_post('colP'));
                exit;
            }
        }

        if ($this->DFE->http->issetPost('uid') === true) {
            $pid = intval($this->DFE->http->_post('uid'));
        }
        if ($this->DFE->http->issetPost('colP') === true) {
            $and_colP_M = " AND colP = " . intval($this->DFE->http->_post('colP')) . " ";
            $position = $GLOBALS['CONTENT_POSITION'][intval($this->DFE->http->_post('colP'))];
            
        } else {
            $and_colP_M = " AND colP = 0 ";
            $position = $GLOBALS['CONTENT_POSITION'][0];
            
        }

        $action_query .= "&jid=" . $this->DFE->http->_post('jid');
        $jid = $this->DFE->http->_post('jid');
        
        
        switch ($this->DFE->http->_post('mode')) {
            case "del":
                $this->DFE->db->Select('CType, script_method, sorting')
                              ->From('content')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->Andd("AND lang = :lang ")
                              ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                              ->doSelect();
                $sorting        = $this->DFE->db->SelectPuffer['sorting'];
                $script_method  = $this->DFE->db->SelectPuffer['script_method'];
                $CType          = $this->DFE->db->SelectPuffer['CType'];
                if ($CType == "IMGAL") {
                    $block_data = unserialize($script_method);
                    $dir_thumbs = \lib\Functions::readDirectory($_SERVER['DOCUMENT_ROOT'] . "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/thumbs", '', 0);
                    foreach ($dir_thumbs as $key => $val) {
                        if ($val != ".DS_Store" && $val != "." && $val != "..") {
                            $image_path_thumbs = "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/thumbs/" . $val;
                            unlink(DOC_ROOT . $image_path_thumbs);
                        }
                    }
                    rmdir(DOC_ROOT . "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/thumbs");

                    $key = "";
                    $val = "";
                    $dir_original = \lib\Functions::readDirectory($_SERVER['DOCUMENT_ROOT'] . "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/original", '', 0);
                    foreach ($dir_original as $key => $val) {
                        if ($val != ".DS_Store" && $val != "." && $val != "..") {
                            $image_path_original = "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/original/" . $val;
                            unlink(DOC_ROOT . $image_path_original);
                        }
                    }
                    rmdir(DOC_ROOT . "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/original");

                    $key = "";
                    $val = "";
                    $dir_large = \lib\Functions::readDirectory($_SERVER['DOCUMENT_ROOT'] . "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/large", '', 0);
                    foreach ($dir_large as $key => $val) {
                        if ($val != ".DS_Store" && $val != "." && $val != "..") {
                            $image_path_large = "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/large/" . $val;
                            unlink(DOC_ROOT . $image_path_large);
                        }
                    }
                    rmdir(DOC_ROOT . "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']) . "/large");
                    rmdir(DOC_ROOT . "/fileadmin/galerie/" . \lib\Functions::updatePagename($block_data['galery_folder'], $GLOBALS['LANGUAGE']));
                }


                $this->DFE->db->Delete('content')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->doDelete();
                $this->DFE->db->Delete('content_media')
                              ->WhereColName('cid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->doDelete();
                $this->DFE->db->Select('uid')
                              ->From('content')
                              ->WhereColName('pid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd("AND sorting >= '" . $sorting . "' AND lang = :lang AND colP = :colp ")
                              ->Order('ORDER BY sorting ASC')
                              ->SelectMethod(1)
                              ->Parameter(array('lang' => $GLOBALS['LANGUAGE'], 'colp' => $this->DFE->http->_post('colP')))
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                $row = $this->DFE->db->SelectPuffer;
                if ($num > 0) {
                    for ($i = 0; $i < $num; $i++) {
                        $this->DFE->db->Update('content')
                                      ->WhereColName('uid')
                                      ->WhereColValue($row[$i]['uid'])
                                      ->Set(array("sorting" => "sorting-1", "lastUpdated" => time()))
                                      ->SetType(false)
                                      ->doUpdate();
                    }
                }
                $jump_link = "?ac=ContentOverview&uid=" . $pid . "" . $action_query;
                header("Location: " . $jump_link);
                exit;
                break;

            case "moveup":
                $this->DFE->db->Select('sorting')
                              ->From('content')
                              ->WhereColName('uid')
                              ->WhereColValue($row[$i]['cid'])
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;

                $sorting = $row['sorting'] - 1;
                $this->DFE->db->Update('content')
                              ->WhereColName('pid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd("AND sorting = '" . $sorting . "'" . $and_colP_M . "AND lang = :lang")
                              ->Set(array("sorting" => "sorting+1", "lastUpdated" => time()))
                              ->SetType(false)
                              ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                              ->doUpdate();  
                $this->DFE->db->Update('content')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->Set(array("sorting" => "sorting-1", "lastUpdated" => time()))
                              ->SetType(false)
                              ->doUpdate();
                $jump_link = "?ac=ContentOverview&uid=" . $pid . "" . $action_query;
                header("Location: " . $jump_link);
                exit;
                break;

            case "movedown":
                $this->DFE->db->Select('sorting')
                              ->From('content')
                              ->WhereColName('uid')
                              ->WhereColValue($row[$i]['cid'])
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;

                $sorting = $row['sorting'] + 1;
                 
                $this->DFE->db->Update('content')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->Set(array("sorting" => $sorting, "lastUpdated" => time()))
                              ->doUpdate();
                $this->DFE->db->Update('content')
                              ->WhereColName('pid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd("AND sorting = '" . $sorting . "'" . $and_colP_M . "AND lang = :lang")
                              ->Set(array("sorting" => $this->DFE->http->_post('sorting'), "lastUpdated" => time()))
                              ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                              ->doUpdate(); 
                $jump_link = "?ac=ContentOverview&uid=" . $pid . "" . $action_query;
                header("Location: " . $jump_link);
                exit;
                break;

            case "notpublic":
                $this->DFE->db->Update('content')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->Set(array("hidden" => 1, "lastUpdated" => time()))
                              ->doUpdate();
                $jump_link = "?ac=ContentOverview&uid=" . $pid . "" . $action_query;
                header("Location: " . $jump_link);
                exit;
                break;

            case "public":
                $this->DFE->db->Update('content')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->Set(array("hidden" => 0, "lastUpdated" => time()))
                              ->doUpdate();
                $jump_link = "?ac=ContentOverview&uid=" . $pid . "" . $action_query;
                header("Location: " . $jump_link);
                exit;
                break;

            case "onlineContent":
                if ($this->DFE->http->issetPost('ContentBlock') === true) {
                    foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                        $this->DFE->db->Update('content')
                                      ->WhereColName('uid')
                                      ->WhereColValue($val)
                                      ->Set(array("hidden" => 0, "lastUpdated" => time()))
                                      ->doUpdate();
                    }
                }
                break;

            case "offlineContent":
                if ($this->DFE->http->issetPost('ContentBlock') === true) {
                    foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                        $this->DFE->db->Update('content')
                                      ->WhereColName('uid')
                                      ->WhereColValue($val)
                                      ->Set(array("hidden" => 1, "lastUpdated" => time()))
                                      ->doUpdate();
                    }
                }
                break;

            case "unlock":
                # Content unlock
                $this->DFE->db->Delete('content_lock')
                              ->WhereColName('cid')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->doDelete();
                break;

            case "fixsort":
                if ($this->DFE->http->isArray('ContentBlock') === true) {
                    foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                        $this->DFE->db->Update('content')
                                      ->WhereColName('uid')
                                      ->WhereColValue($val)
                                      ->Set(array("sorting" => $key + 1))
                                      ->doUpdate();
                    }
                }
                break;
        }

        $a = 0;
        $Blocks = new Blocks($this->DFE, $this->FB, $this->FBup, $this->BE);
        $ccol = count($GLOBALS['CONTENT_POSITION']);
        
        foreach ($GLOBALS['CONTENT_POSITION'] as $key => $val) {
            $col  = 12 / $ccol;
            $this->DFE->TT->setIMC($a, 'col_position_blocks',   $Blocks->GetBlocks($key, $val))
                          ->setIMC($a, "cols",                  round($col,0));               
            $a++;
        }
        
                                
        $this->DFE->TT->setMC('path',                       \lib\Functions::breadcrumb($this->DFE->http->_post('uid'), 'dot'.$this->FBup.'Menu'))
                      ->setMC('content_uid',                $this->DFE->http->_post('uid'))
                      ->setMC('pageurl',                    $this->FB == 'fe_' ? URL_PROTOCOL.'://'. \lib\fe_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 1) : URL_PROTOCOL.'://'. URL_HOST . '/aribu.sys' . \lib\be_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 1))
                      ->setMC('colP',                       $this->DFE->http->_post('colP'))
                      ->setMC('content_copy_all_rights',    $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][27] == 1 || $_SESSION['BE_Rights'] == 1 ? '' : 'disabled')
                      ->setMC('fb',                         '&FB='.$this->FB)
                      ->setMC('page',                       stripslashes($this->DFE->db->getOne("nav_title", $this->DFE->Pages, "uid", $this->DFE->http->_post('uid'), str_replace("%%%n%%%", "", $this->DFE->and_lang), $this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())))
                      ->setMC('optionen',                   '<a href="' . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']) . '" title="'.$this->DFE->TT->getMC('_back').'"><i class="fa fa-arrow-left inverse"></i></a> <a href="' . $this->DFE->TT->getMC('pageurl') . '" title="' . $this->DFE->TT->getMC('_preview') . '" target="_blank"><i class="fa fa-search-plus inverse" aria-hidden="true"></i></a>' . $this->DFE->TT->getMC('action_edit'))
                      ->setMC('lg',                         $GLOBALS['LANGUAGE'] != 'de' ? "/" . $GLOBALS['LANGUAGE'] : "")
                      ->setMC('lang',                       $GLOBALS['LANGUAGE'])
                      ->setMC('action_browser',             '<a href="javascript:void(0);" onclick="javascript: GetPageBrowser();" title="Seiten-Browser aufrufen"><i class="fa fa-sitemap inverse" area-hidden="true"></i></a>')
                      ->setMC('action_edit',                $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][3] == 1 || $_SESSION['BE_Rights'] == 1 ? '<a href="' . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Pages'], $GLOBALS['LANGUAGE']) . '?ac=EditPage&uid=' . $this->DFE->http->_post('uid') . '&jpid=' . $GLOBALS['PageConfig']['UID'] . '"><i class="fa fa-pencil-square-o inverse" aria-hidden="true"></i></a>' : '<a href="javascript:void(0);" title="'. $this->DFE->TT->getMC('_right_edit_page') .'"><i class="fa fa-pencil-square-o disabled" aria-hidden="true"></a>');
        
        $this->DFE->TT->BlockMarker['itorange'] = $_SESSION['sess_username'] == "it.orange" ? 1 : 0;
        

        return $this->DFE->TT->getFilledTemplate($template, NULL, 1);
               
    }

    /**
     * Copy content block or blocks
     * @param type $error
     * @return type
     */
    public function CopyContent($template='/aribu.systems/_templates/content/copy_content.html') {
        
        if ($this->DFE->http->issetPost('save_content_copy') === true) {

            if ($this->DFE->http->_post('lastUID') == 0) {
                $err = 1;
                $this->Error['Validation'] = $this->DFE->TT->getMC('_copy_content_error1');
            }
            
            # Error
            if ($err == 1) {
                $this->DFE->http->unsetPOST('save_content_copy');
                $this->CopyContent();
            } else {
                
                if ($this->DFE->http->issetPost('colP') === true) {
                    $and_colp = " AND colP = :colp ";
                    $colP = $this->DFE->http->_post('colP');
                } else {
                    $colP = 0;
                }

                if ($this->DFE->http->issetPost('recursiv') === false && $this->DFE->http->isEmpty('recursiv') === true) {
                    $this->DFE->db->Select('uid, sorting')
                                  ->From('content')
                                  ->WhereColName('pid')
                                  ->WhereColValue($this->DFE->http->_post('lastUID'))
                                  ->Andd($and_colp . " AND lang = :lang ")
                                  ->Order('ORDER BY sorting DESC')
                                  ->Parameter($this->DFE->http->issetPost('colP') === true ? array('colp' => $this->DFE->http->_post('colP'), 'lang' => $this->DFE->http->_post('lang')) : array('lang' => $this->DFE->http->_post('lang')))
                                  ->doSelect();
                    $num1 = $this->DFE->db->Rows;
                    if (!$num1) {
                        if ($this->DFE->http->isEmpty('ContentBlock') === true) {
                            $this->DFE->db->Select('*')
                                          ->From('content')
                                          ->WhereColName('uid')
                                          ->WhereColValue($this->DFE->http->_post('cid'))
                                          ->doSelect();
                            $row2 = $this->DFE->db->SelectPuffer;
                            if ($this->DFE->http->isEmpty('content_name') === true) {
                                $contname = "Content_1";
                            } else {
                                $contname = $this->DFE->http->_post('content_name');
                            }
                            $this->AddContent($row2, 1, $contname, $this->DFE->http->_post('lastUID'));
                                                        
                            $lastID = $this->DFE->db->LastInsertID;
                            $this->AddContentMedia($row2, $lastID);    
                            
                        } else {
                            $c = 1;
                            foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                                
                                $this->DFE->db->Select('*')
                                          ->From('content')
                                          ->WhereColName('uid')
                                          ->WhereColValue($val)
                                          ->doSelect();
                                $row2 = $this->DFE->db->SelectPuffer;
                                $this->AddContent($row2, $c, $row2['content_name'], $this->DFE->http->_post('lastUID'));
                                
                                $c++;

                                $lastID = $this->DFE->db->LastInsertID;
                                $this->AddContentMedia($row2, $lastID);
                                
                            }
                        }
                    } else {
                        $row = $this->DFE->db->SelectPuffer;
                        if ($this->DFE->http->isEmpty('ContentBlock') === true) {
                            $this->DFE->db->Select('*')
                                          ->From('content')
                                          ->WhereColName('uid')
                                          ->WhereColValue($this->DFE->http->_post('cid'))
                                          ->doSelect();
                            $row2 = $this->DFE->db->SelectPuffer;
                            if ($this->DFE->http->isEmpty('content_name') === true) {
                                $contname = "Content_" . ($row['sorting'] + 1);
                            } else {
                                $contname = $this->DFE->http->_post('content_name');
                            }
                            $this->AddContent($row2, $row['sorting'] + 1, $contname, $this->DFE->http->_post('lastUID'));
                            
                            $lastID = $this->DFE->db->LastInsertID;
                            $this->AddContentMedia($row2, $lastID);
                            
                        } else {
                            $x = 1;
                            $this->DFE->db->Select('sorting')
                                          ->From('content')
                                          ->WhereColName('pid')
                                          ->WhereColValue($this->DFE->http->_post('lastUID'))
                                          ->Andd("AND colP = :colp AND lang = :lang ")
                                          ->Order('ORDER BY sorting DESC')
                                          ->SelectMethod(1)
                                          ->Parameter(array('colp' => $this->DFE->http->_post('colP'), 'lang' => $this->DFE->http->_post('lang')))
                                          ->doSelect();
                            $num = $this->DFE->db->Rows;
                            if ($num) {
                                $sorting = $num;
                            } else {
                                $sorting = 0;
                            }
                            foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                                $this->DFE->db->Select('*')
                                          ->From('content')
                                          ->WhereColName('uid')
                                          ->WhereColValue($val)
                                          ->doSelect();
                                $row2 = $this->DFE->db->SelectPuffer;
                                $this->AddContent($row2, $sorting + $x, $row2['content_name'], $this->DFE->http->_post('lastUID'));
                                
                                $x++;

                                $lastID = $this->DFE->db->LastInsertID;
                                $this->AddContentMedia($row2, $lastID);
                                
                            }
                        }
                    }
                } else {
                    $and_lang = $this->DFE->http->_post('lang') != $this->SystemLanguage ? "AND o.lang = '" . $this->DFE->http->_post('lang') . "'" : "";
                    $Pages = $this->DFE->http->_post('lang') != $this->SystemLanguage ? "pages_language" : "pages";
                    $rid = $this->DFE->http->_post('lang') != $this->SystemLanguage ? ", o.rid" : "";
                    $this->DFE->db->Select('o.uid' . $rid)
                                  ->From($Pages . " AS n, " . $this->FB . $Pages . " AS p, " . $this->FB . $Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = " . $this->DFE->http->_post('lastUID') . " " . $and_lang)
                                  ->Group('GROUP BY o.lft')
                                  ->Order('ORDER BY o.lft')
                                  ->SelectMehtod(1)
                                  ->doSelect();
                    $num1 = $this->DFE->db->Rows;
                    if ($num1) {
                        $row1 = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num1; $i++) {
                            $this->DFE->db->Select('uid, sorting')
                                          ->From('content')
                                          ->WhereColName('pid')
                                          ->WhereColValue($row1[$i]['uid'])
                                          ->Andd($and_colp . " AND lang = '" . $this->DFE->http->_post('lang') . "'")
                                          ->Order('ORDER BY sorting DESC')
                                          ->doSelect();
                            $num2 = $this->DFE->db->Rows;
                            if (!$num2) {
                                if ($this->DFE->http->isEmpty('ContentBlock') === true) {
                                    $this->DFE->db->Select('*')
                                                  ->From('content')
                                                  ->WhereColName('uid')
                                                  ->WhereColValue($this->DFE->http->_post('cid'))
                                                  ->doSelect();
                                    $row2 = $this->DFE->db->SelectPuffer;
                                    if ($this->DFE->http->isEmpty('content_name') === true) {
                                        $contname = "Content_1";
                                    } else {
                                        $contname = $this->DFE->http->_post('content_name');
                                    }
                                    $this->AddContent($row2, $row1, $i, 1, $contname, $row1[$i]['uid']);
                                    
                                    $lastID = $this->DFE->db->LastInsertID;
                                    $this->AddContentMedia($row2, $lastID);
                                    
                                } else {
                                    $c = 1;
                                    foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                                        $this->DFE->db->Select('*')
                                                  ->From('content')
                                                  ->WhereColName('uid')
                                                  ->WhereColValue($val)
                                                  ->doSelect();
                                        $row2 = $this->DFE->db->SelectPuffer;
                                        $this->AddContent($row2, $row1, $i, $c, $row2['content_name'], $row1[$i]['uid']);
                                        $c++;

                                        $lastID = $this->DFE->db->LastInsertID;
                                        $this->AddContentMedia($row2, $lastID);
                                        
                                    }
                                }
                            } else {
                                $row = $this->DFE->db->SelectPuffer;
                                if ($this->DFE->http->isEmpty('ContentBlock') === true) {
                                    $this->DFE->db->Select('*')
                                                  ->From('content')
                                                  ->WhereColName('uid')
                                                  ->WhereColValue($this->DFE->http->_post('cid'))
                                                  ->doSelect();
                                    $row2 = $this->DFE->db->SelectPuffer;
                                    if ($this->DFE->http->isEmpty('content_name') === true) {
                                        $contname = "Content_" . ($row['sorting'] + 1);
                                    } else {
                                        $contname = $this->DFE->http->_post('content_name');
                                    }
                                    $this->AddContent($row2, $row['sorting'] + 1, $contname, $row1[$i]['uid']);
                                    
                                } else {
                                    $x = 1;
                                    $this->DFE->db->Select('sorting')
                                                  ->From('content')
                                                  ->WhereColName('pid')
                                                  ->WhereColValue($row1[$i]['uid'])
                                                  ->Andd("AND colP = :colp AND lang = :lang ")
                                                  ->Order('ORDER BY sorting DESC')
                                                  ->SelectMethod(1)
                                                  ->Parameter(array('colp' => $this->DFE->http->_post('colP'), 'lang' => $this->DFE->http->_post('lang')))
                                                  ->doSelect();
                                    $num3 = $this->DFE->db->Rows;
                                    if ($num3) {
                                        $sorting = $num3;
                                    } else {
                                        $sorting = 0;
                                    }
                                    foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                                        $this->DFE->db->Select('*')
                                                  ->From('content')
                                                  ->WhereColName('uid')
                                                  ->WhereColValue($val)
                                                  ->doSelect();
                                        
                                        $row2 = $this->DFE->db->SelectPuffer;
                                        $this->AddContent($row2, ($sorting + $x), $row2['content_name'], $row1[$i]['uid']);
                                        $x++;

                                        $lastID = $this->DFE->db->LastInsertID;
                                        $this->AddContentMedia($row2, $lastID);
                                    }
                                }
                            }
                        }
                    }
                }
                header("Location: ?ac=ContentOverview&uid=" . $this->DFE->http->_post('lastUID') . "&colP=" . $colP . "&jid=" . $this->DFE->http->_post('jid'));
                exit;
            }
        }

        # Seite
        $this->DFE->db->Select('nav_title')
                      ->From($this->DFE->Pages)
                      ->WhereColName('uid')
                      ->WhereColValue($this->DFE->http->_post('uid'))
                      ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();
        $row = $this->DFE->db->SelectPuffer;

        
        # Content Blocks kopien
        if ($this->DFE->http->issetPost('ContentBlock') === true) {
            foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                $content_block .= '<input type="hidden" name="ContentBlock[]" value="' . $val . '">';
            }
            $content_name = "*";
        }
        
        if(isset($this->Error['Validation'])) {
            $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
            $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
        } 
        
                
        $this->DFE->TT->setMC('lang_options',   \lib\Functions::getOptions($GLOBALS['BE_LANGUAGES'], $GLOBALS['LANGUAGE']))
                      ->setMC('colp',           $this->DFE->http->issetPost('colP') === true ? $this->DFE->http->_post('colP') : 0)
                      ->setMC('col_position',   $GLOBALS['CONTENT_POSITION'][$this->DFE->http->_post('colP')])
                      ->setMC('page',           stripslashes($row['nav_title']))
                      ->setMC('content_block',  $content_block)
                      ->setMC('content_name',   $content_name)
                      ->setMC('uid',            $this->DFE->http->_post('uid'))
                      ->setMC('cid',            $this->DFE->http->_post('cid'))
                      ->setMC('plugin',         $this->DFE->http->issetPost('plugin') === true ? "&plugin=PageBrowser" : "")
                      ->setMC('backlink',       "?ac=ContentOverview&colP=" . $this->DFE->http->_post('colP') . "&uid=" . $this->DFE->http->_post('uid') . "&jid=" . $this->DFE->http->_post('jid') . $this->DFE->TT->getMC('plugin'))
                      ->setMC('lang',           $GLOBALS['LANGUAGE'])
                      ->setMC('content_colp',   $this->DFE->http->_post('colP'))
                      ->setMC('sid',            $_SESSION['sess_id'])
                      ->setMC('fb',             $this->FB == 'be_' ? '&FB=be_' : '');
                      
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    
    /**
     * Add content
     * @param array $row2
     * @param integer $sorting
     * @param string $content_name
     * @param integer $uid
     */
    public function AddContent($row2, $sorting, $content_name, $uid, $colP=false) {
        $colp = $colP !== false ? $colP : $row2['colP']; 
        $lang = $this->DFE->http->issetPost('lang') === true ? $this->DFE->http->_post('lang') : $GLOBALS['LANGUAGE'];
        $this->DFE->db->Insert('content')
                      ->Parameter(array('uid'               => '',                                     
                                        'pid'               => $uid,                                   
                                        'tstamp'            => time(),                                 
                                        'lastUpdated'        => '',                                     
                                        'hidden'            => '0',                                    
                                        'sorting'           => $sorting,                               
                                        'CType'             => $row2['CType'],                         
                                        'lang'              => $lang,        
                                        'bodytext'          => $row2['bodytext'],          
                                        'starttime'         => $row2['starttime'],                     
                                        'endtime'           => $row2['endtime'],                       
                                        'headline'          => $row2['headline'],         
                                        'subline'           => $row2['subline'],           
                                        'script_method'     => $row2['script_method'],     
                                        'script_path'       => $row2['script_path'],                   
                                        'content_name'      => $content_name,                          
                                        'author'            => $_SESSION['sess_username'],             
                                        'colP'              => $colp,                          
                                        'vid'               => '',                                     
                                        'perms_userid'      => $row2['perms_userid'],                  
                                        'perms_groupid'     => $row2['perms_groupid'],                 
                                        'perms_be_userid'   => $row2['perms_be_userid'],               
                                        'perms_be_groupid'  => $row2['perms_be_groupid']))
                      ->doInsert();           
        }
    
    /**
     * Add content media
     * @param array $row2
     * @param integer $lastID
     */
    public function AddContentMedia($row2, $lastID) {
        if ($row2['CType'] == "TXTI" || $row2['CType'] == "IMG") {
            $this->DFE->db->Select('*')
                          ->From('content_media')
                          ->WhereColName('uid')
                          ->WhereColValue($row2['uid'])
                          ->Andd("AND lang = :lang ")
                          ->Parameter(array('lang' => $this->DFE->http->_post('lang')))
                          ->Order('ORDER BY sorting DESC')
                          ->SelectMethod(1)
                          ->doSelect();
            $numcm = $this->DFE->db->Rows;
            if ($numcm) {
                $rowcm = $this->DFE->db->SelectPuffer;
                for ($a = 0; $a < $numcm; $a++) {
                    $this->DFE->db->Insert('content_media')
                                  ->Parameter(array('cid'                   => $lastID, 
                                                    'file'                  => $rowcm[$a]['file'], 
                                                    'size'                  => $rowcm[$a]['size'], 
                                                    'type'                  => $rowcm[$a]['type'], 
                                                    'title'                 => addslashes($rowcm[$a]['title']), 
                                                    'alt'                   => addslashes($rowcm[$a]['alt']), 
                                                    'headline'              => addslashes($rowcm[$a]['headline']), 
                                                    'description'           => addslashes($rowcm[$a]['description']), 
                                                    'description_position'  => $rowcm[$a]['description_position'], 
                                                    'sorting'               => $rowcm[$a]['sorting'], 
                                                    'width'                 => $rowcm[$a]['width'], 
                                                    'height'                => $rowcm[$a]['height'], 
                                                    'url'                   => $rowcm[$a]['url'], 
                                                    'lang'                  => $GLOBALS['LANGUAGE'], 
                                                    'padding'               => $rowcm[$a]['padding'], 
                                                    'margin'                => $rowcm[$a]['margin'], 
                                                    'css'                   => $rowcm[$a]['css']))
                                  ->doInsert();
                }
            }
        }
    }

    /**
     * Delete content
     */
    public function DelContent() {
        $this->DFE->db->TablePreName = $this->FB;
        if ($this->DFE->http->issetPost('ContentBlock') === true && $this->DFE->http->isEmpty('ContentBlock') === false) {
            foreach ($this->DFE->http->_post('ContentBlock') as $key => $val) {
                $this->DFE->db->Select('sorting')
                              ->From('content')
                              ->WhereColName('uid')
                              ->WhereColValue($val)
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;
                $this->DFE->db->Update('content')
                              ->noWhere(1)
                              ->Andd("WHERE sorting > :sorting AND pid = :pid AND colP = :colp AND lang = :lang ") 
                              ->Set(array("sorting" => "sorting-1"))
                              ->SetType(false)
                              ->Parameter(array('sorting' => $row['sorting'], 'pid' => $this->DFE->http->_post('uid'), 'colp' => $this->DFE->http->_post('colP'), 'lang' => $GLOBALS['LANGUAGE']))
                              ->doUpdate();
                $this->DFE->db->Delete('content')
                              ->WhereColName('uid')
                              ->WhereColValue($val)
                              ->doDelete();
                $this->DFE->db->Delete('content_media')
                              ->WhereColName('cid')
                              ->WhereColValue($val)
                              ->doDelete();
            }
        }
        header("Location: ?ac=ContentOverview&uid=" . $this->DFE->http->_post('uid') . "&colP=" . $this->DFE->http->_post('colP') . "&jid=" . $this->DFE->http->_post('jid'));
        exit;
    }

    
    /**
     * Move columns 
     * @return string
     */
    public function MoveCols() {
        
        if ($this->DFE->http->issetPost('save_move') === true) {
            # Letzte Position der neuen Spalte holen
            $this->DFE->db->Select('sorting')
                          ->From('content')
                          ->WhereColName('pid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Andd("AND colP = :colp AND lang = :lang ")
                          ->Parameter(array('colp' => $this->DFE->http->_post('mcolP'), 'lang' => $GLOBALS['LANGUAGE']))
                          ->SelectMethod(1)
                          ->doSelect();
            $sorting = $this->DFE->db->Rows;

            # Alte Daten holen
            $this->DFE->db->Select('*')
                          ->From('content')
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('cid'))
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            $this->AddContent($row, ($sorting + 1), $row['content_name'], $this->DFE->http->_post('uid'), $this->DFE->http->_post('mcolP'));      

            # Letzten Datensatz löschen
            $this->DFE->db->Delete("content")
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('cid'))
                          ->doDelete();

            # Spalte updaten
            $this->DFE->db->Update('content')
                          ->WhereColName('pid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Set(array("sorting" => "sorting-1", "lastUpdated" => time()))
                          ->SetType(false)
                          ->Andd("AND colP = :colp AND sorting > :sorting AND lang = :lang ")
                          ->Parameter(array('colp' => $this->DFE->http->_post('colP'), 'sorting' => $this->DFE->http->_post('sorting'), 'lang' => $GLOBALS['LANGUAGE']))
                          ->doUpdate();

            # Nach dem Speichern zurück auf die Content-Info Seite mit Seiten-Browser
            $jump = "?ac=ContentOverview&colP=" . $this->DFE->http->_post('mcolP') . "&uid=" . $this->DFE->http->_post('uid') . "&jid=" . $this->DFE->http->_post('jid');
            header("Location: " . $jump);
            exit;
        }
                
        $this->DFE->TT->setMC('col_position', $GLOBALS['CONTENT_POSITION'][$this->DFE->http->_post('colP')])
                      ->setMC('cols', \lib\Functions::getOptions($GLOBALS['CONTENT_POSITION'], $this->DFE->http->_post('colP'), ''))
                      ->setMC('backlink', "?ac=ContentOverview&uid=" . $this->DFE->http->_post('uid') . "&colP=" . $this->DFE->http->_post('colP') . "&jid=" . $this->DFE->http->_post('jid'));
        
        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/content/move_content_cols.html');
    }

    /**
     * Update sorting
     */
    public function updateSorting() {
        if ($this->DFE->http->isArray('content_block') === true) {
            foreach ($this->DFE->http->_post('content_block') as $key => $val) {
                $this->DFE->db->Update('content')
                              ->WhereColName('uid')
                              ->WhereColValue($val)
                              ->Set(array("sorting" => $key + 1))
                              ->doUpdate();
            }
            echo '{"update":true}';
        } else {
            echo '{"update":false}';
        }
    }
    
    public function GetPHPBlockView() {
        return 'PHP Code';
    }
    
    public function GetHTMLBlockView() {
        $this->DFE->db->Select('bodytext')
                      ->From('content')
                      ->WhereColName('uid')
                      ->WhereColValue($this->DFE->http->_post('cid'))
                      ->doSelect();
        return $this->DFE->db->SelectPuffer['bodytext'];
    }
    
    public function HideShowContent() {
        # Hide or show content
        
        if($this->DFE->http->_post('mode') == 'notpublic') {
            $message['action'] = 'show';
            $message['ajax'] = '&mode=public&cid=' . $this->DFE->http->_post('cid');
        } else {
            $message['action'] = 'hide';
            $message['ajax'] = '&mode=notpublic&cid=' . $this->DFE->http->_post('cid');
        }
        $hidden = $this->DFE->http->_post('mode') == 'notpublic' ? 1 : 0;
        $this->DFE->db->Update('content')
                      ->WhereColName('uid')
                      ->WhereColValue($this->DFE->http->_post('cid'))
                      ->Set(array("hidden" => $hidden))
                      ->doUpdate();
        return json_encode($message);
    }
    
    public function dmethod() {      
    }
}