<?php

namespace aribu\scripts\content_module;

/* 
 * aribu.systems 6.0
 * aribu.systems is registered and licensed under our definitions.

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   07.04.2016
 *  
 */

class content_module extends \aribu\scripts\abstracts\Abstracts {
    
    /**
     * Number of database rows
     * @var integer
     */
    public $Num = false;
    
    /**
     * Row of database
     * @var array
     */
    public $Row;
    
    /**
     * DFE Object
     * @var object
     */
    public $DFE;
    
    /**
     * Content data unserialized as array
     * @var array
     */
    public $ContentData = array();
    
    /**
     * Errors
     * @var array
     */
    public $Error = array();
    
    public $Start;
    public $Stop;
    
    public $LastUIDs = '';
    
    

    public function __construct($DFE) {
        parent::__construct($DFE);
        $this->SaveUpdateAction();       
    }
    
        
    public function SaveUpdateAction() {
        if($this->DFE->http->issetPost('FB') === true) {
            $this->FB = $this->DFE->http->_post('FB');
            $this->SetFB();
        }
        
        if ($this->DFE->http->issetPost('save_content') === false && $this->DFE->http->issetPost('save_content_close') === false) {
            $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
            
            if ($this->Error['Validation'] == 1) {
                $this->DFE->TT->BlockMarker['saved'] = 1;
                $message = $this->Error['Error_Text'];
                $type = 'error';
            } else {
                $this->DFE->TT->BlockMarker['saved'] = $this->DFE->http->issetPost('saved') === false ? 0 : 1;
                $message = "Die Daten wurden erfolgreich gespeichert!";
                $type = 'success';
            }
            if($this->DFE->http->issetPost('saved') === true || $this->Error['Validation'] == 1) {
                $this->DFE->TT->setMC('messenger', $Widget->Messenger($message, 'messenger-on-top messenger-on-right', $type));
            }
            
        } else {
            if($this->ValidationData() === true) {
                $this->SaveUpdateContent();
                $this->UnlockContent();
                $this->Jump();
            } else {
                if($this->DFE->http->issetPost('action') === false) {
                   # New content
                   $this->Row = $_POST; 
                } else {
                    # Edit content
                }
            }
        }
    }
 
        
    public function ValidationData() {
        if ($this->DFE->http->_post('timeset') == 1) {
            $timestart  = $this->DFE->http->_post('starttime') != "" ? explode(":", $this->DFE->http->_post('starttime')) : array(0, 0);
            $timestop   = $this->DFE->http->_post('endtime') != "" ? explode(":", $this->DFE->http->_post('endtime')) : array(0, 0);

            $date_fh    = explode($GLOBALS['COUNTRY_SETTINGS']['date_seperator'], $GLOBALS['COUNTRY_SETTINGS']['datepicker_dateformat']);
            $daykey     = array_search("dd", $date_fh);
            $monthkey   = array_search("mm", $date_fh);
            $yearkey    = array_search("yy", $date_fh);

            $sd = explode($GLOBALS['COUNTRY_SETTINGS']['date_seperator'], $this->DFE->http->_post('startdate'));
            $ed = explode($GLOBALS['COUNTRY_SETTINGS']['date_seperator'], $this->DFE->http->_post('enddate'));

            $this->Start    = $this->DFE->http->_post('startdate') != "" ? mktime($timestart[0], $timestart[1], 0, $sd[$monthkey], $sd[$daykey], $sd[$yearkey]) : "";
            $this->Stop     = $this->DFE->http->_post('enddate') != "" ? mktime($timestop[0], $timestop[1], 0, $ed[$monthkey], $ed[$daykey], $ed[$yearkey]) : "";

            if ($this->Start > $this->Stop && $this->Start != "" && $this->Stop != "") {
                $this->Error['Validation'] = 1;
                $this->Error['Error_Text'] = 'Start und Ende bei der Zeitschaltung stimmen nicht!';
                return false;
            } else {
                return true;
            }
        } else {
            $this->Start  = "";
            $this->Stop   = "";
            return true;
        }
    }
    
    public function SaveUpdateContent() {
        # ScriptMethod
        if($this->DFE->http->issetPost('MC') === true && $this->DFE->http->_post('CType') != 'PHP') {
            foreach ($this->DFE->http->_post('MC') as $key => $val) {
                $script_method[$key] = $val;
            }
            $script_method = serialize($script_method);
        } else {
           $script_method = $this->DFE->http->_post('script_method'); 
           
           foreach ($this->DFE->http->_post('MC') as $key => $val) {
                $bodytext[$key] = $val;
            }
            $this->DFE->http->setPostbyName('bodytext', serialize($bodytext));
        }
        
        $this->DFE->db->TablePreName = $this->FB;
        if ($this->DFE->http->issetPost('action') === true) { # Inhalt wird bearbeitet
            $this->DFE->db->Select('sorting')
                          ->From('content')
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('cid'))
                          ->Andd("AND lang = :lang ")
                          ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                          ->doSelect();
            $position = $this->DFE->db->SelectPuffer['sorting'];

            if ($this->DFE->http->_post('lastsorting') == 0) {
                # Gleiche Stelle
                $sorting = $position;
            } else {
                # Über oder nach
                if ($this->DFE->http->_post('join') == "over") {
                    $sorting = $this->DFE->http->_post('lastsorting');
                } else {
                    $sorting = $this->DFE->http->_post('lastsorting') + 1;
                }

                # Sortierung updaten
                $this->DFE->db->Update('content')
                              ->WhereColName('pid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Set(array("sorting" => "sorting+1", "lastUpdated" => time()))
                              ->SetType(false)
                              ->Andd("AND sorting >= :sorting AND lang = :lang AND colP = :colp ")
                              ->Parameter(array('sorting' => $sorting, 'lang' => $GLOBALS['LANGUAGE'], 'colp' => $this->DFE->http->_post('colP')))
                              ->doUpdate();
            }

            # Contentname
            if ($this->DFE->http->isEmpty('content_name') === true) {
                $content_name = $this->DFE->http->_post('seite') . "_" . $sorting;
            } else {
                $content_name = $this->DFE->http->_post('content_name');
            }
            
            $bodytext = $this->DFE->http->issetPost('formInp') === true ? addslashes(serialize($this->DFE->http->_post('formInp'))) : addslashes($this->DFE->http->_post('bodytext'));
            
            $UpdateArray = array(   "sorting"               => $sorting,
                                    "lastUpdated"           => time(),
                                    "bodytext"              => $bodytext,
                                    "hidden"                => $this->DFE->http->_post('hidden'),
                                    "starttime"             => $this->Start,
                                    "endtime"               => $this->Stop,
                                    "headline"              => $this->DFE->http->_post('headline'),
                                    "subline"               => $this->DFE->http->_post('subline'),
                                    "script_method"         => $script_method,
                                    "script_path"           => $this->DFE->http->_post('script_path'),
                                    "content_name"          => addslashes($content_name),
                                    "author"                => $_SESSION['sess_username'],
                                    "lang"                  => $GLOBALS['LANGUAGE'],
                                    "perms_userid"          => $this->DFE->http->_post('perms_userid'),
                                    "perms_groupid"         => $this->DFE->http->_post('perms_groupid'),
                                    "perms_be_userid"       => $this->DFE->http->_post('perms_be_userid'),
                                    "perms_be_groupid"      => $this->DFE->http->_post('perms_be_groupid'));
            
            $this->UpdateContent($this->DFE->http->_post('cid'), $UpdateArray);
            
        } else { # Neuer Inhalt
            $this->DFE->db->Select('sorting')
                          ->From('content')
                          ->WhereColName('pid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Andd("AND lang = :lang AND colP = :colp ")
                          ->Parameter(array('lang' => $GLOBALS['LANGUAGE'], 'colp' => $this->DFE->http->_post('colP')))
                          ->SelectMethod(1)
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            if ($num) {
                if ($this->DFE->http->_post('join') == "over") {
                    $sorting = $this->DFE->http->_post('lastsorting');
                } else {
                    $sorting = $this->DFE->http->_post('lastsorting') + 1;
                }

                # Sortierung updaten
                $this->DFE->db->Update('content')
                              ->WhereColName('pid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Set(array("sorting" => "sorting+1", "lastUpdated" => time()))
                              ->SetType(false)
                              ->Andd("AND sorting >= :sorting AND lang = :lang AND colP = :colp ")
                              ->Parameter(array('sorting' => $sorting, 'lang' => $GLOBALS['LANGUAGE'], 'colp' => $this->DFE->http->_post('colP')))
                              ->doUpdate();
            } else {
                $sorting = 1;
            }

            # Contentname
            if ($this->DFE->http->isEmpty('content_name') === true) {
                $content_name = $this->DFE->http->_post('seite') . "_" . $sorting;
            } else {
                $content_name = $this->DFE->http->_post('content_name');
            }

            $bodytext = $this->DFE->http->issetPost('formInp') === true ? addslashes(serialize($this->DFE->http->_post('formInp'))) : addslashes($this->DFE->http->_post('bodytext'));
            
            # Daten speichern
            $InsertArray = array(   'uid'               => '',
                                    'pid'               => $this->DFE->http->_post('uid'),                     
                                    'tstamp'            => time(),                                            
                                    'lastUpdated'       => '',                                                
                                    'hidden'            => $this->DFE->http->_post('hidden'),                
                                    'sorting'           => $sorting,                                           
                                    'CType'             => $this->DFE->http->_post('CType'),                   
                                    'lang'              => $GLOBALS['LANGUAGE'],                               
                                    'bodytext'          => $bodytext,                                          
                                    'starttime'         => $this->Start,                                       
                                    'endtime'           => $this->Stop,                                        
                                    'headline'          => $this->DFE->http->_post('headline'),    
                                    'subline'           => $this->DFE->http->_post('subline'),     
                                    'script_method'     => $script_method,                         
                                    'script_path'       => $this->DFE->http->_post('script_path'),             
                                    'content_name'      => $content_name,                                      
                                    'author'            => $_SESSION['sess_username'],                        
                                    'colP'              => $this->DFE->http->_post('colP'),                    
                                    'vid'               => $this->DFE->http->_post('vid'),                     
                                    'perms_userid'      => $this->DFE->http->_post('perms_userid'),            
                                    'perms_groupid'     => $this->DFE->http->_post('perms_groupid'),           
                                    'perms_be_userid'   => $this->DFE->http->_post('perms_be_userid'),        
                                    'perms_be_groupid'  => $this->DFE->http->_post('perms_be_groupid'));       
            
            $this->AddContent($InsertArray);
            $this->DFE->http->setPostbyName('LastInsertID', $this->DFE->db->LastInsertID);
        }

        
    }
    
    public function Jump() {
        # Daten wurden gespeichert
        if ($this->DFE->http->issetPost('save_content_close') === true) {
            $jump = "?ac=ContentOverview&colP=" . $this->DFE->http->_post('colP') . "&uid=" . $this->DFE->http->_post('uid') . "&jid=" . $this->DFE->http->_post('jid');
            header("Location: " . $jump);
            exit;
        } else {
            header("Location: " . ARIBU_SYSTEMS_URL . $this->DFE->RequestURI . "?" . str_replace("&saved=ok", "", $_SERVER['QUERY_STRING']) . "&saved=ok");
            exit;
        }
    }
    
    public function UpdateContent($cid, array $UpdateArray) {
        $this->DFE->db->TablePreName = $this->FB;
        $this->DFE->db->Update('content')
                      ->WhereColName('uid')
                      ->WhereColValue($cid)
                      ->Set($UpdateArray)
                      ->doUpdate();
    }
    
    public function AddContent(array $InsertArray) {
        $this->DFE->db->TablePreName = $this->FB;
        $this->DFE->db->Insert('content')
                      ->Parameter($InsertArray)
                      ->doInsert();
    }

    public function GetContentData() {
        $this->DFE->db->TablePreName = $this->FB;
        if ($this->DFE->http->issetPost('colP') === true) {
            $and_colp = " AND cont.colP = " . $this->DFE->http->_post('colP') . " ";
        } else {
            $and_colp = " AND cont.colP = 0 ";
        }

        if ($this->DFE->http->issetPost('cid') === true) {
            $and_id = " AND cont.uid = " . $this->DFE->http->_post('cid') . " ";
        }

        if ($this->DFE->http->_post('action') == 'edit') {
            $this->LockContent();
            $this->DFE->db->Select( "cont.*, pages.nav_title")
                          ->From("content cont, " . $this->FB . $this->DFE->Pages . " pages")
                          ->WhereColName('cont.pid')
                          ->WhereColValue($this->DFE->http->_post('uid')) 
                          ->Andd("AND cont.pid = pages.uid " . $and_id . str_replace("%%%n%%%", "pages.", $this->DFE->and_lang))
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doSelect();
            $this->Num   = $this->DFE->db->Rows;
            if($this->Num) {
                $this->Row   = $this->DFE->db->SelectPuffer;
                
            }
            $this->DFE->TT->setMC('page',              stripslashes($this->Row['nav_title']))
                          ->setMC('headline_action',    $this->DFE->TT->getMC('_edit'));
        } else {
            $this->DFE->db->Select("pages.nav_title")
                          ->From("content cont, " . $this->FB . $this->DFE->Pages . " pages")
                          ->WhereColName('cont.pid')
                          ->WhereColValue($this->DFE->http->_post('uid')) 
                          ->Andd("AND cont.pid = pages.uid " . $and_id . str_replace("%%%n%%%", "pages.", $this->DFE->and_lang). $and_colp . " AND cont.lang = :contlang")
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE'], 'contlang' => $GLOBALS['LANGUAGE']) : array('contlang' => $GLOBALS['LANGUAGE']))
                          ->doSelect();
           
            $this->Num   = $this->DFE->db->Rows;
            if($this->Num) {
                $this->Row   = $this->DFE->db->SelectPuffer;
            }
            $this->DFE->TT->setMC('page', stripslashes($this->Row['nav_title']))
                          ->setMC('headline_action', $this->DFE->TT->getMC('_new'));
        }

        if (!$this->Num) {
            $this->DFE->db->Select('nav_title')
                          ->From($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            $this->DFE->TT->setMC('page', stripslashes($row['nav_title']));
            $this->DFE->TT->BlockMarker['put_in_place'] = 0;
        } else {
            $this->DFE->TT->BlockMarker['put_in_place'] = 0;
            if ($this->DFE->http->_post('action') == 'edit') {
                $this->LastUIDs = '<option value="0">' . $this->DFE->TT->getMC('_same_position') . '</option>';
                $this->DFE->TT->BlockMarker['put_in_place'] = 1;
            } else {
                $this->DFE->TT->BlockMarker['put_in_place'] = 0;
            }
            $this->SetSortingOptions();
        }
        $this->ContentData = unserialize($this->Row['script_method']);
    }
    
    public function SetSortingOptions() {
        $this->DFE->db->Select("*")
                      ->From("content")
                      ->WhereColName('pid')
                      ->WhereColValue($this->DFE->http->_post('uid'))
                      ->Andd("AND colP = :colp AND lang = :lang  ")
                      ->Order("ORDER BY sorting")
                      ->Parameter(array('colp' => $this->DFE->http->_post('colP'), 'lang' => $GLOBALS['LANGUAGE']))
                      ->SelectMethod(1)
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        $row = $this->DFE->db->SelectPuffer;
        for ($i = 0; $i < $num; $i++) {
            if ($this->DFE->http->_post('action') == 'edit') {
                if ($this->DFE->http->_post('sorting') != $row[$i]['sorting']) {
                    $lastuids .= '<option value="' . $row[$i]['sorting'] . '">' . $row[$i]['content_name'] . '</option>';
                }
            } else {
                $lastuids .= '<option value="' . $row[$i]['sorting'] . '">' . $row[$i]['content_name'] . '</option>';
            }
        }
        $this->LastUIDs .= $lastuids;
    }

    public function LockContent() {
        # Lock content
        $this->DFE->db->Select('*')
                      ->From('content_lock')
                      ->WhereColName('cid')
                      ->WhereColValue($this->DFE->http->_post('cid'))
                      ->Andd("AND colP = :colp ")
                      ->Parameter(array('colp' => $this->DFE->http->_post('colP')))
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        if (!$num) {
            $this->DFE->db->Insert('content_lock')
                          ->Parameter(array(    'cid'           => $this->DFE->http->_post('cid'), 
                                                'tstamp'        => time(), 
                                                'updater'       => $_SESSION['sess_username'], 
                                                'updater_id'    => $_SESSION['sess_uid'], 
                                                'colP'          => $this->DFE->http->_post('colP')))
                          ->doInsert();
        }
        $this->DFE->http->addQS('mode', 'unlock');
    }
    
    public function UnlockContent() {
        $this->DFE->db->Delete('content_lock')
                      ->WhereColName('cid')
                      ->WhereColValue($this->DFE->http->_post('cid'))
                      ->doDelete();
    }
    
    public function SetDatas() {
        $this->DFE->TT->setMC('col_p',              $GLOBALS['CONTENT_POSITION'][$this->DFE->http->_post('colP')])
                      ->setMC('cid',                $this->Row['uid'])                      
                      ->setMC('lang',               $_SESSION['sess_language'])                       
                      ->setMC('uid',                $this->DFE->http->_post('uid'))
                      ->setMC('path',               \lib\Functions::breadcrumb($this->DFE->http->_post('uid'), 'dot'.$this->FBup.'Menu'))
                      ->setMC('colp',               $this->DFE->http->_post('colP'))
                      ->setMC('backlink',           $this->DFE->http->addQS('ac', 'ContentOverview')->unsetQS('sorting')->unsetQS('action')->returnQS())
                      ->setMC('datepicker_lang',    $GLOBALS['COUNTRY_SETTINGS']['datepicker']);
    }
    
    /**
     * Timeset tab
     */
    public function SetTimesetTab() {
        # Timeset
        $TT = clone $this->DFE->TT;
        
        if ($this->Row['starttime'] != 0 || $this->Row['endtime'] != 0) {
            $GLOBALS['COUNTRY_SETTINGS']['dateformat'];
            $TT->setMC('starttime',     date("H:i", $this->Row['starttime']))
               ->setMC('endtime',       date("H:i", $this->Row['endtime']))
               ->setMC('startdate',     strftime($GLOBALS['COUNTRY_SETTINGS']['dateformat'], $this->Row['starttime']))
               ->setMC('enddate',       strftime($GLOBALS['COUNTRY_SETTINGS']['dateformat'], $this->Row['endtime']))
               ->setMC('timeset1',      'checked="checked"')
               ->setMC('timeset0',      '');
        } else {
            $TT->setMC('timeset1', '')
               ->setMC('timeset0', 'checked="checked"');
        }
        
        foreach($this->be_language as $key => $val) {
            $TT->setMC($key, $val);               
        }
        
        # Set timeset tab content
        $this->DFE->TT->setMC('timeset_tab_content', $TT->getFilledTemplate('/aribu.systems/_templates/content_module/tabs/timeset_tab_content.html'));
    }
    
    /**
     * Block Tab
     */
    public function SetBlockTab() {
        $TT = clone $this->DFE->TT;
        
        # Status
        if ($this->Row['hidden'] == 0) {
            $TT->setMC('status0', 'checked="checked"');
        } elseif ($this->Row['hidden'] == 1) {
            $TT->setMC('status1', 'checked="checked"');
        } else {
            $TT->setMC('status1', 'checked="checked"');
        }       

        if ($this->ContentData['show_on_detail'] == 0) {
            $TT->setMC('show_on_detail0', 'checked="checked"');
        } elseif ($this->ContentData['show_on_detail'] == 1) {
            $TT->setMC('show_on_detail1', 'checked="checked"');
        } else {
            $TT->setMC('show_on_detail1', 'checked="checked"');
        }

        $block_position_options = '<option style="height:22px;"></option>';
        foreach ($GLOBALS['CONTENT_MOD_TXTI_DESC_POSITION'] as $key => $val) {
            $selected = $this->ContentData['block_position'] == $key ? " selected" : "";
            $block_position_options .= '<option value="' . $key . '"' . $selected . ' style="background: url(/aribu.systems/fileadmin/img/icons/content/block_position/' . $key . '.gif) no-repeat 4px 4px; height:26px; padding-left:28px; padding-top:8px">' . $val . '</option>';
        }

        $border_options = '<option style="height:22px;"></option>';
        foreach ($GLOBALS['CONTENT_MOD_BORDER'] as $key => $val) {
            $selected = $this->ContentData['border'] == $key ? " selected" : "";
            $border_options .= '<option value="' . $key . '"' . $selected . ' style="background: url(/aribu.systems/fileadmin/img/icons/content/border/' . $key . '.gif) no-repeat 4px 4px; height:26px; padding-left:28px; padding-top:8px">' . $val . '</option>';
        }

        $border_style_options = '<option style="height:22px;"></option>';
        foreach ($GLOBALS['CONTENT_MOD_BORDERFORM'] as $key => $val) {
            $selected = $this->ContentData['border_style'] == $key ? " selected" : "";
            $border_style_options .= '<option value="' . $key . '"' . $selected . ' style="background: url(/aribu.systems/fileadmin/img/icons/content/borderform/' . $key . '.gif) no-repeat 4px 4px; height:26px; padding-left:68px; padding-top:8px">' . $val . '</option>';
        }

        $image_direction_options = '<option style="height:22px;"></option>';
        foreach ($GLOBALS['CONTENT_MOD_IMAGES_DIRECTION'] as $key => $val) {
            $selected = $this->ContentData['image_direction'] == $key ? " selected" : "";
            $image_direction_options .= '<option value="' . $key . '"' . $selected . '>' . $val . '</option>';
        }

        
        
        $TT->setMC('content_name',              htmlentities(stripslashes($this->Row['content_name']), ENT_QUOTES, "UTF-8"))
           ->setMC('block_position_options',    $block_position_options)
           ->setMC('border_options',            $border_options)
           ->setMC('border_style_options',      $border_style_options)
           ->setMC('image_direction_options',   $image_direction_options)
           ->setMC('zoom1',                     $this->ContentData['zoom'] == 1 ? 'checked="checked"' : '')
           ->setMC('zoom_lightbox1',            $this->ContentData['zoom_lightbox'] == 1 ? 'checked="checked"' : '') 
           ->setMC('border_color',              $this->ContentData['border_color']) 
           ->setMC('border_width',              $this->ContentData['border_width'])
           ->setMC('block_width',               $this->ContentData['block_width']) 
           ->setMC('block_height',              $this->ContentData['block_height'])
           ->setMC('block_padding',             $this->ContentData['block_padding'])
           ->setMC('block_margin',              $this->ContentData['block_margin'])
           ->setMC('block_class',               $this->ContentData['block_class'])
           ->setMC('block_id',                  $this->ContentData['block_id'])
           ->setMC('lastuids',                  $this->LastUIDs);   
        
        $TT->BlockMarker['put_in_place'] = $this->Num === false || $this->Num === 0 ? $this->DFE->TT->BlockMarker['put_in_place'] : 1;
        
        foreach($this->be_language as $key => $val) {
            $TT->setMC($key, $val);               
        }
        
        # Set block tab content
        $this->DFE->TT->setMC('block_tab_content', $TT->getFilledTemplate('/aribu.systems/_templates/content_module/tabs/block_tab_content.html'));
    }
    
    public function SetContentRightsTab() {
        $TT = clone $this->DFE->TT;
        
        # Content Rechte
        foreach ($GLOBALS['FE_USER_RIGHTS'] as $key => $val) {
            $selected = $this->Row['perms_groupid'] == $key ? "selected" : "";
            $perms_groupid_option .= "<option value=\"" . $key . "\" " . $selected . ">" . $val . "</option>";
        }

        # Seiten-Rechte BE-User
        $this->DFE->db->TablePreName = "be_";
        $this->DFE->db->Get('user_groups');
        $num = $this->DFE->db->Rows;
        $row = $this->DFE->db->SelectPuffer;
        for ($i = 0; $i < $num; $i++) {
            $selected = $this->Row['perms_be_groupid'] == $row[$i]['id'] ? " selected" : "";
            $perms_be_groupid_option .= "<option value=\"" . $row[$i]['id'] . "\"" . $selected . ">" . $row[$i]['name'] . "</option>";
        }

        $this->DFE->db->Get('user');
        $num = $this->DFE->db->Rows;
        $row = $this->DFE->db->SelectPuffer;
        for ($i = 0; $i < $num; $i++) {
            $selected = $this->Row['perms_be_userid'] == $row[$i]['uid'] ? " selected" : "";
            $perms_be_userid_option .= "<option value=\"" . $row[$i]['uid'] . "\"" . $selected . ">" . $row[$i]['full_name'] . "</option>";
        }
        $this->DFE->db->TablePreName = $this->FB;
        
        $TT->setMC('perms_groupid_option',      $perms_groupid_option)
           ->setMC('perms_be_groupid_option',   $perms_be_groupid_option)
           ->setMC('perms_be_userid_option',    $perms_be_userid_option);
        
        foreach($this->be_language as $key => $val) {
            $TT->setMC($key, $val);               
        }
        
        # Set content right tab
        $this->DFE->TT->setMC('cright_tab_content', $TT->getFilledTemplate('/aribu.systems/_templates/content_module/tabs/cright_tab_content.html'));
    }
    
    public function ModulRights() {
        # Modul rights
        if ($this->DFE->http->_post('action') == 'edit') {
            if ($_SESSION['username'] == $this->Row['author'] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][24] == 1 || $_SESSION['BE_Rights'] == 1) {
                $be_rights = "";
            } else {
                $be_rights = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_edit_content'].'"';
            }
        } else {
            if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][23] == 1 || $_SESSION['BE_Rights'] == 1) {
                $be_rights = "";
            } else {
                $be_rights = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_edit_content'].'"';
            }
        }
        $this->DFE->TT->setMC('be_rights', $be_rights);
    }
    
    
    public function dmethod() {        
    }
}