<?php

namespace aribu\scripts\content_module\menu\lib;

/* 
 * aribu.systems 6.0
 * aribu.systems is registered and licensed under our definitions.

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   24.04.2016
 *  
 */

class menu extends \aribu\scripts\content_module\content_module {
    
    /**
     * Be language array
     * @var array
     */
    public $BeLanguage = array();


    public function __construct($DFE) {
        parent::__construct($DFE);
    }
    
     /**
     * Menu
     * @param int $error
     * @param type $CType
     * @param type $CHead
     * @param type $bodytext
     * @return type
     */
    public function menu($error = '', $CType = '', $CHead = '', $bodytext = '') {
        
        require_once FE_MENU;
            
        $this->GetContentData();
        $this->SetDatas();
        $this->SetTimesetTab();
        $this->SetBlockTab();
        $this->SetContentRightsTab();
        $this->ModulRights();

        $block_data = unserialize($this->Row['script_method']);
        if (is_array($block_data)) {
            foreach ($block_data as $key => $val) {
                ${$key} = stripslashes($val);
                $this->DFE->TT->setMC($key, $val);
            }
        }
                    
        if ($block_data['show_on_detail'] == 0) {
            $show_on_detail0 = "checked";
        } elseif ($block_data['show_on_detail'] == 1) {
            $show_on_detail1 = "checked";
        } else {
            $show_on_detail0 = "checked";
        }

        # Menü Type
        foreach ($GLOBALS['MENU_TYPES'] as $key => $val) {
            $selected = $block_data['Type'] == $key ? " selected" : "";
            $menutyps .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
        }

        # Text Attribute64 (von Seiten)
        foreach ($GLOBALS['MENU_TEXT_ATTRIBUTES'] as $key => $val) {
            $selected = $block_data['NameAttributes64'] == $key ? " selected" : "";
            $menuattributes64 .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
        }

        # Text Attribute256 (von Block-Überschriften)
        foreach ($GLOBALS['MENU_TEXT_ATTRIBUTES'] as $key => $val) {
            $selected = $block_data['NameAttributes256'] == $key ? " selected" : "";
            $menuattributes256 .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
        }

        # Menü-Umfließung
        foreach ($GLOBALS['MENU_PRELINK_TAG'] as $key => $val) {
            $selected = $block_data['PreLinkTags'] == $key ? " selected" : "";
            $menu_prelink_tags .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
        }

        # BE Doc-Types
        foreach ($GLOBALS['BE_DOCTYPES_NAMES'] as $key => $val) {
            $selected = $block_data['docType'] == $key ? " selected" : "";
            $doctype .= "<option value=\"" . $key . "\"" . $selected . ">" . $val . "</option>\n";
        }
        
        $ctype = "MENU";
        
        
        $select_filedoc_no = $FileDoc == 'no' ? "selected" : "";
        $select_filedoc_yes = $FileDoc == 'yes' ? "selected" : "";
        $Wrap = htmlspecialchars($Wrap);
        $omo1 = $OnMouseOver == 1 ? "checked" : "";
        $omo0 = $OnMouseOver != 1 ? "checked" : "";
        $mo1 = $MenuOpen == 1 ? "checked" : "";
        $mo0 = $MenuOpen != 1 ? "checked" : "";
        $sm1 = $Sitemap == 1 ? "checked" : "";
        $sm0 = $Sitemap != 1 ? "checked" : "";
        $mo = "HMenu" == $Type ? "" : "display:none;";
        if ($Level == '0') {
            $root = "selected";
        }

        $this->DFE->TT->BlockMarker['freeze_level'] = $Level == 'x' ? 1 : 0;

        $menu_level = \lib\Functions::breadcrumb($Level);
        $menu_level = $Level > 0 ? '<option value="' . $Level . '" selected="selected" style="padding-left:4px">' . $menu_level . '</option>' : '';

        $this->DFE->TT->setMC('show_on_detail0', $show_on_detail0)
                      ->setMC('show_on_detail1', $show_on_detail1)
                      ->setMC('menutyps', $menutyps)
                      ->setMC('menuattributes64', $menuattributes64)
                      ->setMC('menuattributes256', $menuattributes256)
                      ->setMC('menu_prelink_tags', $menu_prelink_tags)
                      ->setMC('doctype', $doctype)
                      ->setMC('select_filedoc_no', $select_filedoc_no)
                      ->setMC('select_filedoc_yes', $select_filedoc_yes)
                      ->setMC('Wrap', $Wrap)
                      ->setMC('omo1', $omo1)
                      ->setMC('omo0', $omo0)
                      ->setMC('mo1', $mo1)
                      ->setMC('mo0', $mo0)
                      ->setMC('sm1', $sm1)
                      ->setMC('sm0', $sm0)
                      ->setMC('mo', $mo)
                      ->setMC('root', $root)
                      ->setMC('menu_level', $menu_level);
        
        return $this->DFE->TT->getFilledTemplate("/aribu.systems/_templates/content_module/menu/menu.html");    
        
    }
    
}