<?php

namespace aribu\scripts\content_module\txti\lib;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   04.04.2016
 * @update: 22.04.2016
 */


class txti extends \aribu\scripts\content_module\content_module {

    
    function __construct($DFE) {
        parent::__construct($DFE);
    }

    /**
     * Text with image block
     * @return string
     */
    function txti() {
        
        require_once FE_MENU;

        $this->GetContentData();
        $this->SetDatas();
        $this->SetTimesetTab();
        $this->SetBlockTab();
        $this->SetContentRightsTab();
        $this->ModulRights();
        
        # WYSIWYG Editor
        $WGE = new \aribu\scripts\editor\lib\WYSIWYG($this->DFE);
        $WGE->Language = $GLOBALS['LANGUAGE'];
        $WGE->Session = $_SESSION['sess_id'];
        $WGE->Editor_Name = "bodytext";

        # Bilder holen
        if ($this->DFE->http->issetPost('action') === true && $this->DFE->http->_post('action') == 'edit') {
            $thumbs = "";
            $thumbs_info = "";
            $this->DFE->db->Select('*')
                          ->From('content_media')
                          ->WhereColName('cid')
                          ->WhereColValue($this->DFE->http->_post('cid'))
                          ->Andd("AND lang = :lang ")
                          ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                          ->SelectMethod(1)
                          ->doSelect();
            $numm = $this->DFE->db->Rows;
            if ($numm) {
                $rowm = $this->DFE->db->SelectPuffer;
                for ($i = 0; $i < $numm; $i++) {
                    $img = \lib\Functions::updatePagename($rowm[$i]['file']);
                    $thumbs .= '<div style="float:left; margin-right:8px; margin-top:10px; padding:2px; border:1px solid #cccccc; cursor:pointer;"><a href="javascript: void(0);" onclick="javascript: fillInfos(\'' . $img . '\');"><img src="' . $rowm[$i]['file'] . '" border="0" height="40" class="thumbinfo" /></a></div>';

                    $thumbs_info .= '<div class="' . $img . '">';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][id]" value="' . $rowm[$i]['id'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][title]" value="' . $rowm[$i]['title'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][alt]" value="' . $rowm[$i]['alt'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][headline]" value="' . $rowm[$i]['headline'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][description]" value="' . $rowm[$i]['description'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][description_position]" value="' . $rowm[$i]['description_position'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][width]" value="' . $rowm[$i]['width'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][height]" value="' . $rowm[$i]['height'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][url]" value="' . $rowm[$i]['url'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][padding]" value="' . $rowm[$i]['padding'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][margin]" value="' . $rowm[$i]['margin'] . '" type="hidden" />';
                    $thumbs_info .= '<input name="IMGINFO[' . $img . '][css]" value="' . $rowm[$i]['css'] . '" type="hidden" />';
                    $thumbs_info .= '</div>';

                    $cimg_options .= '<option value="' . $rowm[$i]['file'] . '" selected="selected">' . $rowm[$i]['file'] . '</option>';
                }
            }
        }
        
                
        $this->DFE->TT->setMC('wysiwyg_tiny_editor_js',     $WGE->getTinyEditorJS())
                      ->setMC('cimg_options',               $cimg_options)
                      ->setMC('display_textblock_width',    $this->ContentData['position'] == 7 || $this->ContentData['position'] == 8 ? "" : "display:none;")
                      ->setMC('display_imgblock_width',     $this->ContentData['position'] == 7 || $this->ContentData['position'] == 8 ? "" : "display:none;")
                      ->setMC('textblock_width',            htmlentities(stripslashes($this->ContentData['textblock_width'])))
                      ->setMC('imgblock_width',             htmlentities(stripslashes($this->ContentData['imgblock_width'])))
                      ->setMC('zoom1',                      $this->ContentData['zoom'] == 1 ? "checked" : "")
                      ->setMC('zoom_lightbox1',             $this->ContentData['zoom_lightbox'] == 1 ? "checked" : "")
                      ->setMC('background_image1',          $this->ContentData['background_image'] == 1 ? "checked" : "")
                      ->setMC('background_position',        $this->ContentData['background_position'])
                      ->setMC('background_repeat',          $this->ContentData['background_repeat'])
                      ->setMC('upload_link',                \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['UploadFiles'], $GLOBALS['LANGUAGE']))
                      ->setMC('content',                    htmlentities(stripslashes($this->Row['bodytext']), ENT_QUOTES, 'UTF-8'))
                      ->setMC('headline',                   htmlentities($this->Row['headline'], ENT_QUOTES, "UTF-8"))
                      ->setMC('subline',                    htmlentities($this->Row['subline'], ENT_QUOTES, "UTF-8"))
                      ->setMC('thumbs_info',                $thumbs_info)
                      ->setMC('thumbs',                     $thumbs)
                      ->setMC('image_direction_options',    \lib\Functions::getOptions($GLOBALS['CONTENT_MOD_IMAGES_DIRECTION'], $this->ContentData['image_direction']))
                      ->setMC('headline_direction_options', \lib\Functions::getOptions($GLOBALS['CONTENT_MOD_TXTI_HEADLINES_DIRECTION'], $this->ContentData['headline_direction']))
                      ->setMC('image_positions_options',    \lib\Functions::getOptions($GLOBALS['CONTENT_MOD_TXTI_POSITION'], $this->ContentData['position']), ' style="background: url(/aribu.systems/fileadmin/img/icons/content/txti/###key###.gif) no-repeat 4px 4px; height:26px; padding-left:28px; padding-top:8px"');
        
        $this->DFE->TT->BlockMarker['background_image'] = $this->ContentData['background_image'] == 1 ? 1 : 0;
        
        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/content_module/txti/txti.html');
        
    }
    
    public function SaveUpdateContent() {
        parent::SaveUpdateContent();
        
        $cid = $this->DFE->http->issetPost('LastInsertID') === true ? $this->DFE->http->_post('LastInsertID') : $this->DFE->http->_post('cid');
        
        # Bilder löschen
        $this->DFE->db->Delete('content_media')
                      ->WhereColName('cid')
                      ->WhereColValue($cid)
                      ->doDelete();
        
        # Erweiterung für die Bilder
        if ($this->DFE->http->issetPost('mediafile') === true && $this->DFE->http->isArray('mediafile') === true) {
            foreach ($this->DFE->http->_post('mediafile') as $mkey => $mval) {
                $size = filesize(DOC_ROOT . $mval);
                $size_e = $this->size_hum_read($size);

                $type = explode(".", $mval);
                $name = \lib\Functions::updatePagename($mval);
                $imginfo = $this->DFE->http->_post('IMGINFO');
                $this->DFE->db->Insert('content_media')
                              ->Parameter(array("cid"                   => $cid,                                           
                                                "file"                  => $mval,                                          
                                                "size"                  => $size_e,                                      
                                                "type"                  => end($type),                                   
                                                "title"                 => $imginfo[$name]['title'],         
                                                "alt"                   => $imginfo[$name]['alt'],             
                                                "headline"              => $imginfo[$name]['headline'],     
                                                "description"           => $imginfo[$name]['description'],     
                                                "description_position"  => $imginfo[$name]['description_position'],        
                                                "sorting"               => ($mkey + 1),                                    
                                                "width"                 => $imginfo[$name]['width'],                       
                                                "height"                => $imginfo[$name]['height'],                      
                                                "url"                   => $imginfo[$name]['url'],                         
                                                "lang"                  => $GLOBALS['LANGUAGE'],                           
                                                "padding"               => $imginfo[$name]['padding'],                     
                                                "margin"                => $imginfo[$name]['margin'],                      
                                                "css"                   => $imginfo[$name]['css']))
                              ->doInsert();
            }
        } 
    }

    /*
     * Get tree files array
     *
     */

    function getFileTreeArray($dir) {
        static $level = 0;
        $fp = opendir($dir);
        while ($datei = readdir($fp)) {
            if (is_dir("$dir/$datei") && $datei != "." && $datei != "..") {
                $level++;
                if ($tmp = $this->getFileTreeArray($dir . "/" . $datei)) {
                    $tree_arr[$datei] = $tmp;
                    $tree_arr2[$datei . "-"] = $tmp;
                } else {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                    $tree_arr2[] = $datei;
                }
                $level--;
            } else {
                if ($datei != "." && $datei != "..") {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                    $tree_arr2[] = $datei;
                }
            }
        }
        closedir($fp);

        return $tree_arr;
    }

    
    /*
     * Convert image name
     *
     */

    function convertIMGName() {
        return \lib\Functions::updatePagename($_POST['img']);
    }

    /*
     * Plugin Image Infos
     *
     */

    function pluginImageInfos($template='/aribu.systems/_templates/content_module/txti/plugin_ImageInfos.html') {
        
        # Language packages
        require_once($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems/scripts/content/lang/" . $_SESSION['sess_language'] . ".php");
        
        $this->PrepareLanguage($be_language);
        
        $Pages = new \aribu\scripts\pages\lib\Pages($this->DFE);
        if ($this->DFE->http->issetPost('display') === true) {
            $linktr = $Pages->FileBrowser("/dot.orange/_templates/pages/inlineAllBrowser.html");
        }

        $img = \lib\Functions::updatePagename($this->DFE->http->_post('img'));
        $img_info = $this->DFE->http->_post('IMGINFO');
        if (isset($img_info[$img])) {
            foreach ($img_info[$img] as $key => $val) {
                ${$key} = $val;
                $this->DFE->TT->setMC($key, $val);
            }
        }

                
        $this->DFE->TT->setMC('linktr',                 $linktr)
                      ->setMC('lang',                   $GLOBALS['LANGUAGE'])
                      ->setMC('desc_position_options',  \lib\Functions::getOptions($GLOBALS['CONTENT_MOD_TXTI_DESC_POSITION'], $description_position))
                      ->setMC('img',                    $img);
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    function real_filesize_linux($file) {
        exec("filesize $file", $out, $ret);
        if ($ret <> '0') {
            return FALSE;
        } else {
            return $out[0];
        }
    }

    function size_hum_read($size) {
        $i = 0;
        $iec = array("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB");
        while (($size / 1024) > 1) {
            $size = $size / 1024;
            $i++;
        }
        return substr($size, 0, strpos($size, '.') + 3) . " " . $iec[$i];
    }

}