<?php

namespace aribu\scripts\documents\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   16.03.2016
 *  
 */

class Documents {
    
    public $Num;
    public $Row;
    public $UpdateID;

    /**
     * DFE object
     * @var object
     */
    public $DFE;

    public function __construct($DFE) {
        $this->DFE = $DFE;
        $this->DFE->db->TablePreName = '';
    }
    
    public function CheckDocumentsByID($id, $i=0, $type) {
        $this->DFE->db->Select("dm.*, d.*")
                      ->From("dms_map dm")
                      ->noWhere(1)
                      ->Andd("LEFT JOIN dms d ON dm.fid = d.id WHERE dm.type_id = :type_id AND dm.type = :type ")
                      ->Parameter(array('type_id' => $id, 'type' => $type))
                      ->SelectMethod(1)
                      ->doSelect();
        $this->Num = $this->DFE->db->Rows;
        if($this->Num) {
            $this->Row = $this->DFE->db->SelectPuffer;
            $this->DFE->TT->setIBM($i, 'is_document', 1);
            $this->DFE->TT->setIMC($i, 'num_docs', $this->Num);
            return true;
        } else {
            $this->DFE->TT->setIBM($i, 'is_document', 0);
            return false;
        }
    }
    
    public function CheckDocumentsAjaxByID($flag=1) {
        $id = $this->DFE->http->issetPost('aid') === true ? $this->DFE->http->_post('aid') : $this->DFE->http->_post('id'); 
        $and = $this->DFE->http->issetPost('cms_type') === true ? " AND (d.name NOT LIKE '%Drittanbieter%' AND d.name NOT LIKE '%Angebot:%') " : "";
        $this->DFE->db->Select("dm.*, d.*")
                      ->From("dms_map dm")
                      ->noWhere(1)
                      ->Andd("LEFT JOIN fe_dms d ON dm.fid = d.id WHERE dm.type_id = :type_id AND dm.type = :type ".$and)
                      ->SelectMethod(1)
                      ->Parameter(array('type_id' => $id, 'type' => $this->DFE->http->_post('type')))
                      ->doSelect();
        $this->Num = $this->DFE->db->Rows;
        if($this->Num) {
            $this->Row = $this->DFE->db->SelectPuffer;
            $documents = $this->GetAjaxDocuments($flag);
        } 
        $this->DFE->db->TablePreName = 'be_';
        if($flag != 1) {
            return $documents;
        }
        
    }
    
    public function GetAjaxDocuments($flag) {
        $documents = '<ul class="documents files" role="presentation">';
        $row = $this->Row;
        for($i=0; $i<$this->Num; $i++) {
            $image_doc_tag = '';
            if($row[$i]['type_name'] == 'mail') {
                $type = 'mail';
            } else {
                $type = explode(".", $row[$i]['name']);
                $type = end($type);
                $type = strtolower($type);
            }
            
            if($row[$i]['type_name'] == '') {
                $class = ' fc-red';
            } else {
                $class = ' inverse';
            }
            
            $documents_name = '<div class="documents-name">'.$row[$i]['name'].'</div>';
            $delete = $flag == 1 ? '<a href="javascript:void(0);" class="doc-delete-icon" onclick="javascript: DeleteDocument(\''.$row[$i]['id'].'\', \''.$row[$i]['type_id'].'\')"><span class="glyphicon glyphicon-trash'.$class.'"></span></a>' : '';
            $check  = $flag != 1 ? '<div class="checkbox checkbox-primary"><input type="checkbox" name="documents[]" value="'.$row[$i]['id'].'" ><label></label></div>' : '';
            $buttonpanel = '<div class="document-button-panel">'.$delete.$check.'</div>';
            if($type == 'pdf') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><a href="javascript:void(0);" onclick="javascript: window.open(\''.$row[$i]['file_path'].$row[$i]['name'].'\', \'_blank\', \'toolbar=0,location=0,menubar=0\');"><i class="fa fa-file-pdf-o'.$class.'"></i>'.$documents_name.'</a></div>';
            } elseif($type == 'doc' || $type == 'docx') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-word-o'.$class.'"></i>'.$documents_name.'</div>';
            } elseif($type == 'jpg' || $type == 'jpeg' || $type == 'gif' || $type == 'png' || $type == 'bmp') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><a href="'.$row[$i]['file_path'].$row[$i]['name'].'" target="_blank"><i class="fa fa-file-image-o'.$class.'"></i>'.$documents_name.'</a></div>';
            } elseif($type == 'txt' || $type == 'rtf') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-text-o'.$class.'"></i>'.$documents_name.'</div>';
            } elseif($type == 'ppt' || $type == 'pptx') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-powerpoint-o'.$class.'"></i>'.$documents_name.'</div>';
            } elseif($type == 'xls' || $type == 'xlsx') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-excel-o'.$class.'"></i>'.$documents_name.'</div>';
            } elseif($type == 'zip' || $type == 'rar' || $type == 'tar' || $type == 'gz') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-archive-o'.$class.'"></i>'.$documents_name.'</div>';
            } elseif($type == 'mail') {
                if($this->DFE->http->issetPost('cms_type') === false) {
                    $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><a href="javascript:void(0);" onclick="javascript: window.open(\'/aribu.systems'. \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['DocumentViewMail'], $GLOBALS['LANGUAGE']) .'?file_id='.$row[$i]['id'].'\', \'_blank\', \'toolbar=0,location=0,menubar=0\');"><i class="fa fa-envelope-o'.$class.'"></i>'.$documents_name.'</a></div>';
                } else {
                    $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><a href="javascript:void(0);" onclick="javascript: window.open(\'/system/email?file_id='.$row[$i]['id'].'\', \'_blank\', \'toolbar=0,location=0,menubar=0\');"><i class="fa fa-envelope-o'.$class.'"></i>'.$documents_name.'</a></div>';
                }
            } else {
                
            }
            $documents .= $row[$i]['name'] != '' ? '<li class="cols-xs-12 col-sm-3 col-md-3 col-lg-3 f'.$row[$i]['id'].'"><div class="outer"><span class="vmiddle"></span>'.$image_doc_tag.$buttonpanel.'</div></li>' : '';
        }
        $documents .= '</ul>';
        if($flag==1) {
            echo $documents;
        } else {
            return $documents;
        }
    }
    
    public function GetDocumentValue($id, $return) {
        $this->DFE->db->Get('dms', 'id', $id);
        $this->Num = $this->DFE->db->Rows;
        if($this->Num) {
            return $this->DFE->db->SelectPuffer[$return]; 
        } else {
            return '';
        }
    }
    
    public function GetDocumentValueByTag($id, $return) {
        $this->DFE->db->Get('dms', 'fid', $id);
        $this->Num = $this->DFE->db->Rows;
        if($this->Num) {
            return $this->DFE->db->SelectPuffer[$return]; 
        } else {
            return '';
        }
    }
    
    public function GetDocumentValueByTagAndType($id, $return, $type_title) {
        $this->DFE->db->Select("*")
                      ->From("dms")
                      ->WhereColName('fid')
                      ->WhereColValue($id)
                      ->Andd("AND type_title LIKE '%".$type_title."%' ")
                      ->doSelect();
        $this->Num = $this->DFE->db->Rows;
        if($this->Num) {
            return $this->DFE->db->SelectPuffer[$return]; 
        } else {
            return '';
        }
    }
    
    public function DeleteDocument($fid='', $type_id='') {
        $fid = $fid != '' ? $fid : $this->DFE->http->_post('fid');
        $type_id = $type_id != '' ? $type_id : $this->DFE->http->_post('type_id');
              
        $file_name = $this->GetDocumentValue($fid, 'name');
        $file_path = $this->GetDocumentValue($fid, 'file_path');
        @unlink(DOC_ROOT.$file_path.$file_name);
        
        # Delete
        if($fid != '') {
            $this->DFE->db->Delete('dms')
                          ->WhereColName('id')
                          ->WhereColValue(intval($fid))
                          ->doDelete();
            $this->DFE->db->Delete('dms_map')
                          ->WhereColName('fid')
                          ->WhereColValue(intval($fid))
                          ->Andd("AND type_id = :type_id ")
                          ->Parameter(array('type_id' => $type_id))
                          ->doDelete();
        }
        
    }
    
    public function DeleteInvoiceDocument($fid) {
        $this->DFE->db->Select("*")
                      ->From("dms")
                      ->WhereColName("tags")
                      ->WhereColValue($fid)
                      ->Andd("AND type_title = 'Rechnung'")
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        if($num) {
            $this->DeleteDocument($this->DFE->db->SelectPuffer['id'], $fid);
        }
    }
    
    public function GetDocumentsModalTemplate($TT, $type='fe_uf_auftrag', $cms_type='be') {
                
        $TT->setMC('upload_url', $cms_type == 'be' ? '/aribu.systems'. \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['UploadFiles'], $GLOBALS['LANGUAGE']) .'?ac=FileUpload&dir=/fileadmin/dms/'.$type.'/'.date('Y', CURRENT_TIME).'/'.date('m', CURRENT_TIME).'/' : '')
           ->setMC('type', $type)
           ->setMC('lang', $GLOBALS['LANGUAGE'])
           ->setMC('cms_type', $cms_type == 'be' ? '' : '&cms_type=fe');
        $TT->BlockMarker['upload_button'] = $cms_type == 'be' ? 1 : 0;
        $TT->BlockMarker['is_js'] = $cms_type == 'be' ? 1 : 0;
        return $TT->getFilledTemplate('/aribu.systems/_templates/documents/documents-modal.html');
    }
    
    public function GetDocumentPathByID($id) {
       $this->DFE->db->Select("name, file_path")
                     ->From("dms")
                     ->WhereColName("id")
                     ->WhereColValue($id)
                     ->doSelect();
       return array($this->DFE->db->SelectPuffer['name'], $this->DFE->db->SelectPuffer['file_path'].$this->DFE->db->SelectPuffer['name']);
    }
    
    public function SaveDocument(array $DocumentArray) {
        $this->DFE->db->Insert('dms')
                      ->Parameter($DocumentArray)
                      ->doInsert();
        return $this->DFE->db->LastInsertID;
    }
    
    public function SaveDocumentMap(array $DocumentMapArray) {
        $this->DFE->db->Insert('dms_map')
                      ->Parameter($DocumentMapArray)
                      ->doInsert();
    }
    
    public function CheckDuplicate($id, $name, $dms_map_type) { 
       $and = $type_title != '' ? "" : "";
       $this->DFE->db->Select("d.id, d.name")
                     ->From("dms d")
                     ->noWhere(1)
                     ->Andd("LEFT JOIN dms_map dm ON d.id = dm.fid WHERE d.name = '".$name."' AND dm.type_id = '".$id."' AND dm.type = '".$dms_map_type."' ")
                     ->doSelect();
       $this->UpdateID = $this->DFE->db->SelectPuffer['id'];
       return $this->DFE->db->Rows;
    }
    
    public function SaveDocuments($id, $name, $file_path, $type_name, $type_title, $type_dms_map, $file='', $update=false, $NoCheck=false) {
        
        if($this->CheckDuplicate($id, $name, $type_dms_map) < 1 || $NoCheck === true) { 
            $DocumentArray = array( 'id'            => '',                             
                                    'uid'           => '',                             
                                    'name'          => $name,                          
                                    'file_date'     => 'NOW()',                        
                                    'file_path'     => $file_path,                     
                                    'file'          => $file,                          
                                    'type_name'     => $type_name,                     
                                    'type_title'    => $type_title,                    
                                    'fid'           => $id,                            
                                    'be_uid'        => $_SESSION['sess_user_id']);     
            $LastInsertID = $this->SaveDocument($DocumentArray);

            $DocumentMapArray = array(  'fid'       => $LastInsertID,
                                        'type_id'   => $id,
                                        'type'      => $type_dms_map,
                                        'client_id' => $GLOBALS['CLIENT_ID'],
                                        'rights_id' => '');
            $this->SaveDocumentMap($DocumentMapArray);
        } else {
            if($update === true) {
                $this->DFE->db->Update('dms')
                              ->WhereColName('id')
                              ->WhereColValue($this->UpdateID)
                              ->Set(array(  'file_date' => date('Y-m-d H:i:s', CURRENT_TIME), 
                                            'file_path' => $file_path))
                              ->doUpdate();
            }
        }
    }
    
    public function __destruct() {
        $this->DFE->db->TablePreName = 'fe_';
    }
}