<?php

namespace aribu\scripts\editor\lib;

/*
  This file is the BE-Extension Class WYSIWYG Editor.

  This file is a part of the dot.orange CMS 2005-2013.
  copyrights by it.orange (c).

  Author: Sascha Momcilovic
  E-Mail: info@it-orange.de
  www: http://www.it-orange.de
  Date: 18.04.2013
 */

class WYSIWYG extends \aribu\scripts\abstracts\Abstracts {

    public $Language = "";
    public $Session;
    public $Editor_Title;
    public $Editor_Content;
    public $Editor_Name;
    public $Editor_Function_Name;
    public $Editor_JS_Function;
    public $Editor_Main_Script = 1;
    public $Editor_Toogle_ID;
    public $Editor_Plugin = '';
    public $AutoStart = true;
    public $TTT;

    public function __construct($DFE) {
        parent::__construct($DFE);
        
        # Template Class
        $this->TTT = clone $this->DFE->TT;
    }
    
    public function getEditor($template="/aribu.systems/_templates/editor/wysiwyg.html") {
                
        # CSS 
        $this->DFE->db->Select('stylesheet, stylesheet_ff')
                      ->From('html_header')
                      ->WhereColName('hid')
                      ->WhereColValue(1)
                      ->doSelect();
        $row_css = $this->DFE->db->SelectPuffer;
                        
        $this->TTT->setMC('editor_title',           $this->Editor_Title)
                  ->setMC('editor_content',         $this->Editor_Content)
                  ->setMC('editor_name',            "textarea#".$this->Editor_Name)
                  ->setMC('editor_function_name',   $this->Editor_Function_Name)  
                  ->setMC('link_language',          $GLOBALS['LANGUAGE'] != SYS_LANGUAGE ? $GLOBALS['LANGUAGE'] : SYS_LANGUAGE)
                  ->setMC('editor_lang',            $_SESSION['sess_language'])
                  ->setMC('base_url',               URL_PROTOCOL . '://' . URL_HOST)
                  ->setMC('css',                    preg_match('#MSIE#', $_SERVER['HTTP_USER_AGENT'], $agent) ? CSS . $GLOBALS['CLIENT_TEMPLATE_FOLDER'] . $row_css['stylesheet'] : CSS . $GLOBALS['CLIENT_TEMPLATE_FOLDER'] . $row_css['stylesheet_ff'])
                  ->setMC('date_format',            $_SESSION['sess_language'] != "de" ? "%m/%d/%Y" : "%d.%m.%Y")
                  ->setMC('plugin',                 $this->Editor_Plugin);

        $this->TTT->BlockMarker['autostart'] = $this->AutoStart === true ? 0 : 1;
        
        return $this->TTT->getFilledTemplate($template, 1);
    }

    public function getTinyEditorJS($template="/aribu.systems/_templates/editor/tiny_wysiwyg_js.html") {
        
        $this->TTT->setMC('js_function', $this->Editor_JS_Function)
                  ->setMC('toggle_id', $this->Editor_Toogle_ID);
                
        $this->TTT->BlockMarker['main_script'] = $this->Editor_Main_Script == 1 ? 1 : 0;

        return $this->getEditor($template);
    }

    public function getTinyEditorFullJS() {
        return $this->getTinyEditorJS("/aribu.systems/_templates/editor/tiny_wysiwyg_full_js.html");
    }
    
    public function getTinyEditorFullModalJS() {
        
        $this->TTT->setMC('css', CSS . $GLOBALS['CLIENT_TEMPLATE_FOLDER'] . 'tinymce.css');

        return $this->getTinyEditorJS("/aribu.systems/_templates/editor/tiny_wysiwyg_full_modal_js.html");
    }

    public function dmethod() {
        
    }

}