<?php

namespace aribu\scripts\files\lib;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   04.11.2005
 * @update: 28.04.2015 
 */

class filemanager extends \aribu\scripts\abstracts\Abstracts {

    /**
     * DFE object
     * @var object
     */
    public $DFE;
    
    public function __construct($DFE) {
        parent::__construct($DFE);
        
        switch ($this->DFE->http->_post('acm')) {
            case 'newFolder':
                if (!empty($this->DFE->http->_post('folderpath')) && !empty($this->DFE->http->_post('foldername'))) {
                    if (!file_exists(DOC_ROOT . $this->DFE->http->_post('folderpath') . \lib\Functions::fixUploadName($this->DFE->http->_post('foldername'), $GLOBALS['LANGUAGE']))) {
                        mkdir(DOC_ROOT . $this->DFE->http->_post('folderpath') . \lib\Functions::fixUploadName($this->DFE->http->_post('foldername'), $GLOBALS['LANGUAGE']));
                        chmod(DOC_ROOT . $this->DFE->http->_post('folderpath') . \lib\Functions::fixUploadName($this->DFE->http->_post('foldername'), $GLOBALS['LANGUAGE']), 0755);
                        $error_folder = str_replace("###foldername###", \lib\Functions::fixUploadName($this->DFE->http->_post('foldername'), $GLOBALS['LANGUAGE']), $this->be_language['_folder_ok']);
                        $this->DFE->TT->BlockMarker['save'] = 1;
                        $save_message = $error_folder;
                    } else {
                        header("Location: ?save=error&error=1");
                        exit;
                    }
                } else {
                    if (empty($this->DFE->http->_post('folderpath')))
                        header("Location: ?save=error&error=2");
                    exit;
                    if (empty($this->DFE->http->_post('foldername')))
                        header("Location: ?save=error&error=3");
                    exit;
                }
                break;

            case 'delFolder':
                @rmdir($this->DFE->http->_post('dir') . $this->DFE->http->_post('file'));
                break;

            case 'delFile':
                @unlink($this->DFE->http->_post('dir') . $this->DFE->http->_post('file'));
                break;
        }
    }
        
    public function FileBrowser($template = "/aribu.systems/_templates/files/file_browser.html") {
               
        $lang = $GLOBALS['LANGUAGE'];
        $sid = $_SESSION['sess_id'];

        if (isset($_SESSION['sess_file_menu'])) {
            $z = 1;
            ksort($_SESSION['sess_file_menu']);
            foreach ($_SESSION['sess_file_menu'] as $mkey => $mval) {

                $timeout = $z == 1 ? 0 : 100 * $z;
                $open_file_menu .= "setTimeout(function() {
var " . str_replace("-", "_", $mval[0]) . " = $.ajax({ 	type: 'POST',
						url: '/aribu.sys/".$lang."/system/ajax',
						data: 'class=/aribu/scripts/files/lib/filemanager&classname=filemanager&method=PluginFileBrowser&folder=" . $mkey . "&fid=" . $mval[0] . "&language=" . $lang . "&SID=" . $sid . "&bl=" . $mval[1] . "&hold=1',
						dataType: 'html'});

" . str_replace("-", "_", $mval[0]) . ".done(function(msg) {
	if(msg != 'false') {
		$('#loader').hide();
		$('." . $mval[0] . "').after(msg);
		$('img#" . $mval[0] . "_img').attr('src', '/aribu.systems/fileadmin/img/icons/tiny/site_close" . $mval[2] . ".gif');
	}
	$('ul.hover-ul').hover(function() {
		 $(this).addClass('hover-page');
	}, function() {
		 $(this).removeClass('hover-page');
	});
			  
});	
												   }," . $timeout . ");
";
                $z++;
            }
            $this->DFE->TT->BlockMarker['file-menu'] = 1;
        } else {
            $this->DFE->TT->BlockMarker['file-menu'] = 0;
        }

        if ($this->DFE->http->issetPost('error') === false) {
            $this->DFE->TT->BlockMarker['save'] = 0;
        } else {
            switch ($this->DFE->http->_post('error')) {
                case 1: $error_folder = $this->be_language['_error1'];
                    break;
                case 2: $error_folder = $this->be_language['_error2'];
                    break;
                case 3: $error_folder = $this->be_language['_error3'];
                    break;
            }
            $this->DFE->TT->BlockMarker['save'] = 1;
            $save_message = $error_folder;
        }

        
        
        $tree_Array = $this->getFileTreeArray(DOC_ROOT . "/fileadmin");
        
        if (array_key_exists(".DS_Store", $tree_Array)) {
            $count = count($tree_Array) - 1;
        } else {
            $count = count($tree_Array);
        }
        ksort($tree_Array);
        reset($tree_Array);

        $tree = $this->getFileTree(DOC_ROOT . "/fileadmin", $tree_Array, '', $count);
        $files_all_table = $tree;
        
        $this->DFE->TT->setMC('files_all_table',    $files_all_table)
                      ->setMC('lang',               $lang)
                      ->setMC('sid',                $sid)
                      ->setMC('open_file_menu',     $open_file_menu);

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    public function getFileTree($dir, $TreeArray, $BLCode = '', $count = 0, $exLevel = 0, $bl = 0) {
        static $level = 0;
        $x = 0;

        $countA = count($TreeArray);
        foreach ($TreeArray as $key => $val) {
            if (is_array($val)) {
                ksort($val);

                $cArr = count($val);
                $file_ext = explode(".", $key);
                $file_ext[1] = "folder";
                $x++;
                $LN = ($countA == $x) ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";

                $tmp = ''; # Buffer
                $folder_dir = str_replace(DOC_ROOT, "", $dir);
                $hash = md5($folder_dir);
                $hash = substr($hash, 0, 4);
                $blevel = $exLevel > 0 ? $bl . "-" : "";
                $key_temp = $key;
                $key = str_replace("-", "_", \lib\Functions::updatePagename($key));

                if ($count == $x || $countA == $x) {
                    $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif\" align=\"absmiddle\" alt=\"site_j\" />"; # Joinbottom
                    if (is_array($val)) {
                        $join = "<a href=\"javascript:void(0);\" onclick=\"menupoint('" . \lib\Functions::updatePagename($folder_dir) . "-" . $key . "','_end','" . $blevel . "1','" . $folder_dir . "/" . $key_temp . "'); return false;\" onfocus=\"blur()\"><img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_open_end.gif\" align=\"absmiddle\" border=\"0\" alt=\"open_end\" id=\"" . \lib\Functions::updatePagename($folder_dir) . "-" . $key . "_img\" /></a>";
                    }
                } else {
                    $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_j.gif\" align=\"absmiddle\" alt=\"site_j\" />";  # Join
                    if (is_array($val)) {
                        $join = "<a href=\"javascript:void(0);\" onclick=\"menupoint('" . \lib\Functions::updatePagename($folder_dir) . "-" . $key . "','','" . $blevel . "0','" . $folder_dir . "/" . $key_temp . "'); return false;\" onfocus=\"blur()\"><img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_open.gif\" align=\"absmiddle\" border=\"0\" alt=\"open\" id=\"" . \lib\Functions::updatePagename($folder_dir) . "-" . $key . "_img\" /></a>";
                    }
                }
                $filetype = !empty($GLOBALS['BE_FILETYPES'][$file_ext[1]]) ? $GLOBALS['BE_FILETYPES'][$file_ext[1]] : $GLOBALS['BE_FILETYPES']['txt'];
                $siteIC = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/" . $filetype . "\" align=\"absmiddle\">&nbsp;";
                if ($exLevel > 0) {
                    $LN = ($count == $x) && $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                    if (!preg_match('#-#', $bl, $res)) {
                        $zLN = $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : $LN;
                    } else {
                        $zLN = '';
                        $bl_arr = explode("-", $bl);
                        foreach ($bl_arr as $blkey => $blval) {
                            $zLN .= $blval == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                        }
                    }
                }
                $blank = $zLN . $join;


                # Actions
                $disabled_upload = SECURITY_UPLOAD_FILES === false ? 'href="javascript:void(0);" class="disabled"' : 'href="?ac=FileUpload&dir=' . $folder_dir . '/' . $key_temp . '/"';
                $action_del = '<i class="fa fa-trash-o disabled" aria-hidden="true" title="' . $this->be_language['_del_folder'] . '"></i>';
                $action_upload = '<a '.$disabled_upload.'><i class="fa fa-upload inverse" aria-hidden="true" title="' . str_replace("###folder###", $key_temp, $this->be_language['_upload_files']) . '"></i></a>';
                $action = $action_del . $action_upload;

                # Tree table
                if ($level == 0) {
                    $tbody_anfang = $exLevel > 0 && $x == 1 ? '<tr class="' . $GLOBALS['FileBrowser_ActivePoint'] . '"><td colspan="4"><table class="table table-files table-hover" style="margin-bottom:0px;">' : "";
                    $tbody_ende = $exLevel > 0 && ($count == $x || $countA == $x) ? "</table></td></tr>" : "";
                    $tmp_tree .= $tbody_anfang . "<tr class=\"hover-ul " . \lib\Functions::updatePagename($folder_dir) . "-" . $key . " \">\n";
                    $tmp_tree .= "<td style=\"width:72%;\">" . $blank . $siteIC . "<a href=\"javascript:void(0);\" onclick=\"javascript:document.getElementsByName('folderpath')[0].value='" . $folder_dir . "/" . $key_temp . "/'; return false;\">" . $key_temp . "</a></td>";
                    $tmp_tree .= "<td style=\"width:8%;\">" . substr(sprintf('%o', fileperms($dir . "/" . $key_temp)), -4) . "</td>";
                    $tmp_tree .= "<td style=\"width:10%;\">0 KB</td>";
                    $tmp_tree .= "<td style=\"width:10%;\">" . $action . "</td>";
                    $tmp_tree .= "</tr>" . $tbody_ende . "\n\n";
                }


                $level++;
                if ($tmp = $this->getFileTree($dir . "/" . $key_temp, $val, $BLCode . $LN, $cArr, $exLevel, $bl)) {
                    $tmp_tree .= $tmp;
                }
                $level--;
            } else {


                if ($level == 0) {
                    if (preg_match('#\.#', $key, $treffer)) {
                        $file_ext = explode(".", $key);
                        $file_ext_end = end($file_ext);
                    } else {
                        $file_ext_end = "";
                    }
                    
                    if(!empty($file_ext)) {
                        $FType = count($file_ext) - 1;
                    } else {
                        $FType = -1;
                    }
                    if (empty($file_ext_end)) {
                        $file_ext[1] = "folder";
                        $file_title = $this->be_language['del_folder'];
                        $acm = "delFolder";
                        $folder_dir = str_replace(DOC_ROOT, "", $dir);
                        $disabled_upload = SECURITY_UPLOAD_FILES === false ? 'href="javascript:void(0);" class="disabled"' : 'href="?ac=FileUpload&dir=' . $folder_dir . '/' . $key . '/"';
                        $action_upload = '<a '.$disabled_upload.'><i class="fa fa-upload inverse" aria-hidden="true" title="' . str_replace("###folder###", $key, $this->be_language['upload_files']) . '"></i></a>';
                    } elseif ($file_ext[1] == '0') {
                        $file_title = $this->be_language['del_file'];
                        $acm = "delFile";
                        $action_upload = "";
                    } else {
                        $file_title = $this->be_language['del_file'];
                        $acm = "delFile";
                        $action_upload = "";
                    }

                    if ($file_ext[1] != "folder") {
                        $file_size = "n.a";
                    } else {
                        $file_size = "0 KB";
                    }
                    $x++;


                    $tmp = ''; # Buffer

                    if ($count == $x || $countA == $x) {
                        $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif\" align=\"absmiddle\">"; # Joinbottom
                    } else {
                        $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_j.gif\" align=\"absmiddle\">";  # Join
                    }
                     
                    if ($FType > 0) {
                        $FTypeImage = !empty($GLOBALS['BE_FILETYPES'][$file_ext[$FType]]) ? $GLOBALS['BE_FILETYPES'][$file_ext[$FType]] : $GLOBALS['BE_FILETYPES']['txt'];
                        $siteIC = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/" . $FTypeImage . "\" align=\"absmiddle\">&nbsp;";
                    } else {
                        $FTypeImage = !empty($GLOBALS['BE_FILETYPES'][$file_ext[1]]) ? $GLOBALS['BE_FILETYPES'][$file_ext[1]] : $GLOBALS['BE_FILETYPES']['txt'];
                        $siteIC = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/" . $FTypeImage . "\" align=\"absmiddle\">&nbsp;";
                    }

                    if ($exLevel > 0) {
                        $LN = ($count == $x) && $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                        if (!preg_match('#-#', $bl, $res)) {
                            $zLN = $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : $LN;
                        } else {
                            $zLN = '';
                            $bl_arr = explode("-", $bl);
                            foreach ($bl_arr as $blkey => $blval) {
                                $zLN .= $blval == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                            }
                        }
                    }
                    $blank = $zLN . $join;

                    # Tree table
                    if ($file_ext[1] == "folder") {
                        $folder_dir = str_replace(DOC_ROOT, "", $dir);
                        $filename = "<a href=\"javascript:void(0);\" onclick=\"javascript:document.getElementsByName('folderpath')[0].value='" . $folder_dir . "/" . $key . "/'; return false;\">" . $key . "</a>";
                    } else {
                        $fileext = explode(".", $key);
                        if ($fileext[1] == "jpg" || $fileext[1] == "gif" || $fileext[1] == "png" || $fileext[1] == "tiff" || $fileext[1] == "JPG" || $fileext[1] == "GIF" || $fileext[1] == "PNG" || $fileext[1] == "TIFF" || $fileext[1] == "bmp" || $fileext[1] == "BMP" || $fileext[1] == "webp") {
                            $filename = "<a href=\"javascript:void(0);\" onmouseover=\"Tip('<img src=\'" . str_replace(DOC_ROOT, "", $dir) . "/" . $key . "\' width=\'120\' style=\'clear:both;\'>', ABOVE, true, BORDERWIDTH, 0, PADDING, 0, WIDTH, 120);\" onmouseout=\"UnTip()\"  onclick=\"javascript: ImageManager('image=" . str_replace(DOC_ROOT, "", $dir) . "/" . $key . "&oldFolder=" . str_replace(DOC_ROOT, "", $dir) . "/&file=" . $key . "&lang=" . $_SESSION['sess_language'] . "&sid=" . $_SESSION['sess_id'] . "'); return false;\" class=\"image-link\">" . $key . "</a>";
                        } elseif ($fileext[1] == "pdf" || $fileext[1] == "PDF" || $fileext[1] == "csv") {
                            $filename = '<a href="' . str_replace(DOC_ROOT, "", $dir) . "/" . $key . '" target="_blank">' . $key . '</a>';
                        } else {
                            $filename = $key;
                        }
                    }
                    # Actions
                    # BE Rights DelFiles
                    $disabled_delete = SECURITY_DELETE_FILES === false ? 'class="disabled"' : 'onclick="javascript: confirmDelFile(\'?ac=FileBrowser&acm=' . $acm . '&dir=' . $dir . '/&file=' . $key . '\')"';
                    if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][48] == 1) {
                        $action_del = '<a href="javascript:void(0);" '.$disabled_delete.'><i class="fa fa-trash-o inverse" aria-hidden="true" title="' . $file_title . '"></i></a>';
                    } else {
                        $action_del = '<i class="fa fa-trash-o disabled" aria-hidden="true" title="' . $this->be_language['_del_folder'] . '"></i>';
                    }
                    $action = $action_del . $action_upload;
                    if ($key != ".DS_Store") {
                        $tbody_anfang = $exLevel > 0 && $x == 1 ? '<tr class="' . $GLOBALS['FileBrowser_ActivePoint'] . '"><td colspan="4"><table class="table table-files table-hover" style="margin-bottom:0px;">' : "";
                        $tbody_ende = $exLevel > 0 && ($count == $x || $countA == $x) ? "</table></td></tr>" : "";
                        $tmp_tree .= $tbody_anfang . "<tr class=\"hover-ul\">\n";
                        $tmp_tree .= "<td style=\"width:72%;\">" . $blank . $siteIC . $filename . "</td>";
                        $tmp_tree .= "<td style=\"width:8%;\">" . substr(sprintf('%o', @fileperms($dir . "/" . $key)), -4) . "</td>";
                        $tmp_tree .= "<td style=\"width:10%;\">" . $file_size . "</td>";
                        $tmp_tree .= "<td style=\"width:10%;\">" . $action . "</td>";
                        $tmp_tree .= "</tr>" . $tbody_ende . "\n\n";
                    } else {
                        $x--;
                    }
                }
            }
        }
        return $tmp_tree;
    }

    public function getFileTreeArray($dir) {
        static $level = 0;
        $fp = opendir($dir);
        while ($datei = readdir($fp)) {
            if (is_dir("$dir/$datei") && $datei != "." && $datei != ".." && $level == 0) {
                $level++;
                if ($tmp = $this->getFileTreeArray($dir . "/" . $datei)) {
                    $tree_arr[$datei] = $tmp;
                } else {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                }
                $level--;
            } else {
                if ($datei != "." && $datei != "..") {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                }
            }
        }
        closedir($fp);
        return $tree_arr;
    }

    public function real_filesize_linux($file) {
        @exec("filesize $file", $out, $ret);
        if ($ret <> '0') {
            return FALSE;
        } else {
            return $out[0];
        }
    }

    public function size_hum_read($size) {
        $i = 0;
        $iec = array("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB");
        while (($size / 1024) > 1) {
            $size = $size / 1024;
            $i++;
        }
        return substr($size, 0, strpos($size, '.') + 3) . " " . $iec[$i];
    }

    /*
     * FileUpload
     *
     */

    public function FileUpload() {
        $this->DFE->TT->setMC('dir',            $this->DFE->http->_post('dir'))
                      ->setMC('image_folder',   $this->DFE->http->_post('dir'))
                      ->setMC('upload_action',  '/aribu.systems/scripts/files/lib/upload.php' . $this->DFE->http->returnQS())
                      ->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['UploadFiles'], $GLOBALS['LANGUAGE']));

        return $this->DFE->TT->getFilledTemplate("/aribu.systems/_templates/files/files_upload.html");
    }

    public function UploadFile() {
        $fileHandle = new \lib\fileupload();

        $upload_dir_raw = $_SERVER['DOCUMENT_ROOT'] . $this->DFE->http->_post('dir');
        $upload_url_raw = $this->DFE->http->_post('dir');

        if ($this->DFE->http->issetPost('Upload') === true && $this->DFE->http->_post('Upload') == 'DMS') {
            if (\lib\Functions::CheckIfDirectoryExists($upload_url_raw)) {
                
            }
        }
        $fileHandle->newFilename = $this->DFE->http->_post('type_title');
        if($this->DFE->http->issetPost('holdFileName') === true) {
            $fileHandle->holdFilename = 0;
        }
        $File = $fileHandle->fileUpload($upload_dir_raw);
        if ($File) {
            if ($this->DFE->http->issetPost('Upload') === true && $this->DFE->http->_post('Upload') == 'DMS') {
                $this->DFE->db->TablePreName = 'fe_';
                $type = explode(".", $File[0]);
                if($this->DFE->http->issetPost('Convert') === true) {
                    switch($this->DFE->http->_post('Convert')) {
                        case 'pdf':
                            $pdf = exec('convert '.$upload_dir_raw.$File[0].' -page a4 '.$upload_dir_raw.$this->DFE->http->_post('type_title').'.pdf');
                            $File[0] = $this->DFE->http->_post('type_title').'.pdf';
                            $type[1] = 'pdf';
                            break;
                    }
                }
                
                $document = new \aribu\scripts\documents\lib\Documents($this->DFE);
                $type_dms_map = $this->DFE->http->issetPost('Type') === true ? $this->DFE->http->_post('Type') : 'fe_uf_auftrag';
                $document->SaveDocuments($this->DFE->http->_post('aid'), $File[0], $this->DFE->http->_post('dir'), $type[1], $this->DFE->http->_post('type_title'), $type_dms_map);
                
            }

            $documents_name = $File[0];

            if ($type[1] == 'pdf') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><a href="javascript:void(0);" onclick="javascript: window.open(\'' . $this->DFE->http->_post('dir') . $documents_name . '\', \'_blank\', \'toolbar=0,location=0,menubar=0\');"><i class="fa fa-file-pdf-o inverse"></i>' . $documents_name . '</a></div>';
            } elseif ($type[1] == 'doc' || $type[1] == 'docx') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-word-o inverse"></i>' . $documents_name . '</div>';
            } elseif ($type[1] == 'jpg' || $type[1] == 'jpeg' || $type[1] == 'gif' || $type[1] == 'png' || $type[1] == 'bmp') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><a href="' . $this->DFE->http->_post('dir') . $documents_name . '" target="_blank"><i class="fa fa-file-image-o inverse"></i>' . $documents_name . '</a></div>';
            } elseif ($type[1] == 'txt' || $type[1] == 'rtf') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-text-o inverse"></i>' . $documents_name . '</div>';
            } elseif ($type[1] == 'ppt' || $type[1] == 'pptx') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-powerpoint-o inverse"></i>' . $documents_name . '</div>';
            } elseif ($type[1] == 'xls' || $type[1] == 'xlsx') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-excel-o inverse"></i>' . $documents_name . '</div>';
            } elseif ($type[1] == 'zip' || $type[1] == 'rar' || $type[1] == 'tar' || $type[1] == 'gz') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><i class="fa fa-file-archive-o inverse"></i>' . $documents_name . '</div>';
            } elseif ($type[1] == 'mail') {
                $image_doc_tag = '<div class="inner"><span class="vmiddle"></span><a href="javascript:void(0);" onclick="javascript: window.open(\'' . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['DocumentViewMail'], $GLOBALS['LANGUAGE']) . '?file_id=' . $row[$i]['id'] . '\', \'_blank\', \'toolbar=0,location=0,menubar=0\');"><i class="fa fa-envelope-o inverse"></i>' . $documents_name . '</a></div>';
            }
            $message['initialPreview'] = $image_doc_tag;
            $message['uploadedFile'] = $this->DFE->http->_post('dir') . $documents_name;
            $message['type_title'] = strtolower($this->DFE->http->_post('type_title'));
            $message['fid'] = $lastID;
            $message['aid'] = $this->DFE->http->_post('aid');
            $message['error'] = 'ok';
            $message['imagemagick'] = $pdf;
            if ($this->DFE->http->issetPost('JSON') === false) {
                echo json_encode($message);
            } else {
                echo '<script type="text/javascript"> top.message = ('.  json_encode($message).'); </script>';
            }
        } else {
            switch ($fileHandle->ErrorType) {
                case "1": # Datei zu groß
                    $message['error_text'] = "Die Datei ist zu groß.";
                    break;

                case "2": # Falsche Dateiendung
                    $message['error_text'] = "Die Datei hat die falsche Endung.";
                    break;

                case "3": # Keine Datei gewählt
                    $message['error_text'] = "Keine Datei gewählt.";
                    break;

                case "4": # Upload Fehler
                    $message['error_text'] = "Da hat etwas nicht gestimmt. Upload Fehler!";
                    break;
            }
            $message['error'] = 'error';
            $message['type_title'] = strtolower($this->DFE->http->_post('type_title'));
            if ($this->DFE->http->issetPost('JSON') === false) {
                echo json_encode($message);
            } else {
                echo '<script type="text/javascript"> top.message = ('.  json_encode($message).'); </script>';
            }
        }
    }
    
    public function PluginFileBrowser() {
        
        # Get session from db
        if ($this->DFE->http->issetPost('hold') === false) {
            $this->DFE->db->TablePreName = "be_";
            $this->DFE->db->Select('*')
                          ->From('session')
                          ->WhereColName('session_id')
                          ->WhereColValue($this->DFE->http->_post('SID'))
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            $row = $this->DFE->db->SelectPuffer;
            if ($num) {
                $sess_userdata = unserialize($this->DFE->db->SelectPuffer['session_data']);
                foreach ($sess_userdata as $key => $val) {
                    $session_datas["" . $key . ""] = $val;
                }
                if ($this->DFE->http->issetPost('rm') === false) {
                    $session_datas['sess_file_menu'][$this->DFE->http->_post('folder')][0] = $this->DFE->http->_post('fid');
                    $session_datas['sess_file_menu'][$this->DFE->http->_post('folder')][1] = $this->DFE->http->_post('bl');
                    $session_datas['sess_file_menu'][$this->DFE->http->_post('folder')][2] = $this->DFE->http->_post('eta');
                } else {
                    unset($session_datas['sess_file_menu'][$this->DFE->http->_post('folder')]);
                }
                $sess_userdata = serialize($session_datas);
                $this->DFE->db->Update('session')
                              ->WhereColName('session_id')
                              ->WhereColValue($this->DFE->http->_post('SID'))
                              ->Set(array('session_data' => $sess_userdata))
                              ->doUpdate();
            }
        }
        
        
        $dir = $this->DFE->http->_post('folder');
        $tree_Array = $this->getFileTreeArray(DOC_ROOT . $dir);
        if (array_key_exists(".DS_Store", $tree_Array)) {
            $count = count($tree_Array) - 1;
        } else {
            $count = count($tree_Array);
        }
        ksort($tree_Array);
        reset($tree_Array);

        $level = explode("/", $this->DFE->http->_post('folder'));
        $level = count($level);
        $GLOBALS['FileBrowser_ActivePoint'] = $this->DFE->http->_post('fid') . "-act";
        $filemenu = $this->getFileTree(DOC_ROOT . $dir, $tree_Array, "", $count, $level - 2, $this->DFE->http->_post('bl'));
        return $filemenu;
    }
    
    public function PluginImageManager() {
        if ($this->DFE->http->issetPost('image') === true) {
            if ($this->DFE->http->issetPost('makeThumb') === false) {
                $dot = \lib\Functions::readFiles("/aribu.systems/_templates/files/ImageManager.html");
                $this->DFE->TT->HTMLBuffer = $dot;

                $getImage = str_replace("..", "", $this->DFE->http->_post('image'));
                # Image size
                $raw_image = DOC_ROOT . $getImage;
                $size = getimagesize($raw_image);
                $width_raw = $size[0];
                $height_raw = $size[1];
                $post_image = $this->DFE->http->_post('image');
                $post_file = $this->DFE->http->_post('file');
                $post_oldFolder = $this->DFE->http->_post('oldFolder');
                $lang = $_SESSION['sess_language'];
                $sid = $_SESSION['sess_id'];

                $image = "<div><b>" . $this->be_language['_file_size'] . ":</b> " . $width_raw . "x" . $height_raw . " Pixel<br /><b>" . $this->be_language['_path'] . ":</b> " . str_replace(DOC_ROOT, "", $getImage) . "<br /><br /></div><img src=\"" . str_replace(DOC_ROOT, "", $getImage) . "\" />";
                $image_path = str_replace(DOC_ROOT, "", $getImage);
                # Folders
                $folders = \lib\Functions::FileManagerOptions(DOC_ROOT . '/fileadmin/img');

                if (preg_match('/(jpg|jpeg|png)/i', $this->DFE->http->_post('file'), $resext)) {
                    $thumb_generator = \lib\Functions::readFiles("/aribu.systems/_templates/files/thumb_generator.html");
                    $thumb_generator = str_replace("###FOLDERS###", $folders, $thumb_generator);
                    $thumb_generator = str_replace("###_make_thumb###", $this->be_language['_make_thumb'], $thumb_generator);
                    $thumb_generator = str_replace("###_same_name###", $this->be_language['_same_name'], $thumb_generator);
                    $thumb_generator = str_replace("###_random_name###", $this->be_language['_random_name'], $thumb_generator);
                    $thumb_generator = str_replace("###_new_name###", $this->be_language['_new_name'], $thumb_generator);
                    $thumb_generator = str_replace("###_thumb_size###", $this->be_language['_thumb_size'], $thumb_generator);
                    $thumb_generator = str_replace("###_into_folder###", $this->be_language['_into_folder'], $thumb_generator);
                    $thumb_generator = str_replace("###_save###", $this->be_language['_save'], $thumb_generator);
                    $thumb_generator = str_replace("###_thumb_name###", $this->be_language['_thumb_name'], $thumb_generator);
                } else {
                    $thumb_generator = "";
                }

                $img_manager = $this->be_language['_img_manager'];

                # Ausgabe 
                $pattern = '/#\#\#(.*?)#\#\#/ims';
                preg_match_all($pattern, $dot, $TempMarker);
                foreach ($TempMarker[0] as $key => $val) {
                    $fieldVal = ${$TempMarker[1][$key]};
                    $defineArr[$val] = $fieldVal;
                }
                $contTemp = $this->DFE->TT->replaceItems($defineArr);
                echo $contTemp;
            } else {
                if ($this->DFE->http->issetPost('makeThumb') === true) {
                    $imgHandle = new \lib\Image();

                    $getImage = str_replace("..", "", $this->DFE->http->_post('image'));
                    $oldFolder = str_replace("..", "", $this->DFE->http->_post('oldFolder'));

                    # Image Name
                    switch ($this->DFE->http->_post('ThumbName')) {
                        case 0:
                            $imgHandle->HoldImageName = 0;
                            break;

                        case 1:
                            $imgHandle->HoldImageName = 1;
                            $imgHandle->Imagename = $this->DFE->http->_post('file');
                            break;

                        case 2:
                            $imgHandle->HoldImageName = 2;
                            $imgHandle->NewImageName = $this->DFE->http->_post('thumb_name');
                            break;
                    }

                    # Image size
                    $raw_image = DOC_ROOT . $getImage;
                    $size = getimagesize($raw_image);
                    $imgHandle->kb = 150000;
                    $imgHandle->width_old = $size[0];
                    $imgHandle->height_old = $size[1];
                    $imgHandle->image_ext = $size[2];
                    $imgHandle->old_image = DOC_ROOT . $getImage;
                    $imgHandle->image_size = $this->DFE->http->_post('MaxWH');
                    $imgHandle->image_ordner = DOC_ROOT . $oldFolder;
                    $imgHandle->thumb_ordner = DOC_ROOT . "/fileadmin/img/" . $this->DFE->http->_post('folder');
                    $thumb = $imgHandle->imageCreate($this->DFE->http->_post('file'));
                    # Text
                    $error = $this->be_language['_created_thumb'] . "<br /><br /><img src=\"/fileadmin/img/" . $this->DFE->http->_post('folder') . $thumb . "\" />";
                } else {
                    # Text
                    $error = $this->be_language['_not_created_thumb'] . "<br /><br />";
                }
                $dot = \lib\Functions::readFiles("/aribu.systems/_templates/files/ImageManager_do.html");
                $this->DFE->TT->HTMLBuffer = $dot;

                $img_manager = $this->be_language['_img_manager'];

                # Ausgabe 
                $pattern = '/#\#\#(.*?)#\#\#/ims';
                preg_match_all($pattern, $dot, $TempMarker);
                foreach ($TempMarker[0] as $key => $val) {
                    $fieldVal = ${$TempMarker[1][$key]};
                    $defineArr[$val] = $fieldVal;
                }
                $contTemp = $this->DFE->TT->replaceItems($defineArr);
                echo $contTemp;
            }
        }
    }

    public function dmethod() {
        
    }

}