<?php

namespace aribu\scripts\pages\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   18.04.2014
 *  
 */

class Browser extends \aribu\scripts\abstracts\Abstracts {
    
    public $chields = array();
    public $RGT = array();
    public $BL = array();
    public $CLevel = array();
    public $sorting = array();
    
    public $jid;

    public $FB = "fe_";
    public $FBup = 'FE';
    public $BE = '';
    
    public function __construct($DFE) {
        parent::__construct($DFE);
    }
    
        
    /**
     * Browser
     * @return string
     */
    public function PageBrowser() {
        
        # Require Level
        if($this->FB == 'fe_') {
            require_once(FE_MENU);
        }
      
        $this->DFE->TT->BlockMarker['action'] = 0;
        $this->DFE->TT->BlockMarker['action_del'] = 0;
        
        
        
        # Actions
        switch ($this->DFE->http->_post('acm')) {
            case 'public':
                $this->DFE->db->Select('hidden, starttime')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('pid'))
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                $row_pid = $this->DFE->db->SelectPuffer;
                if ($row_pid['hidden'] == 1 || $row_pid['starttime'] > 0) {
                    $save_message = $_online_page_error_info;
                    $this->DFE->TT->BlockMarker['action'] = 1;
                } else {
                    $this->DFE->db->Select("o.uid")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                                  ->Group('GROUP BY o.lft')
                                  ->Order('ORDER BY o.lft')
                                  ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                                  ->SelectMethod(1)
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    
                    if ($num) {
                        $row = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num; $i++) {
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($row[$i]['uid'])
                                          ->Set(array("lastUpdated" => time(), "hidden" => 0, "starttime" => 0, "endtime" => 0))
                                          ->doUpdate();
                        }
                    }
                }
                break;

            case 'notpublic':
                $this->DFE->db->Select("o.uid")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                              ->noWhere(1)
                              ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                              ->Group('GROUP BY o.lft')
                              ->Order('ORDER BY o.lft')
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                              ->SelectMethod(1)
                              ->doSelect();
                
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    for ($i = 0; $i < $num; $i++) {
                        $this->DFE->db->Update($this->DFE->Pages)
                                       ->WhereColName('uid')
                                       ->WhereColValue($row[$i]['uid'])
                                       ->Set(array("lastUpdated" => time(), "hidden" => 1, "starttime" => 0, "endtime" => 0))
                                       ->doUpdate();      
                    }
                }

                break;

            case 'delpage':
                $this->DFE->db->Select('uid, pid, rgt, sorting')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;

                $this->DFE->db->Select('uid')
                              ->From($this->DFE->Pages)
                              ->WhereColName('pid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                $num1 = $this->DFE->db->Rows;
                if (!$num1) {

                    $this->DFE->db->Delete($this->DFE->Pages)
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doDelete();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($row['pid'])
                                  ->Andd("AND sorting > :and_sorting " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lastUpdated" => time(), "sorting" => "sorting-1"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('and_sorting' => $row['sorting'], 'lang' => $GLOBALS['LANGUAGE']) : array('and_sorting' => $row['sorting']))
                                  ->doUpdate();

                    # Nested Sets Modell
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lft" => "lft-2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE rgt >= " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("rgt" => "rgt-2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    
                    # Delete content media files
                    $this->DFE->db->Get('content', 'pid', $this->DFE->http->_post('uid'));
                    if(is_array($this->DFE->db->SelectPuffer) && !empty($this->DFE->db->SelectPuffer)) {
                        foreach($this->DFE->db->SelectPuffer as $key => $row) {
                            $this->DFE->db->Delete('content_media')
                                 ->WhereColName('cid')
                                 ->WhereColValue($row['uid'])
                                 ->doDelete();
                        }
                    }
                    
                    
                    $this->DFE->db->Delete('content')
                                  ->WhereColName('pid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->doDelete();
                    
                    
                    
                } else {
                    $this->DFE->TT->BlockMarker['action_del'] = 1;
                    $this->DFE->TT->setMC('ajax_uid', $this->DFE->http->_post('uid'));
                    $this->DFE->TT->setMC('ajax_rgt', $row['rgt']);
                    $this->DFE->TT->setMC('ajax_sort', $row['sorting']);
                    $this->DFE->TT->setMC('ajax_pid', $row['pid']);
                    $this->DFE->TT->setMC('save_message', $this->be_language['_del_page_info']);
                }

                break;

            case 'delpage_all':
                $this->DFE->db->Select("o.uid, o.pid, o.level")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                              ->noWhere(1)
                              ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                              ->Group('GROUP BY o.lft')
                              ->Order("ORDER BY o.level DESC, o.sorting DESC")
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                              ->SelectMethod(1)
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    for ($i = 0; $i < $num; $i++) {

                        $this->DFE->db->Select('rgt, sorting')
                                      ->From($this->DFE->Pages)
                                      ->WhereColName('uid')
                                      ->WhereColValue($row[$i]['uid'])
                                      ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        $row_rs = $this->DFE->db->SelectPuffer;

                        $this->DFE->db->Delete($this->DFE->Pages)
                                      ->WhereColName('uid')
                                      ->WhereColValue($row[$i]['uid'])
                                      ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doDelete();
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->WhereColName('pid')
                                      ->WhereColValue($row[$i]['pid'])
                                      ->Andd("AND sorting > " . $row_rs['sorting'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array("lastUpdated" => time(), "sorting" => "sorting-1"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();

                        # Nested Sets Modell
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft > " . $row_rs['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array("lft" => "lft-2"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE rgt >= " . $row_rs['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array("rgt" => "rgt-2"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        
                                                
                        $this->DFE->db->Delete('content')
                                      ->WhereColName('pid')
                                      ->WhereColValue($row[$i]['uid'])
                                      ->doDelete();
                    }
                    
                }
                $this->DFE->db->Delete('content_media')
                              ->WhereColName('lang')
                              ->WhereColValue($GLOBALS['LANGUAGE'])
                              ->doDelete();
                
                break;

            case 'delcache':
                $this->DFE->db->Truncate()
                              ->Table($this->DFE->Pages . "_cache")
                              ->doTruncate();
                $this->DFE->TT->setMC('save_message', $_del_cache_info);
                $this->DFE->TT->BlockMarker['action'] = 1;
                break;

            case 'delSitemap':
                $this->DFE->db->Delete($this->DFE->Pages)
                              ->noWhere(1)
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doDelete();
                if(SYS_LANGUAGE == $GLOBALS['LANGUAGE']) {
                    $this->DFE->db->Alter()
                                  ->Table($this->DFE->Pages)
                                  ->setAlter("AUTO_INCREMENT = 1")
                                  ->doAlter();
                }
                $this->DFE->db->Delete('content')
                              ->WhereColName('lang')
                              ->WhereColValue($GLOBALS['LANGUAGE'])
                              ->doDelete();
                $this->DFE->db->Delete('content_media')
                              ->WhereColName('lang')
                              ->WhereColValue($GLOBALS['LANGUAGE'])
                              ->doDelete();
                $this->DFE->db->Truncate()
                              ->Table("content_lock")
                              ->doTruncate();
                break;
        }


        $this->DFE->TT->BlockMarker['admin_rights'] = $_SESSION['BE_Rights'] == 1 ? 1 : 0;

        

        $this->DFE->TT->setMC('RootIcon',               CLIENT . '-Server')
                      ->setMC('content_all_table',      $this->getTreeMap())
                      ->setMC('lang',                   $GLOBALS['LANGUAGE'])
                      ->setMC('sid',                    $_SESSION['sess_id'])
                      ->setMC('puid',                   $this->DFE->http->issetPost('puid') === true ? $this->DFE->http->_post('puid') : $this->DFE->RID)
                      ->setMC('jid',                    $this->jid)
                      ->setMC('export_url',             \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'ExportPages'], $GLOBALS['LANGUAGE']))
                      ->setMC('copy_sitemap_url',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'CopySitemap'], $GLOBALS['LANGUAGE']))
                      ->setMC('new_page_url',           \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'NewPage'], $GLOBALS['LANGUAGE']))
                      ->setMC('new_dummy_page_url',     \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'NewDummyPage'], $GLOBALS['LANGUAGE']))
                      ->setMC('dummy_pages_url',        \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'DummyPages'], $GLOBALS['LANGUAGE']))
                      ->setMC('fb',                     $this->FB == 'be_' ? '&FB=be_' : '')
                      ->setMC('da',                     $this->FB == 'be_' && SECURITY_DELETE_BE_SITEMAP === false ? 'disabled' : 'inverse')
                      ->setMC('onclick_delete_sitemap', $this->FB == 'be_' && SECURITY_DELETE_BE_SITEMAP === false ? 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_delete_sitemap'].'"' : 'onclick="javascript: delSitemap();"');
        
        return $this->DFE->TT->getFilledTemplate("/aribu.systems/_templates/pages/browser.html");
    }

    /**
     * Get tree map
     * @staticvar int $nr
     * @return string
     *  
     */
    public function getTreeMap() {
        
        static $nr = 1;
        $level = 0;
        $a = 1;
        
        

        if ($this->DFE->http->issetPost('language') === true) {
            $GLOBALS['LANGUAGE'] = $this->DFE->http->_post('language');
        }

        $this->DFE->db->TablePreName = $this->FB;
        $this->DFE->db->Select('uid')
                      ->From($this->DFE->Pages)
                      ->WhereColName('pid')
                      ->WhereColValue(0)
                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();
        $maxRoot = $this->DFE->db->Rows;


        if ( $this->DFE->http->issetPost('uid') === true && $this->DFE->http->issetPost('acm') === false) {
            $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $this->DFE->http->_post('uid')] = 1;
        }


        if (isset($_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']])) {
            foreach ($_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']] as $key => $val) {
                if ($val == 1) {
                    $or .= "OR n.pid = '" . str_replace("level-", "", $key) . "' ";
                }
            }
        }

        $this->DFE->db->Select("n.nav_title, 
                                n.lft, 
                                n.rgt, 
                                n.uid, 
                                n.pid, 
                                n.docType, 
                                n.sorting, 
                                n.hidden, 
                                n.author, 
                                n.pagename, 
                                n.starttime, 
                                n.endtime, 
                                n.level, 
                                ROUND( (n.rgt - n.lft -1)/2) AS chields")
                        ->From($this->DFE->Pages . " AS n")
                        ->noWhere(1)
                        ->Andd("WHERE (n.pid = 0 " . $or . ") " . str_replace("%%%n%%%", "n.", $this->DFE->and_lang))
                        ->Order("ORDER BY n.lft")
                        ->SelectMethod(1)
                        ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                        ->doSelect();
        $this->SQL .= "\n<br>".$sql;
        $num = $this->DFE->db->Rows;
        $x = 1;
        
        foreach ($this->DFE->db->SelectPuffer as $key => $row) {
            $BLCode = implode("", $this->BL);

            if ($row['level'] == 0) {
                $BLCode = "";
                $this->BL = array();
                $span_ende = "";
            }
            
            if ($row['chields'] != 0) {
                $this->chields[$row['uid']] = $row['chields'];
                $this->sorting[$row['uid']] = $row['sorting'];
                $this->RGT[$row['uid']] = $row['rgt'];
                $this->dbg[] = $this->RGT[$row['pid']].' - '.$row['rgt'].' == 1 || ('.$row['pid'].' == 0 && '.$row['sorting'].' == '.$maxRoot.') - Level = '.$row['level']; 
                if ($this->RGT[$row['pid']] - $row['rgt'] == 1 || ($row['pid'] == 0 && $row['sorting'] == $maxRoot)) {
                    $this->BL[$row['level']] = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif" align="absmiddle" border="0" alt="">';
                } else {
                    $this->BL[$row['level']] = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_line.gif" align="absmiddle" border="0" alt="">';
                }
            } else {
                $this->BL[$row['level']] = "";
            }

            if ($row['level'] < $level) {
                $a++;
                $a = $a - $level != 0 ? $a - $level : $a;
                $span_ende = str_repeat("</span>", $level - $row['level']);
            } else {
                $span_ende = "";
            }

            if ($row['level'] > $level) {
                $a = 1;
                $span_ende = "";
            }

            if ($row['level'] == $level) {
                $a++;
                $span_ende = "";
            }


            if ($num == $x || ($this->chields[$row['pid']] == $a && isset($this->chields[$row['pid']])) || $this->RGT[$row['pid']] - $row['rgt'] == 1 || ($row['pid'] == 0 && $row['sorting'] == $maxRoot)) {
                $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif\" align=\"absmiddle\">"; # Joinbottom
                if ($row['chields'] != 0) {
                    $ocImg = $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || ($this->DFE->http->_post('uid') == $row['uid'] && $this->DFE->http->issetPost('acm') === false) ? "close_end" : "open_end";
                    $join = "<a href=\"javascript:void(0);\" onclick=\"menupoint('level-" . $row['uid'] . "', '_end', 'level=level-" . $row['uid'] . "&uid=" . $row['uid'] . "'); \" onfocus=\"blur()\"><img class=\"" . $ocImg . "\" src=\"/aribu.systems/fileadmin/img/icons/tiny/site_" . $ocImg . ".gif\" align=\"absmiddle\" border=\"0\" id=\"level-" . $row['uid'] . "_img\"></a>";
                }
            } else {
                $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_j.gif\" align=\"absmiddle\">";  # Join
                if ($row['chields'] != 0) {
                    $ocImg = $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || ($this->DFE->http->_post('uid') == $row['uid'] && $this->DFE->http->issetPost('acm') === false) ? "toclose" : "open";
                    $join = '<a href="javascript:void(0);" onclick="menupoint(\'level-' . $row['uid'] . '\', \'\', \'level=level-' . $row['uid'] . '&uid=' . $row['uid'] . '\');" onfocus="blur();"><img class="' . $ocImg . '" src="/aribu.systems/fileadmin/img/icons/tiny/site_' . str_replace("to", "", $ocImg) . '.gif" align="absmiddle" border="0" id="level-' . $row['uid'] . '_img"></a>';
                }
            }

            $BLCode = "";
            for ($i = 0; $i < $row['level']; $i++) {
                $BLCode .= $this->BL[$i] . "";
            }

            $blank = $BLCode . $join;

            $nav_title = stripslashes($row['nav_title']);


            # Language settings
            $hidden = $row['hidden'];
            $data = 'data-uid="'.$row['uid'].'" data-pid="'.$row['pid'].'" ';

            # Page Status
            if ($row['starttime'] > 0 || $row['endtime'] > 0) {
                if (time() > $row['starttime'] && CURRENT_TIME < $row['endtime']) {

                    # Online
                    # Status
                    $public     = '<i class="fa fa-globe inverse" aria-hidden="true" title="' . $this->be_language['_the_page'] . $nav_title . $this->be_language['_is_online'] . '"></i>';
                    $public2    = $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? '<a href="javascript:void(0);" onclick="javascript:hideshow(\'hide\', \'' . $this->be_language['_set_offline_sc'] . '\', \''. $row['uid'] . '\', \'' . $row['pid'] . '\');" title="'.$this->be_language['_set_the_page'] . $nav_title . $this->be_language['_set_offline'].'"><i class="fa fa-globe inverse" aria-hidden="true"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_set_offline'].'"';
                    
                    $data       .= $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? 'data-status="online" data-statustext="'.$this->be_language['_set_offline_sc'].'" data-url=""' : 'data-status="disabled" ';
                    
                } elseif (time() < $row['starttime'] && $row['endtime'] == 0) {

                    # Offline
                    # Status
                    $public = '<i class="fa fa-globe active" aria-hidden="true" title="' . $this->be_language['_the_page'] . $nav_title . $this->be_language['_is_offline'] . '"></i>';
                    $public2 = $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? '<a href="javascript:void(0);" onclick="javascript:hideshow(\'show\',\'' . $this->be_language['_set_online_sc'] . '\', \'' . $row['uid'] . '\', \'' . $row['pid'] . '\');" title="' . $this->be_language['_set_the_page'] . $nav_title . $this->be_language['_set_online'] . '"><i class="fa fa-globe active" aria-hidden="true"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_set_online'].'"';
                    
                    $data .= $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? 'data-status="offline" data-statustext="'.$this->be_language['_set_online_sc'].'" ' : 'data-status="disabled" ';
                    
                    
                } elseif (time() > $row['starttime'] && $row['endtime'] == 0) {

                    # Online
                    # Status
                    $public     = '<i class="fa fa-globe inverse" aria-hidden="true" title="' . $this->be_language['_the_page'] . $nav_title . $this->be_language['_is_online'] . '"></i>';
                    $public2    = $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? '<a href="javascript:void(0);" onclick="javascript:hideshow(\'hide\', \'' . $this->be_language['_set_offline_sc'] . '\', \''. $row['uid'] . '\', \'' . $row['pid'] . '\');" title="'.$this->be_language['_set_the_page'] . $nav_title . $this->be_language['_set_offline'].'"><i class="fa fa-globe inverse" aria-hidden="true"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_set_offline'].'"';
                    
                    $data       .= $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? 'data-status="online" data-statustext="'.$this->be_language['_set_offline_sc'].'" data-url=""' : 'data-status="disabled" ';
                } else {

                    # Offline
                    # Status
                    $public = '<i class="fa fa-globe active" aria-hidden="true" title="' . $this->be_language['_the_page'] . $nav_title . $this->be_language['_is_offline'] . '"></i>';
                    $public2 = $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? '<a href="javascript:void(0);" onclick="javascript:hideshow(\'show\',\'' . $this->be_language['_set_online_sc'] . '\', \'' . $row['uid'] . '\', \'' . $row['pid'] . '\');" title="' . $this->be_language['_set_the_page'] . $nav_title . $this->be_language['_set_online'] . '"><i class="fa fa-globe active" aria-hidden="true"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_set_online'].'"';
                    
                    $data .= $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1 ? 'data-status="offline" data-statustext="'.$this->be_language['_set_online_sc'].'" ' : 'data-status="disabled" ';
                    
                }
            } else {
                # Status
                $public = $hidden == 1 ? '<i class="fa fa-globe active" aria-hidden="true" title="' . $this->be_language['_the_page'] . $nav_title . $this->be_language['_is_offline'] . '"></i>' : '<i class="fa fa-globe inverse" aria-hidden="true" title="' . $this->be_language['_the_page'] . $nav_title . $this->be_language['_is_online'] . '"></i>';

                # Online/Offline
                if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][6] == 1) {
                    $data .= $hidden == 1 ? 'data-status="offline" data-statustext="'.$this->be_language['_set_online_sc'].'" ' : 'data-status="online" data-statustext="'.$this->be_language['_set_offline_sc'].'" ';
                    $public2 = $hidden == 1 ? '<a href="javascript:void(0);" onclick="javascript: hideshow(\'show\', \'' . $this->be_language['_set_online_sc'] . '\', \'' . $row['uid'] . '\', \'' . $row['pid'] . '\');"><i class="fa fa-globe inverse" aria-hidden="true" title="' . $this->be_language['_the_page'] . $nav_title . $this->be_language['_set_online'] . '"></i></a>' : '<a href="javascript:void(0);" onclick="javascript: hideshow(\'hide\', \'' . $this->be_language['_set_offline_sc'] . '\', \'' . $row['uid'] . '\', \'' . $row['pid'] . '\');"><i class="fa fa-globe active" aria-hidden="true" title="' . $this->be_language['_set_the_page'] . $nav_title . $this->be_language['_set_offline'] . '"></i></a>';
                } else {
                    $data .= 'data-status="disabled" ';
                    $public2 = $hidden == 1 ? '<a href="javascript:void(0);" data-toggle="popover" data-original-title="'.$this->be_language['_right_set_online'].'"><i class="fa fa-globe" aria-hidden="true" title="' . $this->be_language['_set_the_page'] . $nav_title . $this->be_language['_set_online'] . '"></i></a>' : '<a href="#" data-toggle="popover" data-original-title="'.$this->be_language['_right_set_offline'].'"><i class="fa fa-globe disabled" aria-hidden="true" title="' . $this->be_language['_set_the_page'] . $nav_title . $this->be_language['_set_offline'] . '"></i></a>';
                }
            }

            
            $pages = \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Pages'], $GLOBALS['LANGUAGE']);
            $data .= 'data-pages="'. $pages .'" ';
            $data .= 'data-rgt="'.$row['rgt'].'" data-lft="'.$row['lft'].'" data-sorting="'.$row['sorting'].'" ';
            $fb = $this->FB == 'be_' ? '&FB=be_' : '';
            
            # Move page
            $data .= $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][7] == 1 || $_SESSION['BE_Rights'] == 1 ? 'data-page_move="able" ' : 'data-page_move="disabled" ';
            $actionmo = $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][7] == 1 || $_SESSION['BE_Rights'] == 1 ? '<a href="' . $pages.'?ac=MovePage&uid=' . $row['uid'] . '&sort=' . $row['sorting'] . '&pid=' . $row['pid'] . '&lft=' . $row['lft'] . '&rgt=' . $row['rgt'] . $fb .'"><i class="fa fa-arrows inverse" aria-hidden="true" title="' . $this->be_language['_move_page'] . '"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_move_page'].'"';

            # Set time
            $data .= $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][8] == 1 || $_SESSION['BE_Rights'] == 1 ? 'data-time_setting="able" ' : 'data-time_setting="disabled" ';
            $actiontime = $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][8] == 1 || $_SESSION['BE_Rights'] == 1 ? '<a href="' . $pages.'?ac=PageTimeSet&uid=' . $row['uid'] . '"><i class="fa fa-clock-o inverse" aria-hidden="true" border="0" title="' . $this->be_language['_set_time'] . '"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_time_setting'].'"';

            # Edit navigation link
            $data .= $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][9] == 1 || $_SESSION['BE_Rights'] == 1 ? 'data-page_link="able" ' : 'data-page_link="disabled" ';
            $actionlink = $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][9] == 1 || $_SESSION['BE_Rights'] == 1 ? '<a href="' . $pages.'?ac=PageLink&uid=' . $row['uid'] . '"><i class="fa fa-link inverse" aria-hidden="true" title="' . $this->be_language['_edit_menu_link'] . '"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_page_link'].'"';
            
            # Del page
            if ($_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][4] == 1 || $_SESSION['BE_Rights'] == 1) {
                $data .= 'data-delete="able" ';
                $onclick_delete = $this->FB == 'be_' && SECURITY_DELETE_BE_PAGES === false ? 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_del_page'].'"' : 'onclick="javascript: delPage(\'' . $row['uid'] . '\', \'' . $row['sorting'] . '\', \'' . $row['pid'] . '\', \'' . $row['rgt'] . '\');"';
                $da = $this->FB == 'be_' && SECURITY_DELETE_BE_PAGES === false ? 'disabled' : 'inverse';
                $actiond = '<a href="javascript:void(0);" '.$onclick_delete.'><i class="fa fa-trash '.$da.'" title="' . $this->be_language['_del_page'] . '"></i></a>';
            } else {
                $data .= 'data-delete="disabled" ';
                $actiond = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_del_page'].'"'; 
            }

            # Edit page
            $data .= $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][3] == 1 || $_SESSION['BE_Rights'] == 1 ? 'data-edit="able" ' : 'data-edit="disabled" ';
            $actione = $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][3] == 1 || $_SESSION['BE_Rights'] == 1 ? '<a href="' . $pages.'?ac=EditPage&uid=' . $row['uid'] . '"><i class="fa fa-pencil inverse" title="' . $this->be_language['_edit_page'] . '"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_edit_page'].'"'; 
            
            # Edit content
            if ($_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][24] == 1 || $_SESSION['BE_Rights'] == 1) {
                $data .= 'data-content="able" data-edit_content_url="' . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Content'], $GLOBALS['LANGUAGE']) . '?ac=ContentOverview&uid=' . $row['uid'] . '&jid=' . $this->jid . '"';
                $puid = $this->DFE->http->issetPost('puid') === true ? $this->DFE->http->_post('puid') : $this->DFE->RID;
                $this->jid = $this->DFE->http->issetPost('jid') === true ? $this->DFE->http->_post('jid') : $GLOBALS['PageConfig']['UID'];
                $actionec = '<a href="' . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Content'], $GLOBALS['LANGUAGE']) . '?ac=ContentOverview&uid=' . $row['uid'] . '&jid=' . $this->jid . '"><i class="fa fa-file-text-o inverse" aria-hidden="true" title="' . $this->be_language['_edit_content'] . '"></i></a>';
            } else {
                $data .= 'data-content="disabled" ';
                $actionec = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_edit_content'].'"'; 
            }

            # Copy page
            $data .= $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][5] == 1 || $_SESSION['BE_Rights'] == 1 ? 'data-copy_page="able" ' : 'data-copy_page="disabled" ';
            $actionsitecp = $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][5] == 1 || $_SESSION['BE_Rights'] == 1 ? '<a href="' . $pages.'?ac=CopyPage&uid=' . $row['uid'] . '"><i class="fa fa-files-o inverse" aria-hidden="true" title="' . $this->be_language['_copy_page'] . '"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_copy_page'].'"';
            
            # Copy page+ 
            $data .= $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS']['5a'] == 1 || $_SESSION['BE_Rights'] == 1 ? 'data-copy_page_plus="able" ' : 'data-copy_page_plus="disabled" ';
            $actionsitecpp = $_SESSION['sess_uid'] == $row['cruser_id '] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS']['5a'] == 1 || $_SESSION['BE_Rights'] == 1 ? '<a href="' . $pages.'?ac=CopyPagePlus&uid=' . $row['uid'] . '"><i class="fa fa-files-o active" aria-hidden="true" title="' . $this->be_language['_copy_page_plus'] . '"></i></a>' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_right_copy_page'].'"'; 
            


            $pageSettings = unserialize($row['pageSettings']);
            $usergroups = explode("-", $_SESSION['Usergroup']);

            if ($_SESSION['BE_Rights'] == 1 || $_SESSION['BE_Rights'] == 2 || $_SESSION['BE_Rights'] == 3 || in_array($pageSettings['be_rights'], $usergroups)) {
                $action = $actions[$nr] . $public2 . $actiond . $actione . $actionec . $actionnc . $actionmo . $actiontime . $actionlink . $actionsitecp . $actionsitecpp . $actioninf;
            } else {
                $action = "";
            }

            $siteIC = '<img src="/aribu.systems/fileadmin/img/icons/tiny/' . $GLOBALS['BE_DOCTYPES'][$row['docType']] . '" style="vertical-align:middle;" alt="' . stripslashes($row['nav_title']) . '" title="UID: ' . $row['uid'] . ' - PID: ' . $row['pid'] . '">&nbsp;';

            $path_names = $row['docType'] == 0 ? 0 : 1;
            
            $path = $this->FB == 'fe_' ? \lib\fe_menu::getTreePathNames($row['uid'], '', 0, 1, $path_names, $GLOBALS['LANGUAGE'], ' AND p.docType != 0 ') : \lib\be_menu::getTreePathNames($row['uid'], '', 0, 1, $path_names, $GLOBALS['LANGUAGE']);
            $site_name_link = '<a href="' . URL_PROTOCOL . '://' . URL_HOST . $path . '" target="_blank" title="' . $nav_title . '" style="position:relative;"'.$data.'>' . $nav_title . '</a>';

            # Tree table
            $display = $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || $this->DFE->http->_post('uid') == $row['uid'] ? "block" : "none";
            $span_anfang = $row['chields'] != 0 && ($_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || $this->DFE->http->_post('uid') == $row['uid']) ? "<span style=\"display:" . $display . ";\" id=\"level-" . $row['uid'] . "\">" : "";
            $span_ende_ab = $x == $num && $row['level'] > 0 ? str_repeat("</span>", $row['level']) : "";
            $tmp_tree .= $span_ende . '<ul style="list-style-type:none; clear:both; height:20px;" class="table-xs page-row">';
            $tmp_tree .= '<li style="width:40%; float:left; padding-left:4px; border:0px solid #C8D5E0; border-right-width:0px; border-top-width:0px; border-bottom-width:0px; overflow:hidden; white-space:nowrap; ">' . $blank . $siteIC . $site_name_link . '</li>';
            $tmp_tree .= '<li style="width:8%; float:left; border:1px solid #C8D5E0; text-align:center; border-right-width:0px; border-top-width:0px; padding-bottom:0px;">' . $public . '</li>';
            $tmp_tree .= '<li style="width:22%; float:left; padding-left:4px; border:1px solid #C8D5E0; border-right-width:0px; border-top-width:0px; padding-bottom:0px;">' . $row['author'] . '</li>';
            $tmp_tree .= '<li style="width:30%; float:left; padding-left:10px; border:1px solid #C8D5E0; border-top-width:0px; text-align:left; padding-bottom:0px;" class="browser-action">' . $action . '</li>';
            $tmp_tree .= '</ul>' . $span_anfang . $span_ende_ab . "\n\n";
            $nr++;
            $x++;
            $level = $row['level'];
        }           
        return $tmp_tree;
    }
    
    public function dmethod() {}
}