<?php

namespace aribu\scripts\pages\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   18.04.2016
 *  
 */

class Elements extends \aribu\scripts\abstracts\Abstracts {
    
    public function __construct($DFE) {
        parent::__construct($DFE);
    }
        
    /**
     * 
     * @return string
     */
    public function NewElement() {
        
        if($this->FB == 'fe_') {
            require_once FE_MENU;
        } else {
            require_once BE_MENU;
        }
        if ($this->DFE->http->issetPost('save_element') === false) {

            $hidden2 = "checked";
            $element_content = "";

            if ($this->DFE->http->issetPost('action') === true) {
                $and = $this->FB == 'fe_' ? "AND client_id = :client_id AND lang = :lang " : "AND lang = :lang ";
                $this->DFE->db->Select('*')
                              ->From('elements')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('eid'))
                              ->Andd($and)
                              ->Parameter($this->FB == 'fe_' ? array('client_id' => $GLOBALS['CLIENT_ID'], 'lang' => $GLOBALS['LANGUAGE']) : array('lang' => $GLOBALS['LANGUAGE']))
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;
                foreach ($row as $key => $val) {
                    ${$key} = $val;
                    $this->DFE->TT->setMC($key, $val);
                }
                if ($hidden == 1) {
                    $hidden1 = "checked";
                    $hidden2 = "";
                } else {
                    $hidden1 = "";
                    $hidden2 = "checked";
                }
                $ec0 = $element_content == 0 ? " checked" : "";
                $ec1 = $element_content == 1 ? " checked" : "";
                $ec2 = $element_content == 2 ? " checked" : "";
                $ec3 = $element_content == 3 ? " checked" : "";

                $element_atr = unserialize($element_attributes);

                $rotate2 = $element_atr['rotate_content'] == 0 ? " checked" : "";
                $rotate1 = $element_atr['rotate_content'] == 1 ? " checked" : "";
               
                $content_limit = $element_atr['content_limit'];
                $selected_page_elmc = $pid != 0 ? '<option value="' . $pid . '" selected>' . \lib\Functions::breadcrumb($pid, 'dot'.$this->FBup.'Menu', $GLOBALS['LANGUAGE']) . '</option>' : '';
                if($element_path == 'element_builder/elements.php') {
                    $this->DFE->http->setPostbyName('class_file', $element_path)->setPostbyName('selected', $class_methods);
                    $select_class_methods = $this->GetMethodsFromElement(true);
                    if($select_class_methods !== false) {
                        $this->DFE->TT->BlockMarker['element_method_select'] = 0;
                    } else {
                        $this->DFE->TT->BlockMarker['element_method_select'] = 1;
                    }
                }
                $this->DFE->TT->setMC('_add', '');
            } else {
                $this->DFE->TT->setMC('_edit', '');
            }
            
            if ($element_atr['pages_show_element'] != "") {
                $page_show_element = explode("-", $element_atr['pages_show_element']);
                foreach ($page_show_element as $key => $val) {
                    $show_elements_option .= $val != 0 ? '<option value="' . $val . '" selected>' . \lib\Functions::breadcrumb($val, 'dot'.$this->FBup.'Menu', $GLOBALS['LANGUAGE']) . '</option>' : "";
                }
            } else {
                $show_elements_option = '<option value="0">' . $_please_select . '</option>';
            }
            
            $this->DFE->TT->setMC('hidden1',                $hidden1)
                          ->setMC('hidden2',                $hidden2) 
                          ->setMC('ec0',                    $ec0)
                          ->setMC('ec1',                    $ec1)
                          ->setMC('ec2',                    $ec2)
                          ->setMC('ec3',                    $ec3)
                          ->setMC('element_atr',            $element_atr)
                          ->setMC('rotate1',                $rotate1)
                          ->setMC('rotate2',                $rotate2)
                          ->setMC('element_content',        $element_content)
                          ->setMC('content_limit',          $content_limit)
                          ->setMC('selected_page_elmc',     $selected_page_elmc)
                          ->setMC('show_elements_option',   $show_elements_option)
                          ->setMC('be_rights',              $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][19] == 1 ? 'onclick="javascript: document.form.action = \'\'; document.form.target = \'_parent\'"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['rights_lock_group'].'"')
                          ->setMC('eid',                    $this->DFE->http->_post('eid'))
                          ->setMC('backlink',               '?')
                          ->setMC('lang',                   $GLOBALS['LANGUAGE'])
                          ->setMC('eid',                    $this->DFE->http->_post('eid'))
                          ->setMC('fb',                     $this->FB == 'be_' ? '&FB=be_' : '')
                          ->setMC('select_class_methods',   $select_class_methods);
            
        } else {
            # Alle Daten werden gespeichert oder upgedated
            if ($this->DFE->http->_post('action') == "edit") {
                $cse = count($this->DFE->http->_post('pages_show_element'));
                if ($cse > 1) {
                    foreach ($this->DFE->http->_post('pages_show_element') as $key => $val) {
                        if ($val != 0) {
                            $pages_show_element[] = $val;
                        }
                    }
                    $pages_show_element = implode("-", $pages_show_element);
                } else {
                    $pages_show_element = $this->DFE->http->isEmpty('pages_show_element') === false ? implode("-", $this->DFE->http->_post('pages_show_element')) : "";
                }

                $element_attributes = array("rotate_content"        => $this->DFE->http->_post('rotate'),
                                            "content_limit"         => $this->DFE->http->_post('content_limit'),
                                            "pages_show_element"    => $pages_show_element);
                $element_attributes = serialize($element_attributes);
                $this->DFE->db->Update('elements')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('eid'))
                              ->Set(array(  "pid"                   => $this->DFE->http->_post('page_uid'),
                                            "element_content"       => $this->DFE->http->_post('element_content'),
                                            "hidden"                => $this->DFE->http->_post('hidden'),
                                            "author"                => $_SESSION['sess_username'],
                                            "marker"                => $this->DFE->http->_post('marker'),
                                            "name"                  => $this->DFE->http->_post('name'),
                                            "element_path"          => $this->DFE->http->_post('element_path'),
                                            "description"           => $this->DFE->http->_post('description'),
                                            "element_attributes"    => $element_attributes,
                                            "class_methods"         => $this->DFE->http->_post('class_methods')))
                              ->doUpdate();
            } else {
                $pages_show_element = $this->DFE->http->_post('pages_show_element') === false ? implode("-", $this->DFE->http->_post('pages_show_element')) : "";
                $element_attributes = array("rotate_content"        => $this->DFE->http->_post('rotate'),
                                            "content_limit"         => $this->DFE->http->_post('content_limit'),
                                            "pages_show_element"    => $pages_show_element);
                $element_attributes = serialize($element_attributes);
                
                $insertArray = array(   'id'                    => '',                                     
                                        'pid'                   => $this->DFE->http->_post('page_uid'),           
                                        'hidden'                => $this->DFE->http->_post('hidden'),         
                                        'marker'                => $this->DFE->http->_post('marker'),             
                                        'tstamp'                => time(),                                    
                                        'name'                  => $this->DFE->http->_post('name'),                
                                        'element_path'          => $this->DFE->http->_post('element_path'),        
                                        'element_content'       => $this->DFE->http->_post('element_content'),     
                                        'description'           => $this->DFE->http->_post('description'),         
                                        'author'                => $_SESSION['sess_username'],                  
                                        'element_attributes'    => $element_attributes,                           
                                        'class_methods'         => $this->DFE->http->_post('class_methods'),       
                                        'lang'                  => $GLOBALS['LANGUAGE'],
                                        'client_id'             => $_SESSION['sess_client_id']);                         
                if($this->FB == 'be_') {
                    unset($insertArray['client_id']);
                }                      
                $this->DFE->db->Insert('elements')
                              ->Parameter($insertArray)
                              ->doInsert();
            }
            # Übersicht nach Datenspeicherung
            header("Location: ?");
            exit;
        }
        
        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/new_element.html');
    }

    public function GetMethodsFromElement($return=false) {
        $db = $this->DFE->db;
        $folder = $this->FB == "be_" ? "/aribu.systems" : "";
        
        if ($this->DFE->http->issetPost('class_file') === true && $this->DFE->http->_post('class_file') != "") {
            if (file_exists(DOC_ROOT . $folder . "/elements/" . $this->DFE->http->_post('class_file'))) {
                include(DOC_ROOT . $folder . "/elements/" . $this->DFE->http->_post('class_file'));
                $classname = get_class($FEContentObj);
                $class_methods = get_class_methods($classname);
                if (is_array($class_methods)) {
                    $select_methods = '<select name="class_methods" class="selectpicker" id="class-methods">';
                    foreach ($class_methods as $key => $val) {
                        if ($val != "__construct") {
                            $selected = $this->DFE->http->_post('selected') == $val ? " selected" : "";
                            $select_methods .= '<option value="' . $val . '"' . $selected . '>' . $val . '</option>';
                        }
                    }
                    $select_methods .= '</select>';
                    if($return === false) {
                        echo $select_methods;
                    } else {
                        return $select_methods;
                    }
                } else {
                    if($return === false) {
                        echo "false";
                    } else {
                        return false;
                    }
                }
            } else {
                if($return === false) {
                    echo "false";
                } else {
                    return false;
                }
            }
        } else {
            if($return === false) {
                echo "false";
            } else {
                return false;
            }
        }
    }

    /**
     * Overview of all elements
     * @return string
     */
    public function Overview() {
        
        switch ($this->DFE->http->_post('action')) {
            case 'hidden':
                $this->DFE->db->Update('elements')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('eid'))
                              ->Set(array("hidden" => 1, "author" => $_SESSION['sess_username']))
                              ->doUpdate();
                break;
            case 'public':
                $this->DFE->db->Update('elements')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('eid'))
                              ->Set(array("hidden" => '0', "author" => $_SESSION['sess_username']))
                              ->doUpdate();
                break;
            case 'del':
                $this->DFE->db->Delete('elements')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('eid'))
                              ->doDelete();
                break;
        }
        
        # Get elements
        $where = $this->FB == 'fe_' ? "WHERE client_id = :client_id AND lang = :lang " : "WHERE lang = :lang ";
        $this->DFE->db->Select('*')
                      ->From('elements')
                      ->noWhere(1)
                      ->Andd($where)
                      ->SelectMethod(1)
                      ->Parameter($this->FB == 'fe_' ? array('client_id' => $GLOBALS['CLIENT_ID'], 'lang' => $GLOBALS['LANGUAGE']) : array('lang' => $GLOBALS['LANGUAGE']))
                      ->doSelect();
        $row = $this->DFE->db->SelectPuffer;
        if ($this->DFE->db->Rows) {
            for ($i = 0; $i < $this->DFE->db->Rows; $i++) {

                # BE Rights Module publish
                if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][21] == 1) {
                    $eid = $row[$i]['id'];
                    $action_hidden = '<a href="javascript:void(0);" onclick="javascript: hideshow(\'hide\',\'' . $_set_offline_sc . '\',\'' . $eid . '\');"><i class="fa fa-globe active" title="' . $this->DFE->TT->getMC('_set_element_offline') . '" aria-hidden="true"></i></a>';
                    $action_public = '<a href="javascript:void(0);" onclick="javascript: hideshow(\'show\',\'' . $_set_online_sc . '\',\'' . $eid . '\');"><i class="fa fa-globe inverse" title="' . $this->DFE->TT->getMC('_set_element_online') . '" aria-hidden="true"></i></a>';
                    $action_status = $row[$i]['hidden'] == 0 ? $action_hidden : $action_public;
                } else {
                    $action_status = $row[$i]['hidden'] == 1 ? '<a href="#" data-toggle="tooltip" data-original-title="'.$this->DFE->TT->getMC('_rights_set_element_online').'"><i class="fa fa-globe disabled" title="' . $this->DFE->TT->getMC('_set_element_online') . '" aria-hidden="true"></i></a>' : '<a href="javascript:void(0);" data-toogle="tooltip" data-original-title="'.$this->DFE->TT->getMC('_rights_set_element_offline').'"><i class="fa fa-globe disabled" title="' . $this->DFE->TT->getMC('_set_element_offline') . '" aria-hidden="true"></i></a>';
                }

                # BE Rights Del Module
                if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][20] == 1) {
                    $action_del = '<a href="javascript:void(0);" onclick="javascript: delElement(\'' . $eid . '\');"><i class="fa fa-trash-o inverse" title="' . $this->DFE->TT->getMC('_del_element') . '" aria-hidden="true"></i></a>';
                } else {
                    $action_del = '<a href="javascript:void(0);" data-toggle="tooltip" data-original-title="Sie haben keine Berechtigung ein Element zu löschen."><i class="fa fa-trash-o disabled" title="' . $this->DFE->TT->getMC('_del_element') . '" aria-hidden="true"></i></a>';
                }

                # Edit element
                $action_edit = '<a href="?ac=NewElement&action=edit&eid=' . $row[$i]['id'] . '"><i class="fa fa-pencil inverse" aria-hidden="true" title="' . $this->DFE->TT->getMC('_edit_element') . '"></i></a>';             

                $this->DFE->TT->setIMC($i, 'no_', ($i + 1) . ".")
                              ->setIMC($i, 'name', $row[$i]['name']) 
                              ->setIMC($i, 'path', !empty($row[$i]['element_path']) ? $row[$i]['element_path'] : '&nbsp;')
                              ->setIMC($i, 'marker', $row[$i]['marker'])
                              ->setIMC($i, 'description', $row[$i]['description'])
                              ->setIMC($i, 'action_status', $action_status)
                              ->setIMC($i, 'action_edit', $action_edit)
                              ->setIMC($i, 'action_del', $action_del);
            }
        } 
        
        $this->DFE->TT->setMC('copy_elements',  '?ac=CopyElements')
                      ->setMC('lang',           $GLOBALS['LANGUAGE'])
                      ->setMC('fb',             $this->FB == 'be_' ? '&FB=be_' : '')
                      ->setMC('be_rights',      $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][34] == 1 ? 'onclick="javascript: location.href = \'?ac=NewElement\';"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['rights_lock_group'].'"');
        
        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/show_elements.html', NULL, 1);
    }
    

    public function CopyElements() {
       
        # Template
        $temp = \lib\Functions::readFiles("/aribu.systems/_templates/pages/copy_elements.html");
        $this->DFE->TT->HTMLBuffer = $temp;
        $this->DFE->TT->TTCompiler();

        
        if ($this->DFE->http->issetPost('save_elements') === false) {
            # Language
            foreach ($GLOBALS['BE_LANGUAGES'] as $key => $val) {
                $selected = $GLOBALS['LANGUAGE'] == $key ? "selected" : "";
                $langoptions .= "<option value=\"" . $key . "\" " . $selected . ">" . $val . "</option>";
            }

            # Backlink
            $backlink = "?";

            $this->DFE->TT->BlockMarker['save'] = 0;
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('lang') == SYS_LANGUAGE) {
                $error = 1;
                $save_message = "Sie können die Elemente in der System-Sprache nicht kopieren. Bitte wählen Sie eine andere Sprache aus.";
                $this->DFE->TT->BlockMarker['save'] = 1;
            }
            $where = $this->FB == 'fe_' ? "WHERE client_id = ".intval($GLOBALS['CLIENT_ID'])." AND lang = '".$this->DFE->http->_post('lang')."' " : "WHERE lang = '".$this->DFE->http->_post('lang')."'";
            $this->DFE->db->Select('*')
                          ->From('elements')
                          ->noWhere(1)
                          ->Andd($where)
                          ->SelectMethod(1)
                          ->doSelect();
            $nume = $this->DFE->db->Rows;
            if ($nume) {
                $error = 1;
                $save_message = "Die Elemente wurden bereits in dieser Sprache angelegt. Bitte wählen Sie eine andere Sprache aus.";
                $this->DFE->TT->BlockMarker['save'] = 1;
            }

            if ($error != 1) {
                $where = $this->FB == 'fe_' ? "WHERE client_id = ".$_SESSION['sess_client_id']." AND lang = '".$GLOBALS['LANGUAGE']."' " : "WHERE lang = '".$GLOBALS['LANGUAGE']."'";
                $this->DFE->db->Select('*')
                          ->From('elements')
                          ->noWhere(1)
                          ->Andd($where)
                          ->SelectMethod(1)
                          ->doSelect();
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    for ($i = 0; $i < $num; $i++) {
                        $insertArray = array(   'id'                    => '', 
                                                'pid'                   => $row[$i]['pid'],                        
                                                'hidden'                => $row[$i]['hidden'],                     
                                                'marker'                => $row[$i]['marker'],                     
                                                'tstamp'                => $row[$i]['tstamp'],                     
                                                'name'                  => $row[$i]['name'],                       
                                                'element_path'          => $row[$i]['element_path'],               
                                                'element_content'       => $row[$i]['element_content'],            
                                                'description'           => $row[$i]['description'],                
                                                'author'                => $row[$i]['author'],                     
                                                'element_attributes'    => $row[$i]['element_attributes'],         
                                                'class_methods'         => $row[$i]['class_methods'],               
                                                'lang'                  => $GLOBALS['LANGUAGE'],
                                                'client_id'             => $row[$i]['client_id']);                  
                                                
                        if($this->FB == 'be_') {
                            unset($insertArray['client_id']);
                        }
                        $this->DFE->db->Insert('elements')
                                      ->Parameter($insertArray)
                                      ->doInsert();
                    }
                }
                # Exit und Jump to folder page
                header("Location: ?");
                exit;
            } else {
                # Fehlerausgabe
                # Language
                foreach ($GLOBALS['BE_LANGUAGES'] as $key => $val) {
                    $selected = $this->DFE->http->_post('lang') == $key ? "selected" : "";
                    $langoptions .= "<option value=\"" . $key . "\" " . $selected . ">" . $val . "</option>";
                }

                # Backlink
                $backlink = "?";
            }
        }

        # Ausgabe 
        $pattern = '/#\#\#(.*?)#\#\#/ims';
        preg_match_all($pattern, $temp, $TempMarker);
        foreach ($TempMarker[0] as $key => $val) {
            $fieldVal = ${$TempMarker[1][$key]};
            $defineArr[$val] = $fieldVal;
        }
        $contTemp = $this->DFE->TT->replaceItems($defineArr);
        return $contTemp;
    }
    
    public function dmethod() {}
}