<?php

namespace aribu\scripts\pages\lib;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   06.09.2012
 * @update: 21.04.2015
 */

class Import_Export extends \aribu\scripts\abstracts\Abstracts {

    public $chields         = array();
    public $RGT             = array();
    public $BL              = array();
    public $CLevel          = array();
    public $sorting         = array();
    public $TableKey;
    public $TableColNames;
    public $LastUID;
    public $Level;
    public $oldContentPID;
    public $Error;

    public function __construct($DFE) {
        parent::__construct($DFE);
        
    }

        
    /*
     * Export pages
     *  
     */
    public function exportPages($template="/aribu.systems/_templates/pages/xml/pages_export_xml.html") {
     
        if ($this->DFE->http->issetPost('export') === true) {
            if($this->DFE->http->_post('exportUID') != 'x') {
                $TTT = clone $this->DFE->TT;

                if ($this->SytemLanguage != $GLOBALS['LANGAUGE']) {
                    $TTT->BlockMarker['rid'] = 0;
                    $TTT->BlockMarker['lang'] = 0;
                }

                if ($this->DFE->http->_post('export_recursiv') == 1) {
                    $and_id = $this->DFE->http->_post('exportUID') != 0 ? "AND n.uid = " . $this->DFE->http->_post('exportUID') : "";
                    $this->DFE->db->Select("o.*")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt " . $and_id . " " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                                  ->Group('GROUP BY o.lft')
                                  ->Order('ORDER BY o.lft')
                                  ->SelectMethod(1)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    if ($num) {
                        $row = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num; $i++) {
                            foreach ($row[$i] as $tkey => $tval) {
                                if ($tkey != "pageSettings") {
                                    $TTT->setIMC($i, $tkey, htmlentities($tval, ENT_QUOTES, "UTF-8"), 1);
                                } else {
                                    $TTT->setIMC($i, $tkey, $tval, 1);
                                }
                                $TTT->setIBM($i, 'lang', $this->DFE->Pages == "pages" ? 0 : 1, 1);
                            }
                            $content_uid[] = $row[$i]['uid'];
                        }
                    }
                } else {
                    $this->DFE->db->Select("n.*")
                                  ->From($this->DFE->Pages . " AS n")
                                  ->noWhere(1)
                                  ->Andd("WHERE n.uid = " . $this->DFE->http->_post('exportUID') . " " . str_replace("%%%n%%%", "n.", $this->DFE->and_lang))
                                  ->SelectMethod(1)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    if ($num) {
                        $row = $this->DFE->db->SelectPuffer;
                        $z=0;
                        foreach ($row as $tkey => $tval) {
                            if ($tkey != "pageSettings") {
                                $TTT->setIMC($z, $tkey, htmlentities($tval, ENT_QUOTES, "UTF-8"), 1);
                            } else {
                                $TTT->setIMC($z, $tkey, $tval, 1);
                            }
                            $TTT->setIBM($z, 'lang', $this->DFE->Pages == "pages" ? 0 : 1, 1);
                            $z++;
                        }
                        $content_uid[0] = $row['uid'];
                    }
                }

                if ($this->DFE->http->_post('copy_content') != 1) {
                    $TTT->BlockMarker['content'] = 0;
                } else {
                    foreach ($content_uid as $ckey => $cval) {
                        # Content holen
                        $this->DFE->db->Select('cont.*')
                                      ->From("content cont, " . $this->FB . $this->DFE->Pages . " pages")
                                      ->WhereColName('cont.pid')
                                      ->WhereColValue($cval)
                                      ->Andd("AND cont.pid = pages.uid " . str_replace("%%%n%%%", "pages.", $this->DFE->and_lang))
                                      ->SelectMethod(1)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        $num = $this->DFE->db->Rows;
                        if ($num) {
                            $row_c = $this->DFE->db->SelectPuffer;
                            for ($a = 0; $a < $num; $a++) {
                                foreach ($row_c[$a] as $ctkey => $ctval) {
                                    if ($tkey != "script_method") {
                                        $TTT->setIMC($a, $ctkey, htmlentities($ctval, ENT_QUOTES, "UTF-8"), 2);

                                    } else {
                                        $TTT->setIMC($a, $ctkey, $ctval, 2);
                                    }
                                    $TTT->setIBM($a, 'lang', $this->DFE->Pages == "pages" ? 0 : 1, 2);
                                }
                            }
                        }
                    }
                }
                $TTT->setMC('tablename',    $this->FB . $this->DFE->Pages)
                    ->setMC('fb',           $this->FB);

                $xmlTemp = $TTT->getFilledTemplate($template,NULL,1,2,0);

                # XML speichern
                $xml_zusatz = date("Y.m.d - H:i", time());
                $xml_zusatz = str_replace(".", "_", $xml_zusatz);
                $xml_zusatz = str_replace(" - ", "-", $xml_zusatz);
                $xml_zusatz = str_replace(":", "_", $xml_zusatz);
                $xml_name = "Export_".$this->FBup."Pages_" . $xml_zusatz . ".xml";
                $XMLfilename = DOC_ROOT . "/fileadmin/xml/" . $xml_name;
                if(\lib\Functions::CheckIfDirectoryExists("/fileadmin/xml/")){}
                $XMLfilehandle = fopen($XMLfilename, "w");

                fputs($XMLfilehandle, $xmlTemp);
                fclose($XMLfilehandle);

                header("Pragma: public");
                header("Expires: 0");
                header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                header("Cache-Control: private", false);
                header("Content-Type: application/force-download");
                header("Content-Disposition: attachment; filename=\"" . $xml_name . "\";");
                header("Content-Transfer-Encoding: binary");
                header("Content-Length: " . filesize($XMLfilename));
                readfile($XMLfilename);
                @unlink($XMLfilename);
                exit;
            } else {
                
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_error_export'), 'messenger-on-top messenger-on-right', 'error'));
                
            }
        }
        
        $TTT = clone $this->DFE->TT;

        $this->DFE->TT->setMC('backlink',         \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                      ->setMC('export_action',    \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'ExportPages'], $GLOBALS['LANGUAGE']))
                      ->setMC('lang',             $GLOBALS['LANGUAGE'])
                      ->setMC('sid',              $_SESSION['sess_id'])
                      ->setMC('fb',               $this->FB == 'be_' ? '&FB=be_' : '');

       
        return $this->DFE->TT->getFilledTemplate("/aribu.systems/_templates/pages/export_pages.html", 1);
    }

    /**
     * Import Data
     * @param string $template
     * @return string 
     */
    public function importData($template="/aribu.systems/_templates/pages/import.html") {
        
        if ($this->DFE->http->issetPost('import') === false) {
            $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
            if ($this->DFE->http->issetPost('imp') === true) {
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_import_successful'), 'messenger-on-top messenger-on-right', 'success'));
            } elseif(isset($this->Error['Validation'])) {
                $this->DFE->TT->BlockMarker['error'] = 0;
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            }
            
        } else {
            # File upload
            $dir = "/fileadmin/xml/";

            $xmlFile = \lib\Functions::readFiles($dir . $this->DFE->http->_post('xmlFile'));
            $xmlArray = \lib\Functions::xml2array($xmlFile, 0);
            if (is_array($xmlArray)) {
                $import_return = $this->importDataFromXML($xmlArray);
                $import_status = $import_return === TRUE ? "ok" : "error";
                unlink(DOC_ROOT . $dir . $this->DFE->http->_post('xmlFile'));

                # Import was successful
                header("Location: ?imp=" . $import_status);
                exit;
            } else {
                $this->Error['Validation'] = $this->DFE->TT->getMC('_import_failure');
            }
        }
        
        $this->DFE->TT->setMC('sid',            $_SESSION['sess_id'])
                      ->setMC('lang',           $GLOBALS['LANGUAGE'])
                      ->setMC('ajax',           \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['Ajax'], $GLOBALS['LANGUAGE']))
                      ->setMC('upload_error',   $fileHandle->UploadError)
                      ->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']));
                      
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    
    /**
     * 
     * @staticvar int $level
     * @param type $xmlArray
     * @return boolean
     */
    public function importDataFromXML($xmlArray) {
      
        static $level = 0;

        if (is_array($xmlArray)) {
            foreach ($xmlArray as $key => $xml_val) {
                if ($level == 1) {
                    $this->TableKey = $key;
                }

                if (is_array($xml_val) && !empty($xml_val) && $key != "column") {
                    $level++;
                    $insert_return = $this->importDataFromXML($xml_val);
                    $this->Level = $level;
                    $level--;
                } else {

                    if ($this->DFE->http->_post('replace') == 1) {
                        $this->getCols($this->TableKey);
                        # Add datas
                        if ($this->TableKey == $this->FB."pages") {
                            $update_begin = 3;
                        } elseif ($this->TableKey == $this->FB."pages_language") {
                            $update_begin = 3;
                        } else {
                            $update_begin = 0;
                        }

                        # Daten updaten
                        $this->DFE->db->TablePreName = "";
                        $update_array = array();
                        for ($a = 0; $a < count($this->TableColNames[$this->TableKey]); $a++) {
                            if ($a > $update_begin) {
                                if ($level == 3) {
                                    $update_array[$this->TableColNames[$this->TableKey][$a]] = is_array($xml_val['column'][$a]) ? "" : html_entity_decode($xml_val['column'][$a], ENT_QUOTES, "UTF-8");
                                } else {
                                    $update_array[$this->TableColNames[$this->TableKey][$a]] = is_array($xml_val[$a]) ? "" : html_entity_decode($xml_val[$a], ENT_QUOTES, "UTF-8");
                                }
                            }
                        }

                        if ($level == 3) {
                            $dbg = $this->DFE->db->Update($this->TableKey)
                                                 ->WhereColName($this->TableColNames[$this->TableKey][0])
                                                 ->WhereColValue($xml_val['column'][0])
                                                 ->Set($update_array)
                                                 ->doUpdate();
                        } else {
                            $dbg = $this->DFE->db->Update($this->TableKey)
                                                 ->WhereColName($this->TableColNames[$this->TableKey][0])
                                                 ->WhereColValue($xml_val[0])
                                                 ->Set($update_array)
                                                 ->doUpdate();
                        }
                        
                    } else {
                        # Daten neu hinzufügen
                        if ($this->TableKey == "fe_pages" || $this->TableKey == "fe_pages_language") {
                            $val_Array = $level == 3 ? $xml_val['column'] : $xml_val;
                            if ($this->TableKey == "fe_pages") {
                                $pageLevel = $val_Array[42] - 1 < 0 ? "0" : $val_Array[42] - 1;
                            } else {
                                $pageLevel = $val_Array[43] - 1 < 0 ? "0" : $val_Array[43] - 1;
                            }
                            $lastUID = $level == 3 ? $this->DFE->http->_post('lastUID') : $this->LastUID[$pageLevel];
                            $insertP = $level == 3 ? "out" : "in";
                            $insert = $level == 3 ? $this->DFE->http->_post('join') : $insertP;

                            # Werte Array aufbereiten
                            foreach ($val_Array as $akey => $aval) {
                                $val_Array[$akey] = !empty($aval) ? html_entity_decode($aval, ENT_QUOTES, "UTF-8") : "";
                            }

                            $insert_return = $this->insertPages($val_Array, $insert, $lastUID);
                            $this->Level = $level;
                        } elseif ($this->TableKey == "fe_content") {
                            $cval = $level == 3 && is_array($xml_val['column']) ? $xml_val['column'] : $xml_val;
                            $opid = $level == 3 && is_array($xml_val['column']) ? $xml_val['column'][1] : $xml_val[1];
                            if ($GLOBALS['LANGUAGE'] == $cval[7]) {

                                $new_uid = $this->oldContentPID[$opid];

                                # Werte Array aufbereiten
                                foreach ($cval as $akey => $aval) {
                                    $val[$akey] = !empty($aval) ? html_entity_decode($aval, ENT_QUOTES, "UTF-8") : "";
                                }

                                $this->DFE->db->Insert('content')
                                              ->Parameter(array(    'uid'               => '', 
                                                                    'pid'               => $new_uid, 
                                                                    'tstamp'            => time(), 
                                                                    'lastUpdated'       => $val[3], 
                                                                    'hidden'            => $val[4], 
                                                                    'sorting'           => $val[5],    
                                                                    'CType'             => $val[6], 
                                                                    'lang'              => $GLOBALS['LANGUAGE'], 
                                                                    'bodytext'          => $val[8], 
                                                                    'starttime'         => $val[9], 
                                                                    'endtime'           => $val[10], 
                                                                    'headline'          => $val[11], 
                                                                    'subline'           => $val[12], 
                                                                    'script_method'     => $val[13], 
                                                                    'script_path'       => $val[14], 
                                                                    'content_name'      => $val[15], 
                                                                    'author'            => $_SESSION['sess_username'], 
                                                                    'colP'              => $val[17], 
                                                                    'vid'               => $val[18], 
                                                                    'perms_userid'      => $val[19], 
                                                                    'perms_groupid'     => $val[20], 
                                                                    'perms_be_userid'   => $val[21], 
                                                                    'perms_be_groupid'  => $val[22]))
                                              ->doInsert();
                                $insert_return = true;
                            }
                        }
                    }
                }
            }
        }
        return $insert_return;
    }

    public function getCols($table) {
        
        if (!isset($this->TableColNames[$table])) {
            $this->DFE->db->GSelect("SHOW COLUMNS FROM " . $table);
            $row = $this->DFE->db->SelectPuffer;
            $num = $this->DFE->db->Rows;

            for ($i = 0; $i < $num; $i++) {
                $this->TableColNames[$table][$i] = $row[$i]['Field'];
            }
        }
    }

    public function uploadXML() {
        
        $fileHandle = new \lib\fileupload();
        
        # File Upload
        $dir = "/fileadmin/xml/";
        if(\lib\Functions::CheckIfDirectoryExists($dir));

        $fileHandle->ErrorExtTypes = array("xml", "XML");
        $File = $fileHandle->fileUpload(DOC_ROOT . $dir);
        if ($File) {
            $xmlFile = \lib\Functions::readFiles($dir . $File[0]);
            $xmlArray = \lib\Functions::xml2array($xmlFile, 0);
            if (isset($xmlArray['aribu_xml_export']['fe_pages']) || isset($xmlArray['aribu_xml_export']['fe_pages_language']) || isset($xmlArray['dotorange_xml_export']['fe_pages']) || isset($xmlArray['dotorange_xml_export']['fe_pages_language'])) {
                $type = "pages";
            } else {
                $type = "normal";
            }
            $javascript .= "<script type=\"text/javascript\">\n";
            $javascript .= "top.uploadResult = ({\"status\":\"uploadReady\",\"file\":\"" . $File[0] . "\",\"type\":\"" . $type . "\"});\n";
            $javascript .= "</script>";
            echo $javascript;
        } else {
            switch ($fileHandle->ErrorType) {
                case "1": # Datei zu groß
                    $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"upbig\"})\n";
                    break;

                case "2": # Falsche Dateiendung
                    $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"ext\"})\n";
                    break;

                case "3": # Keine Datei gewählt
                    $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"empty_file\"})\n";
                    break;

                case "4": # Upload Fehler
                    $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"uperr\"})\n";
                    break;
            }
            $javascript .= "<script type=\"text/javascript\">\n";
            $javascript .= $upError;
            $javascript .= "</script>";
            echo $javascript;
        }
    }
    
    /**
     * 
     * @param type $template
     * @return type
     */
    public function getInsertPageTemp($template="/aribu.systems/_templates/pages/insert_page.html") {
        # Template language
        require_once($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems/scripts/pages/lang/" . $_SESSION['sess_language'] . ".php");
        $this->SetFB();
        $this->setTemplateLanguage($be_language);
        $this->PrepareLanguage($be_language);
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    /**
     * 
     * @param type $val
     * @param type $insert
     * @param type $lastUID
     * @return boolean
     */
    public function insertPages($val, $insert, $lastUID) {
        
        $this->DFE->db->Select('uid, pid, sorting, nav_title, lft, rgt')
                      ->From($this->DFE->Pages)
                      ->WhereColName('uid')
                      ->WhereColValue($lastUID)
                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->Order("ORDER BY sorting ASC")
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        if ($num) {
            $row = $this->DFE->db->SelectPuffer;
            switch ($insert) {
                case 'in': # In a page
                    $this->DFE->db->Select('sorting')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($lastUID)
                                  ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Order('ORDER BY sorting DESC')
                                  ->SelectMethod(1)
                                  ->doSelect();
                    $num_s = $this->DFE->db->Rows;
                    $sorting = $num_s > 0 ? $num_s + 1 : 1;
                    $pid = $row['uid'];

                    # Nested Sets Modell
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lft" => "lft+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE rgt >= " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("rgt" => "rgt+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    $lft = $row['rgt'];
                    $rgt = $row['rgt'] + 1;
                    
                    break;

                case 'out': # After a page
                    $sorting = $row['sorting'] + 1;
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($row['pid'])
                                  ->Andd("AND sorting > " . $row['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array(  "sorting"       => "sorting+1", 
                                                "lastUpdated"   => time()))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $pid = $row['pid'];

                    # Nested Sets Modell
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lft" => "lft+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE rgt > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("rgt" => "rgt+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    $lft = $row['rgt'] + 1;
                    $rgt = $row['rgt'] + 2;
                    break;

                case 'over': # Over a page
                    $sorting = $row['sorting'];
                    if ($sorting == 0) {
                        $sorting = 1;
                    }
                    $pid = $row['pid'];
                    # Update der Seite
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($row['pid'])
                                  ->Andd("AND sorting >= " . $sorting . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array(  "sorting"       => "sorting+1", 
                                                "lastUpdated"   => time()))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    # Nested Sets Modell
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE rgt > " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("rgt" => "rgt+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE lft >= " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lft" => "lft+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    $lft = $row['lft'];
                    $rgt = $row['lft'] + 1;
                    break;
                    
            }


            # Neue Seite speichern
            if ($GLOBALS['LANGUAGE'] == SYS_LANGUAGE) {
                $this->DFE->db->Insert($this->DFE->Pages)
                              ->Parameter(array('uid'               => '', 
                                                'pid'               => $pid, 
                                                'lft'               => $lft, 
                                                'rgt'               => $rgt, 
                                                'docType'           => $val[4], 
                                                'spid'              => $val[5], 
                                                'tstamp'            => time(), 
                                                'sorting'           => $sorting, 
                                                'deleted'           => $val[8], 
                                                'perms_userid'      => $val[9], 
                                                'perms_groupid'     => $val[10], 
                                                'perms_be_userid'   => $val[11], 
                                                'perms_be_groupid'  => $val[12], 
                                                'crdate'            => time(), 
                                                'cruser_id'         => $_SESSION['sess_uid'], 
                                                'pagename'          => $val[15], 
                                                'url'               => $val[16], 
                                                'hidden'            => $val[17], 
                                                'starttime'         => $val[18], 
                                                'endtime'           => $val[19], 
                                                'urltype'           => $val[20], 
                                                'pageSettings'      => $val[21], 
                                                'target'            => $val[22], 
                                                'lastUpdated'       => $val[23], 
                                                'description'       => $val[24], 
                                                'author'            => $val[25], 
                                                'author_email'      => $_SESSION['sess_user_email'], 
                                                'nav_title'         => $val[27], 
                                                'content_from_pid'  => $val[28], 
                                                'button'            => $val[29], 
                                                'button_path'       => $val[30], 
                                                'button_act_path'   => $val[31], 
                                                'sitetpl'           => $val[32], 
                                                'module'            => $val[33], 
                                                'BrowserTitle'      => $val[34], 
                                                'keywords'          => $val[35], 
                                                'page_Hash'         => $val[36], 
                                                'link_title'        => $val[37], 
                                                'move_update'       => $val[38], 
                                                'Javascript'        => $val[39], 
                                                'Stylesheet'        => $val[40], 
                                                'this_css'          => $val[41], 
                                                'level'             => $val[42], 
                                                'search'            => $val[43]))
                              ->doInsert();

                $last_insert_id = $this->DFE->db->LastInsertID;
                $pval = $val[42] == 0 ? "0" : $val[42];
                $this->LastUID[$pval] = $last_insert_id;
                $this->oldContentPID[$val[0]] = $last_insert_id;
            } else {
                $this->DFE->db->Insert($this->DFE->Pages)
                            ->Parameter(array(    'uid'               => '', 
                                                  'rid'               => $val[1], 
                                                  'pid'               => $pid, 
                                                  'lft'               => $lft, 
                                                  'rgt'               => $rgt, 
                                                  'docType'           => $val[5], 
                                                  'spid'              => $val[6], 
                                                  'tstamp'            => time(), 
                                                  'sorting'           => $sorting, 
                                                  'deleted'           => $val[9], 
                                                  'perms_userid'      => $val[10], 
                                                  'perms_groupid'     => $val[11], 
                                                  'perms_be_userid'   => $val[12], 
                                                  'perms_be_groupid'  => $val[13], 
                                                  'crdate'            => time(), 
                                                  'cruser_id'         => $_SESSION['sess_uid'], 
                                                  'pagename'          => $new_pagename, 
                                                  'url'               => $val[17], 
                                                  'hidden'            => $val[18], 
                                                  'starttime'         => $val[19], 
                                                  'endtime'           => $val[20], 
                                                  'urltype'           => $val[21], 
                                                  'pageSettings'      => $val[22], 
                                                  'target'            => $val[23], 
                                                  'lastUpdated'       => $val[24], 
                                                  'description'       => $val[25], 
                                                  'author'            => $_SESSION['sess_username'], 
                                                  'author_email'      => $_SESSION['sess_user_email'], 
                                                  'nav_title'         => $val[28], 
                                                  'content_from_pid'  => $val[29], 
                                                  'button'            => $val[30], 
                                                  'button_path'       => $val[31], 
                                                  'button_act_path'   => $val[32], 
                                                  'sitetpl'           => $val[33], 
                                                  'module'            => $val[34], 
                                                  'BrowserTitle'      => $val[35], 
                                                  'keywords'          => $val[36], 
                                                  'page_Hash'         => $val[37], 
                                                  'link_title'        => $val[38], 
                                                  'move_update'       => $val[39], 
                                                  'Javascript'        => $val[40], 
                                                  'Stylesheet'        => $val[41], 
                                                  'this_css'          => $val[42], 
                                                  'level'             => $val[43], 
                                                  'lang'              => $GLOBALS['LANGUAGE'], 
                                                  'search'            => $val[45]))
                            ->doInsert();

                $last_insert_id = $this->DFE->db->LastInsertID;
                $pval = $val[43] == 0 ? "0" : $val[43];
                $this->LastUID[$pval] = $last_insert_id;
                $this->oldContentPID[$val[0]] = $last_insert_id;
            }
            
            # Page hash berechnen
            $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($last_insert_id, '', 0, 0, 1, '', '', true) : \lib\fe_menu::getTreePathNames($last_insert_id, '', 0, 0, 1, '', '');
            $page_Hash = md5($page_Hash);

            # Update page hash
            $this->DFE->db->Update($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($last_insert_id)
                          ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Set(array("page_Hash" => $page_Hash))
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doUpdate();

            # Level Updaten
            $this->DFE->db->Select("COUNT(*)-1 AS level")
                          ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                          ->noWhere(1)
                          ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                          ->Group("GROUP BY n.lft")
                          ->Order("ORDER BY n.lft") 
                          ->Parameter($this->DFE->and_lang != '' ? array('uid' => $last_insert_id, 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                          ->doSelect();
            $row3 = $this->DFE->db->SelectPuffer;
            $this->DFE->db->Update($this->DFE->Pages)
                          ->noWhere(1)
                          ->Andd("WHERE uid = :uid " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Set(array("level" => $row3['level']))
                          ->Parameter($this->DFE->and_lang != '' ? array('uid' => $last_insert_id, 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                          ->doUpdate();
                                    
            return TRUE;
        } else {
            $this->DFE->db->Select('uid, pid, sorting, nav_title')
                          ->From($this->DFE->Pages)
                          ->WhereColName('pid')
                          ->WhereColValue(0)
                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Order("ORDER BY sorting DESC")
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->SelectMethod(1)
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            if ($num) {
                return false;
            } else {
                $sorting = 1;
                $pid = 0;
                $lft = 1;
                $rgt = 2;

                # Neue Seite speichern
                if ($GLOBALS['LANGUAGE'] == SYS_LANGUAGE) {
                    $this->DFE->db->Insert($this->DFE->Pages)
                                ->Parameter(array('uid'               => '', 
                                                  'pid'               => $pid, 
                                                  'lft'               => $lft, 
                                                  'rgt'               => $rgt, 
                                                  'docType'           => $val[4], 
                                                  'spid'              => $val[5], 
                                                  'tstamp'            => time(), 
                                                  'sorting'           => $sorting, 
                                                  'deleted'           => $val[8], 
                                                  'perms_userid'      => $val[9], 
                                                  'perms_groupid'     => $val[10], 
                                                  'perms_be_userid'   => $val[11], 
                                                  'perms_be_groupid'  => $val[12], 
                                                  'crdate'            => time(), 
                                                  'cruser_id'         => $_SESSION['sess_uid'], 
                                                  'pagename'          => $val[15], 
                                                  'url'               => $val[16], 
                                                  'hidden'            => $val[17], 
                                                  'starttime'         => $val[18], 
                                                  'endtime'           => $val[19], 
                                                  'urltype'           => $val[20], 
                                                  'pageSettings'      => $val[21], 
                                                  'target'            => $val[22], 
                                                  'lastUpdated'       => $val[23], 
                                                  'description'       => $val[24], 
                                                  'author'            => $val[25], 
                                                  'author_email'      => $_SESSION['sess_user_email'], 
                                                  'nav_title'         => $val[27], 
                                                  'content_from_pid'  => $val[28], 
                                                  'button'            => $val[29], 
                                                  'button_path'       => $val[30], 
                                                  'button_act_path'   => $val[31], 
                                                  'sitetpl'           => $val[32], 
                                                  'module'            => $val[33], 
                                                  'BrowserTitle'      => $val[34], 
                                                  'keywords'          => $val[35], 
                                                  'page_Hash'         => $val[36], 
                                                  'link_title'        => $val[37], 
                                                  'move_update'       => $val[38], 
                                                  'Javascript'        => $val[39], 
                                                  'Stylesheet'        => $val[40], 
                                                  'this_css'          => $val[41], 
                                                  'level'             => $val[42], 
                                                  'search'            => $val[43]))
                                ->doInsert();

                    $last_insert_id = $this->DFE->db->LastInsertID;
                    $pval = $val[42] == 0 ? "0" : $val[42];
                    $this->LastUID[$pval] = $last_insert_id;
                    $this->oldContentPID[$val[0]] = $last_insert_id;
                } else {
                    $this->DFE->db->Insert($this->DFE->Pages)
                                  ->Parameter(array(    'uid'               => '', 
                                                        'rid'               => $val[1], 
                                                        'pid'               => $pid, 
                                                        'lft'               => $lft, 
                                                        'rgt'               => $rgt, 
                                                        'docType'           => $val[5], 
                                                        'spid'              => $val[6], 
                                                        'tstamp'            => time(), 
                                                        'sorting'           => $sorting, 
                                                        'deleted'           => $val[9], 
                                                        'perms_userid'      => $val[10], 
                                                        'perms_groupid'     => $val[11], 
                                                        'perms_be_userid'   => $val[12], 
                                                        'perms_be_groupid'  => $val[13], 
                                                        'crdate'            => time(), 
                                                        'cruser_id'         => $_SESSION['sess_uid'], 
                                                        'pagename'          => $new_pagename, 
                                                        'url'               => $val[17], 
                                                        'hidden'            => $val[18], 
                                                        'starttime'         => $val[19], 
                                                        'endtime'           => $val[20], 
                                                        'urltype'           => $val[21], 
                                                        'pageSettings'      => $val[22], 
                                                        'target'            => $val[23], 
                                                        'lastUpdated'       => $val[24], 
                                                        'description'       => $val[25], 
                                                        'author'            => $_SESSION['sess_username'], 
                                                        'author_email'      => $_SESSION['sess_user_email'], 
                                                        'nav_title'         => $val[28], 
                                                        'content_from_pid'  => $val[29], 
                                                        'button'            => $val[30], 
                                                        'button_path'       => $val[31], 
                                                        'button_act_path'   => $val[32], 
                                                        'sitetpl'           => $val[33], 
                                                        'module'            => $val[34], 
                                                        'BrowserTitle'      => $val[35], 
                                                        'keywords'          => $val[36], 
                                                        'page_Hash'         => $val[37], 
                                                        'link_title'        => $val[38], 
                                                        'move_update'       => $val[39], 
                                                        'Javascript'        => $val[40], 
                                                        'Stylesheet'        => $val[41], 
                                                        'this_css'          => $val[42], 
                                                        'level'             => $val[43], 
                                                        'lang'              => $GLOBALS['LANGUAGE'], 
                                                        'search'            => $val[45]))
                                  ->doInsert();

                    $last_insert_id = $this->DFE->db->LastInsertID;
                    $pval = $val[43] == 0 ? "0" : $val[43];
                    $this->LastUID[$pval] = $last_insert_id;
                    $this->oldContentPID[$val[0]] = $last_insert_id;
                }

                # Update page hash
                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($last_insert_id)
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Set(array("page_Hash" => $page_Hash))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doUpdate();

                # Level Updaten
                $this->DFE->db->Select("COUNT(*)-1 AS level")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                              ->noWhere(1)
                              ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                              ->Group("GROUP BY n.lft")
                              ->Order("ORDER BY n.lft") 
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $last_insert_id, 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                              ->doSelect();
                $row3 = $this->DFE->db->SelectPuffer;
                $this->DFE->db->Update($this->DFE->Pages)
                              ->noWhere(1)
                              ->Andd("WHERE uid = :uid " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Set(array("level" => $row3['level']))
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $last_insert_id, 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                              ->doUpdate();

                return TRUE;
            }
        }
    }

    public function dmethod() {}

}