<?php

namespace aribu\scripts\pages\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   18.04.2016
 *  
 */

class Javascript extends \aribu\scripts\abstracts\Abstracts {
    
    public function __construct($DFE) {
        parent::__construct($DFE);
    }
    
       
    /**
     * Javascript
     * @param type $error
     * @return string
     */
    public function Javascript($error = '', $type = 'success') {
                
        if ($this->DFE->http->issetPost('savejs') === false) {

            # JS holen
            $this->DFE->db->Select('jscripts')
                          ->From('html_header')
                          ->noWhere(1)
                          ->Andd('WHERE (client_id = :client_id OR client_id = 0) AND (lang = :lang OR lang = "") ')
                          ->Parameter(array('client_id' => $_SESSION['sess_client_id'], 'lang' => $GLOBALS['LANGUAGE']))
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            if($num) {
                
                $this->DFE->TT->setMC('be_rights',  $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][16] == 1 ? '' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_js'].'"')
                              ->setMC('javascript', htmlentities(stripslashes($this->DFE->db->SelectPuffer['jscripts']), ENT_QUOTES, "UTF-8"));
                
                if ($error != '') {
                    $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                    $this->DFE->TT->setMC('messenger',  $Widget->Messenger($error, 'messenger-on-top messenger-on-right', $type));
                } 
            } else {
                # Insert new client
                $this->DFE->db->Insert('html_header')
                              ->Parameter(array(    'hid'           => '', 
                                                    'metatags'      => '', 
                                                    'stylesheet'    => '', 
                                                    'stylesheet_ff' => '', 
                                                    'jscripts'      => '', 
                                                    'lang'          => $GLOBALS['LANGUAGE'],
                                                    'client_id'     => $_SESSION['sess_client_id']))
                              ->doInsert();
            }
            
        } else {
            # Update Speichern
            $this->DFE->db->Update('html_header')
                           ->noWhere(1)
                           ->Andd("WHERE client_id = :client_id OR client_id = 0 ")
                           ->Set(array("jscripts" => $this->DFE->http->_post('jscript')))
                           ->Parameter(array('client_id' => $_SESSION['sess_client_id']))
                           ->doUpdate();
            $this->DFE->http->unsetPost('savejs');
            $this->Javascript(str_replace("###file###", "JS", $this->be_language['_saveok']));
        }

        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/javascript.html');
    }

    public function dmethod() {
        
    }

}