<?php

namespace aribu\scripts\pages\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   18.04.2016
 *  
 */

class Menu extends \aribu\scripts\abstracts\Abstracts {
    
    public function __construct($DFE) {
        parent::__construct($DFE);
    }
    
    /**
     * Overview menu configuration
     * @return string
     */
    public function Overview() {
       
        switch ($this->DFE->http->_post('action')) {
            case 'del':
                $this->DFE->db->Delete('menu_config')
                              ->WhereColName('menu_title')
                              ->WhereColValue($this->DFE->http->_post('mid'))
                              ->doDelete();
                break;
            case 'deleteAll':
                if($_SESSION['BE_Rights'] == 1) {
                    $this->DFE->db->Truncate()
                                  ->Table("menu_config")
                                  ->doTruncate();
                    header("Location: ?");
                    exit;
                    break;
                } else {
                    $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                    $this->DFE->TT->setMC('messenger', $Widget->Messenger($this->DFE->TT->getMC('_error_delete_menu_setup'), 'messenger-on-top messenger-on-right', 'error'));
                }
        }

        if($this->FB == 'fe_') {
            $where = "client_id = ".intval($GLOBALS['CLIENT_ID'])." AND";
        }
                       
        $this->DFE->db->Select('*')
                      ->From('menu_config')
                      ->noWhere(1)
                      ->Andd("WHERE ".$where." menu_key = 'Type' AND menu_lang = :menu_lang ")
                      ->Order('ORDER BY menu_title')
                      ->Parameter(array('menu_lang' => $GLOBALS['LANGUAGE']))
                      ->SelectMethod(1)
                      ->doSelect();
        $row = $this->DFE->db->SelectPuffer;
        $num = $this->DFE->db->Rows;
        if ($num) {
            for ($i = 0; $i < $num; $i++) {
                
                $this->DFE->TT->setIMC($i, 'action_del', $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][36] == 1 ? '<a href="?ac=Overview&action=del&mid=' . $row[$i]['menu_title'] . '" title="'. $this->be_language['_del_menu'] .'"><i class="fa fa-trash inverse" aria-hidden="true"></i></a>' : '<a href="#" title="'. $this->be_language['_del_menu'] .'"><i class="fa fa-trash inverse disabled" aria-hidden="true"></i></a>')
                              ->setIMC($i, 'action_edit', $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][37] == 1 ? '<a href="?ac=EditMenu&action=copy&mid=' . $row[$i]['menu_title'] .'" title="'. $this->be_language['_copy_menu'] .'"><i class="fa fa-copy inverse" aria-hidden="true"></i></a>' : '<a href="#" title="'. $this->be_language['_copy_menu'] .'"><i class="fa fa-copy inverse disabled" aria-hidden="true"></i></a>')
                              ->setIMC($i, 'action_copy', $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][35] == 1 ? '<a href="?ac=EditMenu&action=edit&mid=' . $row[$i]['menu_title'] . '" title="'. $this->be_language['_edit_menu'] .'"><i class="fa fa-pencil inverse" aria-hidden="true"></i></a>' : '<a href="#" title="'. $this->be_language['_edit_menu'] .'"><i class="fa fa-pencil inverse disabled" aria-hidden="true"></i></a>')
                              ->setIMC($i, 'menu_value', $row[$i]['menu_value'] == '' ? "&nbsp;" : $row[$i]['menu_value'])
                              ->setIMC($i, 'nr', ($i + 1).'.')
                              ->setIMC($i, 'menu_key', $row[$i]['menu_title'])
                              ->setIMC($i, 'menu_type', htmlspecialchars($row[$i]['menu_value']));  
            }
        } else {
            $this->DFE->TT->setIMC(0, 'nr', '');
        }

        if ($this->DFE->http->_post('action') == "edit") {
            $this->DFE->db->Select('*')
                          ->From('menu_config')
                          ->WhereColName('menu_id')
                          ->WhereColValue($this->DFE->http->_post('mid'))
                          ->doSelect();
            $rowe = $this->DFE->db->SelectPuffer;
        }

        $this->DFE->TT->setMC('be_rights', $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][34] == 1 ? 'onclick="javascript: location.href = \'?ac=EditMenu\';"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_new_menu'].'"')
                      ->setMC('be_rights_copy', $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][34] == 1 ? 'onclick="javascript: location.href = \'?ac=CopyMenuConfig\';"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_new_menu'].'"')
                      ->setMC('be_rights_delete', $_SESSION['BE_Rights'] == 1 ? 'onclick="javascript: DeleteMenuSetup();"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_delete_menu_setup'].'"');
        
        $this->DFE->TT->BlockMarker['delete_menu'] = $_SESSION['BE_Rights'] == 1 ? 1 : 0;
        
        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/menu_setup.html', NULL, 1);
    }

    /**
     * Edit menu
     * @return string
     */
    public function EditMenu($template = "/aribu.systems/_templates/pages/edit_menu.html") {
        if($this->FB == 'fe_') {
            require_once FE_MENU;
        }
        
        if ($this->DFE->http->issetPost('save_menu') === false) {

            if ($this->DFE->http->issetPost('action') === true) {
                $and = $this->FB == 'fe_' ? "AND client_id = ".$_SESSION['sess_client_id']."" : "";
                $this->DFE->db->Select('*')
                              ->From('menu_config')
                              ->WhereColName('menu_title')
                              ->WhereColValue($this->DFE->http->_post('mid'))
                              ->Andd("AND menu_lang = :menu_lang ".$and)
                              ->Parameter(array('menu_lang' => $GLOBALS['LANGUAGE']))
                              ->SelectMethod(1)
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;
                $num = $this->DFE->db->Rows;
                for ($i = 0; $i < $num; $i++) {
                    ${$row[$i]['menu_key']} = stripslashes($row[$i]['menu_value']);
                    $this->DFE->TT->setMC($row[$i]['menu_key'], stripslashes($row[$i]['menu_value']));
                }
                $select_filedoc_no = $FileDoc == 'no' ? "selected" : "";
                $select_filedoc_yes = $FileDoc == 'yes' ? "selected" : "";
                $omo1 = $OnMouseOver == 1 ? "checked" : "";
                $omo0 = $OnMouseOver != 1 ? "checked" : "";
                $mo1 = $MenuOpen == 1 ? "checked" : "";
                $mo0 = $MenuOpen != 1 ? "checked" : "";
                $menu_head = $this->DFE->http->_post('action') == 'edit' ? $this->be_language['_edit'] : $this->be_language['_copy'];
                $root = $Level == '0' ? "selected" : "";
                $x = $Level == 'x' ? "selected" : "";
                $status0 = $Status == 0 ? "checked" : "";
                $status1 = $Status == 1 ? "checked" : "";
                $this->DFE->TT->BlockMarker['freeze_level'] = $Level == 'x' ? 1 : 0;
            } else {
                $menu_head = $this->be_language['_new'];
                $root = "";
                $x = "";
                $mo1 = "disabled";
                $mo0 = "disabled";
                $status1 = "checked";
                $this->DFE->TT->BlockMarker['freeze_level'] = 0;
            }
            $menu_level = \lib\Functions::breadcrumb($Level, "dot".$this->FBup."Menu", $GLOBALS['LANGUAGE']);
            $menu_level = $Level > 0 ? "<option value=\"" . $Level . "\" selected=\"selected\" style=\"padding-left:4px\">" . $menu_level . "</option>" : "";

            $mo = "HMenu" == $Type ? "" : "display:none;";

            # Menü Type
            foreach ($GLOBALS['MENU_TYPES'] as $key => $val) {
                $selected = $Type == $key ? " selected" : "";
                $menutyps .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
            }

            # Text Attribute64 (von Seiten)
            foreach ($GLOBALS['MENU_TEXT_ATTRIBUTES'] as $key => $val) {
                $selected = $NameAttributes64 == $key ? " selected" : "";
                $menuattributes64 .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
            }

            # Text Attribute256 (von Block-Überschriften)
            foreach ($GLOBALS['MENU_TEXT_ATTRIBUTES'] as $key => $val) {
                $selected = $NameAttributes256 == $key ? " selected" : "";
                $menuattributes256 .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
            }

            # Menü-Umfließung
            foreach ($GLOBALS['MENU_PRELINK_TAG'] as $key => $val) {
                $selected = $PreLinkTags == $key ? " selected" : "";
                $menu_prelink_tags .= "<option value=\"" . $key . "\"" . $selected . " style=\"padding-left:4px\">" . $val . "</option>\n";
            }

            # BE Doc-Types
            foreach ($GLOBALS['BE_DOCTYPES_NAMES'] as $key => $val) {
                $selected = $docType == $key ? " selected" : "";
                $doctype .= "<option value=\"" . $key . "\"" . $selected . ">" . $val . "</option>\n";
            }

            $Wrap = htmlspecialchars($Wrap);

            $sid = $_SESSION['sess_id'];
            $lang = $GLOBALS['LANGUAGE'];
            $fb = $this->FB == 'be_' ? '&FB=be_' : '';

            $this->DFE->TT->setMC('select_filedoc_no',      $select_filedoc_no)
                          ->setMC('select_filedoc_yes',     $select_filedoc_yes)
                          ->SetMC('omo1',                   $omo1)
                          ->setMC('omo0',                   $omo0)
                          ->setMC('mo0',                    $mo0)
                          ->setMC('mo1',                    $mo1)
                          ->setMC('menu_head',              $menu_head)
                          ->setMC('root',                   $root)
                          ->setMC('x',                      $x)
                          ->setMC('status0',                $status0)
                          ->setMC('status1',                $status1)
                          ->setMC('menu_level',             $menu_level)
                          ->setMC('mo',                     $mo)
                          ->setMC('menutyps',               $menutyps)
                          ->setMC('menuattributes64',       $menuattributes64)
                          ->setMC('menuattributes256',      $menuattributes256)
                          ->setMC('menu_prelink_tags',      $menu_prelink_tags)
                          ->setMC('doctype',                $doctype)
                          ->setMC('Wrap',                   $Wrap)
                          ->setMC('fb',                     $fb)
                          ->setMC('sid',                    $sid)
                          ->setMC('lang',                   $lang);
        } else {
            # Menu speichern
            switch ($this->DFE->http->_post('action')) {
                case "copy":
                    $where = $this->FB == 'fe_' ? "client_id = ".intval($GLOBALS['CLIENT_ID'])." AND" : "";
                    $this->DFE->db->Select('*')
                                  ->From('menu_config')
                                  ->noWhere(1)
                                  ->Andd("WHERE ".$where." menu_key = 'Type' AND menu_lang = :menu_lang ")
                                  ->Parameter(array('menu_lang' => $GLOBALS['LANGUAGE']))
                                  ->SelectMethod(1)
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    foreach ($this->DFE->http->_post('MC') as $key => $val) {
                        $this->DFE->db->Insert('menu_config')
                                      ->Parameter(array(    'menu_id'           => '', 
                                                            'menu_title'        => $num, 
                                                            'menu_key'          => $key, 
                                                            'menu_value'        => $val, 
                                                            'menu_description'  => '', 
                                                            'menu_group_id'     => 0, 
                                                            'menu_lang'         => $GLOBALS['LANGUAGE'], 
                                                            'last_modified'     => NULL, 
                                                            'date_added'        => time(), 
                                                            'client_id'         => $GLOBALS['CLIENT_ID']))
                                      ->doInsert();
                    }
                    break;

                case "edit":
                    foreach ($this->DFE->http->_post('MC') as $key => $val) {
                        $and = $this->FB == 'fe_' ? "AND client_id = '" . intval($GLOBALS['CLIENT_ID']) . "'" : "";
                        $this->DFE->db->Select('*')
                                      ->From('menu_config')
                                      ->WhereColName('menu_title')
                                      ->WhereColValue($this->DFE->http->_post('mid'))
                                      ->Andd("AND menu_key = '" . $key . "' AND menu_lang = :menu_lang ".$and)
                                      ->Parameter(array('menu_lang' => $GLOBALS['LANGUAGE']))
                                      ->doSelect();
                        $num = $this->DFE->db->Rows;
                        if ($num) {
                            $this->DFE->db->Update('menu_config')
                                          ->WhereColName('menu_title')
                                          ->WhereColValue($this->DFE->http->_post('mid'))
                                          ->Andd("AND menu_key = '" . $key . "' ".$and)
                                          ->Set(array(  "menu_value" => addslashes($val),
                                                        "last_modified" => time()))
                                          ->doUpdate();                        
                        } else {
                            
                            $this->DFE->db->Insert('menu_config')
                                          ->Parameter(array(    'menu_id'           => '', 
                                                                'menu_title'        => $this->DFE->http->_post('mid'), 
                                                                'menu_key'          => $key, 
                                                                'menu_value'        => $val, 
                                                                'menu_description'  => '', 
                                                                'menu_group_id'     => 0, 
                                                                'menu_lang'         => $GLOBALS['LANGUAGE'], 
                                                                'last_modified'     => NULL, 
                                                                'date_added'        => time(), 
                                                                'client_id'         => $GLOBALS['CLIENT_ID']))
                                          ->doInsert();
                        }
                    }
                    break;

                default:
                    $and = $this->FB == 'fe_' ? "AND client_id = " . intval($GLOBALS['CLIENT_ID']) . " " : "";
                    $this->DFE->db->Select(' DISTINCT menu_title')
                                  ->From('menu_config')
                                  ->WhereColName('menu_lang')
                                  ->WhereColValue($GLOBALS['LANGUAGE'])
                                  ->Andd($and)
                                  ->SelectMethod(1)
                                  ->doSelect();
                    $nums = $this->DFE->db->Rows;
                    if (!$nums) {
                        $this->DFE->http->setPostbyName('mid', 0);
                    } else {
                        $this->DFE->http->setPostbyName('mid', $nums);
                    }
                    $this->DFE->http->setPostByName('mid', $GLOBALS['LANGUAGE'] == SYS_LANGUAGE ? $this->DFE->http->_post('mid') : $this->DFE->http->_post('mid') . $GLOBALS['LANGUAGE']);
                    foreach ($this->DFE->http->_post('MC') as $key => $val) {
                        $this->DFE->db->Select('*')
                                      ->From('menu_config')
                                      ->WhereColName('menu_title')
                                      ->WhereColValue($this->DFE->http->_post('mid'))
                                      ->Andd("AND menu_key = '" . $key . "' ".$and)
                                      ->doSelect();
                        $num = $this->DFE->db->Rows;
                        if ($num) {
                            $this->DFE->db->Update('menu_config')
                                          ->WhereColName('menu_title')
                                          ->WhereColValue($this->DFE->http->_post('mid'))
                                          ->Set(array(  "menu_value"    => $val, 
                                                        "last_modified" => time()))
                                          ->Andd("AND menu_key = '" . $key . "' ".$and)
                                          ->doUpdate();
                        } else {

                            $this->DFE->db->Insert('menu_config')
                                          ->Parameter(array(    'menu_id'           => '', 
                                                                'menu_title'        => $this->DFE->http->_post('mid'), 
                                                                'menu_key'          => $key, 
                                                                'menu_value'        => $val, 
                                                                'menu_description'  => '', 
                                                                'menu_group_id'     => 0, 
                                                                'menu_lang'         => $GLOBALS['LANGUAGE'], 
                                                                'last_modified'     => NULL, 
                                                                'date_added'        => time(), 
                                                                'client_id'         => $GLOBALS['CLIENT_ID']))
                                          ->doInsert();
                        }
                    }
            }
            header("Location: ?ac=Overview");
            exit;
        }
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    /**
     * Copy menu configuration
     * @return string
     */
    public function CopyMenuConfig($template="/aribu.systems/_templates/pages/copy_menu_setup.html") {
        
        if ($this->DFE->http->issetPost('save_menu_config') === false) {
            # Language
            foreach ($GLOBALS['BE_LANGUAGES'] as $key => $val) {
                $selected = $GLOBALS['LANGUAGE'] == $key ? "selected" : "";
                $lang_options .= '<option value="' . $key . '" ' . $selected . '>' . $val . '</option>';
            }

                        
            if (!empty($this->Error)) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger', $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));           
            } 

            
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('lang') == SYS_LANGUAGE) {
                $error = 1;
                $this->Error['Validation'] = $this->DFE->TT->getMC('_error_copy_menu');
            }
            $and = $this->FB == 'fe_' ? " AND client_id = '" . intval($GLOBALS['CLIENT_ID']) . "'" : "";
            $this->DFE->db->Select('*')
                          ->From('menu_config')
                          ->WhereColName('menu_lang')
                          ->WhereColValue($this->DFE->http->_post('lang'))
                          ->Andd($and)
                          ->SelectMethod(1)
                          ->doSelect();
            $nume = $this->DFE->db->Rows;
            if ($nume) {
                $error = 1;
                $this->Error['Validation'] = $this->DFE->TT->getMC('_error_copy_menu_language');
            }

            if ($error != 1) {
                $this->DFE->db->Select('*')
                              ->From("menu_config")
                              ->WhereColName('menu_lang')
                              ->WhereColValue($GLOBALS['LANGUAGE'])
                              ->Andd($and)
                              ->Order("ORDER BY menu_id")
                              ->SelectMethod(1)
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    for ($i = 0; $i < $num; $i++) {
                        
                        $this->DFE->db->Insert('menu_config')
                                      ->Parameter(array(    'menu_id'           => '', 
                                                            'menu_title'        => $row[$i]['menu_title'] . $this->DFE->http->_post('lang'), 
                                                            'menu_key'          => $row[$i]['menu_key'], 
                                                            'menu_value'        => $row[$i]['menu_value'], 
                                                            'menu_description'  => $row[$i]['menu_description'], 
                                                            'menu_group_id'     => $row[$i]['menu_group_id'], 
                                                            'menu_lang'         => $this->DFE->http->_post('lang'), 
                                                            'last_modified'     => NULL, 
                                                            'date_added'        => time(), 
                                                            'client_id'         => $row[$i]['client_id']))
                                      ->doInsert();
                        
                    }
                }
                # Exit und Jump to folder page
                header("Location: ?");
                exit;
            } else {
                $this->DFE->http->unsetPost('save_menu_config');
                $this->CopyMenuConfig();
            }
        }
        
        $this->DFE->TT->setMC('lang_options',   $lang_options)
                      ->setMC('backlink',       "?");
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    public function dmethod() {       
    }

}