<?php

namespace aribu\scripts\pages\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   18.04.2016
 *  
 */

class Stylesheet extends \aribu\scripts\abstracts\Abstracts {
    
    public $MessengerType = 'success';


    public function __construct($DFE) {
        parent::__construct($DFE);
    }
    
    
    /**
     * Stylesheet
     * @return string
     */
    public function Stylesheet($template='/aribu.systems/_templates/pages/css.html') {
        $cssfolder = $this->FB == 'be_' ? '' : str_replace(':'.URL_PORT, '', $_SESSION['sess_client_template_folder']);
        $cssRootFolder = $this->FB != 'be_' ? '' : ARIBU_SYSTEMS_SFOLDER;
        
        if ($this->DFE->http->issetPost('save_css') === false) {
            
            # CSS holen  
            $this->DFE->db->Select('stylesheet, stylesheet_ff')
                          ->From('html_header')
                          ->WhereColName('client_id')
                          ->WhereColValue($_SESSION['sess_client_id'])
                          ->Andd("AND lang = :lang ")
                          ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            
            if($num) {
                $row = $this->DFE->db->SelectPuffer;
                
                $this->DFE->TT->setMC('cssbody',        stripslashes(\lib\Functions::readFiles($cssRootFolder . "/fileadmin/css/" . $cssfolder . $row['stylesheet'])))
                              ->setMC('css_body_ff',    stripslashes(\lib\Functions::readFiles($cssRootFolder . "/fileadmin/css/" . $cssfolder . $row['stylesheet_ff'])))
                              ->setMC('css',            $row['stylesheet'])
                              ->setMC('css_ff',         $row['stylesheet_ff'])
                              ->setMC('display_ie',     $GLOBALS['BE_SETTINGS']['CSS'] == 'IE' ? 'display:block;' : 'position:absolute; top:-999px;')
                              ->setMC('display_ff',     $GLOBALS['BE_SETTINGS']['CSS'] == 'FF' ? 'display:block;' : 'position:absolute; top:-999px;')
                              ->setMC('be_rights',      ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][15] == 1) && (SECURITY_EDIT_BE_STYLESHEET === true) ? '' : 'disabled data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_css'].'"');
                
            } else {
                 # Insert new client                
                $this->DFE->db->Insert('html_header')
                              ->Parameter(array(    'hid'           => '', 
                                                    'metatags'      => '', 
                                                    'stylesheet'    => '', 
                                                    'stylesheet_ff' => '', 
                                                    'jscripts'      => '', 
                                                    'lang'          => $GLOBALS['LANGUAGE'],
                                                    'client_id'     => $_SESSION['sess_client_id']));
            }
            if (isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',  $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', $this->MessengerType));
            } 
        } else {
            
            # Update Speichern Internet Explorer
            if ($this->DFE->http->_post('css_type') == 'ie') {
                $this->DFE->db->Update('html_header')
                              ->WhereColName('client_id')
                              ->WhereColValue($_SESSION['sess_client_id'])
                              ->Set(array("stylesheet" => $this->DFE->http->_post('css')))
                              ->doUpdate();
                $filename = DOC_ROOT . $cssRootFolder . "/fileadmin/css/" . $cssfolder . $this->DFE->http->_post('css');
                $tmp = \lib\Functions::htmlchars_decode(stripslashes($this->DFE->http->_post('css_body')));
                $css_body = $this->DFE->http->_post('css_body');
                $css_file = $this->DFE->http->_post('css');
            }
            # Update Speichern Firefox
            if ($this->DFE->http->_post('css_type') == 'ff') {
                $this->DFE->db->Update('html_header')
                              ->WhereColName('client_id')
                              ->WhereColValue($_SESSION['sess_client_id'])
                              ->Set(array("stylesheet_ff" => $this->DFE->http->_post('css_ff')))
                              ->doUpdate();
                $filename = DOC_ROOT . $cssRootFolder . "/fileadmin/css/" . $cssfolder . $this->DFE->http->_post('css_ff');
                $tmp = \lib\Functions::htmlchars_decode(stripslashes($this->DFE->http->_post('css_body_ff')));
                $css_body = $this->DFE->http->_post('css_body_ff');
                $css_file = $this->DFE->http->_post('css_ff');
            }

            if (is_writable($filename)) {
                if (!$handle = @fopen($filename, "w")) {
                    $this->Error['Validation'] = str_replace("###file###", $css_file, $this->DFE->TT->getMC('_read_error'));
                    $this->MessengerType = 'error';
                }

                if (!fwrite($handle, $css_body)) {
                    $this->Error['Validation'] = str_replace("###file###", $css_file, $this->DFE->TT->getMC('_write_error'));
                    $this->MessengerType = 'error';
                } else {
                    $this->Error['Validation'] = str_replace("###file###", $css_file, $this->DFE->TT->getMC('_saveok'));
                }
                @fclose($handle);
            } else {
                if (!$handle = @fopen($filename, "w")) {
                    $this->Error['Validation'] = str_replace("###file###", $css_file, $this->DFE->TT->getMC('_read_error'));
                    $this->MessengerType = 'error';
                }

                if (!@fwrite($handle, $tmp)) {
                    $this->Error['Validation'] = str_replace("###file###", $css_file, $this->DFE->TT->getMC('_writeable_error'));
                    $this->MessengerType = 'error';
                } else {
                    $this->Error['Validation'] = str_replace("###file###", $css_file, $this->DFE->TT->getMC('_saveok'));
                }
                @fclose($handle);
            }

            $this->DFE->http->unsetPost('save_css');
            $this->Stylesheet();
        }
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    public function dmethod() {
        
    }

}