<?php

namespace aribu\scripts\pages\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   18.04.2016
 *  
 */


class Template extends \aribu\scripts\abstracts\Abstracts {
    
    public function __construct($DFE) {
        parent::__construct($DFE);
    }
    
    /**
     * New template
     * @return string
     */
    public function NewTemplate($template="/aribu.systems/_templates/pages/new_template.html") {
        
        $folder_fb = $this->FB == 'be_' ? ARIBU_SYSTEMS_SFOLDER : '';
        
        $this->DFE->BrowserTitle = $this->DFE->TT->getMC('_browser_title_'.$this->FB.'add_new_template');
        
        if ($this->DFE->http->issetPost('save_temp') === false) {

            $newtpl_body = '<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Template</title>
</head>

<body>
</body>
</html>';
            $fb = $this->FB == 'be_' ? ARIBU_SYSTEMS_SFOLDER : "";
            $tdir = \lib\Functions::getDirs(DOC_ROOT . $fb . "/_templates/");
            
            foreach ($tdir as $key => $val) {
                $ordner .= '<option value="' . $val . '">' . $val . '</option>';
            }
                       
            # WYSIWYG Editor
            $WGE = new \aribu\scripts\editor\lib\WYSIWYG($this->DFE);
            $WGE->Language              = $GLOBALS['LANGUAGE'];
            $WGE->Session               = $_SESSION['sess_id'];
            $WGE->Editor_Plugin         = 'fullpage';
            $WGE->Editor_Name           = "temp_body_fullpage";
            $WGE->AutoStart             = false;
            $WGE->Editor_Function_Name  = "FullPageEditor";
            
            $this->DFE->TT->setMC('link_language',      $GLOBALS['LANGUAGE'])
                          ->setMC('editor_fullpage_js', $WGE->getEditor("/aribu.systems/_templates/editor/tiny_wysiwyg_full_js.html"))                          
                          ->setMC('folder',             $ordner)
                          ->setMC('backlink',           \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'TemplatesOverview'], $GLOBALS['LANGUAGE']))
                          ->setMC('temp_body',          htmlentities($newtpl_body, ENT_QUOTES, 'UTF-8'))
                          ->setMC('be_rights',          $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][11] == 1 ? 'onclick="javascript: document.form.action = \'\'; document.form.target = \'_parent\'"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_new_template'].'"');
            
            $WGE->Editor_Plugin         = '';
            $WGE->Editor_Name           = "temp_body";
            $WGE->Editor_Function_Name  = "ContentEditor";
            $this->DFE->TT->setMC('editor_js', $WGE->getEditor("/aribu.systems/_templates/editor/tinymce_editor.html"));
            
            $this->DFE->TT->BlockMarker['save'] = 0;
        } else {
            $ord = $this->DFE->http->_post('ordner') == "/" ? "" : $this->DFE->http->_post('ordner');

            # Neues Template Speichern
            $filename = DOC_ROOT . $folder_fb ."/_templates" . $ord . "/" . $this->DFE->http->_post('temp_name');

            # Fehlerbehandlung
            $ErrorExtTypes = array("html", "HTML", "htm", "HTM", "tpl", "TPL");
            $file_ext = explode(".", $this->DFE->http->_post('temp_name'));
            $FType = count($file_ext) - 1;
            if (!in_array($file_ext[$FType], $ErrorExtTypes)) {
                $this->Error['Validation'] = $this->DFE->TT->getMC('_ending_error');
                $false = 1;
            } else {

                # Der Dateizeiger befindet sich am Anfang der Datei, und
                # dort wird $this->DFE->http->_post('temp_body') später mit fwrite() geschrieben.
                if (!$handle = fopen($filename, "w")) {
                    $this->Error['Validation'] = str_replace('###file###', $filename, $this->DFE->TT->getMC('_read_error'));
                    $false = 1;
                }

                # Schreibe $this->DFE->http->_post('temp_body') in die ge&ouml;ffnete Datei.
                $tmp = stripslashes($this->DFE->http->_post('temp_body'));
                if (!fwrite($handle, $tmp)) {
                    $this->Error['Validation'] = str_replace('###file###', $filename, $this->DFE->TT->getMC('_write_error'));
                    $false = 1;
                }
                fclose($handle);
            }


            $tdir = \lib\Functions::getDirs(DOC_ROOT . $folder_fb . "/_templates/");
            foreach ($tdir as $key => $val) {
                $selected = $this->DFE->http->_post('ordner') == $val ? " selected" : "";
                $ordner .= "<option value=\"" . $val . "\"" . $selected . ">" . $val . "</option>";
            }

            if ($false != 1) {
                $newtemp = \lib\Functions::readFiles($folder_fb . "/_templates" . $ord . "/" . $this->DFE->http->_post('temp_name'));
                $temp_body = $newtemp;
            } else {
                $temp_body = $this->DFE->http->_post('temp_body');
            }

            # WYSIWYG Editor
            $WGE = new \aribu\scripts\editor\lib\WYSIWYG($this->DFE);
            $WGE->Language = $GLOBALS['LANGUAGE'];
            $WGE->Session = $_SESSION['sess_id'];
            $WGE->Editor_Plugin = 'fullpage';
            $WGE->Editor_Name = "temp_body_fullpage";
            
            $this->DFE->TT->setMC('link_language',      $GLOBALS['LANGUAGE'])
                          ->setMC('editor_fullpage_js', $WGE->getEditor("/aribu.systems/_templates/editor/tiny_wysiwyg_full_js.html"))                          
                          ->setMC('folder',             $ordner)
                          ->setMC('backlink',           \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'TemplatesOverview'], $GLOBALS['LANGUAGE']))
                          ->setMC('temp_body',          htmlentities($temp_body, ENT_QUOTES, 'UTF-8'))
                          ->setMC('temp_name',          $this->DFE->http->_post('temp_name'))
                          ->setMC('be_rights',          $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][11] == 1 ? 'onclick="javascript: document.form.action = \'\'; document.form.target = \'_parent\'"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_new_template'].'"');
            
            $WGE->Editor_Plugin = '';
            $WGE->Editor_Name = "temp_body";
            $this->DFE->TT->setMC('editor_js', $WGE->getEditor("/aribu.systems/_templates/editor/tinymce_editor.html"));

            $this->DFE->TT->BlockMarker['save'] = 1;
            
            if(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            } elseif($false != 1) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_save_template_ok'), 'messenger-on-top messenger-on-right', 'success'));
            }   
            
        }

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    
    /**
     * Overview
     * @return string
     */
    public function Overview($template='/aribu.systems/_templates/pages/show_templates.html') {
        
        require_once($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems/scripts/files/lang/" . $_SESSION['sess_language'] . ".php");
        
        $this->PrepareLanguage($be_language); 
        
        $this->DFE->BrowserTitle = $this->DFE->TT->getMC('_browser_title_'.$this->FB.'template_overview');
        
        $folder = $this->FB == 'be_' ? '/aribu.systems' : '';
        if ($this->DFE->http->issetPost('ordner') === true && $this->DFE->http->isEmpty('ordner') === false) {
            $ordner = DOC_ROOT . $folder . "/_templates/" . $this->DFE->http->_post('ordner');
            $get_ordner = "&ordner=" . $this->DFE->http->_post('ordner');
            $this->DFE->TT->BlockMarker['ordner'] = 1;
            $ordner_arr = explode("/", $this->DFE->http->_post('ordner'));
            $count_ordner = count($ordner_arr);
            unset($ordner_arr[($count_ordner - 1)]);
            $back_ordner = implode("/", $ordner_arr);
            $backlink_ordner = $count_ordner == 1 ? "?" : "?ordner=" . $back_ordner;
            $backlink = $backlink_ordner;
        } else {
            $ordner = DOC_ROOT . $folder . "/_templates";
            $this->DFE->TT->BlockMarker['ordner'] = 0;
        }

        switch ($this->DFE->http->_post('acm')) {
            case 'deltemp':
                if ($this->DFE->http->issetPost('ordner') === true && $this->DFE->http->_post('ordner') != "") {
                    $unlink_ordner = $this->DFE->http->_post('ordner') . "/";
                }
                @unlink(DOC_ROOT . $folder . '/_templates/' . $unlink_ordner . $this->DFE->http->_post('tmp'));
                header("Location: ?ordner=" . $this->DFE->http->_post('ordner'));
                exit;
                break;

            case 'newFolder':
                $save_message = '';
                if ($this->DFE->http->isEmpty('foldername') === false) {
                    if (!file_exists($ordner . "/" . $this->DFE->http->_post('foldername'))) {
                        mkdir($ordner . "/" . $this->DFE->http->_post('foldername'));
                        chmod($ordner . "/" . $this->DFE->http->_post('foldername'), 0777);
                        $save_message = str_replace("###foldername###", $this->DFE->http->_post('foldername'), $this->DFE->TT->getMC('_folder_ok'));
                        $type = 'success';
                    } else {
                        $save_message = $this->DFE->TT->getMC('_error1');
                        $type = 'error';
                    }
                } else {
                    if ($this->DFE->http->isEmpty('foldername') === true) {
                        $save_message = $this->DFE->TT->getMC('_error3');
                        $type = 'error';
                    }
                }
                
                break;

            case 'delfolder':
                $del_folder = $this->DFE->http->_post('ordner') != "" ? $this->DFE->http->_post('ordner') . "/" : "";
                rmdir(DOC_ROOT . $folder. '/_templates/' . $del_folder . $this->DFE->http->_post('folder'));
                header("Location: ?ordner=" . $this->DFE->http->_post('ordner'));
                exit;
                break;
        }

        # Action NewFolder
        $action_newfolder = "?acm=newFolder" . $get_ordner;

        $temps = \lib\Functions::readDirectory($ordner, \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'TemplatesOverview'], $GLOBALS['LANGUAGE']) ."?fo=1");
        $fb = $this->FB == 'be_' ? '&FB=be_' : '';

        $i = 0;
        if (is_array($temps) && !empty($temps)) {
            foreach ($temps as $key => $val) {
                if (!preg_match('#.LCK#', $val, $match)) {
                    $folder_ordner = $this->DFE->http->issetPost('ordner') === true ? $this->DFE->http->_post('ordner') . "/" : "";
                    $folder_templates = \lib\Functions::readDirectory(DOC_ROOT . $folder. "/_templates/" . $folder_ordner . strip_tags($val));
                    
                    if (!preg_match('#<a.*href\="?(\S+)"([^>]*)>.+</a>#', $val, $linkmatch)) {
                        
                        # BE Rights Del Template
                        if (is_array($folder_templates) && !empty($folder_templates)) {
                            $action_delete = "&nbsp;";
                        } else {
                            if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][12] == 1) {
                                $action_delete = '<a href="#" onclick="javascript: confirmDelTemplate(\'' . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'TemplatesOverview'], $GLOBALS['LANGUAGE']) . '?acm=deltemp&tmp=' . $val . '&ordner=' . $this->DFE->http->_post('ordner') . $fb . '\');"><i class="fa fa-trash-o inverse" aria-hidden="true" title="' . $this->DFE->TT->getMC('_del_template') . '"></i></a>';
                            } else {
                                $action_delete = '<a href="#"><i class="fa fa-trash-o disabled" aria-hidden="true" title="' . $this->DFE->TT->getMC('_del_template') . '"></i></a>';
                            }
                        }
                        $action_edit = '<a href="?ac=EditTemplate&tmp=' . $val . '&ordner=' . $this->DFE->http->_post('ordner') . '"><i class="fa fa-pencil inverse" title="' . $this->DFE->TT->getMC('_edit_template') . '" aria-hidden="true"></i></a>';

                        $fileimg = '<i class="fa fa-file-text-o inverse" aria-hidden="true"></i>';
                    } else {
                        
                        if (is_array($folder_templates) && !empty($folder_templates)) {
                            $action_delete = "&nbsp;";
                        } else {
                            if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][12] == 1) {
                                $action_delete = '<a href="#" onclick="javascript: confirmDelFolder(\'' . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'TemplatesOverview'], $GLOBALS['LANGUAGE']) . '?acm=delfolder&folder=' . strip_tags($val) . '&ordner=' . $this->DFE->http->_post('ordner') . $fb . '\');"><i class="fa fa-trash-o inverse" aria-hidden="true" title="' . $this->DFE->TT->getMC('_del_folder') . '"></i></a>';
                            } else {
                                $action_delete = '<a href="#"><i class="fa fa-trash-o disabled" aria-hidden="true" title="' . $this->DFE->TT->getMC('_del_template') . '"></i></a>';
                            }
                        }

                        $action_edit = "&nbsp;";
                        $fileimg = '<i class="fa fa-folder-open-o inverse" aria-hidden="true"></i>';
                    }
                    
                    $this->DFE->TT->setIMC($i, 'no',            ($i+1) . ".")
                                  ->setIMC($i, 'tmp_img',       $fileimg)
                                  ->setIMC($i, 'tmp_name',      $val)
                                  ->setIMC($i, 'action_edit',   $action_edit)
                                  ->setIMC($i, 'action_delete', $action_delete);
                    
                } else {
                   $this->DFE->TT->setIMC($i, 'no', ""); 
                }
                $i++;
            }
        } 
        if($save_message != '') {
            $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
            $this->DFE->TT->setMC('messenger',  $Widget->Messenger($save_message, 'messenger-on-top messenger-on-right', $type));
        }
        
        $this->DFE->TT->setMC('action_newfolder',   $action_newfolder)
                      ->setMC('backlink',           $backlink)
                      ->setMC('new_template_url',   \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'NewTemplate'], $GLOBALS['LANGUAGE']));
        
        return $this->DFE->TT->getFilledTemplate($template, NULL, 1);
    }

    /**
     * Edit template
     * @param type $error
     * @return string
     */
    public function EditTemplate($template='/aribu.systems/_templates/pages/edit_template.html') {
        
        $this->DFE->BrowserTitle = $this->DFE->TT->getMC('_browser_title_'.$this->FB.'edit_template');
        
        $folder = $this->FB == 'be_' ? '/aribu.systems' : '';
        if ($this->DFE->http->issetPost('ordner') === true && $this->DFE->http->isEmpty('ordner') === false) {
            $ordner = $this->DFE->http->_post('ordner') . "/";
        } else {
            $ordner = "";
        }
        
        if ($this->DFE->http->issetPost('save_temp') === false) {
                        
            # WYSIWYG Editor
            $WGE = new \aribu\scripts\editor\lib\WYSIWYG($this->DFE);
            $WGE->Language              = $GLOBALS['LANGUAGE'];
            $WGE->Session               = $_SESSION['sess_id'];
            $WGE->Editor_Plugin         = 'fullpage';
            $WGE->Editor_Name           = "temp_body_fullpage";
            $WGE->AutoStart             = false;
            $WGE->Editor_Function_Name  = "FullPageEditor";
            
            $this->DFE->TT->setMC('be_rights',          $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][13] == 1 ? 'onclick="javascript: document.form.action = \'\'; document.form.target = \'_parent\';"' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_edit_template'].'"')
                          ->setMC('temp_name',          $this->DFE->http->_post('tmp'))
                          ->setMC('editor_fullpage_js', $WGE->getEditor("/aribu.systems/_templates/editor/tiny_wysiwyg_full_js.html"))
                          ->setMC('temp_body',          htmlentities( \lib\Functions::readFiles( $folder. "/_templates/" . $ordner . $this->DFE->http->_post('tmp')), ENT_QUOTES, "UTF-8"));
            
            $WGE->Editor_Plugin         = '';
            $WGE->Editor_Name           = "temp_body";
            $WGE->Editor_Function_Name  = "ContentEditor";
            $this->DFE->TT->setMC('editor_js', $WGE->getEditor("/aribu.systems/_templates/editor/tinymce_editor.html"));
        } else {
            # Template-Update speichern
            $filename = DOC_ROOT . $folder."/_templates/" . $ordner . $this->DFE->http->_post('temp_name');
            if (is_writable($filename)) {
                # Der Dateizeiger befindet sich am Anfang der Datei, und
                # dort wird $this->DFE->http->_post('temp_name') später mit fwrite() geschrieben.
                if (!$handle = fopen($filename, "w")) {
                    $this->Error['Validation'] = $this->DFE->TT->getMC('_read_error');            
                    $type = 'error';
                }

                # Schreibe $this->DFE->http->_post('temp_name') in die ge&ouml;ffnete Datei.
                $tmp = \lib\Functions::htmlchars_decode(stripslashes($this->DFE->http->_post('temp_body')));
                if (!fwrite($handle, $tmp)) {
                    $this->Error['Validation'] = str_replace("###file###", $filename, $this->DFE->TT->getMC('_write_error')); 
                    $type = 'error';
                } else {
                    $this->Error['Validation'] = $this->DFE->TT->getMC('_save_template_ok');
                    $type = 'success';
                }

                fclose($handle);
            } else {
                $this->Error['Validation'] = str_replace("###file###", $filename, $this->DFE->TT->getMC('_writeable_error'));
                $type = 'error';
            }
            $this->DFE->http->unsetPost('save_temp');
            $this->EditTemplate();
        }
            
        if(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', $type));
        } 
        
        
        $this->DFE->TT->setMC('ordner', $ordner)
                      ->setMC('backlink', "?fo=1&ordner=" . $this->DFE->http->_post('ordner'));

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    public function dmethod() {
        
    }

}