<?php

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   09.03.2010
 * @update: 05.08.2015 
 */

# Headers
header("Content-type: text/html; charset=utf-8");

# Error reporting
error_reporting(E_ALL ^ E_NOTICE);
ini_set('display_errors', TRUE);

# Defines the security level and the conf-path
define('GPO_ON', true);
define('SYS_CONF', $_SERVER['DOCUMENT_ROOT'] . '/sys/sys.conf.php');

# Autoload classes
function __autoload($classname) {
    $classname = str_replace("\\", "/", $classname);
    $classname = explode("/", $classname);
    $classname_file = end($classname);
    $classname_file = '/class.' . $classname_file . '.php';
    array_pop($classname);
    $classname = '/' . implode("/", str_replace("aribu", "dot.orange", $classname)) . $classname_file;
    
    if (file_exists(DOC_ROOT . strtolower($classname))) {
        require_once(DOC_ROOT . strtolower($classname));
    }
}

/*
 * Here starts the requiring-level
 */
require_once(SYS_CONF);
require_once(REGISTRY);
require_once(PHPMAILER);
require_once(SMTP);
require_once(DB_CLASS);
require_once(DB_FUNCTION);
require_once(SYS_FUNCTION);
require_once(DOC_ROOT . '/lib/class.dot_FEmenu.php');
require_once(IMAGE);
require_once(TT);

/**
 * Mandant
 */
$mandant_folder_explode = explode(".", $_SERVER['HTTP_HOST']);
$mandant_array_count    = count($mandant_folder_explode);
if($mandant_array_count == 4 || $mandant_array_count == 3) {
    $mandant = $mandant_folder_explode[1];
} elseif($mandant_array_count == 2 || $mandant_array_count == 1) {
    $mandant = $mandant_folder_explode[0];
} 

$client = new \lib\Client($db);
$client_name = str_replace("/", "", $mandant);
$client->SetConstantAndGlobalOfClient($client_name);

/*
 * HttpRequest
 * @var object
 */
require_once (DOC_ROOT . '/lib/class.http_request.php');
$http = new HttpRequest();
\lib\Registry::setObj('http', $http);

# Session
$Session = new \lib\session\backend\Session;
$Session->handleBESession($_GET['sid'], 'be_');

$GLOBALS['LANGUAGE'] = $_GET['lang'];

# Database to BE
$db->TablePreName = "fe_";

# Backend und Frontend Variablen
require_once($_SERVER['DOCUMENT_ROOT'] . '/aribu.systems/scripts/be_fe.var.php');

# Klasse einbinden
require_once($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems/scripts/pages/lib/class.pages.php");

$BEContentObj = new \aribu\scripts\pages\lib\Pages();
$dir = $_GET['folder'];
$tree_Array = $BEContentObj->getFileTreeArrayPl(DOC_ROOT . $dir);
if (array_key_exists(".DS_Store", $tree_Array)) {
    $count = count($tree_Array) - 1;
} else {
    $count = count($tree_Array);
}
@ksort($tree_Array);
@reset($tree_Array);
$level = explode("/", $_GET['folder']);
$level = count($level);
$GLOBALS['FileBrowser_ActivePoint'] = $_GET['id'] . "-act";
$BEAjaxCObj = $BEContentObj->getFileTreePl(DOC_ROOT . $dir, $tree_Array, "", $count, $level - 2, $_GET['bl']);
echo $BEAjaxCObj;