<?php
namespace aribu\scripts\system\lib;
/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   08.02.2016
 *  
 */



class Client_Setup extends \aribu\scripts\abstracts\Abstracts {
    
        
    public function __construct($DFE) {
        parent::__construct($DFE);
        
        if($this->DFE->http->issetPost('save_client') === true && $this->DFE->http->_post('action') != 'edit') {
            $this->SaveClient();
        } elseif($this->DFE->http->issetPost('save_client') === true && $this->DFE->http->_post('action') == 'edit') {
            $this->UpdateClient();
        }
        
        
    }
    
    public function ClientOverview() {
        switch ($this->DFE->http->_post['action']) {
            case 'del':
                $this->DFE->db->Delete('client')
                              ->WhereColName('client_id')
                              ->WhereColValue($this->DFE->http->_post('client_id'))
                              ->doDelete();
                break;
           
            case 'public':
                $this->DFE->db->Update('client')
                              ->WhereColName('client_id')
                              ->WhereColValue($this->DFE->http->_post('client_id'))
                              ->Set(array("status" => 1))
                              ->doUpdate();
                break;

            case 'npublic':
                $this->DFE->db->Update('client')
                              ->WhereColName('client_id')
                              ->WhereColValue($this->DFE->http->_post('client_id'))
                              ->Set(array("status" => 0))
                              ->doUpdate();
                break;
        }

        # Daten holen
        $this->DFE->db->TablePreName = "fe_";
        $this->DFE->db->Select('*')
                      ->From('client')
                      ->noWhere(1)
                      ->Order("ORDER BY client_id ASC")
                      ->SelectMethod(1)
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        $row = $this->DFE->db->SelectPuffer;
        for ($i = 0; $i < $num; $i++) {

            $this->DFE->TT->setIMC($i, 'client_name', $row[$i]['client_name'])
                          ->setIMC($i, 'http', $row[$i]['http'])
                          ->setIMC($i, 'url_protocol', $row[$i]['url_protocol'])         
                          ->setIMC($i, 'nr', ($i + 1) . '.')
                          ->setIMC($i, 'id', $row[$i]['client_id'])
                          ->setIMC($i, 'action_status_offline', SECURITY_SET_STATUS_CLIENT === true ? 'href="?action=npublic&client_id='.$row[$i]['client_id'].'"' : 'href="javascript:void(0);" class="disabled" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_set_status_client'].'"')
                          ->setIMC($i, 'action_status_online', SECURITY_SET_STATUS_CLIENT === true ? 'href="?action=public&client_id='.$row[$i]['client_id'].'"' : 'href="javascript:void(0);" class="disabled" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_set_status_client'].'"')
                          ->setIMC($i, 'action_delete', SECURITY_DELETE_CLIENT === true ? 'onclick="javascript: confirmDelClient(\'?action=del&client_id='.$row[$i]['client_id'].'\');"' : 'href="javascript:void(0);" class="disabled" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_delete_client'].'"')
                          ->setIMC($i, 'action_edit', SECURITY_EDIT_CLIENT === true ? 'href="?ac=NewClient&action=edit&client_id='.$row[$i]['client_id'].'"' : 'href="javascript:void(0);" class="disabled" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_edit_client'].'"');
            
            $this->DFE->TT->setIBM($i, 'status', $row[$i]['status'] == 1 ? 1 : 0);
            if(is_array($this->be_language)) {
                foreach($this->be_language as $key => $val) {
                    $this->DFE->TT->setIMC($i, $key, $val);
                }
            }
            
        }
        
        $this->DFE->TT->setMC('be_rights', $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][461] == 1 ? 'onclick="javascript: location.href=\'?ac=NewClient\'"' : '');
        
        return $this->DFE->TT->getFilledTemplate("/aribu.systems/_templates/system/clients.html", NULL, 1);
    }
    
    public function NewClient() {
                
        $this->BENotice();
        $this->DFE->db->TablePreName = 'fe_';
        if($this->DFE->http->_post('action') == 'edit') {
            $this->DFE->db->Select('*')
                          ->From('client')
                          ->WhereColName('client_id')
                          ->WhereColValue($this->DFE->http->_post('client_id'))
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            
            foreach($row as $key => $val) {
                $this->DFE->TT->setMC($key, $val);
            }
            
            $this->DFE->TT->setMC('status0', $row['status'] == 0 ? 'checked="checked"' : '')
                          ->setMC('status1', $row['status'] == 1 ? 'checked="checked"' : '')
                          ->setMC('action', '?ac=NewClient&action=edit&client_id='.$this->DFE->http->_post('client_id'));
        
            $this->DFE->TT->BlockMarker['headline'] = 0;
        } else {
            $this->DFE->TT->setMC('status1', 'checked="checked"')
                          ->setMC('action', '?');
            
            $this->DFE->TT->BlockMarker['headline'] = 1;
        }
        
        $this->DFE->TT->setMC('save', $be_language['save'])
                      ->setMC('aktiv', $be_language['aktiv'])
                      ->setMC('inaktiv', $be_language['inaktive'])
                      ->setMC('backlink', '?');   
        
        return $this->DFE->TT->getFilledTemplate("/aribu.systems/_templates/system/new_client.html", NULL, 0);
    }
    
    public function SaveClient() {
        $this->DFE->db->TablePreName = 'fe_';
        $this->DFE->db->Insert('client')
                      ->Parameter(array(    'client_id'                 => '', 
                                            "client_name"               => $this->DFE->http->_post('client_name'), 
                                            "status"                    => $this->DFE->http->_post('status'), 
                                            "http"                      => $this->DFE->http->_post('http'), 
                                            "httpo"                     => $this->DFE->http->_post('httpo'), 
                                            "https"                     => $this->DFE->http->_post('https'), 
                                            "url_host"                  => $this->DFE->http->_post('url_host'), 
                                            "url_protocol"              => $this->DFE->http->_post('url_protocol'), 
                                            "url_port"                  => $this->DFE->http->_post('url_port'),
                                            "client_email_address"      => $this->DFE->http->_post('client_email_address'), 
                                            "client_email_name"         => $this->DFE->http->_post('client_email_name'), 
                                            "browser_name"              => $this->DFE->http->_post('browser_name'),
                                            "client"                    => $this->DFE->http->_post('client')))
                      ->doInsert();
        
        # Copy templates
        \lib\Functions::rcopy(DOC_ROOT.'/_templates/plugins', DOC_ROOT.'/_templates/'.str_replace(':'.$this->DFE->http->_post('url_port'), '', $this->DFE->http->_post('client_name')).'/plugins');
        
        # Copy elements templates to client
        \lib\Functions::rcopy(DOC_ROOT.'/_templates/elements', DOC_ROOT.'/_templates/'.str_replace(':'.$this->DFE->http->_post('url_port'), '', $this->DFE->http->_post('client_name')).'/elements');
        
        # Copy stylesheets
        \lib\Functions::rcopy(DOC_ROOT.'/fileadmin/css', DOC_ROOT.'/fileadmin/css/'.str_replace(':'.$this->DFE->http->_post('url_port'), '', $this->DFE->http->_post('client_name')));
        
        header("Location: ?saved=ok");
        exit;
    }
    
    public function UpdateClient() {
        $this->DFE->db->TablePreName = 'fe_';
        $this->DFE->db->Update('client')
                      ->WhereColName('client_id')
                      ->WhereColValue($this->DFE->http->_post('client_id'))
                      ->Set(array(  "client_name"               => $this->DFE->http->_post('client_name'),
                                    "status"                    => $this->DFE->http->_post('status'),
                                    "http"                      => $this->DFE->http->_post('http'),
                                    "httpo"                     => $this->DFE->http->_post('httpo'),
                                    "https"                     => $this->DFE->http->_post('https'),
                                    "url_host"                  => $this->DFE->http->_post('url_host'),
                                    "url_protocol"              => $this->DFE->http->_post('url_protocol'),
                                    "url_port"                  => $this->DFE->http->_post('url_port'),
                                    "client_email_address"      => $this->DFE->http->_post('client_email_address'),
                                    "client_email_name"         => $this->DFE->http->_post('client_email_name'),
                                    "browser_name"              => $this->DFE->http->_post('browser_name'),
                                    "client"                    => $this->DFE->http->_post('client')))
                      ->doUpdate();
        header("Location: ?ac=NewClient&saved=ok&action=edit&client_id=".$this->DFE->http->_post('client_id'));
        exit;
    }
    
    public function BENotice() {
        if($this->DFE->http->_post('saved') == 'ok') {
            $this->DFE->TT->BlockMarker['saveok'] = 1;
            $this->DFE->TT->setMC('save_message', 'Die Daten wurden erfolgreich gespeichert.');
        } else {
            $this->DFE->TT->BlockMarker['saveok'] = 0;
        }
    }

    public function dmethod() {
        
    }

}