<?php

namespace aribu\scripts\system\lib;

/*
  This file is the BE-Extension class.system_config.php.

  This file is a part of the dot.orange CMS 2005-2011.
  copyrights by it.orange (c).

  Author: Sascha Momcilovic
  E-Mail: info@it-orange.de
  www: http://www.it-orange.de
  Date: 13.04.2011
 */



class System_Config extends \aribu\scripts\abstracts\Abstracts {
   
    public $BL = array();
     
    
    public function __construct($DFE) {
        parent::__construct($DFE);
        $this->DFE->db->TablePreName = 'fe_';
    }
    
        
    /*
     * Variablen Verwaltung
     *
     */

    public function variablen() { 
        $this->DFE->db->TablePreName = 'fe_';
        if ($this->DFE->http->issetPost('saved') === true) {
            $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
            $this->DFE->TT->setMC('messenger', $Widget->Messenger($this->be_language['_save_ok'], 'messenger-on-top messenger-on-right', 'success'));           
        } elseif($this->DFE->http->issetPost('delete') === true) {
            $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
            $this->DFE->TT->setMC('messenger', $Widget->Messenger('Die Varibale wurde erfolgreich gelöscht.', 'messenger-on-top messenger-on-right', 'success')); 
        }
        
        if ($this->DFE->http->issetPost('save_variable') === true) {
            $config = $this->DFE->http->_post('config');
            if ($this->DFE->http->_post('action') == "edit") {
                # Updaten	
                $this->DFE->db->Update('system_config')
                              ->WhereColName('config_id')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->Set(array(  "config_title"          => $config['title'], 
                                            "config_key"            => $config['key'], 
                                            "config_value"          => $config['value'], 
                                            "config_description"    => $config['description'], 
                                            "config_lang"           => $config['lang'], 
                                            "config_hidden"         => $config['hidden'], 
                                            "last_modified"         => "NOW()"))
                              ->doUpdate();
                header("Location: ?saved=ok");
                exit;
            } else {
                
                # Überprüfen ob die Variable schon vorhanden ist
                $this->DFE->db->Select('*')
                              ->From('system_config')
                              ->WhereColName('config_title')
                              ->WhereColValue($config['title'])
                              ->Andd("AND config_key = '" . $config['key'] . "' AND config_lang = :lang AND client_id = :clientid ")
                              ->Parameter(array('lang' => $GLOBALS['LANGUAGE'], 'clientid' => $_SESSION['sess_client_id']))
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                if (!$num) {
                    # Speichern
                    $this->DFE->db->Insert('system_config')
                                  ->Parameter(array(    "config_id"          => '', 
                                                        "config_title"       => $config['title'], 
                                                        "config_key"         => $config['key'], 
                                                        "config_value"       => $config['value'], 
                                                        "config_description" => $config['description'], 
                                                        "config_lang"        => $config['lang'], 
                                                        "config_group_id"    => $config['hidden'], 
                                                        "config_hidden"      => 0, 
                                                        "last_modified"      => 0, 
                                                        "date_added"         => 'NOW()', 
                                                        "client_id"          => $_SESSION['sess_client_id']))
                                  ->doInsert();
                    header("Location: ?saved=ok");
                    exit;
                } else {
                    foreach ($config as $key => $val) {
                        $cm = 'config_' . $key;
                        $this->DFE->TT->setMC($cm, $val);
                    }
                    $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                    $this->DFE->TT->setMC('messenger', $Widget->Messenger('Die Variable ist schon einmal angelegt. Bitte ändern Sie die Parameter.', 'messenger-on-top messenger-on-right', 'error'));  
                }
            }
        }

        switch ($this->DFE->http->_post('action')) {
            case "del":
                $this->DFE->db->Delete('system_config')
                              ->WhereColName('config_id')
                              ->WhereColValue($this->DFE->http->_post('cid'))
                              ->doDelete();
                header("Location: ?delete=ok");
                exit;
                break;
            
            case "deleteVariable":
                if($this->DFE->http->issetPost('key') === true) {
                    $this->DFE->db->Delete('system_config')
                                  ->WhereColName('config_title')
                                  ->WhereColValue($this->DFE->http->_post('key'))
                                  ->Andd("AND config_lang = :lang")
                                  ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                                  ->doDelete();
                } elseif($this->DFE->http->issetPost('cid') === true) {
                    $this->DFE->db->Delete('system_config')
                                  ->WhereColName('config_id')
                                  ->WhereColValue($this->DFE->http->_post('cid'))
                                  ->Andd("AND config_lang = :lang")
                                  ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                                  ->doDelete();
                }
                header("Location: ?delete=ok#".$this->DFE->http->_post('anker'));
                exit;
                break;
        }
               
        $RootIconS = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_root.png" align="absmiddle" style="margin-left:4px;"> ';
        $system_config = $RootIconS . $this->be_language['_system_config'];

        $copy_plus = $_SESSION['BE_Rights'] == 1 ? '<a href="?ac=copySystemConfig" title="'.$this->DFE->TT->getMC('_copy_system_config_to_language').'"><i class="fa fa-sitemap inverse" aria-hidden="true"></i></a> ' : '';
        $del_cnf = $_SESSION['BE_Rights'] == 1 ? '<a href="?ac=delSystemConfig" title="'.$this->DFE->TT->getMC('_del_system_config').'"><i class="fa fa-trash inverse" aria-hidden="true"></i></a>' : '';

        $actions = $copy_plus . $del_cnf;


        # System configuration
        $SCTree = $this->getSystemConfigTree();
        $this->DFE->db->TablePreName = 'fe_';
        if ($this->DFE->http->_post('action') == "edit") {
            $this->DFE->db->Select('*')
                          ->From('system_config')
                          ->WhereColName('config_id')
                          ->WhereColValue($this->DFE->http->_post('cid'))
                          ->Andd("AND config_lang = :config_lang AND client_id = :client_id ")
                          ->Parameter(array('config_lang' => $GLOBALS['LANGUAGE'], 'client_id' => $_SESSION['sess_client_id']))
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            if ($num) {
                $row = $this->DFE->db->SelectPuffer;
                $config_title = $row['config_title'];
                $config_key = $row['config_key'];
                $config_value = htmlentities(stripslashes($row['config_value']), ENT_QUOTES, 'UTF-8');
                $config_description = htmlentities(stripslashes($row['config_description']), ENT_QUOTES, 'UTF-8');
                $hidden1 = $row['config_hidden'] == "1" ? "checked" : "";
                $hidden0 = $row['config_hidden'] == "0" ? "checked" : "";
            }
        } else {
            $hidden0 = "checked";
        }

        # Language
        foreach ($GLOBALS['BE_LANGUAGES'] as $key => $val) {
            if ($this->DFE->http->_post('action') == "edit") {
                $selected = $row['config_lang'] == $key ? "selected" : "";
            } else {
                $selected = $GLOBALS['LANGUAGE'] == $key ? "selected" : "";
            }
            $config_lang_options .= "<option value=\"" . $key . "\" " . $selected . ">" . $val . "</option>";
        }
        $del_link = $this->DFE->http->issetPost('cid') === true ? "?action=del&cid=" . $this->DFE->http->_post('cid') : "?";

        
        $open_system_config_points = isset($_SESSION['sess_system_config_menu']) ? '"' . implode('", "', $_SESSION['sess_system_config_menu']) . '"' : '';
        
        $this->DFE->TT->setMC('lang',                       $GLOBALS['LANGUAGE'])
                      ->setMC('sid',                        $_SESSION['sess_id'])
                      ->setMC('config_lang_options',        $config_lang_options)
                      ->setMC('system_config',              $system_config)
                      ->setMC('copy_plus',                  $copy_plus)
                      ->setMC('del_cnf',                    $del_cnf)
                      ->setMC('actions',                    $actions)
                      ->setMC('SCTree',                     $SCTree)
                      ->setMC('config_title',               $config_title)
                      ->setMC('config_key',                 $config_key)
                      ->setMC('config_description',         $config_description)
                      ->setMC('config_value',               $config_value)
                      ->setMC('hidden1',                    $hidden1)
                      ->setMC('hidden0',                    $hidden0)
                      ->setMC('del_link',                   $del_link)
                      ->setMC('open_system_config_points',  $open_system_config_points);

        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/system/variablen.html');
    }

    /*
     * System configuration tree
     *
     */

    function getSystemConfigTree() {
        $this->DFE->db->TablePreName = 'fe_';
        $this->DFE->db->Select('*, SOUNDEX( config_key ) AS mykey')
                      ->From('system_config')
                      ->WhereColName('config_lang')
                      ->WhereColValue($GLOBALS['LANGUAGE'])
                      ->Andd("AND client_id = :client_id ")
                      ->Order('ORDER BY config_title ASC, mykey ASC')
                      ->SelectMethod(1)
                      ->Parameter(array('client_id' => $_SESSION['sess_client_id']))
                      ->doSelect();
        
        $num = $this->DFE->db->Rows;
        if ($num) {
            $row = $this->DFE->db->SelectPuffer;
            $config_array = array();
            for ($i = 0; $i < $num; $i++) {
                $config_array[$row[$i]['config_title']][$row[$i]['config_key']] = $row[$i]['config_value'];
            }
        }
        $ConfigBrowserTree = $this->getSystemConfigBrowserTree($config_array);
        return $ConfigBrowserTree;
    }

    /*
     * System configuration browser tree
     *
     */

    public function getSystemConfigBrowserTree(array $config_array, $BLCode = '', $count = 0, $lCount = 0, $z = 0, $id = "") {
        
        $x = 0;
        static $level = 0;
        $countA = count($config_array);
        
        if (is_array($config_array)) {
            ksort($config_array);
            foreach ($config_array as $key => $val) {
                
                if (is_array($val)) {
                    $cArr = count($val);
                    $x++;
                    if ($level != 0) {
                        $LN = ($countA == $x) ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                    } else {
                        $LN = "";
                    }
                    $tmp = ''; # Buffer
                    if ($count == $x || $countA == $x) {
                        $join = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif" align="absmiddle">'; # Joinbottom
                        if (is_array($val)) {
                            $join = '<a href="javascript:void(0);" onclick="javascript: menupointConfig(\'' . strtolower($key) . '\',\'_end\'); return false;" onfocus="blur()"><img src="/aribu.systems/fileadmin/img/icons/tiny/site_open_end.gif" align="absmiddle" border="0" id="' . strtolower($key) . '_img" alt="plusminus"></a>';
                        }
                    } else {
                        $join = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_j.gif" align="absmiddle">';  # Join
                        if (is_array($val)) {
                            $join = '<a href="javascript:void(0);" onclick="javascript: menupointConfig(\'' . strtolower($key) . '\',\'\'); return false;" onfocus="blur()"><img src="/aribu.systems/fileadmin/img/icons/tiny/site_open.gif" align="absmiddle" border="0" id="' . strtolower($key) . '_img" alt="plusminus"></a>';
                        }
                    }

                    $blank = $LN . $join;

                    # Tree
                    if ($level == 0) {
                        $span_anfang = $exLevel > 0 && $x == 1 ? '<span class="' . $GLOBALS['FileBrowser_ActivePoint'] . '">' : "";
                        $span_ende = $exLevel > 0 && ($count == $x || $countA == $x) ? '</span>' : "";
                        $n = "\n";
                        $tmp_tree .= $span_anfang . '<ul style="list-style-type:none; width:600px; clear:both; padding-left:0px;" class="variables-ul">'.$n;
                        $tmp_tree .= '<li data-key="'.$key.'" style="float:left; padding-left:4px; width:100%; height:20px; display:block" data-anker="'.\lib\Functions::updatePagename($key).'">' . $blank . '[<a href="javascript:void(0);" onclick="javascript:document.getElementById(\'ctitle\').value=\'' . $key . '\'">' . $key . '</a>] <a name="'.\lib\Functions::updatePagename($key).'"></a></li>'.$n;
                        $tmp_tree .= '</ul>' . $span_ende . $n.$n;
                    }

                    $level++;
                    if ($tmp = $this->getSystemConfigBrowserTree($val, $BLCode . $LN, $cArr, $countA, $x, strtolower($key))) {
                        $tmp_tree .= $tmp;
                    }
                    $level--;
                    $z++;
                } else {
                    $x++;
                    $LN = ($count != $x || $lCount != $z) ? '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_line.gif" align="absmiddle">' : '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif" align="absmiddle">';
                    $LN = ($lCount == $z) ? '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif" align="absmiddle">' : $LN;

                    $tmp = ''; # Buffer
                    #echo "$count == $x && $lCount == $z<br>";
                    if ($count == $x || $countA == $x) {
                        $join = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif" align="absmiddle">'; # Joinbottom
                    } else {
                        $join = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_j.gif" align="absmiddle">';  # Join
                    }

                    $blank = $LN . $join;
                    $this->DFE->db->TablePreName = 'fe_';
                    $this->DFE->db->Select('config_id')
                                  ->From('system_config')
                                  ->WhereColName('config_lang')
                                  ->WhereColValue($GLOBALS['LANGUAGE'])
                                  ->Andd("AND config_key = '" . $key . "' AND config_title = '" . strtoupper($id) . "' AND client_id = :client_id ")
                                  ->Parameter(array('client_id' => $_SESSION['sess_client_id']))
                                  ->doSelect();
                    $cid = $this->DFE->db->SelectPuffer['config_id'];
                    $public = trim(stripslashes($val)) != "" ? trim(stripslashes($val)) : "empty";
                    $span_anfang = $x == 1 ? '<span style="display:none;" id="' . $id . '">' : "";
                    $span_ende = ($count == $x) ? '</span>' : "";
                    $n = "\n";
                    $tmp_tree .= $span_anfang . '<ul style="list-style-type:none; width:600px; clear:both; padding-left:0px;" class="variables-ul-l2">'.$n;
                    $tmp_tree .= '<li style="float:left; padding-left:4px; width:100%; height:auto; display:block" data-cid="'.$cid.'" data-anker="'.\lib\Functions::updatePagename($id).'-'.\lib\Functions::updatePagename($oldKey).'">' . $blank . '[' . stripslashes($key) . '] => <a href="' . \lib\Functions::dotLinkBE($this->DFE->RID, $GLOBALS['LANGUAGE']) . '?action=edit&cid=' . $cid . $client .  '">' . $public . '</a> <a name="'.\lib\Functions::updatePagename($id).'-'.\lib\Functions::updatePagename($key).'"></a></li>'.$n;
                    $tmp_tree .= '</ul>' . $span_ende . $n.$n;
                }
                $oldKey = $key;
            }
        } 
        return $tmp_tree;
    }

    public function language($template = "/aribu.systems/_templates/system/languages.html") {
        
        return $this->DFE->TT->getFilledTemplate($template, 1, 1);
    }

    public function copySystemConfig($template = "/aribu.systems/_templates/system/copy_system_config.html") {        
        $this->DFE->db->TablePreName = 'fe_';
        if ($this->DFE->http->issetPost('save_config') === false) {
            # Language
            foreach ($GLOBALS['BE_LANGUAGES'] as $key => $val) {
                $selected = $GLOBALS['LANGUAGE'] == $key || $this->DFE->http->_post('lang') == $key ? "selected" : "";
                $lang_options .= "<option value=\"" . $key . "\" " . $selected . ">" . $val . "</option>";
            }

            if(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            } elseif($this->DFE->http->issetPost('saved') === true) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_save_config_ok'), 'messenger-on-top messenger-on-right', 'success'));
            }   
            $this->DFE->TT->BlockMarker['save'] = 0;
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('lang') == SYS_LANGUAGE) {
                $error = 1;
                $save_message = "Sie können die System-Konfiguration nicht kopieren. Bitte wählen Sie eine andere Sprache aus.";
                $this->DFE->TT->BlockMarker['save'] = 1;
            }
            $this->DFE->db->Select('*')
                          ->From('system_config')
                          ->WhereColName('config_lang')
                          ->WhereColValue($this->DFE->http->_post('lang'))
                          ->Andd("AND client_id = :client_id ")
                          ->Parameter(array('client_id' => $_SESSION['sess_client_id']))
                          ->SelectMethod(1)
                          ->doSelect();
            $nume = $this->DFE->db->Rows;
            

            if ($error != 1) {
                $this->DFE->db->Select('*')
                              ->From("system_config")
                              ->WhereColName('config_lang')
                              ->WhereColValue($GLOBALS['LANGUAGE'])
                              ->Andd("AND client_id = :client_id ")
                              ->Order("ORDER BY config_id ASC")
                              ->Parameter(array('client_id' => $_SESSION['sess_client_id']))
                              ->SelectMethod(1)
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    for ($i = 0; $i < $num; $i++) {
                        $this->DFE->db->TablePreName = 'fe_';
                        $this->DFE->db->Select('*')
                                      ->From("system_config")
                                      ->WhereColName('config_title')
                                      ->WhereColValue($row[$i]['config_title'])
                                      ->Andd("AND config_key = '" . $row[$i]['config_key'] . "' AND config_lang = :config_lang AND client_id = :client_id ")
                                      ->Order("ORDER BY config_id ASC")
                                      ->Parameter(array('config_lang' => $this->DFE->http->_post('lang'), 'client_id' => $_SESSION['sess_client_id']))
                                      ->doSelect();
                        $num_d = $this->DFE->db->Rows;
                        if (!$num_d) {
                            
                            $this->DFE->db->Insert('system_config')
                                          ->Parameter(array(    "config_id"          => '', 
                                                                "config_title"       => $row[$i]['config_title'], 
                                                                "config_key"         => $row[$i]['config_key'], 
                                                                "config_value"       => $row[$i]['config_value'], 
                                                                "config_description" => $row[$i]['config_description'], 
                                                                "config_lang"        => $_POST['lang'], 
                                                                "config_group_id"    => $row[$i]['config_group_id'], 
                                                                "config_hidden"      => $row[$i]['config_hidden'], 
                                                                "last_modified"      => 0, 
                                                                "date_added"         => time(),
                                                                "client_id"          => $row[$i]['client_id']))
                                          ->doInsert();
                        }
                    }
                }

                # Exit und Jump to folder page
                header("Location: ?");
                exit;
            } else {
                $this->DFE->http->unsetPost('save_config');
                $this->copySystemConfig();
            }
        }
        
        $this->DFE->TT->setMC('backlink',       '?')
                      ->setMC('lang_options',   $lang_options);
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    
    public function delSystemConfig($template = "/aribu.systems/_templates/system/delete_system_config.html") {
        $this->DFE->db->TablePreName = 'fe_';        
        if ($this->DFE->http->issetPost('save_config') === false) {
            # Language
            foreach ($GLOBALS['BE_LANGUAGES'] as $key => $val) {
                $selected = $GLOBALS['LANGUAGE'] == $key || $this->DFE->http->_post('lang') == $key ? "selected" : "";
                $lang_options .= '<option value="' . $key . '" ' . $selected . '>' . $val . '</option>';
            }

            if(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            } elseif($this->DFE->http->issetPost('saved') === true) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_save_config_ok'), 'messenger-on-top messenger-on-right', 'success'));
            }   
            
            
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('lang') == $GLOBALS['SYSTEM_LANGUAGE'][0]) {
                $error = 1;
                $save_message = "Sie können die System-Konfiguration nicht löschen. Bitte wählen Sie eine andere Sprache aus.";
            }
            $this->DFE->db->Select('*')
                          ->From('system_config')
                          ->WhereColName('config_lang')
                          ->WhereColValue($this->DFE->http->_post('lang'))
                          ->SelectMethod(1)
                          ->doSelect();
            $nume = $this->DFE->db->Rows;
            if (!$nume) {
                $error = 1;
                $this->Error['Validation'] = $this->DFE->TT->getMC('_error_delete_config');
                $this->DFE->TT->BlockMarker['save'] = 1;
            }

            if ($error != 1) {
                $this->DFE->db->Delete('system_config')
                              ->WhereColName('config_lang')
                              ->WhereColValue($this->DFE->http->_post('lang'))
                              ->doDelete();

                # Exit und Jump to folder page
                header("Location: ?");
                exit;
            } else {
                $this->DFE->http->unsetPost('save_config');
                $this->copySystemConfig();
            }
        }
        
        $this->DFE->TT->setMC('backlink', '?')
                      ->setMC('lang_options', $lang_options);

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    public function SetSystemConfigMenuToSession() {
        # Menu in die Session aufnehmen
        $this->DFE->db->TablePreName = "be_";
        $this->DFE->db->Select('*')
                      ->From('session')
                      ->WhereColName('session_id')
                      ->WhereColValue($_SESSION['sess_id'])
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        $row = $this->DFE->db->SelectPuffer;
        if ($num) {
            $sess_userdata = unserialize($this->DFE->db->SelectPuffer['session_data']);

            foreach ($sess_userdata as $key => $val) {
                $session["" . $key . ""] = $val;
            }
            if (isset($session['sess_system_config_menu'])) {
                if(is_array($session['sess_system_config_menu']) && $this->DFE->http->_post('action') == 'open') {
                    array_push($session['sess_system_config_menu'], $this->DFE->http->_post('system_config_point'));
                } else {
                    $key = array_search($this->DFE->http->_post('system_config_point'), $session['sess_system_config_menu']);
                    unset($session['sess_system_config_menu'][$key]);
                }               
            } else {
                if($this->DFE->http->_post('action') == 'open') {
                    $session['sess_system_config_menu'] = array();
                    array_push($session['sess_system_config_menu'], $this->DFE->http->_post('system_config_point'));
                }
            }
            $sess_userdata = serialize($session);
            $this->DFE->db->Update('session')
                          ->WhereColName('session_id')
                          ->WhereColValue($_SESSION['sess_id'])
                          ->Set(array('session_data' => $sess_userdata))
                          ->doUpdate();
            
            return 'ok';
        }
    }
    
    public function DownloadVariables() {
        if($this->DFE->http->issetPost('download') === true && $this->DFE->http->isArray('download') === true) {    
            $this->DFE->db->TablePreName = 'fe_';
            $this->DFE->db->Select('*')
                          ->From('system_config')
                          ->noWhere(1)
                          ->Andd("WHERE config_id IN (".implode(", ", $this->DFE->http->_post('download')).") AND config_lang = :config_lang ")
                          ->Parameter(array('config_lang' => $GLOBALS['LANGUAGE']))
                          ->SelectMethod(1)
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            if($num) {
                $keys = array_flip($this->DFE->db->SelectPuffer[0]);
                $insert = "INSERT INFO fe_system_config (".implode(", ", $keys).") VALUES ";
                foreach($this->DFE->db->SelectPuffer as $key => $row) {
                    $insert .= "('', '".$row['config_title']."', '".$row['config_key']."', '".$row['config_value']."', '".$row['config_description']."', '".$row['config_lang']."', '".$row['config_hidden']."', '".$row['last_modified']."', '".$row['date_added']."', '".$row['client_id']."'); ";
                }
                
                $sql_ad = date("Y.m.d - H:i", time());
                $sql_ad = str_replace(".", "_", $sql_ad);
                $sql_ad = str_replace(" - ", "-", $sql_ad);
                $sql_ad = str_replace(":", "_", $sql_ad);
                $sql_name = "Export_SystemConfig_" . $sql_ad . ".sql";
                $sqlfilename = DOC_ROOT . ARIBU_SYSTEMS_SFOLDER . "/fileadmin/sql/" . $sql_name;
                if(\lib\Functions::CheckIfDirectoryExists(ARIBU_SYSTEMS_SFOLDER ."/fileadmin/sql/")){}
                $sqlfilehandle = fopen($sqlfilename, "w");

                fputs($sqlfilehandle, $insert);
                fclose($sqlfilehandle);
                
                header("Pragma: public");
                header("Expires: 0");
                header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                header("Cache-Control: private", false);
                header("Content-Type: application/force-download");
                header("Content-Disposition: attachment; filename=\"" . $sql_name . "\";");
                header("Content-Transfer-Encoding: binary");
                header("Content-Length: " . filesize($sqlfilename));
                 
                readfile($sqlfilename);
                @unlink($sqlfilename);
                exit;
            }
        }
    }
    
    public function DeleteVariables() {
        if($this->DFE->http->issetPost('download') === true && $this->DFE->http->isArray('download') === true) {    
            $this->DFE->db->TablePreName = 'fe_';
            $this->DFE->db->Delete("system_config")
                          ->noWhere(1)
                          ->Andd("WHERE config_id IN (".implode(", ", $this->DFE->http->_post('download')).") AND config_lang = :config_lang ")
                          ->Parameter(array("config_lang" => $GLOBALS['LANGUAGE']))
                          ->doDelete();
            return json_encode(array("msg" => "ok"));
        } else {
            return json_encode(array("msg" => "error"));
        }
    }

    public function dmethod() {
        
    }

}