<?php

namespace aribu\scripts\user\lib;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   04.11.2005
 * @update: 09.04.2016
 */



class User extends \aribu\scripts\abstracts\Abstracts {
    
          
    public $StaticName = "BE";
    
    /**
     * BE user rights config
     * @var boolen
     */
    public $BEUserRights = false;
    
    public function __construct($DFE) {
        parent::__construct($DFE);
    }

    public function newuser($template = "/aribu.systems/_templates/user/new_user.html") {

        require_once FE_MENU;

        if ($this->DFE->http->issetPost('save_newuser') === false) {

            $this->DFE->TT->setMC('head', $this->be_language['__head_add']);

            if ($this->DFE->http->_post('action') == "edit") {
                if ($this->DFE->http->issetPost('user') === false) {
                    $this->DFE->db->TablePreName = "be_";
                    $this->DFE->db->Select('*')
                                  ->From('user')
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->doSelect();
                    $row = $this->DFE->db->SelectPuffer;
                    $this->DFE->TT->setMC('display_url', "display:none; ")
                                  ->setMC('display_redirect', "display:none;");
                } 
                $this->DFE->TT->setMC('head', $this->be_language['__head_edit']);
                $this->DFE->db->TablePreName = "fe_";
            } else {
                $this->DFE->TT->setMC('display_redirect', "display:none;")
                              ->setMC('display_url', "display:none; ")
                              ->setMC('user_area', '');
                $row = array();
            }

            # Gruppe
            $this->DFE->db->TablePreName = "be_";
            $this->DFE->db->Select('*')
                          ->From('user_groups')
                          ->noWhere(1)
                          ->SelectMethod(1)
                          ->doSelect();
            $numg = $this->DFE->db->Rows;
            $rowg = $this->DFE->db->SelectPuffer;
            for ($i = 0; $i < $numg; $i++) {
                $group = @explode("-", trim($row['user_group'],'-'));
                $selected = in_array($rowg[$i]['id'], $group) ? " selected" : "";
                $group_options .= "<option value=\"" . $rowg[$i]['id'] . "\"" . $selected . ">" . $rowg[$i]['name'] . "</option>";
            }
            $this->DFE->db->TablePreName = "fe_";


            # Be-User rights
            ksort($GLOBALS['BE_USER_RIGHTS']);
            foreach ($GLOBALS['BE_USER_RIGHTS'] as $key => $val) {
                $selected = $row['admin'] == $key ? "selected" : "";
                $be_rights_options .= "<option value=\"" . $key . "\" " . $selected . ">" . $val . "</option>";
            }  
             
            # FE-User rights
            ksort($GLOBALS['FE_USER_RIGHTS']);
            foreach ($GLOBALS['FE_USER_RIGHTS'] as $key => $val) {
                $selected = $row['fe_user_rights'] == $key ? "selected" : "";
                $fe_user_rights_options .= "<option value=\"" . $key . "\" " . $selected . ">" . $val . "</option>";
            } 
            
            # Languages
            foreach ($GLOBALS['BE_LANGUAGES'] as $key => $val) {
                $selected = $row['lang'] == $key ? "selected" : "";
                $lang_options .= '<option value="'.$key.'" '.$selected.'>'.$val.'</option>';
            }

            $status_0 = $row['disable'] == 0 ? "checked" : "";
            $status_1 = $row['disable'] == 1 ? "checked" : "";

            # BE rights 
            if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][41] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][43] == 1) {
                $be_rights = "";
            } else {
                $be_rights = 'data-toggle="tooltip" data-placement="top" title="'. $this->be_language['_rights_setup_user'] .'"'; 
            }
            
            
            $user_image = $row['user_image'] != "" ? '<img src="/fileadmin/backend/user/normal/' . $row['user_image'] . '" border="0" id="pro-image" class="img-thumbnail width-200"><input name="user_image" value="' . $row['user_image'] . '" type="hidden" />' : "";
            $del_user_image = $user_image != "" ? '<a href="javascript:void(0);" onclick="javascript:delUserImage(\'acm=delimage&uid=' . $this->DFE->http->_post('uid') . '\');"><i class="fa fa-trash inverse" aria-hidden="true"></i></a><br style="clear:both;" />' : "";
            
            foreach($row as $key => $val) {
                $this->DFE->TT->setMC($key, $val);
            }
            
            $this->DFE->TT->setMC('lang',                   $GLOBALS['LANGUAGE'])
                          ->setMC('sid',                    $_SESSION['sess_id'])
                          ->setMC('user_image',             $user_image)
                          ->setMC('del_user_image',         $del_user_image)
                          ->setMC('lang_options',           $lang_options)
                          ->setMC('status_0',               $status_0)
                          ->setMC('status_1',               $status_1)
                          ->setMC('be_rights_options',      $be_rights_options)
                          ->setMC('fe_user_rights_options', $fe_user_rights_options)
                          ->setMC('group_options',          $group_options)
                          ->setMC('be_rights',              $be_rights)
                          ->setMC('backlink',               \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['BEUserOverview'], $GLOBALS['LANGUAGE']))
                          ->setMC('password',               $this->DFE->TT->getMC('userCache') != '' ? \lib\vendor\defuse\crypto\Crypto::decryptWithPassword($this->DFE->TT->getMC('userCache'), ARIBU_API_PASSWORD) : '')
                          ->setMC('new_user_url',           \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['BENewUser'], $GLOBALS['LANGUAGE']));
            
            
            $this->DFE->TT->BlockMarker['error'] = 1;
            if ($this->DFE->http->issetPost('save_newuser') === true) {
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_save_user_ok'), 'messenger-on-top messenger-on-right', 'success'));
            } elseif(isset($this->Error['Validation'])) {
                $this->DFE->TT->BlockMarker['error'] = 0;
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            }    
        } else {
            if ($this->DFE->http->_post('action') != "edit") {

                # Fehlerbehandlung
                if ($this->DFE->http->_post('password1') != $this->DFE->http->_post('password2')) {
                    $err = 1;
                    $error['password'] = "<span style=\"color:#CC0000; font-weight:bold;\">" . $this->be_language['_error_user_pw'] . "</span>";
                    $this->Error['Validation'] = $this->be_language['_error_user_pw'];
                }

                $this->DFE->db->TablePreName = "be_";

                $this->DFE->db->Select('count(*) AS num')
                              ->From('user')
                              ->WhereColName('username')
                              ->WhereColValue($this->DFE->http->_post('username'))
                              ->doSelect();
                $num = $this->DFE->db->SelectPuffer['num'];
                if ($num > 0) {
                    $err = 1;
                    $this->DFE->TT->setMC('error_username', 'danger');
                    $this->Error['Validation'] .= $this->be_language['_error_username'];
                }

                if ($this->DFE->http->isEmpty('username') === true) {
                    $err = 1;
                    
                    $this->DFE->TT->setMC('error_username', 'danger');
                    $this->Error['Validation'] .= $this->be_language['_error_username2'];
                }

                if ($this->DFE->http->isEmpty('password1') === true || $this->DFE->http->isEmpty('password2') === true) {
                    $err = 1;
                    $this->DFE->TT->setMC('error_password', "danger");
                    $this->Error['Validation'] .= $this->be_language['_error_user_pw2'];
                }

                # Fehlerausgabe
                if ($err == 1) {
                    $this->DFE->http->unsetPost('save_newuser');
                    $this->newuser($template);
                    
                } else {
                    
                    $gruppen = $this->DFE->http->_post('be_group') != 'x' ? implode("-", $this->DFE->http->_post('be_group')) : "";

                    $password = md5($this->DFE->http->_post('password1'));
                    
                    # Encrypt password
                    $EncryptedPassword = \lib\vendor\defuse\crypto\Crypto::encryptWithPassword($this->DFE->http->_post('password1'), ARIBU_API_PASSWORD);

                    $this->DFE->db->TablePreName = "be_";
                    $this->DFE->db->Insert('user')
                                  ->Parameter(array('uid'           => '', 
                                                    'tstamp'        => time(), 
                                                    'username'      => $this->DFE->http->_post('username'), 
                                                    'password'      => $password, 
                                                    'admin'         => $this->DFE->http->_post('be_rights'), 
                                                    'usergroup'     => $gruppen, 
                                                    'disable'       => $this->DFE->http->_post('status'), 
                                                    'starttime'     => '', 
                                                    'endtime'       => '', 
                                                    'lang'          => $this->DFE->http->_post('lang'), 
                                                    'email'         => $this->DFE->http->_post('email'), 
                                                    'last_login'    => '', 
                                                    'deleted'       => '', 
                                                    'full_name'     => $this->DFE->http->_post('full_name'), 
                                                    'userCache'     => $EncryptedPassword, 
                                                    'be_rights'     => '', 
                                                    'author'        => $this->DFE->http->_post('author'), 
                                                    'user_image'    => $this->DFE->http->_post('user_image'),
                                                    'fe_user_rights' => $this->DFE->http->_post('fe_user_rights')));
                    
                    header("Location: ?ac=showuser");
                    exit;
                }
            } else {
                
                $password = md5($this->DFE->http->_post('password1'));
                $EncryptedPassword = \lib\vendor\defuse\crypto\Crypto::encryptWithPassword($this->DFE->http->_post('password1'), ARIBU_API_PASSWORD);
                $gruppen = $this->DFE->http->_post('be_group') != 'x' ? implode("-", $this->DFE->http->_post('be_group')) : "";

                $this->DFE->db->TablePreName = "be_";
                $this->DFE->db->Update('user')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid')) 
                              ->Set(array(  "username"          => $this->DFE->http->_post('username'),
                                            "password"          => $password,
                                            "admin"             => $this->DFE->http->_post('be_rights'),
                                            "disable"           => $this->DFE->http->_post('status'),
                                            "email"             => $this->DFE->http->_post('email'),
                                            "full_name"         => $this->DFE->http->_post('full_name'),
                                            "userCache"         => $EncryptedPassword,
                                            "lang"              => $this->DFE->http->_post('lang'),
                                            "usergroup"         => $gruppen,
                                            "author"             => $this->DFE->http->_post('author'),
                                            "user_image"        => $this->DFE->http->_post('user_image'),
                                            "fe_user_rights"    => $this->DFE->http->_post('fe_user_rights')))
                              ->doUpdate();
                
                $user = $this->DFE->http->issetPost('user') === true ? '&user='.$this->DFE->http->_post('user') : '';    
                header("Location: ?ac=showuser".$user);
                exit;
            }
        }

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    /*
     * User overview
     *
     */

    public function showuser($template = "/aribu.systems/_templates/user/user_overview.html") {

        $this->DFE->db->TablePreName = "be_";

        switch ($this->DFE->http->_post('action')) {
            case 'disabled':
                if ($this->DFE->http->issetPost('user') === false) {
                    $this->DFE->db->Update('user')
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Set(array("disable" => 1))
                                  ->doUpdate();
                } else {
                    $this->DFE->db->TablePreName = "fe_";
                    $this->DFE->db->Update('user_accounts')
                                  ->WhereColName('user_id')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Set(array("user_active" => 0))
                                  ->doUpdate();
                    $this->DFE->db->TablePreName = "be_";
                }
                break;

            case 'able':
                if ($this->DFE->http->issetPost('user') === false) {
                    $this->DFE->db->Update('user')
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Set(array("disable" => 0))
                                  ->doUpdate();
                } else {
                    $this->DFE->db->TablePreName = "fe_";
                    $this->DFE->db->Update('user_accounts')
                                  ->WhereColName('user_id')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Set(array("user_active" => 1))
                                  ->doUpdate();
                    $this->DFE->db->TablePreName = "be_";
                }
                break;

            case 'del':
                if ($this->DFE->http->issetPost('user') === false) {
                    $this->DFE->db->Delete('user')
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->doDelete();
                } else {
                    $this->DFE->db->TablePreName = "fe_";
                    $this->DFE->db->Delete('user_accounts')
                                  ->WhereColName('user_id')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->doDelete();
                    $this->DFE->db->TablePreName = "be_";
                }
                break;
        }


        if ($this->DFE->http->_post('user') != '') {
            if ($this->DFE->http->issetPost('user') === false || $this->DFE->http->_post('user') == "be") {
                $this->DFE->db->Select('*')
                              ->From('user')
                              ->noWhere(1)
                              ->SelectMethod(1)
                              ->doSelect();
                $user_be = "selected=\"selected\"";
                $this->DFE->TT->BlockMarker['be_user'] = 1;
            } else {
                $this->DFE->db->TablePreName = "fe_";
                $this->DFE->db->Select('user_id AS uid, username, user_lastname AS full_name, user_rights AS admin, user_active AS disable, user_data, user_phone AS email, user_last_visit AS last_login')
                              ->From('user_accounts')
                              ->WhereColName('user_rights')
                              ->WhereColValue('256')
                              ->Operator('>=')
                              ->SelectMethod(1)
                              ->doSelect();
                $user_fe = 'selected="selected"';
                $user_query = "&user=fe";
                $this->DFE->TT->BlockMarker['be_user'] = 0;
            }
        } else {
            $this->DFE->db->Select('*') 
                          ->From('user')
                          ->noWhere(1)
                          ->SelectMethod(1)
                          ->doSelect();
        }
        $row = $this->DFE->db->SelectPuffer;
        $num = $this->DFE->db->Rows;
        for ($i = 0; $i < $num; $i++) {


            $action_rights = '<a href="?ac=UserRights&uid=' . $row[$i]['uid'] . '" title="'. $this->be_language['_user_rights'] .'"><i class="fa fa-lock inverse" aria-hidden="true"></i></a>';

            # BE Rights publish BE user
            if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][44] == 1) {
                $action_hidden = SECURITY_SET_STATUS_BE_USERT === true ? '<a href="?ac=showuser&action=disabled&uid=' . $row[$i]['uid'] . $user_query . '"><i class="fa fa-globe inverse" aria-hidden="true"></i></a>' : '<a href="javascript:void(0);" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_lock_user'].'"><i class="fa fa-globe inverse disabled" aria-hidden="true"></i></a>';
                $action_public = SECURITY_SET_STATUS_BE_USERT === true ? '<a href="?ac=showuser&action=able&uid=' . $row[$i]['uid'] . $user_query . ' title="'.$this->be_language['_unlock_user'].'"><i class="fa fa-globe aribu" aria-hidden="true"></i></a>' : '<a href="javascript:void(0);" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_unlock_user'].'"><i class="fa fa-globe aribu disabled" aria-hidden="true"></i></a>';
            } else {
                $action_hidden = '<a href="javascript:void(0);" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_lock_user'].'"><i class="fa fa-globe inverse disabled" aria-hidden="true"></i></a>';
                $action_public = '<a href="javascript:void(0);" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_unlock_user'].'"><i class="fa fa-globe aribu disabled" aria-hidden="true"></i></a>';
            }

            # BE Rights del BE user
            if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][42] == 1) {
                $action_del = SECURITY_DELETE_BE_USER === true ? '<a href="javascript: void(0);" onclick="javascript: deleteUser(\'?ac=showuser&action=del&uid=' . $row[$i]['uid'] . $user_query . '\');" title="'.$this->be_language['_del_user'].'"><i class="fa fa-trash inverse" aria-hidden="true"></i></a>' : '<a href="javascript:void(0);" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_del_user'].'"><i class="fa fa-trash inverse disabled" aria-hidden="true"></i></a>';
            } else {
                $action_del = '<a href="#" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_del_user'].'"><i class="fa fa-trash inverse" aria-hidden="true"></i></a>';
            }

            if ($this->DFE->http->_post('user') != '') {
                if ($this->DFE->http->issetPost('user') === false || $this->DFE->http->_post('user') == "be") {
                    $action_status = $row[$i]['disable'] == 0 ? $action_hidden : $action_public;
                } else {
                    $action_status = $row[$i]['disable'] == 1 ? $action_hidden : $action_public;
                }
            } else {
                $action_status = $row[$i]['disable'] == 0 ? $action_hidden : $action_public;
            }
            
            $actions_login = '';
            if($this->DFE->http->_post('user') != "be" && $this->DFE->http->issetPost('user') === true) {
                $user_data  = unserialize($row[$i]['user_data']);
                $lData      = base64_encode("login=1&admin_login=1&username=" . $row[$i]['username'] . "&password=" . $user_data['password']);
                $user_login = '?' . base64_encode("logout=true&lData=" . $lData);
                $actions_login = '<a href="/' . $user_login . '" title="Als FE-User einloggen" target="_blank" style="color:#666666; font-size:14px;"><i class="fa fa-sign-in"></i></a>';

            }

            $action_edit = SECURITY_EDIT_BE_USER === true ? '<a href="?ac=newuser&action=edit&uid=' . $row[$i]['uid'] . $user_query . '" title="'.$this->be_language['_edit_user'].'"><i class="fa fa-pencil inverse" aria-hidden="true"></i></a>' : '<a href="javascript:void(0);" data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_edit_user'].'"><i class="fa fa-pencil inverse disabled" aria-hidden="true"></i></a>';

            
            $actions = $action_status . $action_edit . $action_rights . $action_del . $actions_login;
            
            
            $type = $this->DFE->http->issetPost('user') === false || $this->DFE->http->_post('user') === 'be' ? $GLOBALS['BE_USER_RIGHTS'][$row[$i]['admin']] : $GLOBALS['FE_USER_RIGHTS'][$row[$i]['admin']];
            $act = $row[$i]['uid'] == 1 && $_SESSION['sess_uid'] != 1 ? "" : $actions;
            $username = '<a href="javascript:void(0);" title="Letzter Login: ' . date("d.m.Y - H:i", $row[$i]['last_login']) . ' Uhr">' . $row[$i]['full_name'] . '</a>';
            $aut .= '<tr>';
            $aut .= '<td>' . ($i + 1) . ".</td>";
            $aut .= '<td>' . $username . "</td>";
            $aut .= '<td>' . $row[$i]['username'] . '</td>';
            $aut .= '<td>' . $type . "</td>";
            $aut .= '<td>' . $row[$i]['email'] . '</td>';
            $aut .= '<td align="center">' . $act . '</td>';
            $aut .= '</tr>';
            
        }

        $this->DFE->TT->setMC('user_table',     $aut)
                      ->setMC('num',            $num)
                      ->setMC('new_user_url',   \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['BENewUser'], $GLOBALS['LANGUAGE']));

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    

    public function UserRights($template = "/aribu.systems/_templates/user/user_rights.html") {
        if ($this->DFE->http->issetPost('save_be_rights') === false) {
            if($this->BEUserRights === false) {
                $this->DFE->db->TablePreName = "be_";
                $this->DFE->db->Select('be_rights, full_name')
                              ->From('user')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;
                $user = $row['full_name'];
                $uid = $this->DFE->http->_post('uid');
            } else {
                $this->DFE->TT->BlockMarker['be_user_rights'] = 0;
                $this->DFE->TT->setMC('role_options', \lib\Functions::getOptions($GLOBALS['BE_USER_RIGHTS'], $this->DFE->http->_post('BE_USER_RIGHTS')));
                
                if($this->DFE->http->issetPost('BE_USER_RIGHTS') === true) {
                    $this->DFE->db->TablePreName = "be_";
                    $this->DFE->db->Select('rights as be_rights')
                                  ->From('rights')
                                  ->WhereColName('rid')
                                  ->WhereColValue($this->DFE->http->_post('BE_USER_RIGHTS'))
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    if($num) {
                        $row = $this->DFE->db->SelectPuffer;
                    } else {
                        $this->DFE->TT->setMC('hidden_data', '<input type="hidden" name="new">');
                    }
                }
                
            }

            # Rights
            $user_rights_table = $this->UserRightsTree($GLOBALS['BE_SYSTEM_RIGHTS'], unserialize($row['be_rights']));
            $backlink = \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['BEUserOverview'], $GLOBALS['LANGUAGE']);

            # BE Rights Change user rights
            if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][45] == 1) {
                $be_rights = "";
            } else {
                $be_rights = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_be_user'].'"'; 
            }
            
            $this->Messenger();
            
        } else {
            $be_rights_data = serialize($this->DFE->http->_post('be_rights'));
            $this->DFE->db->TablePreName = "be_";
            if($this->BEUserRights === false) {
                $this->DFE->db->Update('user')
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Set(array("be_rights" => $be_rights_data))
                              ->doUpdate();
                header("Location: ?ac=showuser");
                exit;
            } else {
                $be_rights_data = serialize($this->DFE->http->_post('be_rights'));
                if($this->DFE->http->issetPost('new') === true) {
                    $this->DFE->db->Insert('rights')
                                  ->Parameter(array(   'rid'    => $this->DFE->http->_post('BE_USER_RIGHTS'), 
                                                       'rights' => $be_rights_data))
                                  ->doInsert();
                } else {
                    $this->DFE->db->Update('rights')
                                  ->WhereColName('rid')
                                  ->WhereColValue($this->DFE->http->_post('BE_USER_RIGHTS'))
                                  ->Set(array("rights" => $be_rights_data))
                                  ->doUpdate();
                }
                header("Location: ?saved=ok&BE_USER_RIGHTS=".$this->DFE->http->_post('BE_USER_RIGHTS'));
                exit;
            }
           
            
        }
        $this->DFE->TT->setMC('user_rights_table', $user_rights_table)
                      ->setMC('backlink', $backlink)
                      ->setMC('be_rights', $be_rights)
                      ->setMC('uid', $uid)
                      ->setMC('user', $user);

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    public function Messenger() {
        $this->DFE->TT->BlockMarker['saved'] = $this->DFE->http->issetPost('saved') === false ? 0 : 1;
        $save_message = "Die Daten wurden erfolgreich gespeichert!";
        $messenger_type = 'success';
            
        $this->DFE->TT->setMC('save_message', $save_message)
                      ->setMC('messenger_type', $messenger_type);
    }

    public function UserRightsTree($arr, $be_rights = array()) {
        $max = count($arr);
        $a = 1;
        $nbr = "\n";
        ksort($arr);
        foreach ($arr as $key => $val) {
            $this->DFE->db->TablePreName = 'fe_';
            $this->DFE->db->Select('*')
                          ->From('system_config')
                          ->WhereColName('config_title')
                          ->WhereColValue('BE_SYSTEM_RIGHTS')
                          ->Andd("AND config_key = '" . $key . "' AND config_lang = :config_lang")
                          ->Parameter(array('config_lang' => $_SESSION['sess_language']))
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            $desc = $row['config_description'];

            if ($desc == "Head") {

                $tmp_tree_start = $key == '0' ? '<div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">'.$nbr : $nbr.'</div>'.$nbr.'</div>'.$nbr.'</div>'.$nbr.'</div>'.$nbr;
                $tmp_tree .= $tmp_tree_start . '<div class="panel panel-default">'.$nbr.'
                                                <div class="panel-heading" role="tab" id="headingOne">'.$nbr.'
                                                <h4 class="panel-title">'.$nbr.'
                                                <a role="button" data-toggle="collapse" data-parent="#accordion" href="#collapse'.$key.'" aria-expanded="true" aria-controls="collapse'.$key.'">' . $val . '</a>'.$nbr
                                            . ' </h4>'.$nbr
                                            . '</div>'.$nbr
                                            . '<div id="collapse'.$key.'" class="panel-collapse collapse" role="tabpanel" aria-labelledby="heading'.$key.'">'.$nbr.'
                                                <div class="panel-body"><div class="row">'.$nbr;
            } else {
                if (!empty($be_rights)) {
                    $checked = $be_rights['BE_SYSTEM_RIGHTS'][$key] == 1 ? ' checked="checked"' : '';
                }
                $tmp_tree_ende = $max == $a ? '</div>'.$nbr : '';
                $tmp_tree .= '<div class="form-group col-lg-3"><label class="col-lg-8">' . $val . '</label>';
                $tmp_tree .= '<div class="col-lg-4"><div class="checkbox checkbox-circle"><input type="checkbox" name="be_rights[BE_SYSTEM_RIGHTS][' . $key . ']" value="1"'. $checked . '><label></label></div></div></div>' . $tmp_tree_ende;
            }
            $a++;
        }
        return $tmp_tree.$nbr.'</div></div></div></div></div>';
    }

    
    public function newgroup($template = "/aribu.systems/_templates/user/new_group.html") {
       
        if ($this->DFE->http->issetPost('save_newgroup') === false) {

            $head = $this->be_language['__head_add'];

            if ($this->DFE->http->_post('action') == "edit") {
                $this->DFE->db->TablePreName = $this->TablePreName;
                $this->DFE->db->Select('*')
                              ->From('user_groups')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('gid'))
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;
                foreach ($row as $key => $val) {
                    $$key = $val;
                }
                $head = $this->be_language['__head_edit'];
            }
           
            $this->DFE->TT->BlockMarker['error'] = 1;
            if ($this->DFE->http->issetPost('save_newuser') === true) {
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_save_user_ok'), 'messenger-on-top messenger-on-right', 'success'));
            } elseif(isset($this->Error['Validation'])) {
                $this->DFE->TT->BlockMarker['error'] = 0;
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            } 
            $this->DFE->TT->setMC('backlink',   \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['BEUsergroup'], $GLOBALS['LANGUAGE']).$this->DFE->http->ReturnQS())
                          ->setMC('be_rights',  $be_rights = $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][391] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][392] == 1 ? "" : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_setup_group'].'"')
                          ->setMC('status_0',   $status == 0 ? "checked" : "")
                          ->setMC('status_1',   $status == 1 ? "checked" : "")
                          ->setMC('head',       $head);
        } else {
            if ($this->DFE->http->_post('action') != "edit") {
                # Fehlerbehandlung
                $this->DFE->db->TablePreName = $this->TablePreName;
                $this->DFE->db->Select('count(id) as num')
                              ->From('user_groups')
                              ->WhereColName('name')
                              ->WhereColValue($this->DFE->http->_post('name'))
                              ->doSelect();
                $num = $this->DFE->db->SelectPuffer['num'];
                if ($num > 0) {
                    $err = 1;
                    $error_name = "danger";
                    $this->Error['Validation'] = $this->be_language['_error_group_name'];
                    
                }
                if ($this->DFE->http->isEmpty('name')) {
                    $err = 1;
                    $error_name = "danger";
                    $this->Error['Validation'] = $this->be_language['_error_group_name2'];
                    
                }

                if ($err == 1) {
                    $this->DFE->http->unsetPost('save_newgroup');
                    $this->newgroup($template);
                } else {
                    # Insert
                    $this->DFE->db->TablePreName = $this->TablePreName;
                    
                    $insert_array = array(  'id'            => '', 
                                            'name'          => $this->DFE->http->_post('name'), 
                                            'author'        => $_SESSION['sess_username'], 
                                            'lastUpdate'    => time(), 
                                            'status'        => $this->DFE->http->_post('status'),
                                            'client_id'     => $this->DFE->http->_post('client_id'));
                    
                    $this->DFE->db->Insert('user_groups')
                                  ->Parameter($insert_array)
                                  ->doInsert();
                    header("Location: ".\lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->StaticName.'UserGroup'], $GLOBALS['LANGUAGE']).$this->DFE->http->ReturnQS());
                    exit;
                }
            } else {
                # Edit and update
                $this->DFE->db->TablePreName = $this->TablePreName;
                $this->DFE->db->Update('user_groups')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('gid'))
                              ->Set(array(  "name"          => $this->DFE->http->_post('name'), 
                                            "author"        => $_SESSION['sess_username'], 
                                            "lastUpdated"   => time(), 
                                            "status"        => $this->DFE->http->_post('status')))
                              ->doUpdate();
                
                header("Location: ".\lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->StaticName.'UserGroup'], $GLOBALS['LANGUAGE']).$this->DFE->http->ReturnQS());
                exit;
            }
        }
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    
    public function showgroup($template = "/aribu.systems/_templates/user/group_overview.html") {
        
        $this->DFE->db->TablePreName = 'be_';

        switch ($this->DFE->http->_post('action')) {
            case 'disabled':
                $this->DFE->db->Update('user_groups')
                               ->WhereColName('id')
                               ->WhereColValue($this->DFE->http->_post('gid')) 
                               ->Set(array("status" => 1))
                               ->doUpdate();
                break;

            case 'able':
                $this->DFE->db->Update('user_groups')
                               ->WhereColName('id')
                               ->WhereColValue($this->DFE->http->_post('gid')) 
                               ->Set(array("status" => 0))
                               ->doUpdate();
                break;

            case 'del':
                $this->DFE->db->Delete('user_groups')
                              ->WhereColName('id')
                              ->WhereColValue($this->DFE->http->_post('gid'))
                              ->doDelete();
                break;
        }

        
        $this->DFE->db->Select('*')
                      ->From('user_groups')
                      ->WhereColName('client_id')
                      ->WhereColValue($_SESSION['sess_client_id'])
                      ->SelectMEthod(1)
                      ->doSelect();
        
        $num = $this->DFE->db->Rows;
        $row = $this->DFE->db->SelectPuffer;

        if ($num) {
            for ($i = 0; $i < $num; $i++) {

                foreach ($row[$i] as $key => $val) {
                    ${$key} = $val;
                    $this->DFE->TT->SetIMC($i, $key, $val);
                }

                $nr = $i + 1 . ".";

                # BE Rights publish BE user
                if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][394] == 1) {
                    $action_hidden = '<a href="?action=disabled&gid='.$id.'" title="'.$this->be_language['_lock_group'].'"><i class="fa fa-globe inverse" aria-hidden="true"></i></a>';
                    $action_public = '<a href="?action=able&gid='.$id.'" title="'.$this->be_language['_unlock_group'].'"><i class="fa fa-globe aribu" aria-hidden="true"></i></a>';
                } else {
                    $action_hidden = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_lock_group'].'"'; 
                    $action_public = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_unlock_group'].'"'; 
                }

                # BE Rights del BE user
                if ($_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][393] == 1) {
                    $action_del = "<a href=\"?action=del&gid=" . $id . "\"><img src=\"/aribu.systems/fileadmin/img/icons/tiny/admin_del.gif\" border=\"0\" title=\"" . $this->be_language['_del_group'] . "\" style=\"margin-right:4px\"></a>";
                } else {
                    $action_del = 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_del_group'].'"'; 
                }
                $action_status = $status == 0 ? $action_hidden : $action_public;
                $action_edit = '<a href="'.\lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->StaticName.'NewUserGroup'], $GLOBALS['LANGUAGE']).'?action=edit&gid=' . $id . $this->DFE->http->returnQS(2) .'"><img src="/aribu.systems/fileadmin/img/icons/tiny/admin_edit.gif" border="0" title="' . $this->be_language['_edit_group'] . '" style="margin-right:4px"></a>';
                $actions = $action_status . $action_edit . $action_del;

                $this->DFE->TT->SetIMC($i, 'actions', $actions)
                              ->SetIMC($i, 'nr', $nr);
            }
        } else {
            $num = '0';
        }
        
        $this->DFE->TT->SetMC('num',            $num)
                      ->SetMC('new_group_url',  \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['BENewUserGroup'], $GLOBALS['LANGUAGE']));
        
        return $this->DFE->TT->getFilledTemplate($template, 1, 1);
    }

    
    public function uploadImage() {
        $imgHandle = new \lib\Image();

        if (!empty($_FILES)) {
            $imgHandle->makeThumb = 1;
            $imgHandle->HoldImageName = 1;
            $imgHandle->image_size = 40;
            $imgHandle->IMG_Size = 'width';
            $imgHandle->kb = "2048";
            if(\lib\Functions::CheckIfDirectoryExists($_SERVER['DOCUMENT_ROOT'] . "/fileadmin/backend/user/thumbs"));
            if(\lib\Functions::CheckIfDirectoryExists($_SERVER['DOCUMENT_ROOT'] . "/fileadmin/backend/user/normal"));
            $image = $imgHandle->imageUpload('', $_SERVER['DOCUMENT_ROOT'] . "/fileadmin/backend/user/thumbs/", $_SERVER['DOCUMENT_ROOT'] . "/fileadmin/backend/user/normal/");
            if (!$image) {
                # Fehler beim Hochladen	
                switch ($imgHandle->ErrorType) {
                    case 1: # Image to large
                        $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"1\"})\n";
                        break;

                    case 2: # Extension error
                        $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"2\"})\n";
                        break;

                    case 3: # Empty select
                        $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"3\"})\n";
                        break;

                    case 4: # Upload error
                        $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"4\"})\n";
                        break;
                    
                    case 5: # File error no image
                        $upError = "top.uploadResult = ({\"status\":\"error\",\"error\":\"5\"})\n";
                        break;
                }
                $javascript .= "<script type=\"text/javascript\">\n";
                $javascript .= $upError;
                $javascript .= "</script>";
                return $javascript;
            } else {
                $javascript .= "<script type=\"text/javascript\">\n";
                $javascript .= "top.uploadResult = ({\"status\":\"uploadReady\",\"image\":\"" . $image[0] . "\"});\n";
                $javascript .= "</script>";
                return $javascript;
            }
        }
    }
    
    public function PasswordRoutine($template = '/aribu.systems/_templates/user/password_routine.html') {
        
        $this->DFE->TT->BlockMarker['send'] = $this->DFE->http->issetPost('SendPassword') === false && $this->DFE->http->issetPost('send') === false ? 1 : 0;
        
        if($this->DFE->http->issetPost('SendPassword') === true) {
            $error_box = '';
            if($this->DFE->http->isEmpty('username') === true || $this->DFE->http->isEmpty('email_address') === true ) {
                $error = 1;
                $error_box = '<div class="alert alert-danger margin-top-15"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> <b>Fehler:</b> Identifikation fehlgeschlagen: Der/die angegebene Nutzername oder E-Mail-Adresse ist ungültig. Bitte versuchen Sie es erneut.</div>';
            }
            if($error == 1) {
                $this->DFE->TT->BlockMarker['send'] = 1;
            } else {
                $this->DFE->db->TablePreName = 'be_';
                $this->DFE->db->Select('*')
                              ->From('user')
                              ->WhereColName('email')
                              ->WhereColValue(trim(strip_tags($this->DFE->http->_post('email_address'))))
                              ->Andd('AND username = :username')
                              ->Parameter(array('username' => trim(strip_tags($this->DFE->http->_post('username')))))
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                if($num) {
                    $this->DFE->TT->BlockMarker['send'] = 0;
                    $row = $this->DFE->db->SelectPuffer;
                    $DecryptedPassword = \lib\vendor\defuse\crypto\Crypto::decryptWithPassword($row['userCache'], ARIBU_API_PASSWORD);
                    $Username = $row['username'];
                    
                    $mail = \lib\Registry::getObj('mail');
                    $TTT = clone $this->DFE->TT;
                    $mailbuilder = new \lib\mailer\mailbuilder($mail, $TTT);

                    $mailbuilder->setFrom(MASTERMAIL_ADDRESS)
                                ->setFromName(CLIENT)
                                ->setSubject('Ihre Zugangsdaten für '.CLIENT)
                                ->setMailer('mail')
                                ->setHostname(URL_HOST)
                                ->setAddress($row['email'], $row['email'])
                                ->setData('password', $DecryptedPassword)
                                ->setData('username', $Username)
                                ->setData('fullname', $row['full_name'])
                                ->setData('host', URL_PROTOCOL.'://'.URL_HOST)
                                ->setCharSet('utf8')
                                ->setMailTemplate("/aribu.systems/_templates/user/password_routine_email.html");
                                
                    $mailbuilder->sendEMail(NULL, 0, 0, "");
                    $this->DFE->http->unsetPost('username')->unsetPost('email_address')->unsetPost('SendPassword');
                    header('Location: '. \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['PasswordRoutine'], $GLOBALS['LANGUAGE']).'?send=ok');
                    exit();
                } else {
                    $this->DFE->TT->BlockMarker['send'] = 1;
                    $error_box = '<div class="alert alert-danger margin-top-15"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> <b>Fehler:</b> Identifikation fehlgeschlagen: Der/die angegebene Nutzername oder E-Mail-Adresse ist ungültig. Bitte versuchen Sie es erneut.</div>';
                }
            }
        }
        
        $this->DFE->TT->setMC('client', CLIENT)
                      ->setMC('routine_error', $error_box);
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    public function dmethod() {}
}