<?php

namespace elements\element_builder\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   12.05.2011
 * @update: 30.04.2015 
 */

class element {

    public $Pages = "pages";
    public $and_lang = "";
    public $LangFolder = "";
    
    /**
     * DFE object
     * @var object
     */
    public $DFE;

    public function __construct($DFE) {
        $this->DFE = $DFE;

        if ($GLOBALS['LANGUAGE'] != SYS_LANGUAGE) {
            $this->Pages = "pages_language";
            $this->and_lang = "AND %%%n%%%lang = '" . $GLOBALS['LANGUAGE'] . "'";
            $this->LangFolder = $GLOBALS['LANGUAGE'] . '/';
        } else {
            $this->Pages = "pages";
            $this->and_lang = "";
            $this->LangFolder = '';
        }
    }

    # Loginbox FE User

    public function Login() {
       
        $this->DFE->TT->BlockMarker['login'] = isset($_SESSION['sess_username']) ? 1 : 0;
        
        return $this->DFE->TT->getFilledTemplate("/_templates/".$GLOBALS['CLIENT_TEMPLATE_FOLDER']."elements/community/" . $this->LangFolder . "login.html");
    }

    # Language

    public function GetLanguage() {
        return $GLOBALS['LANGUAGE'];
    }

    # Language Box

    public function GetLanguageBox() {

        $num_arr = @count($GLOBALS['FE_LANGUAGES']);
        $l = 1;
        foreach ($GLOBALS['FE_LANGUAGES'] as $key => $val) {
            $active_lang = $GLOBALS['LANGUAGE'] == $key ? " act-lang" : " lang";
            if ($GLOBALS['LANGUAGE'] == SYS_LANGUAGE) {
                if ($key == SYS_LANGUAGE) {
                    $uid = $GLOBALS['PageConfig']['UID'];
                } else {
                    $this->DFE->db->Select('uid, url, urltype')
                                  ->From("pages_language")
                                  ->WhereColName('rid')
                                  ->WhereColValue($GLOBALS['PageConfig']['UID'])
                                  ->Andd("AND lang = :lang ")
                                  ->Parameter(array('lang' => $key))
                                  ->doSelect();
                    $uid = $this->DFE->db->SelectPuffer['uid'];
                    $urltype = $this->DFE->db->SelectPuffer['urltype'];
                    if ($urltype == 5) {
                        $uid = $this->DFE->db->SelectPuffer['url'];
                    }
                }
            } else {
                if ($key == SYS_LANGUAGE) {
                    $this->DFE->db->Select('p.uid, p.url, p.urltype')
                                  ->From("pages_language pl, fe_pages p")
                                  ->WhereColName('pl.uid')
                                  ->WhereColValue($GLOBALS['PageConfig']['UID'])
                                  ->Andd("AND pl.lang = :lang AND pl.rid = p.uid")
                                  ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                                  ->doSelect();
                    $uid = $this->DFE->db->SelectPuffer['uid'];
                    $urltype = $this->DFE->db->SelectPuffer['urltype'];
                    if ($urltype == 5) {
                        $uid = $this->DFE->db->SelectPuffer['url'];
                    }
                } else {
                    $this->DFE->db->Select('uid, url, urltype')
                                  ->From("pages_language")
                                  ->WhereColName('uid')
                                  ->WhereColValue($GLOBALS['PageConfig']['UID'])
                                  ->Andd("AND lang = :lang ")
                                  ->Parameter(array('lang' => $key))
                                  ->doSelect();
                    $uid = $this->DFE->db->SelectPuffer['uid'];
                    $urltype = $this->DFE->db->SelectPuffer['urltype'];
                    if ($urltype == 5) {
                        $uid = $this->DFE->db->SelectPuffer['url'];
                    }
                }
            }
            $first = $l == 1 ? "first" : "";
            $last = $l == $num_arr ? "last" : "";
            $language_box .= '<a href="' . \lib\Functions::dotLink($uid, $key) . '" class="' . $first . $last . $active_lang . ' language-box" id="langbox-' . $key . '">' . $val . '</a>';
            $l++;
        }

        $language_array = $GLOBALS['FE_LANGUAGE'];

        $this->DFE->TT->setMC('language_text',  $language_array[$GLOBALS['LANGUAGE']])
                      ->setMC('language_box',   $language_box);

        return $this->DFE->TT->getFilledTemplate("/_templates/".$GLOBALS['CLIENT_TEMPLATE_FOLDER']."elements/language/" . $this->LangFolder . "language_box.html");
    }
    
    public function Breadcrumb() {
        $this->DFE->TT->BlockMarker['login'] = isset($_SESSION['sess_username']) ? 1 : 0;
        $this->DFE->TT->setMC('breadcrumb',  \lib\Functions::breadcrumbLink($GLOBALS['PageConfig']['UID'], '&gt;'));
        return $this->DFE->TT->getFilledTemplate("/_templates/".$GLOBALS['CLIENT_TEMPLATE_FOLDER']."elements/navigation/" . $this->LangFolder . "breadcrumb.html");
    }

    public function Searchbox() {
        return $this->DFE->TT->getFilledTemplate("/_templates/".$GLOBALS['CLIENT_TEMPLATE_FOLDER']."elements/search/" . $this->LangFolder . "search_box.html");
    }

    
    public function DateTime() {
        
        # Set locale
        setlocale(LC_ALL, $GLOBALS['SYSTEM_LOCALE'][$GLOBALS['LANGUAGE']]);

        $this->DFE->TT->setMC('time',   strftime("%H:%M"))
                      ->setMC('p',      strftime("%P"))
                      ->setMC('date',   strftime("%A, %d. %B %Y"))
                      ->setMC('year',   strftime("%Y"));
        
        return $this->DFE->TT->getFilledTemplate("/_templates/".$GLOBALS['CLIENT_TEMPLATE_FOLDER']."elements/date_time/date_time.html");
    }

    public function Year() {
        # Set locale
        setlocale(LC_ALL, $GLOBALS['SYSTEM_LOCALE'][$GLOBALS['LANGUAGE']]);

        $year = strftime("%Y");
        return $year;
    }

    public function Next() {
       
        $this->DFE->db->Select('uid, rgt, url')
                      ->From($this->Pages)
                      ->noWhere(1)
                      ->Andd("WHERE lft > " . $GLOBALS['PageConfig']['LFT'] . " " . str_replace("%%%n%%%", "", $this->and_lang) . " "
                              . "AND ((starttime = 0 AND endtime = 0 AND hidden != 1) "
                              . "OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime = 0 AND hidden != 1) "
                              . "OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) "
                              . "OR (starttime = 0 AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) "
                              . "OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime = 0 AND hidden = 1) "
                              . "OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) "
                              . "OR (starttime = 0 AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) "
                              . "OR (starttime != 0 AND starttime < '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) "
                              . "OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime > '" . time() . "' AND hidden = 1))")
                      ->Order('ORDER by lft ASC')
                      ->SelectMethod(1)
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();

        $next_link = $this->DFE->db->SelectPuffer[0]['url'] == "" ? \lib\Functions::dotLink($this->DFE->db->SelectPuffer[0]['uid'], $GLOBALS['LANGUAGE']) : \lib\Functions::dotLink($this->DFE->db->SelectPuffer[0]['url'], $GLOBALS['LANGUAGE']);

        return $next_link;
    }

    public function PageTitle() {
        return $GLOBALS['PageConfig']['PAGE_TITLE'];
    }
    
    public function PageName() {
        return $GLOBALS['PageConfig']['PAGE_NAME'];
    }
    
    public function ClientName() {
        return CLIENT;
    }
    
    public function URLHost() {
        return URL_HOST;
    }
    
    public function HTTP() {
        return HTTP;
    }
    
    public function URLProtocol() {
        return URL_PROTOCOL;
    }
    
    public function UID() {
        return $GLOBALS['PageConfig']['UID'];        
    }
    
    public function PID() {
        return $GLOBALS['PageConfig']['PID'];        
    }
    
    public function RequestURI() {
       return $this->DFE->RequestURI; 
    }
}