<?php

/* 
 * aribu systems - Version 1.0.1
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   26.10.2005
 * @update: 23.04.2018 
 */

# Headers
header("Content-Type: text/html; charset=utf-8");

/*
 * Error Reporting
 *
 */
error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED ^ E_WARNING);
ini_set('display_errors', 1);

# Redirect to installation, if config file not exists
if(!file_exists($_SERVER['DOCUMENT_ROOT']."/sys/sys.conf.php")) {
    header('Location: /install/index.php');
    exit();
}

/*
 * Caches the Output
 */
ob_start();


/*
 * Defines the security level and the conf-path
 */
define('GPO_ON', true);
define('SYS_CONF', $_SERVER['DOCUMENT_ROOT'] . '/sys/sys.conf.php');

function aribuAutoload($classname) {    
    $classname          = str_replace("\\", "/", $classname);
    $classname          = explode("/", $classname);
    $classname_file     = end($classname);
    $classname_file_woc = '/'.$classname_file.'.php';
    $classname_file     = '/class.' . $classname_file . '.php';
    array_pop($classname);
    $classname_path = '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . $classname_file_path;
    $classname_woc  = '/' . implode("/", $classname) . $classname_file_woc;
    $classname      = '/' . implode("/", $classname) . $classname_file;
    
    if (file_exists(DOC_ROOT . strtolower(str_replace("aribu", "aribu.systems", $classname)))) {
        require_once(DOC_ROOT . strtolower(str_replace("aribu", "aribu.systems", $classname)));
    } elseif(file_exists(DOC_ROOT . str_replace("aribu", "aribu.systems", $classname))) {
        require_once(DOC_ROOT . str_replace("aribu", "aribu.systems", $classname));
    } elseif(file_exists(DOC_ROOT . str_replace("aribu", "aribu.systems", $classname_woc))) {
        require_once(DOC_ROOT . str_replace("aribu", "aribu.systems", $classname_woc));
    } elseif(file_exists(DOC_ROOT . strtolower(str_replace("aribu", "aribu.systems", $classname_woc)))) {
        require_once(DOC_ROOT . strtolower(str_replace("aribu", "aribu.systems", $classname_woc)));
    }
    
}

spl_autoload_register('aribuAutoload');

/*
 * Here starts the requiring-level
 */
require_once(SYS_CONF);
require_once(REGISTRY);
require_once(PHPMAILER);
require_once(SMTP);

/*
 * HttpRequest
 * @var object
 */
require_once (DOC_ROOT . '/lib/class.http_request.php');
$http = new HttpRequest();
\lib\Registry::setObj('http', $http);

require_once(SYS_FUNCTION);
require_once(DB_FUNCTION);
require_once(TEMPLATE);
require_once(FE_MENU);
require_once(TT);

# PHP Version
if (!defined('PHP_VERSION_ID')) {
    $version = explode('.', PHP_VERSION);
    define('PHP_VERSION_ID', ($version[0] * 10000 + $version[1] * 100 + $version[2]));
}
if(PHP_VERSION_ID < 70200) {
    echo \lib\Functions::readfiles(ARIBU_SYSTEMS_SFOLDER . '/_templates/php_version_error.html');
    exit();
}

/**
 * Mandant
 */
$mandant_folder_explode = explode(".", $_SERVER['HTTP_HOST']);
$mandant_array_count    = count($mandant_folder_explode);
if($mandant_array_count == 4 || $mandant_array_count == 3) {
    $mandant = $mandant_folder_explode[1];
} elseif($mandant_array_count == 2 || $mandant_array_count == 1) {
    $mandant = $mandant_folder_explode[0];
} 

$client = new \lib\Client($db);
$client_name = str_replace("/", "", $mandant);
$client->SetConstantAndGlobalOfClient($client_name);

/*
 * Date Timezone set
 */
date_default_timezone_set(TIMEZONE);


/*
 * Redirect to URL_HOST
 *
 */

if ($_SERVER['HTTP_HOST'] != URL_HOST) {
    header("HTTP/1.1 301 Moved Permanently");
    if (defined('URL_PROTOCOL')) {
        $protocol = URL_PROTOCOL;
    } else {
        $protocol = 'http';
    }
    header("Location: " . $protocol . "://" . URL_HOST . $_SERVER['REQUEST_URI']);
    exit;
}

/*
 * Weiterleitung http:// --> https://
 *
 */
if (defined('URL_PROTOCOL')) {
    if (URL_PROTOCOL == 'https' && !isset($_SERVER['HTTPS'])) {
        header("HTTP/1.1 301 Moved Permanently");
        header("Location: https://" . URL_HOST . $_SERVER['REQUEST_URI']);
        exit;
    }
}




/*
 * Weiterleitung /home.html -> /home
 * oder auch umgekehrt
 * 
 */
if (defined('URL_DOCUMENT')) {
    if(URL_DOCUMENT == 'html') {
        
    } else {
        if(preg_match('/.html/ism', $http->_RequestUri(), $hhtml)) {
            header("HTTP/1.1 301 Moved Permanently");
            if (URL_PROTOCOL == 'https' && !isset($_SERVER['HTTPS'])) {
                header("Location: https://" . URL_HOST . str_replace(".html", "", $http->_RequestUri() . $http->returnQS()));
            } else {
                header("Location: http://" . URL_HOST . str_replace(".html", "", $http->_RequestUri() . $http->returnQS()));
            }
        }
    }
}


/*
 * Sprache wird gefiltert
 */
if (preg_match('!/[a-z]{2}/!', $_SERVER['REQUEST_URI'], $lang_array)) {
    $GLOBALS['LANGUAGE'] = str_replace("/", "", $lang_array[0]);
} else {
    $GLOBALS['LANGUAGE'] = SYS_LANGUAGE;
}


# Backend und Frontend Variablen
require_once($_SERVER['DOCUMENT_ROOT'] . '/aribu.systems/scripts/be_fe.var.php');

/*
 * Dot.Session Management
 */
$Session = new \lib\session\frontend\session($db, $http);
$Session->handleFESession();


# Set locale
setlocale(LC_ALL, $GLOBALS['SYSTEM_LOCALE'][$GLOBALS['LANGUAGE']]);


/*
 * Dot FE starts
 */
\lib\Registry::setObj('DFE', new \lib\Frontend());
$DFE = \lib\Registry::getObj('DFE');

if ($DFE->PageGlobals()) {  
    
    $DFE->Content($GLOBALS['CONTENT_MARKER']);
    $DFE->HTMLHeader();
    $DFE->Elements();
    $DFE->Menu();


    /*
     * Template output 
     */
    if (!$DFE->TemplatePage) {
        $tmp = NOTEMPLATE;
    } else {
        $tmp = $DFE->TemplatePage;
    }
    $template->define(array("page" => $tmp));
    $template->assign($DFE->TemplateAssignArray);
    $template->parse("ausgabe", "page");
    $template->FastPrint("ausgabe");
    if ($template->ERROR == 1 || $DFE->Error == 1) {
        header("HTTP/1.0 404 Not Found");
        $template->define(array("page" => NOTEMPLATE));
        $template->parse("ausgabe", "page");
        $template->FastPrint("ausgabe");
    }

    /*
     * Reduce HTML-Code
     */
    $html = ob_get_contents();
    ob_end_clean();
    
    $httpStatusCode = 200;
    $httpStatusMsg  = 'Ok';
    $protocol = isset($_SERVER['SERVER_PROTOCOL']) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0';
    header($protocol.' '.$httpStatusCode.' '.$httpStatusMsg);
    

    /*
     * Intigrate own PHP-Code
     */
    if ($DFE->PHPTag != 1) {
        echo \lib\Functions::replaceLinks($html, "dotLink");
    } else {
        foreach ($DFE->PHPMarkerPath as $sc_marker => $sc_path) {
            ob_start();

            $sc_method = $GLOBALS['PHPMethod'][$sc_marker]; # Methode, die man noch über die Datenbank festlegen kann
            if (!empty($sc_method)) {
                $sc_method_param = str_replace("(", ",", $sc_method);
                $sc_method_param = str_replace(")", ",", $sc_method_param);
                $sc_method_param = explode(",", $sc_method_param); # Script Parameter hier als Array
            }

            include($sc_path);
            $php_content = ob_get_contents();

            ob_end_clean();

            # PHP Block
            $BlockData = unserialize($GLOBALS['PHPBlock'][$sc_marker]);

            $h1 = isset($GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][1]) ? $GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][1] : 'h1';
            $h2 = isset($GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][2]) ? $GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][2] : 'h2';
            $headlines = "";
            $headlines = $row[$i]['headline'] != "" ? '<' . $h1 . '>' . $row[$i]['headline'] . '</' . $h1 . '>' : "";
            $headlines .= $row[$i]['subline'] != "" ? '<' . $h2 . '>' . $row[$i]['subline'] . '</' . $h2 . '>' : "";

            $block_style = "";
            $clear = '<br style="clear:both;" />';

            $block_style .= $BlockData['block_width'] != "" ? "width:" . $BlockData['block_width'] . "; " : "";
            $block_style .= $BlockData['block_height'] != "" ? "height:" . $BlockData['block_height'] . "; " : "";

            $border_width = $BlockData['border_width'] != "" ? $BlockData['border_width'] : '1';
            $border_color = $BlockData['border_color'] != "" ? '' . $BlockData['border_color'] . '' : '';
            $border_style = $BlockData['border_style'] != "" ? '' . $BlockData['border_style'] . ' ' : '';

            if (isset($BlockData['border'])) {
                switch ($BlockData['border']) {
                    case "1": 
                        $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "2": 
                        $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "3": 
                        $block_style .= 'border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "4": 
                        $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "5": 
                        $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "6": 
                        $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "7": 
                        $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "8": 
                        $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "9": 
                        $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "10": 
                        $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                    case "11": 
                        $block_style .= 'border:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                }
            }

            $block_style .= $BlockData['block_padding'] != "" ? "padding:" . $BlockData['block_padding'] . "; " : "";
            $block_style .= $BlockData['block_margin'] != "" ? "margin:" . $BlockData['block_margin'] . "; " : "";

            if ($BlockData['block_position'] != "") {
                switch ($BlockData['block_position']) {
                    case "1":
                        $block_style .= "float:left; ";
                        $block_start = '<div class="dor-php-block ' . $BlockData['css_class'] . '" style="' . $block_style . '">';
                        $block_end = '<br style="clear:both;" /></div>';
                    break;

                    case "2":
                        $block_style .= "margin:auto; text-align:center;";
                        $block_start = '<div class="dor-php-block ' . $BlockData['css_class'] . '" style="' . $block_style . '"><div style="margin:auto; display:inline-block;">';
                        $block_end = '<br style="clear:both;" /></div>' . $clear;
                    break;

                    case "3":
                        $block_style .= "float:right;";
                        $block_start = '<div class="dor-php-block ' . $BlockData['css_class'] . '" style="' . $block_style . '">';
                        $block_end = '<br style="clear:both;" /></div>';
                    break;
                }
            }


            $php_content = $block_start . $headlines . $php_content . $block_end;

            # Module ersetzen
            if (!empty($DFE->ModulContent)) {
                foreach ($DFE->ModulMarker as $mkey => $mval) {
                    $php_content = str_replace($DFE->ModulMarker[$mkey], $DFE->ModulContent[$mkey], $php_content);
                }
            }

            $html = str_replace($sc_marker, $php_content, $html);
        }

        if (!empty($DFE->BrowserTitle)) {
            if (preg_match('#<title>(.*?)</title>#is', $html, $title)) {
                $html = str_replace($title[0], "<title>" . $DFE->BrowserTitle . " - " . $GLOBALS['PageConfig']['TITLE'] . "</title>", $html);
            }
        }

        if (!empty($DFE->Description)) {
            preg_match('#<meta\s*name="description"\s*content="(.*?)["](.*?)>#ism', $html, $description);
            $html = str_replace($description[1], substr($DFE->Description . " " . $GLOBALS['PageConfig']['DESCRIPTION'], 0, 160), $html);
            
        } elseif (!empty($GLOBALS['PageConfig']['DESCRIPTION'])) {
            preg_match('#<meta\s*name="description"\s*content="(.*?)["](.*?)>#ism', $html, $description);         
            $html = str_replace($description[1], substr($GLOBALS['PageConfig']['DESCRIPTION'], 0, 160), $html);
        }

        if ($DFE->IndexFollow == 0) {
            if (preg_match('#<meta\s*name="robots"\s*content="(.*?)["](.*?)>#is', $html, $indexfollow)) {
                $html = str_replace($indexfollow[0], "<meta name=\"robots\" content=\"noindex, nofollow\" />", $html);
            }
        }

        if (isset($_POST['aribuFormValidate'])) {
            
        }

        echo \lib\Functions::replaceLinks($html, "dotLink");
    }
} else {
    # Backend redirect if is used
    if (preg_match("#/aribu.sys#", $DFE->RequestURI, $match)) {
        header("Location: ".ARIBU_SYSTEMS_URL."/");
        exit;
    }
    
    
    if ($template->ERROR == 1 || $DFE->Error == 1) {
        ob_start();
        
        header("HTTP/1.0 404 Not Found");
        $template->define(array("page" => $DFE->TemplatePage));
        $template->parse("ausgabe", "page");
        $template->FastPrint("ausgabe");
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    } else {
        echo $html = $DFE->CachedContent;
    }
}

/*
 * Caches the page 
 */
if (!empty($DFE->PageCache) && $DFE->PageCache == 1) {
    if (preg_match('#MSIE#', $_SERVER['HTTP_USER_AGENT'], $agent)) {
        $browser_type = $GLOBALS['BROWSER_TYPES']['MSIE'];
    } else {
        $browser_type = $GLOBALS['BROWSER_TYPES']['MOZ'];
    }

    $expire_time = strtotime($DFE->PageExpireCache);
    $db->Select('*')
       ->From('pages_cache')
       ->WhereColName('uid')
       ->WhereColValue($GLOBALS['PageConfig']['UID'])
       ->Andd("AND lang = :lang AND Browser = '" . $browser_type . "'")
       ->Parameter(array('lang' =>  $GLOBALS['LANGUAGE']))
       ->doSelect();
    $num = $db->Rows;
    $row = $db->SelectPuffer;
    if (!$num) {
        $db->Insert('pages_cache')
           ->Parameter(array(   'id'        => '', 
                                'uid'       => $GLOBALS['PageConfig']['UID'], 
                                'HTML'      => $html, 
                                'lang'      => $GLOBALS['LANGUAGE'], 
                                'Browser'   => $browser_type, 
                                'tstamp'    => time(), 
                                'expires'   => $expire_time))
           ->doInsert();
    } elseif ($DFE->PageCacheUpdate === true) {
        $dbg = $db->Update('pages_cache', $row['id'], array("HTML" => addslashes($html), "expires" => $expire_time), 'id', 0, "", "", 1);
    }
} else {
    if (preg_match('#MSIE#', $_SERVER['HTTP_USER_AGENT'], $agent)) {
        $browser_type = $GLOBALS['BROWSER_TYPES']['MSIE'];
    } else {
        $browser_type = $GLOBALS['BROWSER_TYPES']['MOZ'];
    }

    $db->Select('*')
       ->From('pages_cache')
       ->WhereColName('uid')
       ->WhereColValue($GLOBALS['PageConfig']['UID'])
       ->Andd("AND lang = :lang AND Browser = '" . $browser_type . "'")
       ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
       ->doSelect();
    $num = $db->Rows;
    if ($num) {
        $row = $db->SelectPuffer;
        $db->Delete('pages_cache')
           ->WhereColName('id')
           ->WhereColValue($row['id'])
           ->doDelete();
    }
}

/*
 * Debug-Modus
 */
if ($GLOBALS['DEBUG']['STATUS'] == 1 && ($GLOBALS['DEBUG']['IP'] == $_SERVER['REMOTE_ADDR'] || $GLOBALS['DEBUG']['IP'] == "127.0.0.1")) { 
    $display = $GLOBALS['DEBUG']['ECHO'] == 1 && isset($GLOBALS['DEBUG']['ECHO']) ? 'display:block;' : 'display:none;';
    switch ($GLOBALS['DEBUG']['VAR']) {

        case "post":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($_POST, true);
            echo htmlspecialchars($debug);
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;

        case "get":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($_GET, true);
            echo htmlspecialchars($debug);
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;

        case "dfe":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            echo $DFE;
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;

        case "globals":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($GLOBALS, true);
            echo htmlspecialchars($debug);
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;

        case "module":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($GLOBALS['MODULE_DEBUG'], true);
            echo htmlspecialchars($debug);
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;

        case "class":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($GLOBALS[$GLOBALS['DEBUG']['CLASS']], true);
            echo htmlspecialchars($debug);
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;

        case "session":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            $debug = print_r($_SESSION, true);
            echo htmlspecialchars($debug);
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;
    
        case "mysql":
            echo '<pre style="'.$display.' position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;" class="debug-pre">';
            echo '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
            
            echo '<br /><hr><br />';
            echo '<strong>Datenbank-Abfragen:</strong><br />';
            $debug_sql = print_r($dbg_aribu, true);
            echo $debug_sql;
            echo '<br style="clear:both;" /></div>';
            echo '<br style="clear:both;" />';
            echo '</pre>';
        break;
    }
    echo '<script type="text/javascript" src="/aribu.systems/fileadmin/vendor/jquery/external/jquery/jquery.js"></script>
<script type="text/javascript" src="/aribu.systems/fileadmin/vendor/jquery/jquery-ui.min.js"></script>        
<script type="text/javascript">
console.log($("pre.debug-pre").text());
</script>';
}