<?php

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   01.06.2018
 */

# Headers
header("Content-Type: text/html; charset=utf-8");

/*
 * Error Reporting
 *
 */
error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED ^ E_WARNING);
ini_set('display_errors', 1);

# Autoload classes
function aribuAutoload($classname) {
    
    $classname = str_replace("\\", "/", $classname);
    $classname = explode("/", $classname);
    
    $classname_file = end($classname);
    $classname_file_path = '/class.' . $classname_file . '.php';
    array_pop($classname);
    $classname_path = '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . $classname_file_path;
    if (file_exists(DOC_ROOT . strtolower($classname_path))) {
        require_once(DOC_ROOT . strtolower($classname_path));
    } elseif(file_exists(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  $classname_file.".php")) {
        require_once(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  $classname_file . ".php");
    } elseif(file_exists(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  strtolower($classname_file) . ".php")) {
        require_once(DOC_ROOT . '/' . implode("/", str_replace("aribu", "aribu.systems", $classname)) . '/' .  strtolower($classname_file) . ".php");
    }
}

spl_autoload_register('aribuAutoload');

define('DOC_ROOT',      $_SERVER['DOCUMENT_ROOT']);
define('SYS_LANGUAGE',  'de');
define('TIMEZONE',      'Europe/Berlin');

require_once DOC_ROOT.'/lib/class.functions.php';
require_once DOC_ROOT.'/lib/class.registry.php';
require_once DOC_ROOT.'/lib/class.TT.php';

/*
 * Date Timezone set
 */
date_default_timezone_set(TIMEZONE);

/*
 * HttpRequest
 * @var object
 */
require_once (DOC_ROOT . '/lib/class.http_request.php');
$http = new HttpRequest();
\lib\Registry::setObj('http', $http);

$GLOBALS['LANGUAGE'] = $http->issetPost('language') === true ? $http->_post('language') : SYS_LANGUAGE;


require_once DOC_ROOT.'/install/lang/'.$GLOBALS['LANGUAGE'].'.php';

$Install = new \install\lib\Installation($TT, $http, $be_language);


$TT->setMC('CONTENT',   '') #print_r($_SERVER['HTTP_HOST'], true)
    ->setMC('year',     date('Y', time()));

echo $TT->getFilledTemplate('/install/temp/install_start.html', 1);