<?php

namespace lib;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   05.10.2006
 * @update: 08.04.2015
 */

class TinyTemplate {

    public $TemplateFile;
    public $HTMLBuffer;
    public $HTMLBufferDyn;
    public $HTMLBufferDynBlocks = array();
    public $Buffer;
    public $DYN = 0;
    public $DYNPART;
    public $DYN_Blocks = 1;
    public $Terms = array();
    public $TermsMarker;
    public $TermsSwitch;
    public $MainTemp = 1;
    public $IfBlocks = array();
    public $BlockMarker = array();
    public $ContIfEndIfBlocks = array();
    public $ContIfElseBlocks = array();
    public $ContElseEndIfBlocks = array();
    public $SortingBlocks = array();
    protected $HTML = '';
    protected $MarkerContent = array();
    protected $IterationMarkerContent = array();
    protected $IterationBlockMarker = array();

    
    public function TTCompiler() {
        preg_match_all('#{if\="(.*?)"}#ism', $this->HTMLBuffer, $this->IfBlocks);
        $this->FilterContentBlocks();
    }

    private function FilterContentBlocks() {
        foreach ($this->IfBlocks[1] as $key => $val) {
            if (preg_match_all('#{if\="' . $val . '"}(.*?){endif\="' . $val . '"}#ism', $this->HTMLBuffer, $arr1)) {
                $this->ContIfEndIfBlocks[$val] = $arr1[0];
                $this->BlockMarker[$val] = !isset($this->BlockMarker[$val]) ? 1 : $this->BlockMarker[$val];
            }
        }
        foreach ($this->IfBlocks[1] as $key => $val) {
            if (preg_match_all('#{else\="' . $val . '"}(.*?){endif\="' . $val . '"}#ism', $this->HTMLBuffer, $arr2)) {
                $this->ContElseEndIfBlocks[$val] = $arr2[0];
            }
        }
        foreach ($this->IfBlocks[1] as $key => $val) {
            if (preg_match_all('#{if\="' . $val . '"}(.*?){else\="' . $val . '"}#ism', $this->HTMLBuffer, $arr3)) {
                $this->ContIfElseBlocks[$val] = $arr3[0];
            }
        }
    }

    public function replaceItems($defineArr) {

        if (!empty($this->BlockMarker)) {
            foreach ($this->BlockMarker as $akey => $aval) {
                if ($aval == 1) {
                    if (isset($this->ContElseEndIfBlocks[$akey])) {
                        $this->HTMLBuffer = preg_replace('#{else\="' . $akey . '"}(.*?){endif\="' . $akey . '"}#ism', "", $this->HTMLBuffer);
                    }
                } else {
                    if (isset($this->ContIfElseBlocks[$akey])) {
                        $this->HTMLBuffer = preg_replace('#{if\="' . $akey . '"}(.*?){else\="' . $akey . '"}#ism', "", $this->HTMLBuffer);
                    }
                    if (isset($this->ContIfEndIfBlocks[$akey])) {
                        $this->HTMLBuffer = preg_replace('#{if\="' . $akey . '"}(.*?){endif\="' . $akey . '"}#ism', "", $this->HTMLBuffer);
                    }
                }
                $this->HTMLBuffer = str_replace('{if="' . $akey . '"}', "", $this->HTMLBuffer);
                $this->HTMLBuffer = str_replace('{endif="' . $akey . '"}', "", $this->HTMLBuffer);
                $this->HTMLBuffer = str_replace('{else="' . $akey . '"}', "", $this->HTMLBuffer);
            }
        }

        if (is_array($defineArr)) {
            foreach ($defineArr as $key => $val) {
                $val = $val == "" ? $this->getMC(str_replace("###", "", $key)) : $val;
                $dot = str_replace($key, $val, $this->HTMLBuffer);
                $this->HTMLBuffer = $dot;
            }
        }
        
        if ($this->DYN == 1) {
            for ($i = 0; $i < $this->DYN_Blocks; $i++) {
                $block = $this->DYN_Blocks == 1 ? "" : ($i + 1);
                $DynBuffer = $this->DYN_Blocks == 1 ? $this->HTMLBufferDyn : $this->HTMLBufferDynBlocks[$i];
                if (!is_array($DynBuffer)) {
                    $dot = preg_replace('/<!--Block' . $block . '-start-->(.*?)<!--Block' . $block . '-ende-->/s', "###DYNPART###", $this->HTMLBuffer);
                    $dot = str_replace("###DYNPART###", $DynBuffer, $dot);
                } else {
                    foreach ($DynBuffer as $key => $val) {
                        $block_string = $block . $key;
                        
                        $dot = preg_replace('/<!--Block' . $block_string . '-start-->(.*?)<!--Block' . $block_string . '-ende-->/s', "###DYNPART###", $dot);
                        $dot = str_replace("###DYNPART###", $val, $dot);
                    }
                }
                $this->HTMLBuffer = $dot;
            }
            return $this->HTMLBuffer;
        } else {
            return $this->HTMLBuffer;
        }
    }

    /*
     * Old public function: replaceItemsDyn
     */

    public function replaceItemsDyn($defineArr, $block = '') {
        $a = 1;
        if (is_array($defineArr)) {
            foreach ($defineArr as $key => $val) {
                if ($this->DYN != 1) {
                    $buffer = $a == 1 ? $this->Buffer : $this->HTMLBufferDyn;
                } else {
                    if ($a == 1) {
                        preg_match_all('/<!--Block' . $block . '-start-->(.*?)<!--Block' . $block . '-ende-->/ism', $this->HTMLBuffer, $dynBuffer);

                        if (!empty($this->BlockMarker)) {
                            $buffer = $dynBuffer[1][0];
                            foreach ($this->BlockMarker as $mkey => $mval) {
                                if ($mval == 1) {
                                    if (isset($this->ContElseEndIfBlocks[$mkey])) {
                                        $buffer = preg_replace('#{else\="' . $mkey . '"}(.*?){endif\="' . $mkey . '"}#ism', "", $buffer);
                                    }
                                } else {
                                    if (isset($this->ContIfElseBlocks[$mkey])) {
                                        $buffer = preg_replace('#{if\="' . $mkey . '"}(.*?){else\="' . $mkey . '"}#ism', "", $buffer);
                                    }
                                    if (isset($this->ContIfEndIfBlocks[$mkey])) {
                                        $buffer = preg_replace('#{if\="' . $mkey . '"}(.*?){endif\="' . $mkey . '"}#ism', "", $buffer);
                                    }
                                }
                                $buffer = str_replace('{if="' . $mkey . '"}', "", $buffer);
                                $buffer = str_replace('{else="' . $mkey . '"}', "", $buffer);
                                $buffer = str_replace('{endif="' . $mkey . '"}', "", $buffer);
                            }
                        } else {
                            $buffer = $dynBuffer[1][0];
                        }
                        
                        $this->DYNPART = $dynBuffer[0][0];
                    } else {
                        $buffer = $this->HTMLBufferDyn;
                    }
                }
                $val = $val == "" ? $this->getMC(str_replace("###", "", $key)) : $val;
                $dot = str_replace($key, $val, $buffer);
                $this->HTMLBufferDyn = $dot;
                $a++;
            }
        }
        return $this->HTMLBufferDyn;
    }

    /*
     * New private function: replaceItemsDynIter
     */

    private function replaceItemsDynIter($defineArr, $block = '', $point) {
        $a = 1;
        if (is_array($defineArr)) {
            foreach ($defineArr as $key => $val) {
                if ($this->DYN != 1) {
                    $buffer = $a == 1 ? $this->Buffer : $this->HTMLBufferDyn;
                } else {
                    if ($a == 1) {
                        preg_match_all('/<!--Block' . $block . '-start-->(.*?)<!--Block' . $block . '-ende-->/ism', $this->HTMLBuffer, $dynBuffer);

                        if (!empty($this->IterationBlockMarker)) {
                            $buffer = $dynBuffer[1][0];
                            $BlockMarker = $block == '' ? $this->IterationBlockMarker : $this->IterationBlockMarker[$block];
                            if (is_array($BlockMarker)) {
                                foreach ($BlockMarker as $mkey => $mval) {
                                    if (is_array($mval)) {
                                        foreach ($mval as $u_mkey => $u_mval) {
                                            #echo $mkey." - ".$point. " <br>";
                                            if ($mkey == $point) {
                                                if ($u_mval == 1) {
                                                    if (isset($this->ContElseEndIfBlocks[$u_mkey])) {
                                                        $buffer = preg_replace('#{else\="' . $u_mkey . '"}(.*?){endif\="' . $u_mkey . '"}#ism', "", $buffer);
                                                    }
                                                } else {
                                                    if (isset($this->ContIfElseBlocks[$u_mkey])) {
                                                        $buffer = preg_replace('#{if\="' . $u_mkey . '"}(.*?){else\="' . $u_mkey . '"}#ism', "", $buffer);
                                                    }
                                                    if (isset($this->ContIfEndIfBlocks[$u_mkey])) {
                                                        $buffer = preg_replace('#{if\="' . $u_mkey . '"}(.*?){endif\="' . $u_mkey . '"}#ism', "", $buffer);
                                                    }
                                                }
                                                
                                                $buffer = str_replace('{if="' . $u_mkey . '"}', "", $buffer);
                                                $buffer = str_replace('{else="' . $u_mkey . '"}', "", $buffer);
                                                $buffer = str_replace('{endif="' . $u_mkey . '"}', "", $buffer);
                                            }
                                        }
                                    } else {

                                        if ($mval == 1) {
                                            if (isset($this->ContElseEndIfBlocks[$mkey])) {
                                                $buffer = preg_replace('#{else\="' . $mkey . '"}(.*?){endif\="' . $mkey . '"}#ism', "", $buffer);
                                            }
                                        } else {
                                            if (isset($this->ContIfElseBlocks[$mkey])) {
                                                $buffer = preg_replace('#{if\="' . $mkey . '"}(.*?){else\="' . $mkey . '"}#ism', "", $buffer);
                                            }
                                            if (isset($this->ContIfEndIfBlocks[$mkey])) {
                                                $buffer = preg_replace('#{if\="' . $mkey . '"}(.*?){endif\="' . $mkey . '"}#ism', "", $buffer);
                                            }
                                        }
                                        
                                        $buffer = str_replace('{if="' . $mkey . '"}', "", $buffer);
                                        $buffer = str_replace('{else="' . $mkey . '"}', "", $buffer);
                                        $buffer = str_replace('{endif="' . $mkey . '"}', "", $buffer);
                                    }
                                }
                            } else {
                                $buffer = $dynBuffer[1][0];
                            }
                        } else {
                            $buffer = $dynBuffer[1][0];
                        }
                        $this->DYNPART = $dynBuffer[0][0];
                    } else {
                        $buffer = $this->HTMLBufferDyn;
                    }
                }
                $dot = str_replace($key, $val, $buffer);
                $this->HTMLBufferDyn = $dot;
                $a++;
            }
        }
        return $this->HTMLBufferDyn;
    }

    private function TermsFilter() {
        preg_match_all('#<if[0-9]{1,2}>(.*?)</if[0-9]{1,2}>#ims', $this->HTMLBuffer, $TermsMatch);
        $this->Terms = $TermsMatch;
        $a = 1;
        foreach ($TermsMatch[0] as $key => $val) {
            $this->HTMLBuffer = preg_replace('#<if' . $a . '>(.*?)</if' . $a . '>#ims', "###T" . $a . "###", $this->HTMLBuffer);
            $x = $a - 1;
            $this->TermsMarker[$x] = "###T" . $a . "###";
            $a++;
        }
        foreach ($this->TermsMarker as $key => $val) {
            if ($this->TermsSwitch[$key] == 1) {
                $this->HTMLBuffer = preg_replace('/' . $val . '/ims', $this->Terms[1][$key], $this->HTMLBuffer);
            } else {
                $this->HTMLBuffer = preg_replace('/' . $val . '/ims', '', $this->HTMLBuffer);
            }
        }
        if ($this->MainTemp != 1) {
            $this->HTMLBuffer = preg_replace('/<!--Main-start-->(.*?)<!--Main-ende-->/ism', '', $this->HTMLBuffer);
        }
        return $this->HTMLBuffer;
    }

    public function getFilledTemplate($template, $flag = NULL, $DYN = 0, $DYN_Blocks = 1, $ReplaceLinks = 1) {
        $this->TemplateFile = $template;
        $this->HTML = $this->importTemplate($template);
        
        if($ReplaceLinks == 1) {
            $this->HTMLBuffer = $flag == NULL ? \lib\Functions::replaceLinks($this->HTML) : \lib\Functions::replaceLinks($this->HTML, 'dotLinkBE');
        } else {
            $this->HTMLBuffer = $this->HTML;
        }
        $this->DYN = $DYN;
        $this->DYN_Blocks = $DYN_Blocks;
        $this->TTCompiler();
        $this->RenderSorting($this->HTML, $flag, $ReplaceLinks);
        
        if ($this->DYN != 0) {
            $this->HTMLBufferDyn = "";
            $this->setFIT();
        }

        foreach ($this->MarkerContent as $mkey => $mval) {
            $nmkey = str_replace("#","",$mkey);
            ${$nmkey} = $mval;
        }

        # Ausgabe 
        preg_match_all('/#\#\#(.*?)#\#\#/ims', $this->HTML, $TempMarker);
        foreach ($TempMarker[0] as $key => $val) {
            $fieldVal = ${$TempMarker[1][$key]};
            $defineArr[$val] = $fieldVal;
        }
        $filledTemplate = $this->replaceItems($defineArr);
        return $filledTemplate;
    }

    public function setFIT() {
        $counter = count($this->IterationMarkerContent);
        $iter_temp = '';
        $block = '';


        if ($this->DYN_Blocks == 1) {
            for ($i = 0; $i < $counter; $i++) {
                foreach ($this->IterationMarkerContent[$i] as $imkey => $imval) {
                    ${$imkey} = $imval;
                }

                # Ausgabe 
                preg_match_all('/#\#\#(.*?)#\#\#/ims', $this->HTML, $TempMarker);
                foreach ($TempMarker[0] as $key => $val) {
                    $fieldVal = ${$TempMarker[1][$key]};
                    $defineArrDyn[$val] = $fieldVal;
                }
                $iter_temp .= $this->replaceItemsDynIter($defineArrDyn, $block, $i);
            }
            $this->HTMLBufferDyn = $iter_temp;
        } else {
            $arrkeys = array_keys($this->IterationMarkerContent);
            
            for ($i = 0; $i < $counter; $i++) {
                $iter_temp_num = '';
                if (is_numeric($arrkeys[$i])) {
                    $count_num = count($this->IterationMarkerContent[$arrkeys[$i]]);
                    for ($n = 0; $n < $count_num; $n++) {
                        if (is_array($this->IterationMarkerContent[$arrkeys[$i]][$n])) {
                            foreach ($this->IterationMarkerContent[$arrkeys[$i]][$n] as $imkey => $imval) {
                                ${$imkey} = $imval;
                            }
                        }
                        # Ausgabe 
                        preg_match_all('/#\#\#(.*?)#\#\#/ims', $this->HTML, $TempMarker);
                        foreach ($TempMarker[0] as $key => $val) {
                            $fieldVal = ${$TempMarker[1][$key]};
                            $defineArrDyn[$val] = $fieldVal;
                        }
                        $iter_temp_num .= $this->replaceItemsDynIter($defineArrDyn, $arrkeys[$i], $n);
                    }
                    $this->HTMLBufferDynBlocks[$i] = $iter_temp_num;
                } else {
                    $arrkeys_1 = array_keys($this->IterationMarkerContent[$arrkeys[$i]]);
                    $count_num = count($arrkeys_1);

                    for ($n = 0; $n < $count_num; $n++) {
                        $iter_temp_num_1 = "";
                        if (is_array($this->IterationMarkerContent[$arrkeys[$i]][$arrkeys_1[$n]])) {
                            foreach ($this->IterationMarkerContent[$arrkeys[$i]][$arrkeys_1[$n]] as $key => $val) {
                                if (is_array($val)) {
                                    foreach ($val as $lkey => $lval) {
                                        ${$lkey} = $lval;
                                    }
                                }

                                # Ausgabe 
                                preg_match_all('/#\#\#(.*?)#\#\#/ims', $this->HTML, $TempMarker);
                                foreach ($TempMarker[0] as $key => $val) {
                                    $fieldVal = ${$TempMarker[1][$key]};
                                    $defineArrDyn[$val] = $fieldVal;
                                }
                                $iter_temp_num_1 .= $this->replaceItemsDynIter($defineArrDyn, $arrkeys[$i], $n);
                            }
                        }
                        $this->HTMLBufferDynBlocks[1][$n] = $iter_temp_num_1;
                    }
                }
            }
        }
        
    }
    
    public function RenderSorting($template, $flag, $ReplaceLinks) {
        if(count($this->SortingBlocks) > 0) {
            if(is_array($this->ContIfEndIfBlocks)) {
                $c=1;
                
                foreach($this->ContIfEndIfBlocks as $key => $val) {
                    if(array_key_exists($key, $this->SortingBlocks)) {
                       $template = str_replace($val[0], '###table_col_head_'.$c.'###', $template);
                       $template = str_replace($val[1], '###table_col_body_'.$c.'###', $template);
                       $c++;
                    }             
                }
                
                foreach ($this->ContIfEndIfBlocks as $skey => $svalue) {
                    if(array_key_exists($skey, $this->SortingBlocks)) {
                        $template = str_replace('###table_col_head_'.$this->SortingBlocks[$skey].'###', $svalue[0], $template);
                        $template = str_replace('###table_col_body_'.$this->SortingBlocks[$skey].'###', $svalue[1], $template);
                    }
                }
                
            }
        }
        $this->HTML = $template;
        if($ReplaceLinks == 1) {
            $this->HTMLBuffer = $flag == NULL ? \lib\Functions::replaceLinks($this->HTML) : \lib\Functions::replaceLinks($this->HTML, 'dotLinkBE');
        } else {
            $this->HTMLBuffer = $this->HTML;
        }
    }

    public function importTemplate($template) {
        return \lib\Functions::readFiles($template);
    }

    public function SetMC($name, $var) {
        $this->MarkerContent[$name] = $var;
        return $this;
    }
    
    public function SetMCArr(array $array) {
        foreach ($array as $key => $value) {
            $this->MarkerContent[$key] = $value;
        }
        return $this;
    }

    public function getMC($name) {
        $name = trim($name);
        if(isset($this->MarkerContent[$name])) {
            return $this->MarkerContent[$name];
        } else {
            return false;
        }
    }

    public function SetIMC($iter, $name, $var, $block = NULL, $pointer = NULL) {
        $name = trim($name);
        if ($block == NULL) {
            $this->IterationMarkerContent[$iter][$name] = $var;
        } else {
            if ($pointer == NULL) {
                $this->IterationMarkerContent[$block][$iter][$name] = $var;
            } else {
                $this->IterationMarkerContent[$pointer][$block][$iter][$name] = $var;
            }
        }
        return $this;
    }

    public function getIMC($iter, $name, $block = NULL, $pointer = NULL) {
        $name = trim($name);
        if ($block == NULL) {
            return $this->IterationMarkerContent[$iter][$name];
        } else {
            return $pointer == NULL ? $this->IterationMarkerContent[$block][$iter][$name] : $this->IterationMarkerContent[$pointer][$block][$iter][$name];
        }
    }

    public function setIBM($iter, $name, $val, $block = NULL) {
        $name = trim($name);
        if ($block == NULL) {
            $this->IterationBlockMarker[$iter][$name] = $val;
        } else {
            $this->IterationBlockMarker[$block][$iter][$name] = $val;
        }
        return $this;
    }

    public function resetAll() {
        $this->HTMLBuffer = '';
        $this->HTMLBufferDyn = '';
        $this->HTMLBufferDynBlocks = array();
        $this->Buffer = '';
        $this->DYN = 0;
        $this->DYNPART = '';
        $this->DYN_Blocks = 1;
        $this->Terms = array();
        $this->TermsMarker = '';
        $this->TermsSwitch = '';
        $this->MainTemp = 1;
        $this->IfBlocks = array();
        $this->BlockMarker = array();
        $this->ContIfEndIfBlocks = array();
        $this->ContIfElseBlocks = array();
        $this->ContElseEndIfBlocks = array();
        $this->HTML = '';
        $this->MarkerContent = array();
        $this->IterationMarkerContent = array();
        $this->IterationBlockMarker = array();
    }
    
    public function __clone() {
        $this->resetAll();
    }

    public function Debug() {
        echo '<pre style="text-align:left;">';
        $debug = print_r($this, true);
        echo htmlspecialchars($debug);
        echo '</pre>';
    }
    
    public function __toString() {
        $class_vars = get_class_vars(get_class($this));
        
        $string = '';
        $string .= '<script type="text/javascript">
	$(document).ready(function() {
	var winheight = $("html").innerHeight();
 	$("div#debug-div").css("height", winheight+"px");
	});
	</script>';
        $string .= '<pre style="display:block; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;">';
        $string .= '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
           
        $string .= "Discount: \n";
        foreach($class_vars as $key => $val) {
            $values = !is_object($this->{$key}) ? print_r($this->{$key}, true) : 'Object';
            $string .= $key.': '.$values."\n";
        }
        $string .= '</div></pre>';
        return $string;
    }

}

# Intialisize class
Registry::setObj('TT', new TinyTemplate);
$TT = Registry::getObj('TT');