<?php

namespace lib;

/* 
 * aribu systems - Version 1.0.1
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   20.02.2006
 * @update: 22.04.2018 
 */

class Backend extends objects\Loader {

    public $id = "";  # the page id
    public $spid = 1;  # Start page ID
    public $QueryString;
    public $RequestURI;
    public $pagename = "";  # the pagename
    public $page_Hash = "";  # Hash of the pagetree
    public $PageTreePoints;
    public $PageTreePointsHashes;
    public $PageTreePointsLevel;
    public $TemplateAssignArray = array();
    public $TemplatePage = "";  
    public $PHPTag = 0; 
    public $PHP_Path = "";  
    public $PHPMarkerPath = array();
    public $HTMLOldHeader = "";  
    public $CFromPID;       
    public $AdminShowHidden = 0;  
    public $RootFolder;
    public $Counter = array();
    public $LastPointer = 0;
    public $ColPosition = "";
    public $PageCache = 0;
    public $PageExpireCache;
    public $CachedContent = "";
    public $PageCacheUpdate = false;
    public $Error = 0;
    public $ChieldBuffer = "";
    public $Description = "";
    public $BrowserTitle = "";
    public $ModulContent = "";
    public $ModulMarker = "";
    public $IndexFollow = 1;
    public $FID;
    public $TID;
    public $MSID;
    public $URLHash;
    public $AdminShowContent = 0;
    public $Index = 0;
    public $PageConfig = "";
    public $JavaScript = "";
    public $Stylesheet = "";
    public $Pages = "pages";
    public $and_lang = "";
    public $PageSettings = "";
    public $jumpURL;
    public $RID;
    public $num_content;
    
    /*
     * BE initialization
     * 		
     */

    public function __construct() {
        parent::__construct();

        # Init Tables
        $this->db->TablePreName = 'be_';

        if ($this->http->issetPost('id') === true) {
            $this->id = intval($this->http->_post('id'));

            $GLOBALS['LANGUAGE'] = isset($GLOBALS['LANGUAGE']) ? $GLOBALS['LANGUAGE'] : SYS_LANGUAGE;
        } else {
            $request_uri = urldecode($_SERVER['REQUEST_URI']);
            if (strstr($request_uri, "?")) {
                $request_uri_explode = explode("?", $request_uri);
                $request_uri = $request_uri_explode[0];
            }
            if (!strstr($request_uri, ".html")) {
                $file_doc = ".html";
            }

            # Request URL e. g. /football/soccer
            $this->RequestURI = str_replace(ARIBU_SYSTEMS, "", $request_uri);

            $query_string = $_SERVER['QUERY_STRING'];
            $this->QueryString = $query_string;
            $request_uri_oqs = str_replace($query_string, "", $request_uri);

            # ID's Update
            if (strstr($request_uri_oqs, "/b/")) {
                $req_url = explode("/b/", $request_uri_oqs);
                $request_uri = $req_url[0];
                $hash = strstr($req_url[1], "/") ? explode("/", $req_url[1]) : str_replace(".html", "", $req_url[1]);
                if (is_array($hash)) {
                    switch (count($hash)) {
                        case 2:
                            $this->http->setPostByName('SEITE', $hash[0]);
                            break;
                        case 3:
                            $this->http->setPostByName('SEITE', $hash[0])
                                       ->setPostByName('Sorting', $hash[1]);
                            break;
                    }
                    $hash = end($hash);
                } else {
                    $hash = $hash;
                }
                $this->FID = !empty($hash) ? md5($hash) : "";
                $this->URLHash = $hash;
                $uri = $request_uri;
            } else {
                $uri = str_replace(ARIBU_SYSTEMS_URL, "", $request_uri_oqs);
                $uri = str_replace("/" . SYS_LANGUAGE, "", $uri);
            }

            $uriArr = Functions::pagenameExplode("/", $uri);
            if (count($uriArr) > 2) {
                if (strlen($uriArr[1]) == 2 && is_string($uriArr[1])) {
                    $GLOBALS['LANGUAGE'] = \lib\Functions::removeCriticSigns($uriArr[1]);
                } else {
                    $this->RootFolder = $uriArr[1];
                    $get_id = intval($uriArr[2]);
                    if ($get_id != 0) {
                        $GLOBALS['GET_ID'] = $uriArr[2];
                    }
                    $GLOBALS['LANGUAGE'] = SYS_LANGUAGE;
                    
                }
            } else {
                $GLOBALS['LANGUAGE'] = SYS_LANGUAGE;
            }

            if (SYS_LANGUAGE != $GLOBALS['LANGUAGE']) {
                $this->RUO = substr($uri . $file_doc, 3);
                $this->page_Hash = md5(substr($uri . $file_doc, 3));
            } else {
                $this->RUO = $uri . $file_doc;
                $this->page_Hash = md5($uri . $file_doc);
            }
            $pagename = explode(".", end($uriArr));
            $this->pagename = $pagename[0];
        }

        if ($GLOBALS['LANGUAGE'] != SYS_LANGUAGE) {
            $this->Pages = "pages_language";
            $this->and_lang = "AND %%%n%%%lang = :lang ";
        } else {
            $this->Pages = "pages";
            $this->and_lang = "";
        }
    }

    /*
     * Page Globals
     * 		
     */

    public function PageGlobals() {
        # Set locale
        setlocale(LC_ALL, $GLOBALS['SYSTEM_LOCALE'][$GLOBALS['LANGUAGE']]);

        if (!empty($this->id)) {
            $this->db->Select('*')
                     ->From($this->Pages)
                     ->WhereColName('uid')
                     ->WhereColValue($this->id)
                     ->Andd(str_replace("%%%n%%%", "", $this->and_lang) . " AND ((starttime = 0 AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime = 0 AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime = 0 AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime = 0 AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime < '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime > '" . time() . "' AND hidden = 1))")
                     ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                     ->doSelect();
            $row = $this->db->SelectPuffer;
            $num = $this->db->Rows;
        } elseif (!empty($this->pagename)) {
            $this->db->Select('p.*, p2.pagename as content_from_pid_name')
                     ->From($this->Pages . " as p")
                     ->WhereColName("p.page_Hash")
                     ->WhereColValue($this->page_Hash)
                     ->Joins("LEFT JOIN be_" . $this->Pages . " as p2 ON p.content_from_pid = p2.uid")
                     ->Andd(str_replace("%%%n%%%", "p.", $this->and_lang) . " AND ((p.starttime = 0 AND p.endtime = 0 AND p.hidden != 1) OR (p.starttime != 0 AND p.starttime <= '" . time() . "' AND p.endtime = 0 AND p.hidden != 1) OR (p.starttime != 0 AND p.starttime <= '" . time() . "' AND p.endtime != 0 AND p.endtime >= '" . time() . "' AND p.hidden != 1) OR (p.starttime = 0 AND p.endtime != 0 AND p.endtime >= '" . time() . "' AND p.hidden != 1) OR (p.starttime != 0 AND p.starttime >= '" . time() . "' AND p.endtime = 0 AND p.hidden = 1) OR (p.starttime != 0 AND p.starttime >= '" . time() . "' AND p.endtime != 0 AND p.endtime <= '" . time() . "' AND p.hidden = 1) OR (p.starttime = 0 AND p.endtime != 0 AND p.endtime <= '" . time() . "' AND p.hidden = 1) OR (p.starttime != 0 AND p.starttime < '" . time() . "' AND p.endtime != 0 AND p.endtime <= '" . time() . "' AND p.hidden = 1) OR (p.starttime != 0 AND p.starttime >= '" . time() . "' AND p.endtime != 0 AND p.endtime > '" . time() . "' AND p.hidden = 1))")
                     ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                     ->doSelect();
            
            $row = $this->db->SelectPuffer;
            $num = $this->db->Rows;
        } else {
            # Startseite
            $this->db->Select('*')
                     ->From($this->Pages)
                     ->WhereColName('spid')
                     ->WhereColValue($this->spid)
                     ->Andd(str_replace("%%%n%%%", "", $this->and_lang) . " AND ((starttime = 0 AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime = 0 AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime = 0 AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime = 0 AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime < '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime > '" . time() . "' AND hidden = 1))")
                     ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                     ->doSelect();
            $row = $this->db->SelectPuffer;
            $num = $this->db->Rows;
        }

        if ($num) {

            # Template Pfad
            $this->TemplatePage = ARIBU_SYSTEMS_SFOLDER . "/_templates/" . $row['sitetpl'];

            # Browser Titel
            if (!empty($row['BrowserTitle'])) {
                $BrowserTitle = $row['BrowserTitle'];
            } else {
                $BrowserTitle = BROWSER_NAME . " - " . $row['nav_title'];
            }

            $pageSettings = unserialize($row['pageSettings']);
            $this->PageCache = $pageSettings['pageCache'];
            $this->PageExpireCache = $pageSettings['expireCache'];
            $this->Index = $pageSettings['Index'];
            $this->JavaScript = stripslashes($row['Javascript']);
            $this->Stylesheet = stripslashes($row['Stylesheet']);
            $this->PageSettings = $pageSettings;

            $GLOBALS['PageConfig'] = array( 'UID'                   => $row['uid'],
                                            'PID'                   => $row['pid'],
                                            'PAGE_TITLE'            => $row['nav_title'],
                                            'AUTH_USER_ID'          => is_null($row['perms_userid']) ? 0 : $row['perms_userid'],
                                            'AUTH_GROUP_ID'         => $row['perms_groupid'],
                                            'PAGENAME'              => $row['pagename'],
                                            'PAGE_URL'              => $row['url'],
                                            'PAGE_URL_TYP'          => $row['urltype'],
                                            'STARTTIME'             => $row['starttime'],
                                            'ENDTIME'               => $row['endtime'],
                                            'PAGE_URL_TARGET'       => $row['target'],
                                            'NAVI_TITLE'            => $row['nav_title'],
                                            'CONTENT_FROM_PID'      => $row['content_from_pid'],
                                            'CONTENT_FROM_PID_NAME' => $row['content_from_pid_name'],
                                            'BUTTON'                => $row['button'],
                                            'BUTTON_PATH'           => $row['button_path'],
                                            'BUTTON_ACT_PATH'       => $row['button_act_path'],
                                            'PAGE_TEMPLATE'         => $row['sitetpl'],
                                            'MODULE'                => $row['module'],
                                            'TITLE'                 => $BrowserTitle,
                                            'KEYWORDS'              => $row['keywords'],
                                            'ROOT_FOLDER'           => $this->RootFolder,
                                            'DOC_TYPE'              => $row['docType'],
                                            'DESCRIPTION'           => $row['description'],
                                            'PAGE_HASH'             => $row['page_Hash'],
                                            'THIS_CSS'              => $row['this_css'],
                                            'PONDON_UID'            => $row['rid']);
            $this->PageConfig = $GLOBALS['PageConfig'];

            # Pfadinfos werden geholt
            $this->getPathInformation($GLOBALS['PageConfig']['UID']);


            # Page Cache
            if (preg_match('#MSIE#', $_SERVER['HTTP_USER_AGENT'], $agent)) {
                $browser_type = 'ie';
            } else {
                $browser_type = 'ff';
            }
            $this->db->Select('*')
                     ->From('pages_cache')
                     ->WhereColName('uid')
                     ->WhereColValue($GLOBALS['PageConfig']['UID'])
                     ->Andd("AND lang = :lang AND browser = :browser")
                     ->Parameter(array('lang' => $GLOBALS['LANGUAGE'], 'browser' => $browser_type))
                     ->doSelect();
            $row = $this->db->SelectPuffer;
            if (!$this->db->Rows && $this->PageCache != 1) {
                return true;
            } else {
                $this->CachedContent = stripslashes($row['HTML']);
                if ($row['expires'] > time()) {
                    $this->PageCacheUpdate = false;
                    return false;
                } else {
                    $this->PageCacheUpdate = true;
                    return true;
                }
            }
        } else {
            $this->TemplatePage = TEMPLATE_PATH . "error.tpl";
            $GLOBALS['PageConfig']['TITLE'] = "<title>" . BROWSER_NAME . " - ERROR!</title>";
            $this->Error = 1;
        }
    }

    /*
     * Hilfsfunktion für Pfadinformationen
     *
     */

    public function getPathInformation($uid) {
        $this->db->Select("p.*")
                 ->From($this->Pages . " n, be_" . $this->Pages . " p")
                 ->noWhere(1)
                 ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $this->and_lang))
                 ->Order('ORDER BY p.lft')
                 ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE'], 'uid' => $uid) : array('uid' => $uid))
                 ->SelectMethod(1)
                 ->doSelect();
        
        $num = $this->db->Rows;
        if($num) {
            foreach ($this->db->SelectPuffer as $key => $row) {
                $ouri = $uri;
                $this->PageTreePointsHashes[$key] = $row['page_Hash'];
                $this->PageTreePointsLevel[$key] = $row['uid'];
                $this->PageTreePoints[$key]['uri'] = $uri . "/" . $row['pagename'] . ".html";
                $this->PageTreePoints[$key]['hash'] = $row['page_Hash'];
                $this->PageTreePoints[$key]['uid'] = $row['uid'];
                $this->PageTreePoints[$key]['pagename'] = $row['pagename'];
                $uri = $ouri . "/" . $row['pagename'];
            }
            $this->RID = end($this->PageTreePointsLevel);
        }
    }

    /*
     * HTML-Header
     * 		
     */

    public function HTMLHeader() {
        
        $this->db->Select('*')
                 ->From('html_header')
                 ->WhereColName('hid')
                 ->WhereColValue(1)
                 ->doSelect();
        $num = $this->db->Rows;
        if ($num) {
            $row = $this->db->SelectPuffer;
            $oldTemp = Functions::readFiles("/" . $this->TemplatePage);
            preg_match('#<head[^>]*>(.+)</head>#is', $oldTemp, $headers);
            if (preg_match('#MSIE#', $_SERVER['HTTP_USER_AGENT'], $agent)) {
                $css_file = $row['stylesheet'];
            } else {
                $css_file = $row['stylesheet_ff'];
            }
            $css = Functions::readFiles(ARIBU_SYSTEMS_SFOLDER."/fileadmin/css/" . $css_file);
            if (!empty($this->BrowserTitle)) {
                $title = $this->BrowserTitle . " - ";
            }
            $header .= "<title>" . $title . $GLOBALS['PageConfig']['TITLE'] . "</title>\n";
            if (!empty($GLOBALS['PageConfig']['KEYWORDS'])) {
                preg_match('#<meta\s*name="keywords"\s*content="(.*?)["]\s*/>#', stripslashes($row['metatags']), $keywords);
                $metatags = str_replace($keywords[1], $GLOBALS['PageConfig']['KEYWORDS'], stripslashes($row['metatags']));
            } else {
                $metatags = stripslashes($row['metatags']);
            }
            if (!empty($this->Description)) {
                preg_match('#<meta\s*name="description"\s*content="(.*?)["]\s*/>#', $metatags, $description);
                $metatags = str_replace($description[1], $this->Description . " " . $GLOBALS['PageConfig']['DESCRIPTION'], $metatags);
                
            } elseif (!empty($GLOBALS['PageConfig']['DESCRIPTION'])) {
                preg_match('#<meta\s*name="description"\s*content="(.*?)["]\s*/>#', $metatags, $description);
                $metatags = str_replace($description[1], $GLOBALS['PageConfig']['DESCRIPTION'], $metatags);
                
            }

            if (!empty($this->Index)) {
                switch ($this->Index) {
                    case "1":
                        preg_match_all('#<meta\s*name="robots"\s*content="(.*?)["]\s*/>#is', $metatags, $indexfollow);
                        $metatags = str_replace($indexfollow[0][0], "<meta name=\"robots\" content=\"index, follow\" />", $metatags);

                        break;

                    case "2":
                        preg_match_all('#<meta\s*name="robots"\s*content="(.*?)["]\s*/>#is', $metatags, $indexfollow);
                        $metatags = str_replace($indexfollow[0][0], "<meta name=\"robots\" content=\"noindex, nofollow\" />", $metatags);

                        break;
                }
            }

            if ($GLOBALS['PageConfig']['THIS_CSS'] != 1) {
                $header .= ARIBU_COPYRIGHTS . "\n" . $metatags . "\n<style type=\"text/css\"><!--\n" . stripslashes($css) . "\n--></style>\n" . $this->Stylesheet . "\n" . stripslashes($row['jscripts']) . "\n" . stripslashes($this->JavaScript) . "\n";
            } else {
                $header .= ARIBU_COPYRIGHTS . "\n" . $metatags . "\n" . $this->Stylesheet . "\n" . stripslashes($row['jscripts']) . "\n" . stripslashes($this->JavaScript) . "\n";
            }
            $this->HTMLOldHeader = $headers[1];
            
            $TemplateAssignArray = array('HTML_HEADER' => $header);
            $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
        }
    }
    
    public function getContentFromDB($key) {
       
        $order = $key == '0' ? "ORDER BY sorting" : "ORDER BY sorting";
        $content_id = $GLOBALS['PageConfig']['CONTENT_FROM_PID'] != 0 ? $GLOBALS['PageConfig']['CONTENT_FROM_PID'] : $GLOBALS['PageConfig']['UID'];
        
        $this->db->Select('*')
                 ->From('content')
                 ->WhereColName('pid')
                 ->WhereColValue($content_id)
                 ->Andd(" AND colP = :colp AND lang = :lang AND ((starttime = 0 AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime = 0 AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime = 0 AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime = 0 AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime < '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime > '" . time() . "' AND hidden = 1))")
                 ->Order('ORDER BY sorting')
                 ->SelectMethod(1)
                 ->Parameter(array('colp' => $key, 'lang' => SYS_LANGUAGE ))
                 ->doSelect();
        $this->num_content = $this->db->Rows;
        if(SYS_LANGUAGE != $GLOBALS['LANGUAGE']) {     
           if(!$this->num_content) {
               $content_id = $GLOBALS['PageConfig']['PONDON_UID'];
               $this->db->Select('*')
                 ->From('content')
                 ->WhereColName('pid')
                 ->WhereColValue($content_id)
                 ->Andd(" AND colP = :colp AND lang = :lang AND ((starttime = 0 AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime = 0 AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime = 0 AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime = 0 AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime < '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime > '" . time() . "' AND hidden = 1))")
                 ->Order('ORDER BY sorting')
                 ->SelectMethod(1)
                 ->Parameter(array('colp' => $key, 'lang' => SYS_LANGUAGE ))
                 ->doSelect();
               $this->num_content = $this->db->Rows;
           } 
        }                   
    }

    /*
     * Content-Builder
     *
     */

    public function Content() {
        
        $session_user_rights = isset($_SESSION['sess_user_rights']) ? $_SESSION['sess_user_rights'] : 0;
        if (isset($_SESSION['sess_id']) || $GLOBALS['PageConfig']['UID'] == $GLOBALS['BE_STATIC_URLS']['PasswordRoutine'] || (SYS_LANGUAGE != $GLOBALS['LANGUAGE'] && $GLOBALS['PageConfig']['PONDON_UID'] == $GLOBALS['BE_STATIC_URLS']['PasswordRoutine'])) {
            foreach ($GLOBALS['CONTENT_MARKER'] as $key => $CMarkerval) {
                $CMarkerval = str_replace('#', '', $CMarkerval);
                if ($GLOBALS['PageConfig']['AUTH_GROUP_ID'] <= $session_user_rights || $_SESSION['sess_user_type'] == 'fe') {
                    if ($GLOBALS['PageConfig']['AUTH_USER_ID'] == $_SESSION['sess_user_id'] || $GLOBALS['PageConfig']['AUTH_USER_ID'] == 0) {

                        $this->getContentFromDB($key);
                        if ($this->num_content) {
                            
                            $row = $this->db->SelectPuffer;
                            for ($i = 0; $i < $this->num_content; $i++) {
                                
                                if ($row[$i]['perms_groupid'] <= $session_user_rights) {
                                    # Dot-Content
                                    switch ($row[$i]['CType']) {
                                        case "HTML":
                                            $ContentTag = Functions::replaceLinks(stripslashes($row[$i]['bodytext']), "dotLinkBE");

                                            if (!isset($this->FID) || $this->FID == "") {
                                                $CTag .= $ContentTag;
                                            } else {
                                                if ($key != 0) {
                                                    $CTag .= $ContentTag;
                                                }
                                            }


                                            break;

                                        case "PHP":
                                            #$GLOBALS['PHPMethod'][] = $row[$i]['script_method'];
                                            $PHP_Path = preg_match('#extern#ism', $row[$i]['script_path'], $arr_path) ? DOC_ROOT . "/scripts/" . $row[$i]['script_path'] : DOC_ROOT  . ARIBU_SYSTEMS_SFOLDER . "/scripts/" . $row[$i]['script_path'];
                                            $this->PHPTag = 1;
                                            $script_marker = str_replace("###", "", $GLOBALS['CONTENT_MARKER'][$key]);
                                            $script_marker = "###" . $script_marker . "_" . $i . "###";
                                            $PHPMarkerPath = array($script_marker => $PHP_Path);
                                            $GLOBALS['PHPMethod'][$script_marker] = $row[$i]['script_method'];
                                            $this->PHPMarkerPath = array_merge($this->PHPMarkerPath, $PHPMarkerPath);
                                            $CTag .= $script_marker;
                                            break;

                                        case "MENU":
                                            $ContentMenu = new be_menu($this);
                                            $ContentMenu->AdminShow = $this->AdminShowHidden;
                                            $GLOBALS['MenuConfig'][1000] = unserialize($row[$i]['script_method']);
                                            $ContentMenuObj = $ContentMenu->{$GLOBALS['MenuConfig'][1000]['Type']}(1000);
                                            $CTag .= $ContentMenuObj[$GLOBALS['MenuConfig'][1000]['Marker']];
                                            unset($GLOBALS['MenuConfig']);
                                            break;


                                        default:
                                            $ContentTag = stripslashes($row[$i]['bodytext']);
                                            $BlockData = unserialize($row[$i]['script_method']);


                                            if ((!isset($BlockData['show_on_detail']) && $this->FID == "") || ($BlockData['show_on_detail'] != 1 || $this->FID == "")) {
                                                if ($BlockData['classname'] != "") {
                                                    if (isset($this->Counter[$BlockData['classname']])) {
                                                        $this->Counter[$BlockData['classname']] ++;
                                                    } else {
                                                        $this->Counter[$BlockData['classname']] = 1;
                                                    }
                                                }

                                                $BlockData['CID'] = $row[$i]['uid'];
                                                $BlockData['COLP'] = $key;
                                                $BlockData['Content'] = $ContentTag;
                                                $BlockData['Headline'] = stripslashes($row[$i]['headline']);
                                                $BlockData['Subline'] = stripslashes($row[$i]['subline']);
                                                $BlockData['Sorting'] = $row[$i]['sorting'];
                                                if(file_exists(DOC_ROOT . $BlockData['script_path'])) {
                                                   include(DOC_ROOT . $BlockData['script_path']); 
                                                }
                                                if ($BlockData['classname'] != "") {
                                                    $ContModul = new $BlockData['classname'];
                                                    $ContModul->GlobalVars = $BlockData;
                                                    $CTag .= $ContModul->initClass();
                                                } else {
                                                    $CTag .= $pluginCObj;
                                                }
                                            }
                                    }
                                } else {
                                    $CTag .= '';
                                }
                            }
                            $marker = str_replace('#', '', $GLOBALS['CONTENT_MARKER'][$key]);
                            $TemplateAssignArray = array($marker => $CTag);
                            $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                            unset($CTag);
                            unset($TemplateAssignArray);
                            unset($PHPMarkerPath);
                            
                        } else {
                            
                            if (!empty($GLOBALS['PageConfig']['MODULE'])) {
                                if ( $CMarkerval == "CONTENT" ) {
                                    switch ($GLOBALS['PageConfig']['MODULE']) {

                                        default:
                                            # Installierte Module werden geladen
                                            if (file_exists(DOC_ROOT . ARIBU_SYSTEMS_SFOLDER . '/plugins/' . strtolower($GLOBALS['PageConfig']['MODULE']) . '/index.php')) {
                                                include(DOC_ROOT . ARIBU_SYSTEMS_SFOLDER . '/plugins/' . strtolower($GLOBALS['PageConfig']['MODULE']) . '/index.php');
                                                $TemplateAssignArray = array("CONTENT" => $pluginCObj);
                                                $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                            } else {
                                                $TemplateAssignArray = array("CONTENT" => "Konnte das Modul nicht einbinden. Das Modul ist nicht im Plugin-Ordner vorhanden.");
                                                $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                            }
                                    }
                                    return true;
                                } else {
                                    # Falls kein Content vorhanden
                                    $TemplateAssignArray = array($CMarkerval => '');
                                    $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                    return false;
                                }
                            } else {
                                # Falls kein Content vorhanden
                                $TemplateAssignArray = array($CMarkerval => '');
                                $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                
                            }
                        }
                    } else {
                        
                        # User hat keinen Zutritt
                        $contemp = Functions::readFiles(ARIBU_SYSTEMS_SFOLDER."/_templates/error/norights.html");
                        $TemplateAssignArray = array($CMarkerval => $contemp);
                        $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                    }
                } else {
                    # User hat keinen Zutritt
                    if ($CMarkerval == "###CONTENT###") {
                        switch ($GLOBALS['PageConfig']['MODULE']) {

                            default:
                                # Installierte Module werden geladen
                                if (file_exists(DOC_ROOT . ARIBU_SYSTEMS_SFOLDER . '/plugins/' . strtolower($GLOBALS['PageConfig']['MODULE']) . '/index.php')) {
                                    include(DOC_ROOT . ARIBU_SYSTEMS_SFOLDER . '/plugins/' . strtolower($GLOBALS['PageConfig']['MODULE']) . '/index.php');
                                }
                        }
                    }
                    if ($this->jumpURL == "") {
                        
                        $contemp = Functions::readFiles( ARIBU_SYSTEMS_SFOLDER . "/_templates/error/norights.html");
                        $TemplateAssignArray = array($CMarkerval => $contemp);
                        $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                    } else {
                        header("Location: " . $this->jumpURL);
                        exit;
                    }
                }
            } # Ende foreach
        } else {
            # Not logged in
            
        }
    }

# Ende function


    /*
     * ElementBuilder
     *
     */

    public function Elements() {
        $db = $this->db;
        $DFE = $this;
        
        $this->db->Select("*")
                 ->From("elements")
                 ->noWhere(1)
                 ->SelectMethod(1)
                 ->doSelect();
        
        $num = $this->db->Rows;
        if ($num) {
            $element = $this->db->SelectPuffer;
            
            for ($i=0; $i<$num; $i++) {
                $this->Element_Attributes = unserialize($element[$i]['element_attributes']);
                $pages_show_element = explode("-", $this->Element_Attributes['pages_show_element']);

                if (in_array($GLOBALS['PageConfig']['UID'], $pages_show_element) || empty($this->Element_Attributes['pages_show_element']) || $this->Element_Attributes['pages_show_element'] == 0) {
                    switch ($element[$i]['element_content']) {
                        case 0:
                            if ($element[$i]['hidden'] != 1) {
                                $sc_method = $element[$i]['class_methods'];
                                $sc_marker = $element[$i]['marker'];
                                include(DOC_ROOT . ARIBU_SYSTEMS_SFOLDER . "/elements/" . $element[$i]['element_path']);
                                # Assign Module
                                $TemplateAssignArray = array($element[$i]['marker'] => $GLOBALS['ELEMENT_TAG'][$element[$i]['marker']]);
                                $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                unset($TemplateAssignArray);
                                unset($GLOBALS['ELEMENT_TAG']);
                            } else {
                                $TemplateAssignArray = array("" . $element[$i]['marker'] . "" => '');
                                $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                unset($TemplateAssignArray);
                                unset($GLOBALS['ELEMENT_TAG']);
                            }
                            break;

                        case 1:
                            if ($element[$i]['hidden'] != 1) {
                                $element_content = $this->ContentElement($element[$i]['pid'], $element[$i]['marker']);
                                $TemplateAssignArray = array($element[$i]['marker'] => $element_content);
                                $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                unset($TemplateAssignArray);
                            } else {
                                $element_content = "";
                                $TemplateAssignArray = array($element[$i]['marker'] => $element_content);
                                $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                                unset($TemplateAssignArray);
                            }
                            break;

                        case 2:
                            if ($element[$i]['hidden'] != 1) {
                                $sc_method = $element[$i]['class_methods'];
                                $sc_marker = $element[$i]['marker'];
                                include_once(DOC_ROOT . ARIBU_SYSTEMS_SFOLDER . "/elements/" . $element[$i]['element_path']);
                                foreach ($this->TemplateAssignArray as $marker_key => $content_val) {
                                    if (preg_match('/' . $element[$i]['marker'] . '/', $content_val, $treffer)) {
                                        $dot = $this->TemplateAssignArray[$marker_key];
                                        $dot = str_replace($element[$i]['marker'], $GLOBALS['ELEMENT_TAG'][$element[$i]['marker']], $dot);
                                        $this->TemplateAssignArray[$marker_key] = $dot;
                                    }
                                }
                            } else {
                                $element_content = "";
                            }
                            break;

                        case 3:
                            if ($element[$i]['hidden'] != 1) {
                                $element_content = $this->ContentElement($element[$i]['pid']);
                            } else {
                                $element_content = "";
                            }
                            $element_content_buffer[] = $element_content;
                            $element_buffer[] = $element[$i]['marker'];
                            foreach ($this->TemplateAssignArray as $marker_key => $content_val) {
                                if (preg_match('/' . $element[$i]['marker'] . '/', $content_val, $treffer)) {
                                    $dot = $this->TemplateAssignArray[$marker_key];
                                    $dot = str_replace($element[$i]['marker'], $element_content, $dot);
                                    $this->TemplateAssignArray[$marker_key] = $dot;
                                }
                            }
                            break;
                    }
                } else {
                    switch ($element[$i]['module_content']) {
                        case 0:
                            $TemplateAssignArray = array("" . $element[$i]['marker'] . "" => '');
                            $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                            unset($TemplateAssignArray);
                            unset($GLOBALS['ELEMENT_TAG']);
                            break;

                        case 1:
                            $element_content = "";
                            $TemplateAssignArray = array($element[$i]['marker'] => $element_content);
                            $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                            unset($TemplateAssignArray);
                            break;

                        case 2:
                            $element_content = "";
                            break;

                        case 3:
                            $element_content = "";
                            $element_content_buffer[] = $element_content;
                            $element_buffer[] = $element[$i]['marker'];
                            foreach ($this->TemplateAssignArray as $marker_key => $content_val) {
                                if (preg_match('/' . $element[$i]['marker'] . '/', $content_val, $treffer)) {
                                    $dot = $this->TemplateAssignArray[$marker_key];
                                    $dot = str_replace($element[$i]['marker'], $element_content, $dot);
                                    $this->TemplateAssignArray[$marker_key] = $dot;
                                }
                            }
                            break;
                    }
                }
            }
            $this->ElementContent = $element_content_buffer;
            $this->ElementMarker = $element_buffer;
        }
    }

    /*
     * Content Element
     *
     */

    public function ContentElement($cid) {
        
        if (SYS_LANGUAGE != $GLOBALS['LANGUAGE']) {
            $this->db->Select('uid')
                     ->From('pages_language')
                     ->WhereColName('rid')
                     ->WhereColValue($cid)
                     ->Andd("AND lang = :lang ")
                     ->Parameter(array('lang' => SYS_LANGUAGE))
                     ->doSelect();
            $cid = $this->db->SelectPuffer['uid'];
        }

        $this->Element = 1;
        $session_user_rights = isset($_SESSION['sess_user_rights']) ? $_SESSION['sess_user_rights'] : 0;

        $order = $this->Element_Attributes['rotate_content'] == 1 ? " ORDER BY RAND()" : " ORDER BY sorting";
        $limit = !empty($this->Element_Attributes['content_limit']) ? " LIMIT " . $this->Element_Attributes['content_limit'] : "";

        $this->db->Select('*')
                 ->From('content')
                 ->WhereColName('pid')
                 ->WhereColValue($cid)
                 ->Andd(" AND colP = 0 AND lang = :lang AND ((starttime = 0 AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime = 0 AND hidden != 1) OR (starttime != 0 AND starttime <= '" . time() . "' AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime = 0 AND endtime != 0 AND endtime >= '" . time() . "' AND hidden != 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime = 0 AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime = 0 AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime < '" . time() . "' AND endtime != 0 AND endtime <= '" . time() . "' AND hidden = 1) OR (starttime != 0 AND starttime >= '" . time() . "' AND endtime != 0 AND endtime > '" . time() . "' AND hidden = 1))")
                 ->Order($order)
                 ->Limit($limit)
                 ->SelectMethod(1)
                 ->Parameter(array('lang' => SYS_LANGUAGE))
                 ->doSelect();
        $row = $this->db->SelectPuffer;
        $num = $this->db->Rows;
        if ($num > 0) {
            for ($i = 0; $i < $num; $i++) {
                if ($row[$i]['perms_groupid'] <= $session_user_rights) {
                    # Dot-Content
                    switch ($row[$i]['CType']) {

                        case "HTML":
                            $BlockData = unserialize($row[$i]['script_method']);

                            $h1 = isset($GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][1]) ? $GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][1] : 'h1';
                            $h2 = isset($GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][2]) ? $GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][2] : 'h2';
                            $headlines = "";
                            $headlines = $row[$i]['headline'] != "" ? '<' . $h1 . '>' . $row[$i]['headline'] . '</' . $h1 . '>' : "";
                            $headlines .= $row[$i]['subline'] != "" ? '<' . $h2 . '>' . $row[$i]['subline'] . '</' . $h2 . '>' : "";

                            $block_style = "";
                            $clear = '<br style="clear:both;" />';

                            $block_style .= $BlockData['block_width'] != "" ? "width:" . $BlockData['block_width'] . "; " : "";
                            $block_style .= $BlockData['block_height'] != "" ? "height:" . $BlockData['block_height'] . "; " : "";

                            $border_width = $BlockData['border_width'] != "" ? $BlockData['border_width'] : 1;
                            $border_color = $BlockData['border_color'] != "" ? '' . $BlockData['border_color'] . '' : '';
                            $border_style = $BlockData['border_style'] != "" ? '' . $BlockData['border_style'] . ' ' : '';

                            if (isset($BlockData['border'])) {
                                switch ($BlockData['border']) {
                                    case "1": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "2": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "3": $block_style .= 'border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "4": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "5": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "6": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "7": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "8": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "9": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "10": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                    case "11": $block_style .= 'border:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                                        break;
                                }
                            }

                            $block_style .= $BlockData['block_padding'] != "" ? "padding:" . $BlockData['block_padding'] . "; " : "";
                            $block_style .= $BlockData['block_margin'] != "" ? "margin:" . $BlockData['block_margin'] . "; " : "";

                            if ($BlockData['block_position'] != "") {
                                switch ($BlockData['block_position']) {
                                    case "1":
                                        $block_style .= "float:left; ";
                                        $block_start = '<div class="dor-html-block" style="' . $block_style . '">';
                                        $block_end = '<br style="clear:both;" /></div>';
                                        break;

                                    case "2":
                                        $block_style .= " text-align:center;";
                                        $block_start = '<div class="dor-html-block" style="' . $block_style . '"><div style="margin:auto; display:inline-block;">';
                                        $block_end = '<br style="clear:both;" /></div>' . $clear;
                                        break;

                                    case "3":
                                        $block_style .= "float:right;";
                                        $block_start = '<div class="dor-html-block" style="' . $block_style . '">';
                                        $block_end = '<br style="clear:both;" /></div>';
                                        break;
                                }
                            }


                            $ContentTag = $block_start . $headlines . stripslashes(Functions::replaceLinks($row[$i]['bodytext'], "dotLink")) . $block_end;
                            $ContentElementTag .= $ContentTag;

                            break;

                        default:
                            $ContentTag = stripslashes($row[$i]['bodytext']);
                            $BlockData = unserialize($row[$i]['script_method']);

                            if ($BlockData['classname'] != "") {
                                if (isset($this->Counter[$BlockData['classname']])) {
                                    $this->Counter[$BlockData['classname']] ++;
                                } else {
                                    $this->Counter[$BlockData['classname']] = 1;
                                }
                            }
                            DOC_ROOT . $BlockData['script_path'];
                            $BlockData['CID'] = $row[$i]['uid'];
                            $BlockData['COLP'] = $key;
                            $BlockData['Content'] = $ContentTag;
                            $BlockData['Headline'] = stripslashes($row[$i]['headline']);
                            $BlockData['Subline'] = stripslashes($row[$i]['subline']);
                            $BlockData['Sorting'] = $row[$i]['sorting'];

                            include(DOC_ROOT . $BlockData['script_path']);

                            if ($BlockData['classname'] != "") {
                                $ContentElementObj = new $BlockData['classname'];
                                $ContentElementObj->GlobalVars = $BlockData;
                                $ContentElementTag .= $ContentElementObj->initClass();
                            } else {
                                $ContentElementTag .= $pluginCObj;
                            }
                    }
                } else {
                    $ContentElementTag .= '';
                }
            }
            return $ContentElementTag;
        }
    }

    /*
     * Menu
     *
     */

    public function Menu() {
        
        # Menu Konfiguration aus der Datenbank lesen
        $this->db->Select('*')
                 ->From('menu_config')
                 ->WhereColName('menu_lang')
                 ->WhereColValue($GLOBALS['LANGUAGE'])
                 ->SelectMethod(1)
                 ->doSelect();
        
        $num = $this->db->Rows;
        if ($num) {
           
            foreach ($this->db->SelectPuffer as $skey => $row) {
                if (!empty($row['menu_key'])) {
                    $GLOBALS['MenuConfig'][$row['menu_title']][$row['menu_key']] = $row['menu_value'];
                } else {
                    $GLOBALS['MenuConfig'][$row['menu_title']] = $row['menu_value'];
                }
            }

            $Menu = new be_menu($this);
            $Menu->AdminShow = $this->AdminShowHidden;
            $countmenu = count($GLOBALS['MenuConfig']);
            foreach ($GLOBALS['MenuConfig'] as $mkey => $mval) {
                if ($GLOBALS['MenuConfig'][$mkey]['Status'] == 1) {
                    $CMenuObj[$mkey] = $Menu->{$GLOBALS['MenuConfig'][$mkey]['Type']}($mkey);
                } else {
                    $CMenuObj[$mkey] = array("" . $GLOBALS['MenuConfig'][$mkey]['Marker'] . "" => "");
                }
            }
            if (is_array($CMenuObj)) {
                foreach ($CMenuObj as $key => $val) {
                    if (is_array($val)) {
                        foreach ($val as $kkey => $vval) {
                            if ($GLOBALS['MenuConfig'][$key]['MenuInContent'] == 1 && isset($GLOBALS['MenuConfig'][$key]['MenuInContent'])) {
                                $dot = str_replace($GLOBALS['MenuConfig'][$key]['Marker'], $vval, $this->TemplateAssignArray[$GLOBALS['MenuConfig'][$key]['MenuContentMarker']]);
                                $TemplateAssignArray = array($GLOBALS['MenuConfig'][$key]['MenuContentMarker'] => $dot);
                            } else {
                                $TemplateAssignArray = array($kkey => $vval);
                            }
                            $this->TemplateAssignArray = array_merge($this->TemplateAssignArray, $TemplateAssignArray);
                        }
                    } 
                }
            }
        }
    } 
}