<?php

namespace lib;

/* 
 * aribu systems - Version 1.0.1
 * aribu systems is registered and licensed under our definitions.
 * Do not change this code.
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   06.02.2016
 * @update: 21.04.2018
 *  
 */

class Client {
    
    /**
     * Database object
     * @var object 
     */
    private $db;
    
    public function __construct($db) {
        $this->db = $db;
    }
    
    public function SetConstantAndGlobalOfClient($client_name) {
       $this->db->Select('*')
                ->From('client')
                ->WhereColName('client_name')
                ->WhereColValue($client_name)
                ->Andd('AND status != :status')
                ->Parameter(array('status' => 0))
                ->doSelect();
        
        $row = $this->db->SelectPuffer;
        
        
        define('HTTP',                  $row['http']);
        define('HTTPO',                 $row['httpo']);
        define('HTTPS',                 $row['https']);
        define('URL_HOST',              $row['url_host']);
        define('URL_PROTOCOL',		$row['url_protocol']);
        define('URL_PORT',              $row['url_port']);
        
        define('MASTERMAIL_ADDRESS',    $row['client_email_address']);
        define('MASTERMAIL_NAME',       $row['client_email_name']);
        
        define('BROWSER_NAME', 		$row['browser_name']);
	define('CLIENT', 		$row['client']);
        
        
        $GLOBALS['CLIENT_ID']               = $row['client_id'];
        $GLOBALS['CLIENTNAME']              = $client_name;
        $GLOBALS['CLIENT_TEMPLATE_FOLDER']  = str_replace(':'.URL_PORT, '', $GLOBALS['CLIENTNAME'])."/"; 
        
        $this->db->Select('client_id, client_name, url_host')
                 ->From('client')
                 ->WhereColName('status')
                 ->WhereColValue(0)
                 ->Operator('!=')
                 ->SelectMethod(1)
                 ->doSelect();
        $num = $this->db->Rows;
        
        if($num) {
            $rows = $this->db->SelectPuffer;
            for($i=0; $i<$num; $i++) {
                $GLOBALS['CLIENT'][$rows[$i]['client_id']] = $rows[$i]['client_name'];
                $GLOBALS['CLIENT_URL_HOST'][$rows[$i]['client_id']] = $rows[$i]['url_host'];  
            }
        }
    }
 
    public function GetOneClientData($name, $id) {
        $this->db->TablePreName = "fe_";
        $this->db->Select($name)
                 ->From('client')
                 ->WherColName('client_id')
                 ->WhereColValue($id)
                 ->Andd("AND status != :status")
                 ->Parameter(array('status' => 0))
                 ->doSelect();
        return $this->db->SelectPuffer[$name];
    }
}