<?php

namespace lib;

/* 
 * aribu systems - Version 1.0.1
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   12.11.2006
 * @update: 23.04.2018 
 */

class fe_menu {

    public $uid;
    public $pid;
    public $wrap = ''; # Umbruch
    public $left;
    public $LinkTarget;
    public $PageURL;
    public $ButtonSet;
    public $Path_to_NO_Button;
    public $Path_to_ACT_Button;
    public $NavigationTitle;
    public $Pagename;
    public $URLType;
    public $PreImage = ''; # Bild vor einem Textlink
    public $CSS = ''; # Stylesheetname
    public $MenuConfigPoint;    # Zeiger im MenuConfig Array
    public $RootPagename;
    public $MaxRootItems = 0;
    public $AdminShow = 0;
    public $LLN;
    public $LCSS = '';
    public $Level = 0;
    public $RootFolder;
    public $DocType;
    public $MenuEndTag = '';
    public $MenuStartPoint = 0;
    public $MenuStartTag = "";
    public $startTag;
    public $tmp_tree = "";
    public $hiddenLinks = "";
    public $LinkHash;
    public $RPid = 0;
    public $submenu = array();
    public $liAb = 0;
    public $liAbN = 0;
    public $Counter = array();
    public $newSorting = 0;
    public $TitleTag = '';
    public $FirstItem = 0;
    public $LastItem = 0;
    public $LinkIcon = "";
    public $Pages = "pages";
    public $and_lang = "";
    public $Rel = "";
    public $DocTypeAllowed = 64;
    public $UIDName = "";
    public $LangFolder = "";
    public $Chields = 0;
    public $DFE;



    public function __construct($DFE) {
        $this->DFE = $DFE;
        
        if ($GLOBALS['LANGUAGE'] != SYS_LANGUAGE) {
            $this->Pages = "pages_language";
            $this->and_lang = "AND %%%n%%%lang = :lang ";
            $this->UIDName = "rid";
            $this->LangFolder = "/" . $GLOBALS['LANGUAGE'];
        } else {
            $this->Pages = "pages";
            $this->and_lang = "";
            $this->UIDName = "uid";
        }
    }

    public function AMenu($a) {
        
        $this->RootFolder = $this->DFE->RootFolder;
        $this->MenuConfigPoint = $a;

        $docTypeAllowed = isset($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['docType']) ? $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['docType'] : $this->DocTypeAllowed;
        $this->DocTypeAllowed = $docTypeAllowed;

        #$dot = Functions::readFiles("/" . TEMPLATE_PATH . $GLOBALS['PageConfig']['PAGE_TEMPLATE']);
        $num_menu_points = count($GLOBALS['MenuConfig']);

        $startPoint = $GLOBALS['MenuConfig'][$a]['StartLevel'] != "" && isset($this->DFE->PageTreePoints[$GLOBALS['MenuConfig'][$a]['StartLevel']]['uid']) ? $this->DFE->PageTreePoints[$GLOBALS['MenuConfig'][$a]['StartLevel']]['uid'] : -1;
        $this->MenuStartPoint = !empty($GLOBALS['MenuConfig'][$a]['Level']) ? $GLOBALS['MenuConfig'][$a]['Level'] != 'x' ? $GLOBALS['MenuConfig'][$a]['Level'] : $startPoint : 0;


        $perms_groupid = isset($_SESSION['sess_user_rights']) ? $_SESSION['sess_user_rights'] : 0;
        $logged_user = isset($_SESSION['sess_username']) ? " AND a.perms_groupid >= 0 " : "";

        $this->DFE->db->Select('COUNT(*) as max')
                      ->From($this->Pages)
                      ->WhereColName('pid')
                      ->WhereColValue($this->MenuStartPoint)
                      ->Andd("AND deleted != 1 AND docType <= " . $this->DocTypeAllowed . " AND hidden != 1 " . str_replace("%%%n%%%", "", $this->and_lang) . " " . str_replace("a.", "", $logged_user) . " AND perms_groupid <= " . $perms_groupid)
                      ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())     
                      ->doSelect();
        $max = $this->DFE->db->SelectPuffer['max'];
        
        if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['MenuStopp'] != "") {
            $this->DFE->db->Select('sorting')
                          ->From($this->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['MenuStopp'])
                          ->doSelect();
            $and = "AND a.sorting < ".$this->DFE->db->SelectPuffer['sorting'];
        }


        $this->DFE->db->Select(   'a.uid, '
                                . 'a.pid, '
                                . 'a.lft, '
                                . 'a.rgt, '
                                . 'a.urltype, '
                                . 'a.docType, '
                                . 'a.button, '
                                . 'a.pagename, '
                                . 'a.page_Hash, '
                                . 'a.link_title, '
                                . 'a.pageSettings, '
                                . 'a.button_act_path, '
                                . 'a.button_path, '
                                . 'a.target, '
                                . 'a.url, '
                                . 'a.hidden, '
                                . 'a.nav_title, '
                                . 'a.perms_groupid, '
                                . 'a.starttime, '
                                . 'a.endtime, '
                                . 'b.pagename as rootfolder, '
                                . 'b.pid as rootpid')
                       ->From($this->Pages . " a ")
                       ->noWhere(1)
                       ->Andd("LEFT JOIN  fe_" . $this->Pages . " b ON b.uid = a.pid WHERE a.pid = " . $this->MenuStartPoint 
                            . " AND a.docType <= " . $this->DocTypeAllowed 
                            . " AND a.docType != 0 " . $logged_user . " "
                            . " AND a.perms_groupid <= " . $perms_groupid . " " . str_replace("%%%n%%%", "a.", $this->and_lang) . " "
                            . " AND ((a.starttime = 0 AND a.endtime = 0 AND a.hidden != '1') "
                            . " OR (a.starttime != 0 AND a.starttime <= '" . time() . "' AND a.endtime = 0 AND a.hidden != '1') "
                            . " OR (a.starttime != 0 AND a.starttime <= '" . time() . "' AND a.endtime != 0 AND a.endtime >= '" . time() . "' AND a.hidden != '1') "
                            . " OR (a.starttime = 0 AND a.endtime != 0 AND a.endtime >= '" . time() . "' AND a.hidden != '1') "
                            . " OR (a.starttime != 0 AND a.starttime >= '" . time() . "' AND a.endtime = 0 AND a.hidden = '1') "
                            . " OR (a.starttime != 0 AND a.starttime >= '" . time() . "' AND a.endtime != 0 AND a.endtime <= '" . time() . "' AND a.hidden = '1') "
                            . " OR (a.starttime = 0 AND a.endtime != 0 AND a.endtime <= '" . time() . "' AND a.hidden = '1') "
                            . " OR (a.starttime != 0 AND a.starttime < '" . time() . "' AND a.endtime != 0 AND a.endtime <= '" . time() . "' AND a.hidden = '1') "
                            . " OR (a.starttime != 0 AND a.starttime >= '" . time() . "' AND a.endtime != 0 AND a.endtime > '" . time() . "' AND a.hidden = '1')) ".$and)
                        ->Order("ORDER BY a.sorting ASC")
                        ->SelectMethod(1)
                        ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                        ->doSelect();
        $num = $this->DFE->db->Rows;
        $x = 1;
        $this->FirstItem = 0;
        $this->LastItem = 0;
        if ($num) {
            $row = $this->DFE->db->SelectPuffer;
            for ($i = 0; $i < $num; $i++) {
                $this->URLType = $row[$i]['urltype'];

                $this->FirstItem = $x == 1 ? 1 : 0;
                $this->LastItem = $num == $x ? 1 : 0;

                $nav_title = stripslashes($row[$i]['nav_title']);

                switch ($GLOBALS['MenuConfig'][$a]["NameAttributes"]) {
                    case "normal": $this->NavigationTitle = $nav_title;
                        break;
                    case "ucf": $this->NavigationTitle = ucfirst($nav_title);
                        break;
                    case "lower": $this->NavigationTitle = mb_strtolower($nav_title, 'UTF-8');
                        break;
                    case "upper": $this->NavigationTitle = mb_strtoupper($nav_title, 'UTF-8');
                        break;
                }
                switch ($GLOBALS['MenuConfig'][$a]["NameAttributes64"]) {
                    case "normal": $this->NavigationTitle = $nav_title;
                        break;
                    case "ucf": $this->NavigationTitle = ucfirst($nav_title);
                        break;
                    case "lower": $this->NavigationTitle = mb_strtolower($nav_title, 'UTF-8');
                        break;
                    case "upper": $this->NavigationTitle = mb_strtoupper($nav_title, 'UTF-8');
                        break;
                }
                $this->uid = $row[$i]['uid'];
                $this->DocType = $row[$i]['docType'];
                $this->ButtonSet = $row[$i]['button'];
                $this->Pagename = $row[$i]['pagename'];
                $this->PreImage = $GLOBALS['MenuConfig'][$a]['PreImage'];
                $this->wrap = stripslashes($GLOBALS['MenuConfig'][$a]['Wrap']);
                $this->CSS = $GLOBALS['MenuConfig'][$a]['CSS'];
                $this->page_Hash = $row[$i]['page_Hash'];
                $this->TitleTag = htmlentities(stripslashes($row[$i]['link_title']), ENT_QUOTES, 'UTF-8');

                $pageSettings = unserialize($row[$i]['pageSettings']);
                $this->LinkCSS = !empty($pageSettings['LinkCSS']) ? $pageSettings['LinkCSS'] : '';
                if (strstr($pageSettings['LinkIcon'], '<') || !strstr($pageSettings['LinkIcon'], '/')) {
                    $this->LinkIcon = $pageSettings['LinkIcon'] != "" ? stripslashes(base64_decode($pageSettings['LinkIcon'])) : "";
                } else {
                    $this->LinkIcon = $pageSettings['LinkIcon'] != "" ? $pageSettings['LinkIcon'] : "";
                }


                if (!empty($row[$i]['button_act_path'])) {
                    $this->Path_to_ACT_Button = $row[$i]['button_act_path'];
                } else {
                    $this->Path_to_ACT_Button = $row[$i]['button_path'];
                }
                $this->Path_to_NO_Button = $row[$i]['button_path'];
                if (!empty($row[$i]['target'])) {
                    $target = ' target="' . $row[$i]['target'] . '"';
                    $this->LinkTarget = $target;
                    $this->Rel = "rel=\"" . $row[$i]['target'] . "\"";
                } else {
                    $this->LinkTarget = "";
                    $this->Rel = "";
                }

                $fileDoc = $GLOBALS['MenuConfig'][$a]['FileDoc'] == "no" ? "" : ".html";

                if (!empty($row[$i]['url']) && $row[$i]['urltype'] != 0) {
                    if (preg_match("/###dotlink-(.*)###(.*)/", stripslashes($row[$i]['url']), $url_arr)) {
                        $purl = $row['urltype'] != 7 ? $this->getTreePathNames($url_arr[1], '', 0, 1, 1, '', ' AND p.docType != 0 ') . $fileDoc : $this->getTreePathNames($this->uid, '', 0, 1, 1, '', ' AND p.docType != 0 ') . $fileDoc;
                        $this->PageURL = $purl . $url_arr[2];
                    } else {
                        $purl = stripslashes($row[$i]['url']);
                        $this->PageURL = $purl;
                    }
                    
                } else {
                    $purl = $this->getTreePathNames($this->uid, '', 0, 1, 1, '', ' AND p.docType != 0 ') . $fileDoc;
                    $this->PageURL = $purl;
                }

                if ($GLOBALS['MenuConfig'][$a]["PreLinkTags"] == "list") {
                    $this->startTag = "<ul class=\"" . $this->CSS . "\">";
                    $BLCode = $max == $x ? "</li></ul>\n" : "</li>\n";
                } else {
                    $this->startTag = "";
                }

                $this->LinkURLType();
                $menu_points[] = $this->MenuButtons($a, $x, $BLCode, $max);
                $x++;
            }

            # Menu-Array wird zu einem String zusammengefasst
            if (is_array($menu_points)) {
                $menu_structure = implode("", $menu_points);
            }
            $this->MenuStartTag = stripslashes($GLOBALS['MenuConfig'][$a]["MenuStartTag"]);
            $this->MenuEndTag = stripslashes($GLOBALS['MenuConfig'][$a]["MenuEndTag"]);

            $CMenuObj[$GLOBALS['MenuConfig'][$a]['Marker']] = stripslashes($this->MenuStartTag) . $this->startTag . $menu_structure . stripslashes($this->MenuEndTag);
            unset($menu_points);
        } else {
            $CMenuObj[$GLOBALS['MenuConfig'][$a]['Marker']] = "";
        }

        return $CMenuObj;
    }

    /*
     * URL Type
     *
     */

    public function LinkURLType() {

        $first_item = $this->FirstItem == 1 ? " first" : "";
        $last_item = $this->LastItem == 1 ? " last" : "";
        $chields = $this->Chields > 0 ? ' has-chields' : '';
        $dropdown = $this->Chields > 0 ? ' dropdown' : '';
        
        # CSS
        if (!empty($this->CSS)) {
            if ($this->Level < 1) {
                $css_act = ' class="act-' . $this->Pagename . ' '. $this->CSS . ' current level' . $this->Level . $first_item . $last_item . $chields . $dropdown . ' ' . $this->Pagename . ' ' . $this->LinkCSS . '"';
                $css_no = ' class="' . $this->CSS . ' level' . $this->Level . $first_item . $last_item . ' ' . $this->Pagename . $chields . ' ' . $this->LinkCSS . '"';
            } else {
                if ($this->Level < 2) {
                    $css_act = ' class="act-' . $this->Pagename . ' '. $this->CSS . ' current level' . $this->Level . $first_item . $last_item . $chields . $dropdown . ' ' . $this->Pagename . ' ' . $this->LinkCSS . '"';
                    $css_no = ' class="' . $this->CSS . ' level' . $this->Level . $first_item . $last_item . ' ' . $this->Pagename . $chields . ' ' . $this->LinkCSS . '"';
                } else {
                    $css_act = ' class="act-' . $this->Pagename . ' '. $this->CSS . ' current level' . $this->Level . $first_item . $last_item . $chields . $dropdown . ' ' . $this->Pagename . ' ' . $this->LinkCSS . '"';
                    $css_no = ' class="' . $this->CSS . ' level' . $this->Level . $first_item . $last_item . ' ' . $this->Pagename . $chields . ' ' . $this->LinkCSS . '"';
                }
            }
        } else {
            if ($this->Level <= $GLOBALS['MenuConfig'][$a]['HeadLinksLevel']) {
                $css_act = " class=\"act-head-links level" . $this->Level . $first_item . $last_item . $chields . ' ' . $this->LinkCSS . "\"";
                $css_no = " class=\"" . $this->Pagename . " level" . $this->Level . $first_item . $last_item . $chields . ' ' . $this->LinkCSS . "\"";
            } else {
                $css_act = " class=\"act-sub-links level" . $this->Level . $first_item . $last_item . $chields . ' ' . $this->LinkCSS . "\"";
                $css_no = " class=\"sub-links level" . $this->Level . $first_item . $last_item . $chields . ' ' . $this->LinkCSS . "\"";
            }
        }


        # Bei Listen muß li definiert werden
        $this->LCSS = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? $css_act : $css_no;
        if ($GLOBALS['PageConfig']['PID'] != 0 && $this->uid != $GLOBALS['PageConfig']['UID']) {
            $this->LCSS = $this->uid == $GLOBALS['PageConfig']['PID'] || @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? $css_act : " class=\"item level" . $this->Level . " " . $this->CSS . "\"";
        }

        switch ($this->URLType) {
            case 0:

                # Sub-Navi
                if ($GLOBALS['PageConfig']['CONTENT_FROM_PID'] != '0') {
                    $old_uid = $GLOBALS['PageConfig']['CONTENT_FROM_PID'];
                } else {
                    $old_uid = $GLOBALS['PageConfig']['UID'];
                }

                if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['OnMouseOver'] == 1) {
                    if ($old_uid != $this->uid) {
                        $omo = " onmouseover=\"MM_swapImage('" . $this->Pagename . "','','/fileadmin/buttons/" . $this->Path_to_ACT_Button . "',1)\" onmouseout=\"MM_swapImgRestore()\" ";
                    }
                }

                if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['OnClick'] != '') {
                    $ocl = ' onclick="' . $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['OnClick'] . '" ';
                }

                # Title Tag
                $title_tag = !empty($this->TitleTag) ? " title=\"" . $this->TitleTag . "\"" : "";


                if (empty($GLOBALS['PageConfig']['CONTENT_FROM_PID_NAME'])) {
                    # Link bei gleichem Seiteninhalt

                    $url = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? "<a href=\"" . $this->PageURL . "\"" . $this->LinkTarget . str_replace($this->CSS, 'nav-link', $css_act) . " id=\"" . $this->CSS . "-" . $this->Pagename . "\" onfocus=\"blur();\"" . $title_tag . $ocl . ">" : "<a href=\"" . $this->PageURL . "\"" . $this->LinkTarget . str_replace($this->CSS, 'nav-link', $css_no) . $omo . " id=\"" . $this->CSS . "-" . $this->Pagename . "\" onfocus=\"blur();\"" . $title_tag . $ocl . ">";
                    $this->LCSS = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? $css_act : $css_no;

                    if ($GLOBALS['PageConfig']['PID'] != 0 && $this->uid != $GLOBALS['PageConfig']['UID']) {
                        $this->LCSS = $this->uid == $GLOBALS['PageConfig']['PID'] || @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? $css_act : $css_no;
                    }
                } else {
                    # Link bei anderem Seiteninhalt
                    $url = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? "<a href=\"" . $this->PageURL . "\"" . $this->LinkTarget . str_replace($this->CSS, 'nav-link', $css_act) . " id=\"" . $this->CSS . "-" . $this->Pagename . "\" onfocus=\"blur();\"" . $title_tag . ">" : "<a href=\"" . $this->PageURL . "\"" . $this->LinkTarget . str_replace($this->CSS, 'nav-link', $css_no) . $omo . " id=\"" . $this->CSS . "-" . $this->Pagename . "\" onfocus=\"blur();\"" . $title_tag . ">";
                    $this->LCSS = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? $css_act : $css_no;

                    if ($GLOBALS['PageConfig']['PID'] != 0 && $this->uid != $GLOBALS['PageConfig']['UID']) {
                        if ($this->pid != 0) {
                            $this->LCSS = $this->uid == $GLOBALS['PageConfig']['CONTENT_FROM_PID'] ? $css_act : $css_no;
                        } else {
                            $this->LCSS = $this->uid == $GLOBALS['PageConfig']['PID'] ? $css_act : $css_no;
                        }
                    }
                }
                if ($this->DocType == 256) {
                    $this->LCSS = " class=\"menu-head " . $this->Pagename . "\"";
                }

                $this->URLType = $url;
                break;

            case 1: # HTTP
                $protocol = "http:";
                $url = "<a href=\"" . $protocol . "//" . $this->PageURL . "\"" . $this->LinkTarget . " class=\"nav-link level".$this->Level."\" onfocus=\"blur();\" id=\"" . $this->Pagename . "\"" . $title_tag . ">";
                $this->URLType = $url;
                break;

            case 2: # FTP
                $url = "<a href=\"ftp://" . $this->PageURL . "\"" . $this->LinkTarget . " class=\"nav-link level".$this->Level."\" onfocus=\"blur();\"" . $title_tag . ">";
                $this->URLType = $url;
                break;

            case 3: # Mail
                $url = "<a href=\"mailto:" . $this->PageURL . "\" class=\"nav-link\" onfocus=\"blur();\"" . $title_tag . ">";
                $this->URLType = $url;
                break;

            case 4: # Javascript
                $url = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? "<a href=\"javascript:" . $this->PageURL . "\" " . str_replace($this->CSS, 'nav-link', $css_act) . " onfocus=\"blur();\"" . $title_tag . " " . $this->Rel . ">" : "<a href=\"javascript:" . $this->PageURL . "\" " . str_replace($this->CSS, 'nav-link', $css_no) . " onfocus=\"blur();\"" . $title_tag . " " . $this->Rel . ">";
                $this->URLType = $url;
                break;

            case 5: # Intern
                $url = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? "<a href=\"" . $this->PageURL . "\"" . $this->LinkTarget . str_replace($this->CSS, 'nav-link', $css_act) . " onfocus=\"blur();\">" : "<a href=\"" . $this->PageURL . "\"" . $this->LinkTarget . str_replace($this->CSS, 'nav-link', $css_no) . " onfocus=\"blur();\" id=\"" . $this->Pagename . "\"" . $title_tag . ">";
                $this->URLType = $url;
                break;

            case 6: # HTTPS
                $protocol = "https:";
                $url = "<a href=\"" . $protocol . "//" . $this->PageURL . "\"" . $this->LinkTarget . " class=\"nav-link level".$this->Level."\" onfocus=\"blur();\" id=\"" . $this->Pagename . "\"" . $title_tag . ">";
                $this->URLType = $url;
                break;

            case 7: # Redirect
                $url = "<a href=\"" . $this->PageURL . "\"" . $this->LinkTarget . " class=\"nav-link\" onfocus=\"blur();\" id=\"" . $this->Pagename . "\"" . $title_tag . ">";
                $this->URLType = $url;
                break;
            
            case 8: # Anker
                $url = @in_array($this->page_Hash, $this->DFE->PageTreePointsHashes) ? "<a href=\"" . $this->PageURL . "\" " . str_replace($this->CSS, 'nav-link', $css_act) . " onfocus=\"blur();\"" . $title_tag . " " . $this->Rel . ">" : "<a href=\"" . $this->PageURL . "\" " . str_replace($this->CSS, 'nav-link', $css_no) . " onfocus=\"blur();\"" . $title_tag . " " . $this->Rel . ">";
                $this->URLType = $url;
                break;
        }
    }

    /*
     * Menu wrap
     *
     */

    public function MenuButtons($a, $countx = 0, $BLCode = '', $max = 0) {

        # Wrap
        if ($countx != $max) {
            $wrap = $this->wrap;
        }

        switch ($this->ButtonSet) {
            case 0:
                $ahref_first = $this->URLType;
                $ahref_last = "</a>";

                $image_icon = preg_match("#<#ism", $this->LinkIcon, $hit) ? $this->LinkIcon : '<img src="' . $this->LinkIcon . '" border="0" class="link-pre-icon" />';
                $icon_preimage = $this->LinkIcon != "" && $GLOBALS['MenuConfig'][$a]['PreImageLevel'] == 3 ? $image_icon : "";

                if ($this->Level == $GLOBALS['MenuConfig'][$a]['PreImageLevel'] && !empty($GLOBALS['MenuConfig'][$a]['PreImage'])) {
                    $pre_image = $ahref_first . stripslashes($this->PreImage) . $ahref_last;
                }
                if ($this->DocType <= $this->DocTypeAllowed) {
                    $menu_points = $pre_image . $ahref_first . $icon_preimage . $this->NavigationTitle . $ahref_last . $wrap;
                } else {
                    $menu_points = $pre_image . $icon_preimage . $this->NavigationTitle . $wrap;
                }
                break;
            case 1:
                # Sub-Navi
                if ($GLOBALS['PageConfig']['CONTENT_FROM_PID'] != '0') {
                    $old_uid = $GLOBALS['PageConfig']['CONTENT_FROM_PID'];
                } else {
                    $old_uid = $GLOBALS['PageConfig']['UID'];
                }
                if (!isset($this->RootFolder)) {
                    $ahref_first = $old_uid == $this->uid ? $this->URLType . "<img src=\"" . BUTTON_PATH . $this->Path_to_ACT_Button . "\" border=\"0\" id=\"act-button-" . $this->Pagename . "\" name=\"" . $this->Pagename . "\" alt=\"" . $this->NavigationTitle . "\" title=\"" . $this->NavigationTitle . "\" />" : $this->URLType . "<img src=\"" . BUTTON_PATH . $this->Path_to_NO_Button . "\" border=\"0\" id=\"no-button-" . $this->Pagename . "\" name=\"" . $this->Pagename . "\" alt=\"" . $this->NavigationTitle . "\" title=\"" . $this->NavigationTitle . "\" />";
                } else {
                    $ahref_first = $this->RootFolder == $this->Pagename ? $this->URLType . "<img src=\"" . BUTTON_PATH . $this->Path_to_ACT_Button . "\" border=\"0\" id=\"act-button-" . $this->Pagename . "\" name=\"" . $this->Pagename . "\" alt=\"" . $this->NavigationTitle . "\" title=\"" . $this->NavigationTitle . "\" />" : $this->URLType . "<img src=\"" . BUTTON_PATH . $this->Path_to_NO_Button . "\" border=\"0\" id=\"no-button-" . $this->Pagename . "\" name=\"" . $this->Pagename . "\" alt=\"" . $this->NavigationTitle . "\" title=\"" . $this->NavigationTitle . "\" />";
                }
                $ahref_last = "</a>";
                $menu_points = $ahref_first . $ahref_last . $wrap;
                break;
        }
        switch ($GLOBALS['MenuConfig'][$a]['PreLinkTags']) {
            case "div":
                if ($this->DocType <= $this->DocTypeAllowed) {
                    $menu_points = "<div class=\"" . $this->CSS . " " . $this->Pagename . "\">" . $menu_points . "</div>";
                } else {
                    $menu_points = "<div class=\"" . $this->Pagename . "\">" . $menu_points . "</div>";
                }
                break;
            case "p":
                if ($this->DocType <= $this->DocTypeAllowed) {
                    $menu_points = "<p class=\"" . $this->CSS . "\">" . $menu_points . "</p>";
                } else {
                    $menu_points = "<p class=\"" . $this->Pagename . "\">" . $menu_points . "</p>";
                }
                break;
            case "span":
                if ($this->DocType <= $this->DocTypeAllowed) {
                    $menu_points = "<span class=\"" . $this->CSS . "\">" . $menu_points . "</span>";
                } else {
                    $menu_points = "<span class=\"" . $Pagename . "\">" . $menu_points . "</span>";
                }
                break;
            case "list":
                $icon = $this->LinkIcon != "" && $GLOBALS['MenuConfig'][$a]['PreImageLevel'] == 1 && $GLOBALS['MenuConfig'][$a]['PreImageLevel'] != "" ? " style=\"background-image:url(" . $this->LinkIcon . ");\"" : "";
                $menu_points = "<li" . str_replace($this->CSS, 'nav-item', str_replace($this->LinkCSS, '', $this->LCSS)) . "" . $icon . ">" . $menu_points . $BLCode;
                break;
        }
        return $menu_points;
    }

    /*
     * HMenü
     *
     */

    public function HMenu($a) {

        $this->RootFolder = $this->DFE->RootFolder;
        $this->MenuConfigPoint = $a;

        $this->MenuStartTag = $GLOBALS['MenuConfig'][$a]['MenuStartTag'];
        $uid = empty($GLOBALS['MenuConfig'][$a]['FreezeLevel']) ? $GLOBALS['PageConfig']['UID'] : $this->DFE->PageTreePoints[$GLOBALS['MenuConfig'][$a]['FreezeLevel']]['uid'];
        $this->MenuStartPoint = !empty($GLOBALS['MenuConfig'][$a]['Level']) ? $GLOBALS['MenuConfig'][$a]['Level'] != 'x' ? $GLOBALS['MenuConfig'][$a]['Level'] : $uid : 0;
        $this->FirstItem = 0;
        $this->LastItem = 0;
        $this->Counter = array();
        if ($GLOBALS['MenuConfig'][$a]['Level'] == 'x') {
            $this->UIDName = "uid";
        }

        $docTypeAllowed = isset($GLOBALS['MenuConfig'][$a]['docType']) ? $GLOBALS['MenuConfig'][$a]['docType'] : $this->DocTypeAllowed;
        $this->DocTypeAllowed = $docTypeAllowed;

        $HNavi = $this->getTreeNSM($this->MenuStartPoint);

        if ($HNavi != false) {
            $CMenuObj[$GLOBALS['MenuConfig'][$this->MenuConfigPoint]['Marker']] = stripslashes($GLOBALS['MenuConfig'][$a]["MenuStartTag"]) . stripslashes($this->MenuStartTag) . $HNavi . stripslashes($this->MenuEndTag) . stripslashes($GLOBALS['MenuConfig'][$a]['MenuEndTag']);
        } else {
            $CMenuObj[$GLOBALS['MenuConfig'][$this->MenuConfigPoint]['Marker']] = "";
        }
        return $CMenuObj;
    }

    /*
     * Nested Sets Model: Menübaum mit einer Abfrage holen.
     *
     */

    public function getTreeNSM($SP = '') {
        $perms_groupid = isset($_SESSION['sess_user_rights']) ? $_SESSION['sess_user_rights'] : 0;

        if (is_array($this->DFE->PageTreePoints) && $GLOBALS['MenuConfig'][$this->MenuConfigPoint]["MenuOpen"] != 1) {
            $SP = $SP == "" ? 0 : $SP;
            $count_ptp = count($this->DFE->PageTreePoints);
            for ($i = 0; $i < $count_ptp; $i++) {
                $xor = $i == 0 ? " WHERE (o.pid = " . $SP . " OR " : " OR ";
                $lastxor = $i == $count_ptp - 1 ? ")" : "";
                $per_click .= $xor . "o.pid = " . $this->DFE->PageTreePoints[$i]['uid'] . " " . $lastxor;
            }
            $zusatz = "";
            $group_by = "";
            $start_point = "";

            if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['MenuStopp'] != "") {
                $this->DFE->db->Select('lft')
                              ->From($this->Pages)
                              ->WhereColName("uid")
                              ->WhereColValue($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['MenuStopp'])
                              ->Andd(str_replace("%%%n%%%", "", $this->and_lang))
                              ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                $num_stopp = $this->DFE->db->Rows;
                if ($num_stopp) {
                    $rgt = $this->DFE->db->SelectPuffer['lft'];
                    $menu_stopp = " AND o.rgt < " . $rgt;
                }
            } else {
                $menu_stopp = "";
            }
        } else {
            $per_click = "";
            $zusatz_from = ", fe_" . $this->Pages . " AS p";
            $zusatz_where = "WHERE o.lft BETWEEN p.lft AND p.rgt " . str_replace("%%%n%%%", "p.", $this->and_lang);
            $group_by = "GROUP BY o.lft";
            $start_point = $SP == 0 ? "" : "AND p.uid = " . $SP;

            if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['MenuStopp'] != "") {
                $this->DFE->db->Select('lft')
                              ->From($this->Pages)
                              ->WhereColName("uid")
                              ->WhereColValue($GLOBALS['MenuConfig'][$this->MenuConfigPoint]['MenuStopp'])
                              ->Andd(str_replace("%%%n%%%", "", $this->and_lang))
                              ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())  
                              ->doSelect();
                $num_stopp = $this->DFE->db->Rows;
                if ($num_stopp) {
                    $rgt = $this->DFE->db->SelectPuffer['lft'];
                    $menu_stopp = " AND o.rgt < " . $rgt;
                }
            } else {
                $menu_stopp = "";
            }
        }


        $start_Level = $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['StartLevel'] != "" ? " AND o.level > " . $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['StartLevel'] : "";
        $stopp_Level = $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['StopLevel'] != "" ? " AND o.level < " . $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['StopLevel'] : "";
        $logged_user = isset($_SESSION['sess_username']) ? " AND o.perms_groupid >= 0 " : "";


        $this->DFE->db->Select('uid')
                      ->From($this->Pages)
                      ->WhereColName('pid')
                      ->WhereColValue($SP)
                      ->Andd("AND docType <= " . $this->DocTypeAllowed . " AND hidden = 0")
                      ->doSelect();
        $maxRoot = $this->DFE->db->Rows;

        $this->DFE->db->Select("o.uid, 
                                o.pid, 
                                o.lft, 
                                o.rgt, 
                                o.urltype, 
                                o.docType, 
                                o.button, 
                                o.pagename, 
                                o.page_Hash, 
                                o.link_title, 
                                o.pageSettings, 
                                o.button_act_path, 
                                o.button_path, 
                                o.target, 
                                o.url, 
                                o.hidden, 
                                o.nav_title, 
                                o.perms_groupid, 
                                o.starttime, 
                                o.endtime, 
                                o.level,
                                ROUND( (o.rgt - o.lft - 1)/2) AS chields ")
                       ->From($this->Pages . " AS o" . $zusatz_from)
                       ->noWhere(1)
                       ->Andd($zusatz_where . $per_click . "
                                " . $menu_stopp . "
                                " . $start_point . "
                                AND o.docType <= " . $this->DocTypeAllowed . "

                                " . $logged_user . "
                                AND o.perms_groupid <= " . $perms_groupid . "
                                AND ((o.starttime = 0 AND o.endtime = 0 AND o.hidden != '1') OR (o.starttime != 0 AND o.starttime <= '" . time() . "' AND o.endtime = 0 AND o.hidden != '1') OR (o.starttime != 0 AND o.starttime <= '" . time() . "' AND o.endtime != 0 AND o.endtime >= '" . time() . "' AND o.hidden != '1') OR (o.starttime = 0 AND o.endtime != 0 AND o.endtime >= '" . time() . "' AND o.hidden != '1') OR (o.starttime != 0 AND o.starttime >= '" . time() . "' AND o.endtime = 0 AND o.hidden = '1') OR (o.starttime != 0 AND o.starttime >= '" . time() . "' AND o.endtime != 0 AND o.endtime <= '" . time() . "' AND o.hidden = '1') OR (o.starttime = 0 AND o.endtime != 0 AND o.endtime <= '" . time() . "' AND o.hidden = '1') OR (o.starttime != 0 AND o.starttime < '" . time() . "' AND o.endtime != 0 AND o.endtime <= '" . time() . "' AND o.hidden = '1') OR (o.starttime != 0 AND o.starttime >= '" . time() . "' AND o.endtime != 0 AND o.endtime > '" . time() . "' AND o.hidden = '1'))
                                " . $start_Level . "
                                " . $stopp_Level . "
                                " . str_replace("%%%n%%%", "o.", $this->and_lang))
                       ->Group($group_by)
                       ->Order("ORDER BY o.lft")
                       ->Parameter($this->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                       ->SelectMethod(1)
                       ->doSelect();
        
        $tmp_tree = ''; # Cont Buffer;
        
        $num = $this->DFE->db->Rows;
        $x = 0;
        $list_level = 0;
        $this->PreImage = $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['PreImage'];
        $this->wrap = $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['Wrap'];
        $this->CSS = $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['CSS'];
        $this->MenuStartTag = "";
        
        foreach ($this->DFE->db->SelectPuffer as $mkey => $row) {

            if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]["PreLinkTags"] == "list" && $x == 0) {
                $this->MenuStartTag .= "<ul class=\"" . $this->CSS . "\">\n";
            }
            if ($x == 0) {
                $list_level = $row['level'];
                $main_level = $row['level'];
            }

            $this->URLType = $row['urltype'];
            $this->DocType = $row['docType'];
            $this->uid = $row['uid'];
            $this->pid = $row['pid'];
            $this->ButtonSet = $row['button'];
            $this->Pagename = $row['pagename'];
            $this->page_Hash = $row['page_Hash'];
            $this->TitleTag = htmlentities(stripslashes($row['link_title']), ENT_QUOTES, 'UTF-8');
            $this->Chields = $row['chields'];

            $pageSettings = unserialize($row['pageSettings']);
            $this->LinkCSS = !empty($pageSettings['LinkCSS']) ? $pageSettings['LinkCSS'] : '';
            if (strstr($pageSettings['LinkIcon'], '<') || !strstr($pageSettings['LinkIcon'], '/')) {
                $this->LinkIcon = $pageSettings['LinkIcon'] != "" ? stripslashes(base64_decode($pageSettings['LinkIcon'])) : "";
            } else {
                $this->LinkIcon = $pageSettings['LinkIcon'] != "" ? $pageSettings['LinkIcon'] : "";
            }

            $tmptree = '';

            if ($row['uid'] == $SP && $SP != "") {
                $transLevel = $row['level'] + 1;
            }

            if ($row['hidden'] != 1) {
                $this->Level = $row['level'];
            }

            if ($row['level'] > $list_level) {
                $this->Counter[$row['level']] = 1;
            } else {
                $this->Counter[$row['level']] = $this->Counter[$row['level']] + 1;
            }


            $this->FirstItem = $x == 0 ? 1 : 0;
            $this->LastItem = $maxRoot == $this->Counter[$main_level] ? 1 : 0;


            $nav_title = stripslashes($row['nav_title']);


            if ($row['level'] <= $GLOBALS['MenuConfig'][$this->MenuConfigPoint]["NameAttributesLevel"]) {
                switch ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]["NameAttributes" . $this->DocType]) {
                    case "normal": $this->NavigationTitle = $nav_title;
                        break;
                    case "ucf": $this->NavigationTitle = ucfirst($nav_title);
                        break;
                    case "lower": $this->NavigationTitle = mb_strtolower($nav_title, 'UTF-8');
                        break;
                    case "upper": $this->NavigationTitle = mb_strtoupper($nav_title, 'UTF-8');
                        break;

                    default:
                        $this->NavigationTitle = $nav_title;
                }
            } else {
                $this->NavigationTitle = $nav_title;
            }


            if (!empty($row['button_act_path'])) {
                $this->Path_to_ACT_Button = $row['button_act_path'];
            } else {
                $this->Path_to_ACT_Button = $row['button_path'];
            }
            $this->Path_to_NO_Button = $row['button_path'];

            if (!empty($row['target'])) {
                $target = ' target="' . $row['target'] . '"';
                $this->LinkTarget = $target;
                $this->Rel = 'rel="' . $row['target'] . '"';
            } else {
                $this->LinkTarget = "";
                $this->Rel = "";
            }

            $fileDoc = $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['FileDoc'] == "no" ? "" : ".html";
            if (!empty($row['url']) && $row['urltype'] != 0) {
                if (preg_match("/###dotlink-(.*)###(.*)/", stripslashes($row['url']), $url_arr)) {
                    $purl = $row['urltype'] != 7 ? $this->getTreePathNames($url_arr[1], '', 0, 1, 1, '', ' AND p.docType != 0 ') . $fileDoc : $this->getTreePathNames($this->uid, '', 0, 1, 1, '', ' AND p.docType != 0 ') . $fileDoc;
                    $this->PageURL = $purl . $url_arr[2];
                } else {
                    $purl = stripslashes($row['url']);
                    $this->PageURL = $purl;
                }
            } else {
                $purl = $this->getTreePathNames($this->uid, '', 0, 1, 1, '', ' AND p.docType != 0 ') . $fileDoc;
                $this->PageURL = $purl;
            }


            # Links holen
            $this->LinkURLType();

            if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]["PreLinkTags"] == "list") {

                $tmp_tree .= $row['level'] == $list_level && $x != 0 ? "</li>\n" : "";

                if ($row['level'] > $list_level) {
                    $tmp_tree .= "\n<ul" . str_replace("act-", "", str_replace("current", "", $this->LCSS)) . ">\n";
                    $tmptree .= "\n<ul" . $this->LCSS . ">\n";
                } else if ($row['level'] < $list_level) {
                    $tmp_tree .= "</li>\n";
                    $tmp_tree .= str_repeat("</ul></li>\n", $list_level - $row['level']);
                }
            }

            $tmp_tree .= $this->MenuButtons($this->MenuConfigPoint, $x, $blank);


            #if($_SERVER['REMOTE_ADDR'] == "217.249.46.60" || $_SERVER['REMOTE_ADDR'] == "")) {
            #echo $row['hidden']." - Chields: ".$row['chields']." - ".$this->NavigationTitle." row-Level: ".$row['level']." == List-Level: ".$list_level." - HL: ".$this->hiddenLinks." - Method: ".$t." - Html: ".htmlspecialchars($tmptree)." MAX: $maxRoot - Zähler: $x - Counter: ".$this->Counter[$row['level']]."<br />";
            #}

            $list_level = $row['level'];
            $x++;
        }
        if ($GLOBALS['MenuConfig'][$this->MenuConfigPoint]["PreLinkTags"] == "list") {
            $this->MenuEndTag = $lasttag . @str_repeat("</li>\n</ul>", $list_level - $GLOBALS['MenuConfig'][$this->MenuConfigPoint]['StartLevel']);
        }
        if ($num > 0) {
            return $tmp_tree;
        } else {
            return false;
        }
    }

    /*
     * Get tree path names
     *
     */

    public static function getTreePathNames($pid, $nextpath = '', $start = 0, $doc = 0, $title = 1, $lang = '', $and_dt = '', $noLang=false) {
        $db = \lib\Registry::getObj('db');
        $language = !empty($lang) ? $lang : $GLOBALS['LANGUAGE'];

        if ($language != SYS_LANGUAGE) {
            $Pages = "pages_language";
            $and_lang = "AND %%%n%%%lang = '" . $language . "'";
            $lang = "/" . $language;
        } else {
            $Pages = "pages";
            $and_lang = "";
            $lang = "";
        }
        $db->TablePreName = 'fe_';
        $db->Select("p.pagename, p.docType, p.nav_title, p.lft, p.rgt, n.lft AS nlft")
           ->From($Pages . " n, fe_" . $Pages . " p")
           ->noWhere(1)
           ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $and_lang) . $and_dt)
           ->Order("ORDER BY p.lft")
           ->Parameter($and_lang != '' ? array('uid' => intval($pid), 'lang' => $language) : array('uid' => intval($pid)))
           ->SelectMethod(1)
           ->doSelect();
        
        $num = $db->Rows;
        $tmp_tree = ''; # Cont Buffer;
        
        $x = 1;
        if($num) {
            if(is_array($db->SelectPuffer)) {
                foreach ($db->SelectPuffer as $key => $row) {
                    $sitename = $title == 1 ? $row['pagename'] : stripslashes($row['nav_title']);
                    if ($num > 1) {
                        $slash = $num == $x ? "" : "/";
                        $doctype = $doc == 0 && $num == $x ? ".html" : "";
                        $path .= ($row['docType'] == 0 ? $row['nav_title'] : $row['pagename']) . $slash . $doctype;
                        $slashp = '/';
                    } elseif ($num == 1) {
                        $doctype = $doc == 0 && $num == $x && $row['docType'] != 0 ? ".html" : "";
                        $path = ($row['docType'] == 0 ? $row['nav_title'] : $row['pagename']) . $doctype;
                        $slashp = $row['docType'] == 0 ? "" : "/";
                    }
                    $x++;
                }
                return $slashp . $path;
            } else {
                return '/';
            }
        } else {
            return '/';
        }
    }

}