<?php

namespace lib;

/*
  This file is a Library Class fileupload.

  This file is a part of the dot.orange CMS 2005.
  copyrights by it.orange (c).

  Author: Sascha Momcilovic
  E-Mail: info@it-orange.de
  www: http://www.it-orange.de
  Date: 04.11.2005
 */

class fileupload {
    

    public $dir;
    public $kb = "50000";
    public $UploadError;
    public $UploadNames = array();
    public $newFilename = '';
    public $holdFilename = 1;
    public $ErrorType;
    public $ErrorExtTypes = array("jpg", "JPG", "gif", "GIF", "png", "PNG", "pdf", "PDF", "doc", "DOC", "mp3", "avi", "AVI", "flv", "FLV", "jpeg", "JPEG", "xls", "XLS", "xml", "XML", "txt", "TXT", "css", "js", "swf", "tif", "TIF", "csv", "CSV", "zip", "ZIP", "kml", "KML", "mp4", "MP4", "webp");
    public $ImageWidth;
    public $ImageHeight;
    public $FileExt;
    public $getImageInfos = 0;
    public $minImageWidth;
    
    
    public function reArrayFiles($file_post) {
        
        $file_ary = array();
        $file_count = count($file_post['file']['name']);
        $file_keys = array_keys($file_post['file']);

        for ($i=0; $i<$file_count; $i++) {
            foreach ($file_keys as $key) {
                $file_ary[$i][$key] = $file_post['file'][$key][$i];
            }
        }
        
        return $file_ary;
        
    }
    
    public function fileUpload($file_dir) {

        $this->dir = $file_dir;
        $kb = $this->kb;
        $max_length = $kb * 1024;

        $i = 1;
        
        foreach ($_FILES as $key => $File) {
            
            $filename = $File['name'];
            $filesize = $File['size'];
            $fileMIME = $File['type'];
            $fileTemp = $File['tmp_name'];
            $filerror = $File['error'];
            $file_ext = explode(".", $filename);

            if ($this->getImageInfos == 1) {
                $this->setImageInfos($File);
            }


            $FType = count($file_ext) - 1;

            if ($filerror != 0) {
                switch ($filerror) {
                    # Error 3
                    case '4':
                    case UPLOAD_ERR_NO_FILE:
                        $this->UploadError[] = $i . ". File wurde nicht ausgewählt!";
                        $this->ErrorType = "3";
                        break;

                    # Error 1
                    case UPLOAD_ERR_INI_SIZE:
                    case UPLOAD_ERR_FORM_SIZE:
                        $this->UploadError[] = "Das " . $i . ". File ist zu groß! Das File darf maximal $kb kb haben!";
                        $this->ErrorType = "1";
                        break;

                    # Error 4
                    case UPLOAD_ERR_PARTIAL:
                        $this->UploadError[] = "Ein Fehler ist während des Uploads aufgetreten. Bitte versuch es noch einmal!";
                        $this->ErrorType = "4";
                        break;
                }
            } elseif (!in_array($file_ext[$FType], $this->ErrorExtTypes)) {
                # Error 2
                if ($fileerror != 4) {
                    $this->UploadError[] = "Falsche Dateiendung bei der Datei " . $i . ". !";
                    $this->ErrorType = "2";
                }
            } elseif ($filesize > $max_length) {
                # Error 1
                $this->ErrorType = "1";
                $this->UploadError[] = "Das " . $i . ". File ist zu groß! Das File darf maximal $kb kb haben!";
            } elseif ($this->getImageInfos == 1 && $this->minImageWidth <= $this->ImageWidth) {
                # Error 5
                $this->UploadError[] = "Das ist Bild ist zu klein! Es muss mehr als " . $this->minImageWidth . " Pixel breit sein!";
                $this->ErrorType = "5";
            } else {
                $ext = end($file_ext);
                $upload_file = $this->holdFilename == 1 ? \lib\Functions::fixUploadName(str_replace("." . $ext, "", $filename)) . "." . $ext : \lib\Functions::fixUploadName($this->newFilename) . "." . $ext;
                copy($fileTemp, $this->dir . $upload_file);
                $this->UploadNames[] = $upload_file;
            }
            $i++;
        } // ende foreach-Schleife
        return $this->UploadNames;
    }
    

    public function filesUpload($file_dir) {

        $this->dir = $file_dir;
        $kb = $this->kb;
        $max_length = $kb * 1024;

        $i = 1;
        
               
        $upload_files = $_FILES;
        $files_array = $this->reArrayFiles($upload_files);
        

        foreach ($files_array as $key => $File) {
            
            $filename = $File['name'];
            $filesize = $File['size'];
            $fileMIME = $File['type'];
            $fileTemp = $File['tmp_name'];
            $filerror = $File['error'];
            $file_ext = explode(".", $filename);

            if ($this->getImageInfos == 1) {
                $this->setImageInfos($File);
            }


            $FType = count($file_ext) - 1;

            if ($filerror != 0) {
                switch ($filerror) {
                    # Error 3
                    case '4':
                    case UPLOAD_ERR_NO_FILE:
                        $this->UploadError[] = $i . ". File wurde nicht ausgewählt!";
                        $this->ErrorType = "3";
                        break;

                    # Error 1
                    case UPLOAD_ERR_INI_SIZE:
                    case UPLOAD_ERR_FORM_SIZE:
                        $this->UploadError[] = "Das " . $i . ". File ist zu groß! Das File darf maximal $kb kb haben!";
                        $this->ErrorType = "1";
                        break;

                    # Error 4
                    case UPLOAD_ERR_PARTIAL:
                        $this->UploadError[] = "Ein Fehler ist während des Uploads aufgetreten. Bitte versuch es noch einmal!";
                        $this->ErrorType = "4";
                        break;
                }
            } elseif (!in_array($file_ext[$FType], $this->ErrorExtTypes)) {
                # Error 2
                if ($fileerror != 4) {
                    $this->UploadError[] = "Falsche Dateiendung bei der Datei " . $i . ". !";
                    $this->ErrorType = "2";
                }
            } elseif ($filesize > $max_length) {
                # Error 1
                $this->ErrorType = "1";
                $this->UploadError[] = "Das " . $i . ". File ist zu groß! Das File darf maximal $kb kb haben!";
            } elseif ($this->getImageInfos == 1 && $this->minImageWidth <= $this->ImageWidth) {
                # Error 5
                $this->UploadError[] = "Das ist Bild ist zu klein! Es muss mehr als " . $this->minImageWidth . " Pixel breit sein!";
                $this->ErrorType = "5";
            } else {
                $ext = end($file_ext);
                $upload_file = $this->holdFilename == 1 ? \lib\Functions::fixUploadName(str_replace("." . $ext, "", $filename)) . "." . $ext : \lib\Functions::fixUploadName($this->newFilename) . "." . $ext;
                copy($fileTemp, $this->dir . $upload_file);
                $this->UploadNames[] = $upload_file;
            }
            $i++;
        } // ende foreach-Schleife
        return $this->UploadNames;
    }

    public function setImageInfos($filename) {
        if ($arr = @getimagesize($filename)) {
            $this->ImageWidth = $arr[0];
            $this->ImageHeight = $arr[1];
            $this->FileExt = $arr[2];
        }
    }

    // End class
}

$fileHandle = new fileupload();