<?php

namespace lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   04.11.2005
 * @update: 27.05.2015
 *  
 */

class Image {

    /**
     * Image size
     * @var type integer
     */
    public $image_size = 100; 
    
    /**
     * Image folder
     * @var type string
     */
    public $image_ordner;   
    
    /**
     * Thumb folder
     * @var type string
     */
    public $thumb_ordner;  
    
    /**
     * Image extension like .jpg .png .gif
     * @var type string
     */
    public $image_ext;    
    
    /**
     * File extension
     * @var type string
     */
    public $file_extension = '';
    
    /**
     * Make thumb or not
     * @var type integer
     */
    public $makeThumb = 0; 
    
    /**
     * Old image width
     * @var type integer
     */
    public $width_old = '';
    
    /**
     * Old image height
     * @var type integer
     */
    public $height_old = '';
    
    /**
     * Old image path
     * @var type string
     */
    public $old_image;
    
    /**
     * New image path
     * @var type string
     */
    public $new_image;
    
    /**
     * Directory path
     * @var type string
     */
    public $dir;
    
    /**
     * Maximal kb
     * @var type integer
     */
    public $kb = "2000";
    
    /**
     * Upload errors
     * @var type array
     */
    public $UploadError = array();
    
    /**
     * Images names in a array
     * @var type array
     */
    public $ImageNames = array();
    
    /**
     * Use old image name or not
     * @var type integer
     */
    public $HoldImageName = 0;
    
    /**
     * Copy image or not
     * @var type integer
     */
    public $CopyOld = 0;
    
    /**
     * Compression
     * @var type integer
     */
    public $Compression = 100;
    
    /**
     * Image name
     * @var type string
     */
    public $Imagename = '';
    
    /**
     * New image name
     * @var type string
     */
    public $NewImageName = '';
    
    /**
     * Error
     * @var type integer
     */
    public $Error = 0;
    
    /**
     * Error types
     * @var type integer
     */
    public $ErrorType;
    
    /**
     * Image size
     * @var type integer
     */
    public $IMG_Size = '';
    
    /**
     * Make folders
     * @var type array
     */
    public $MakeFolders = array();

    
    public function ImageResize($filename = '') {
        if ($filename) {
            $this->filename = $filename;
            $this->loadImage($this->filename);
        }
    }

    public function loadImage($filename) {
        if ($arr = @getimagesize($filename)) {
            $this->width_old = $arr[0];
            $this->height_old = $arr[1];
            $this->image_ext = $arr[2];
        }
    }

    public function imageCreate($image_file = '') {

        switch ($this->HoldImageName) {
            case 0:
                $image_name = md5($image_file);
                $image_name = substr($image_name, 0, 6);
                break;

            case 1:
                #$image_name_string = explode(".", $this->Imagename);
                preg_match_all('%(.*?).(jpg|gif|png)%i', $this->Imagename, $treff_names);
                $image_name = \lib\Functions::updatePagename($treff_names[1][0], $GLOBALS['LANGUAGE']);
                $this->file_extension = $treff_names[2][0];
                break;

            case 2:
                $image_name = $this->NewImageName;
                break;
        }

        switch ($this->IMG_Size) {
            case "width":
                $width_new = intval($this->image_size);
                $height_new = (intval($this->height_old) * $width_new) / intval($this->width_old);
                $height_new = round($height_new);
                break;

            case "height":
                $height_new = $this->image_size;
                $width_new = intval($this->width_old * $height_new / $this->height_old);
                break;

            default:
                if ($this->width_old > $this->height_old) {
                    $width_new = $this->image_size;
                    $height_new = intval($this->height_old * $width_new / $this->width_old);
                } else {
                    $height_new = $this->image_size;
                    $width_new = intval($this->width_old * $height_new / $this->height_old);
                }
        }

        if ($this->image_ext == 1) {
            // Gif is the same
        }
        if ($this->thumb_ordner == $this->image_ordner) {
            $opt_name = "_thumb";
        }

        if ($this->image_ext == 2) {
            if (!empty($this->file_extension)) {
                $extension = $this->file_extension;
            } else {
                $extension = "jpg";
            }

            $old_picture = ImageCreateFromJPEG($this->old_image);
            $new_picture = imagecreatetruecolor($width_new, $height_new);
            imagecopyresampled($new_picture, $old_picture, 0, 0, 0, 0, $width_new, $height_new, $this->width_old, $this->height_old);
            ImageJPEG($new_picture, $this->thumb_ordner . $image_name . $opt_name . "." . $extension, $this->Compression);
            if ($this->CopyOld == 1) {
                ImageJPEG($old_picture, $this->image_ordner . $image_name . $opt_name . "." . $extension, 100);
            }
            $this->destroy_image($old_picture, $new_picture);
        }

        if ($this->image_ext == 3) {
            if (!empty($this->file_extension)) {
                $extension = $this->file_extension;
            } else {
                $extension = "png";
            }
            $old_picture = ImageCreateFromPNG($this->old_image);
            $new_picture = imagecreatetruecolor($width_new, $height_new);
            $bgc = ImageColorAllocate($new_picture, 255, 255, 255);
            ImageFilledRectangle($new_picture, 0, 0, $width_new, $height_new, $bgc);
            $color['lime'] = imagecolorallocate($old_picture, 0x00, 0xFF, 0x00);
            #imagecolortransparent($old_picture, imagecolorallocate($old_picture, 0, 0, 0));
            imagecolortransparent($old_picture, $color['lime']);
            imagealphablending($old_picture, false);
            imagesavealpha($old_picture, true);
            imagecopyresampled($new_picture, $old_picture, 0, 0, 0, 0, $width_new, $height_new, $this->width_old, $this->height_old);
            ImagePNG($new_picture, $this->thumb_ordner . $image_name . $opt_name . "." . $extension);

            $this->destroy_image($old_picture, $new_picture);
        }

        return $image_name . $opt_name . "." . $extension;
    }

    /*
     * Image Upload Methode
     *
     */

    public function imageUpload($img_nr, $thumb_dir, $img_dir) {

        $this->dir = $img_dir;
        $kb = $this->kb;
        $max_length = $kb * 1024;

        $num_files = count($_FILES);

        $i = 1;

        foreach ($_FILES as $fieldname => $File) {
            $filename = $File['name'];
            $filesize = $File['size'];
            $fileMIME = $File['type'];
            $fileTemp = $File['tmp_name'];
            $filerror = $File['error'];
            $file_ext = explode(".", $filename);
            
            $FileInfo = getimagesize($File['tmp_name']);
            if(empty($FileInfo)) {
                $filerror = 5;
            }

            # Init Extension
            $this->file_extension = end($file_ext);
            if ($filerror != 0) {
                switch ($filerror) {
                    // error 1 & 4
                    case '4':
                    case UPLOAD_ERR_NO_FILE:
                        $this->UploadError[] = $i . ". Bild wurde nicht ausgewählt!";
                        $this->ErrorType = "3";
                        $this->Error = 1;
                        break;

                    /// error 2
                    case UPLOAD_ERR_INI_SIZE:
                    case UPLOAD_ERR_FORM_SIZE:
                        $this->UploadError[] = "Das " . $i . ". Bild ist zu groß! Das Bild darf maximal $kb kb haben!";
                        $this->ErrorType = "1";
                        $this->Error = 1;
                        break;

                    //// error 3
                    case UPLOAD_ERR_PARTIAL:
                        $this->UploadError[] = "Ein Fehler ist während des Uploads aufgetreten. Bitte versuch es noch einmal!";
                        $this->Error = 1;
                        $this->ErrorType = "4";
                        break;
                    
                    case 5:
                        $this->UploadError[] = "Sie laden kein Bild hoch. Bitte überprüfen Sie das Format!";
                        $this->Error = 1;
                        $this->ErrorType = "5";
                        break;
                }
            } elseif (!preg_match('/(jpg|jpeg|png|gif)/i', $filename, $resext)) {
                if ($fileerror != 4) {
                    $this->UploadError[] = "Falsche Dateiendung bei Bild " . $i . ". !";
                    $this->Error = 1;
                    $this->ErrorType = "2";
                }
            } elseif ($filesize > $max_length) {
                $this->Error = 1;
                $this->ErrorType = "1";
                $this->UploadError[] = "Das " . $i . ". Bild ist zu groß! Das Bild darf maximal $kb kb haben!";
            } else {
                if ($this->HoldImageName == 0) {
                    if (empty($img_nr)) {
                        $img_nr = uniqid(rand());
                    }
                    $file_string = md5($img_nr);
                    $file_name = substr($file_string, 0, 6);
                    $upload_image = $file_name . "." . $file_ext[1];
                } else {
                    preg_match_all('%(.*?).(jpg|gif|png)%i', $filename, $treff_names);
                    $image_name = \lib\Functions::updatePagename($treff_names[1][0], $GLOBALS['LANGUAGE']);
                    $upload_image = $image_name . "." . $treff_names[2][0];
                    #$file_name = \lib\Functions::UploadFileName($filename);
                }

                if (!empty($this->MakeFolders)) {
                    foreach ($this->MakeFolders as $key => $val) {
                        if (!file_exists($val)) {
                            @mkdir($val);
                            @chmod($val, 0777);
                        }
                    }
                }

                # Make folder if not exits
                if (!file_exists($this->dir)) {
                    @mkdir($this->dir);
                    @chmod($this->dir, 0777);
                }

                copy($fileTemp, $this->dir . $upload_image);
                if ($this->makeThumb == 1) {
                    if (($file_ext[1] != "gif") && ($file_ext[1] != "GIF")) {
                        $this->old_image = $this->dir . $upload_image;
                        $size = getimagesize($this->old_image);
                        $this->width_old = $size[0];
                        $this->height_old = $size[1];
                        $this->HoldImageName = 1;
                        $this->Imagename = $upload_image;
                        $this->image_ext = $size[2];
                        $this->thumb_ordner = $thumb_dir;

                        $this->imageCreate($upload_image);
                    }
                }
                $this->ImageNames[] = $upload_image;
            }
            $i++;
            unset($img_nr);
        } // ende foreach-Schleife
        if ($this->Error != 1) {
            return $this->ImageNames;
        } else {
            return false;
        }
    }

    public function upload_error($error) {
        $this->UploadError[] = $error;
        #echo "<br><p>$error_upload</p>";
    }

    public function destroy_image($oldimg, $newimg) {
        imagedestroy($oldimg);
        imagedestroy($newimg);
    }
    
    public function __destruct() {
        $this->image_size = 100; 
        $this->image_ordner;  
        $this->thumb_ordner;   
        $this->image_ext;    
        $this->file_extension = ''; 
        $this->makeThumb = 0; 
        $this->width_old = '';
        $this->height_old = '';
        $this->old_image;
        $this->new_image;
        $this->dir;
        $this->kb = "2000";
        $this->UploadError = array();
        $this->ImageNames = array();
        $this->HoldImageName = 0; 
        $this->CopyOld = 0;
        $this->Compression = 100;
        $this->Imagename = '';
        $this->NewImageName = '';
        $this->Error = 0;
        $this->ErrorType;
        $this->IMG_Size = '';
        $this->MakeFolders = array();
       
    }

    public function Debug() {
        echo '<pre>';
        print_r($this);
        echo '</pre>';
    }
}