<?php

namespace lib\database;


/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   26.10.2006
 * @update: 30.04.2015
 */

require_once(DOC_ROOT . '/lib/exception/class.mysql_exception.php');


class mysql {
    
    # Variablendefinitionen
    private $db_conn_id;
    private $used_db;
    public $result;
    public $NumRows;
    public $num_fields;
    public $sqlError = "";
    public $sql;

    /*
     * Connect to datbase
     *
     */

    public function __construct() {

        try {
            if (!$this->db_conn_id = @mysql_connect(DB_HOST, DB_USER, DB_PASSWORD)) {
                throw new \lib\exception\MySQLException('MySQL Verbindungsfehler: Host, Username oder Passwort falsch!');
            } else {
                try {
                    $this->used_db = mysql_select_db(DB_NAME);
                    if ($this->used_db) {
                        mysql_set_charset("utf8");
                        mysql_query("SET NAMES 'utf8'", $this->db_conn_id);
                    } else {
                        throw new \lib\exception\MySQLException('MySQL Fehler: Datenbank kann nicht genutzt werden. Datenbank fehlt!');
                    }
                } catch (\lib\exception\MySQLException $e) {
                    echo $e->showExceptionInfo();
                    exit();
                }
            }
        } catch (MySQLException $e) {
            echo $e->showExceptionInfo();
            exit();
        } catch (Exception $e) {
            echo 'Catching default exceptions...<br />';
            echo 'Exception message: ' . $e->getMessage() . '<br />';
            echo 'Source filename of exception: ' . $e->getFile() . '<br />';
            echo 'Source line of exception: ' . $e->getLine() . '<br />';
            echo 'Code: ' . $e->getCode();
            exit();
        }
    }

    public function sql_query() {
        $this->result = mysql_query($this->sql, $this->db_conn_id);
        if (mysql_error()) {
            $this->sql_error("Fehler query!");
        } else {
            if (is_resource($this->result)) {
                return true;
            } else {
                return false;
            }
        }
    }

    public function sql_save_query() {
        if (is_resource($this->db_conn_id)) {
            $this->result = mysql_query($this->sql, $this->db_conn_id);
            if (mysql_error()) {
                $this->sqlError = "save";
                $this->sql_error("Update/Insert Fehler!");
            }
        }
    }

    public function num_rows() {
        $this->NumRows = mysql_num_rows($this->result);
        if (mysql_error()) {
            $this->sql_error("Fehler rows!");
        } else {
            return $this->NumRows;
        }
    }

    public function insert_id() {
        if (is_resource($this->db_conn_id)) {
            return mysql_insert_id($this->db_conn_id);
        }
    }

    public function sql_fetch_array() {
        $content = @mysql_fetch_array($this->result);
        $this->error = mysql_error();
        return $content;
    }

    public function sql_error($msg) {
        global $mail;

        $code = @mysql_errno($this->db_conn_id);
        $error = @mysql_error($this->db_conn_id);
        $error_text = " [$msg] $code : $error <br>" . $this->sql . "<br><br>IP-Adresse: " . $_SERVER['REMOTE_ADDR'] . "<br>Client: " . $_SERVER['HTTP_USER_AGENT'];


        # Fehler wird an it.orange versendet
        $mail->From = MASTERMAIL_ADDRESS;
        $mail->FromName = MASTERMAIL_NAME;
        $mail->Subject = "SQL-Fehler von " . MASTERMAIL_NAME;
        $mail->Mailer = "mail";
        $mail->CharSet = "utf8";

        $mail->Body = $error_text;
        $mail->Body .= "<br /><br />" . $_SERVER['REQUEST_URI'];
        $mail->AltBody = strip_tags(str_replace("<br />", "\n", $mail->Body));
        $mail->AddAddress("info@it-orange.de", "info@it-orange.de");
        $mail->Send();

        # Clear all addresses and attachments for next loop
        $mail->ClearAddresses();
        if ($this->sqlError == "save") {
            exit;
        }
    }

    /*
     * Close database
     *
     */

    public function __destruct() {
        if (is_resource($this->db_conn_id)) {
            mysql_close($this->db_conn_id);
        }
    }
}