<?php

namespace lib\database;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   26.10.2005
 * @update: 06.07.2015
 */

class mysql_functions extends mysql {

    public $TableName;
    public $NumFields;
    public $SelectAs;
    public $RowNames;
    public $TablePre;
    public $SelectPuffer;
    public $TablePreName = TABLE_PRE_NAME;
    public $InsertValuesNames;
    public $SelectPufferString;
    public $LastInsertID;
    public $Rows;

    /*
     * MySQL Fetch Field
     *
     */

    public function fetchField($TableName) {
        $this->sql = "  SELECT *
			FROM " . $this->TablePreName . $TableName . "
			LIMIT 1";
        $this->sql_query();
        $this->fields($this->result);
        for ($i = 0; $i < $this->NumFields; $i++) {
            $this->RowNames[] = @mysql_field_name($this->result, $i);
        }
        $this->selectAs();
        @mysql_free_result($this->result);
    }

    public function fields($result) {
        $this->NumFields = @mysql_num_fields($result);
    }

    public function selectAs() {
        $ko = 1;
        foreach ($this->RowNames as $kea => $val) {
            $sep = $ko == $this->NumFields ? "" : ", ";
            $stringAsArray[] = $val . " AS " . str_replace($this->TablePre, "", $val) . $sep;
            $ko++;
        }
        $this->SelectAs = implode("", $stringAsArray);
    }

    /**
     * Build insert names
     * @param type $TableName
     * @return string
     */
    public function InsertValues($TableName) {
        $this->fetchField($TableName);
        $ko = 1;
        foreach ($this->RowNames as $kea => $val) {
            $sep = $ko == $this->NumFields ? "" : ", ";
            $stringInsArray[] = $val . $sep;
            $ko++;
        }
        $insval = implode("", $stringInsArray);
        $insval = "(" . $insval . ")";
        $this->InsertValuesNames = $insval;
        return $insval;
    }
    
    
    /**
     * Build values for insert
     * @param type $TableName
     * @param type $array
     * @return string
     */
    public function ValuesForInsert($TableName, $array) {
        $this->fetchField($TableName);
        $ko = 1;
        foreach ($this->RowNames as $kea => $val) {
            $sep = $ko == $this->NumFields ? "" : ", ";
            $ivalue = $array[$val] == 'NOW()' ? "".$array[$val] ."" : "'". mysql_real_escape_string(stripslashes($array[$val])) ."'";
            $valueArray[] = $ivalue . $sep;
            $ko++;
        }
        $insert_val = implode("", $valueArray);
        $insert_val = "(" . $insert_val . ")";
        return $insert_val;
    }

    /*
     * MySQL Select + Auto Insert String
     *
     */

    public function Select($RN = '*', $TableName, $TableRowName, $ID, $And = '', $AutoIncrement = 0, $Join = '', $Order = '', $Limit = '', $SelectMethod = 0, $is = '', $noWhere = 0, $zusatz = '') {
        global $dbg_aribu;

        $this->ClearAll();
        $sql_is = !empty($is) ? $is : " =";
        $Where = $noWhere != 1 ? "WHERE " . $TableRowName . $sql_is . " '" . $ID . "'" : "";

        if ($zusatz != "") {
            $this->sql = $zusatz;
            $this->sql_query();
        }

        $this->sql = "	SELECT " . $RN . "
			FROM " . $this->TablePreName . $TableName . "
			" . $Join . "
			" . $Where . "
			" . $And . "
			" . $Order . "
			" . $Limit . "";

        $query = $this->sql_query();

        $this->Rows = $query === true ? $this->num_rows() : $query;

        if ($SelectMethod == 0) {
            $this->SelectPuffer = @mysql_fetch_assoc($this->result);
        } elseif ($SelectMethod == 1) {
            # Method for more hits
            # Clear SelectPuffer
            $this->ClearAll();
            while ($row = @mysql_fetch_assoc($this->result)) {
                $this->SelectPuffer[] = $row;
            }
        } elseif ($SelectMethod == 2) {
            $this->SelectPuffer = @mysql_fetch_row($this->result);
        }

        if ($AutoIncrement == 1) {
            $this->fields($this->result);
            $ko = 1;
            foreach ($this->SelectPuffer as $key => $val) {
                $sep = $ko == $this->NumFields ? "" : ", ";
                if ($AutoIncrement == 1 && $ko == 1) {
                    $SelectPufferStringArray[] = "''" . $sep;
                } else {
                    $SelectPufferStringArray[] = "'" . $val . "'" . $sep;
                }
                $ko++;
            }
            $this->SelectPufferString = "(" . implode($SelectPufferStringArray) . ")";
        }

        # Debug
        if (method_exists($dbg_aribu, 'addMySQLSelect')) {
            $dbg_aribu->addMySQLSelect($this->sql);
        }

        return $this->sql;
    }
    
    
    public function DummySelect($RN = '*', $TableName, $TableRowName, $ID, $And = '', $AutoIncrement = 0, $Join = '', $Order = '', $Limit = '', $SelectMethod = 0, $is = '', $noWhere = 0, $zusatz = '') {
        
        $this->ClearAll();
        $sql_is = !empty($is) ? $is : " =";
        $Where = $noWhere != 1 ? "WHERE " . $TableRowName . $sql_is . " '" . $ID . "'" : "";

        if ($zusatz != "") {
            $this->sql = $zusatz;
            $this->sql_query();
        }

        $this->sql = "	SELECT " . $RN . "
			FROM " . $this->TablePreName . $TableName . "
			" . $Join . "
			" . $Where . "
			" . $And . "
			" . $Order . "
			" . $Limit . "";

        
        return $this->sql;
    }

    /*
     * Given MySQL Select
     *
     */

    public function GSelect($query) {
        $this->sql = $query;
        $this->sql_query();
        $this->Rows = $this->num_rows();
        $this->ClearAll();
        while ($row = @mysql_fetch_assoc($this->result)) {
            $this->SelectPuffer[] = $row;
        }
        return $this->sql;
    }

    /*
     * Returns the MySQL-Statement
     *
     */

    public function sqlReturn($RN = '*', $TableName, $TableRowName, $ID, $And = '', $AutoIncrement = 0, $Join = '', $Order = '', $Limit = '', $SelectMethod = 0) {
        $this->sql = "  SELECT " . $RN . "
						FROM " . $this->TablePreName . $TableName . "
						" . $Join . "
						WHERE " . $TableRowName . "='" . $ID . "'
						" . $And . "
						" . $Order . "
						" . $Limit . "";
        return $this->sql;
    }

    /*
     * MySQL Update + Auto Select auf die Tabelle
     *
     */

    public function Update($TableName, $ID, $SET, $TableRowName, $AutoSelect = 1, $And = '', $Where = '', $SetOpt = 1, $operator = "=", $ignore='') {

        global $dbg_aribu;

        $cSET = count($SET);
        $ko = 1;
        foreach ($SET as $key => $val) {
            $sep = $ko == $cSET ? "" : ", ";
            if ($val == 'NOW()' || $val == 'counter+1') {
                $nSET[] = $key . " = " . $val . $sep;
            } else {
                if ($SetOpt == 1) {
                    if($val == 'NULL') {
                        $nSET[] = $key . " = " . mysql_real_escape_string(stripslashes($val)) . "" . $sep;
                    } else {
                        $nSET[] = $key . " = '" . mysql_real_escape_string(stripslashes($val)) . "'" . $sep;
                    }
                } else {
                    $nSET[] = $key . " = " . mysql_real_escape_string(stripslashes($val)) . $sep;
                }
            }
            $ko++;
        }
        $nSET = implode("", $nSET);
        $whereClause = $Where == '' ? "WHERE " . $TableRowName . " " . $operator . " '" . $ID . "'" : $Where;
        $this->sql = "	UPDATE " . $ignore . $this->TablePreName . $TableName . "
						SET " . $nSET . "
						" . $whereClause . "
						" . $And . "";
        $this->sql_save_query();
        if ($AutoSelect == 1) {
            $this->Select('*', $TableName, $TableRowName, $ID, '', 1, '', '', '', 0);
        }

        # Debug
        if (method_exists($dbg_aribu, 'addMySQLUpdate')) {
            $dbg_aribu->addMySQLUpdate($this->sql);
        }

        return $this->sql;
    }

    /*
     * MySQL Insert + Auto Select Anweisung
     *
     */

    public function Insert($TableName, $Values, $AutoIncrement = 1, $AutoSelect = 0, $TableRowName = '', $ignore = '') {
        global $dbg_aribu;

        if (is_array($Values) && count($Values) != 0) {
            $ko = 1;
            foreach ($Values as $key => $val) {
                $sep = $ko == count($Values) ? "" : ", ";
                if ($AutoIncrement == 1 && $ko == 1) {
                    $SelectPufferStringArray[] = "''" . $sep;
                } else {
                    if ($val == 'NOW()' || $val == 'NULL') {
                        $SelectPufferStringArray[] = $val . $sep;
                    } else {
                        $SelectPufferStringArray[] = "'" . mysql_real_escape_string(stripslashes($val)) . "'" . $sep;
                    }
                }
                $ko++;
            }
            $this->SelectPufferString = "(" . implode($SelectPufferStringArray) . ")";
        }
        $this->ClearAll();
        $this->sql = "INSERT ".$ignore."INTO " . $this->TablePreName . $TableName . " " . $this->InsertValues($TableName) . " VALUES " . $this->SelectPufferString . "";
        $this->sql_save_query();
        $this->LastInsertID = $this->insert_id();
        if ($AutoSelect == 1) {
            $this->SelectLastID($TableName, $this->LastInsertID, $TableRowName);
        }

        # Debug
        if (method_exists($dbg_aribu, 'addMySQLInsert')) {
            $dbg_aribu->addMySQLInsert($this->sql);
        }

        return $this->sql;
    }
    
    public function SInsert($TableName, $Values, $AutoIncrement = 1, $AutoSelect = 0, $TableRowName = '', $ignore = '') {
        global $dbg_aribu;

        $this->ClearAll();
        $insert_values = $this->ValuesForInsert($TableName, $Values);
        $this->sql = "INSERT ".$ignore."INTO " . $this->TablePreName . $TableName . " " . $this->InsertValues($TableName) . " VALUES " . $insert_values . "";
        $this->sql_save_query();
        $this->LastInsertID = $this->insert_id();
        if ($AutoSelect == 1) {
            $this->SelectLastID($TableName, $this->LastInsertID, $TableRowName);
        }

        # Debug
        if (method_exists($dbg_aribu, 'addMySQLInsert')) {
            $dbg_aribu->addMySQLInsert($this->sql);
        }

        return $this->sql;
    }

    /*
     * MySQL Last ID
     *
     */

    public function SelectLastID($TableName, $ID, $TableRowName) {
        $this->sql = "SELECT *
							FROM " . $this->TablePreName . $TableName . "
							WHERE " . $TableRowName . " = '" . $ID . "'";
        $this->sql_query();
        $this->SelectPuffer = @mysql_fetch_assoc($this->result);
    }

    /*
     * MySQL Delete
     *
     */

    public function Delete($TableName, $Where, $ID, $TableRowName, $And = '') {
        global $dbg_aribu;

        $whereClause = $Where == '' ? "WHERE " . $TableRowName . "='" . $ID . "' " . $And . "" : $Where;
        $this->sql = "DELETE FROM " . $this->TablePreName . $TableName . " " . $whereClause . "";
        $this->sql_query();

        # Debug
        if (method_exists($dbg_aribu, 'addMySQLDelete')) {
            $dbg_aribu->addMySQLDelete($this->sql);
        }
        return $this->sql;
    }

    public function ClearAll() {
        unset($this->InsertValuesNames);
        unset($this->RowNames);
        unset($this->SelectPuffer);
    }

    public function ClearPuffer() {
        unset($this->SelectPuffer);
    }

}

$register = \lib\Registry::setObj('db', new mysql_functions);
$db = \lib\Registry::getObj('db');