<?php

namespace lib\database\pdo;

/* 
 * aribu system - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   21.04.2018
 *  
 */

class DBFunctions extends DB {
    
    public $Statement;
    public $CachedStatement;
    public $NumFields;
    public $SelectAs;
    public $RowNames;
    public $TablePre;
    public $SelectPuffer;
    public $TablePreName = TABLE_PRE_NAME;
    public $InsertValuesNames;
    private $ValuesString = '';
    private $ColNameString = '';
    private $SetString = '';
    public $LastInsertID;
    public $Rows;
    public $DBResult;
    
    /**
     * Preparing statement
     * 
     * @var string
     */
    private $Show;
    private $Describe;
    private $Ignore;
    private $Select;
    private $From; 
    private $WhereColName; 
    private $WhereColValue; 
    private $And;
    private $Joins;
    private $Order = ''; 
    private $Limit = '';
    private $Having;
    private $SelectMethod;
    private $Operator;
    private $noWhere=0;
    private $AddQuery;
    private $Parameter = array();
    private $Set = array();
    private $Truncate;
    private $Alter;
    private $setAlter = '';
    private $Group;
    private $SetType = true;
    private $Union;





    public function __construct($DBHost, $DBName, $DBUser, $DBPassword, $DBPort) {
        parent::__construct($DBHost, $DBName, $DBUser, $DBPassword, $DBPort);
    }
    
    public function Show() {
        $this->Show = 'SHOW ';
        return $this;
    }
    
    public function Describe() {
        $this->Describe = 'DESCRIBE ';
        return $this;
    }
    
    public function Ignore() {
        $this->Ignore = 'IGNORE';
        return $this;
    }
    
    public function Truncate() {
        $this->Truncate = 'TRUNCATE TABLE ';
        return $this;
    }
    
    public function Alter() {
        $this->Alter = 'ALTER TABLE ';
        return $this;
    }
    
    public function setAlter($string) {
        if(is_string($string)) {
            $this->setAlter = $string;
        }
        return $this;
    }
    
    public function Table($value) {
        $this->From($value);
        return $this;
    }
    
    public function Select($value) {
        $this->Select = $value;
        return $this;
    }
    
    public function From($value) {
        $this->From = $value;
        return $this;
    }
    
    public function WhereColName($value) {
        $this->WhereColName = $value;
        return $this;
    }
    
    public function WhereColValue($value) {
        $this->WhereColValue = $value;
        return $this;
    }
    
    public function Andd($value) {
       $this->And = $value;
       return $this;
    }
    
    public function Joins($value) {
        $this->Joins = $value;
        return $this;
    }
    
    public function Order($value) {
        $this->Order = $value;
        return $this;
    }
    
    public function Limit($value) {
        $this->Limit = $value;
        return $this;
    }
    
    public function Having($value) {
        $this->Having = $value;
        return $this;
    }
    
    public function Union($value) {
        $this->Union = $value;
        return $this;
    }
    
    public function SelectMethod($value) {
        $this->SelectMethod = intval($value);
        return $this;
    }
    
    public function Operator($value) {
        $this->Operator = $value;
        return $this;
    }
    
    public function noWhere($value) {
        $this->noWhere = intval($value);
        return $this;
    }
    
    public function AddQuery($value) {
        $this->AddQuery = $value;
        return $this;
    }
    
    public function Group($value) {
        $this->Group = $value;
        return $this;
    }
    
    public function Insert($value) {
        $this->From($value);
        return $this;
    }
    
    public function Delete($value) {
        $this->From($value);
        return $this;
    }
    
    public function Update($value) {
        $this->From($value);
        return $this;
    }
    
    public function Parameter(array $parameter) {
        if(count($parameter) > 0) {
            if(!empty($this->Parameter)) {
                $this->Parameter = array_merge($this->Parameter, $parameter);
            } else {
                $this->Parameter = $parameter;
            }
        }
        return $this;
    }
    
    public function Set(array $array) {
        $this->Set = $array;
        return $this;
    }
    
    public function SetType($value) {
        $this->SetType = $value;
        return $this;
    }
    
    public function Where() {
        $this->Operator = !empty($this->Operator) ? $this->Operator : " =";
        $Where = $this->noWhere != 1 ? "WHERE " . $this->WhereColName . $this->Operator . " :".$this->GetRawName() : "";

        if($this->noWhere != 1) {
            $this->Parameter[$this->GetRawName()] = $this->WhereColValue;
        }
        return $Where;
    }
    
    public function GetRawName() {
        $RawName = explode(".",$this->WhereColName);
        return end($RawName);
    }
    
    public function Get($table, $WhereColName='', $WhereColValue='') {
        $this->Select('*')
             ->From($table)
             ->SelectMethod(1);
        if(!empty($WhereColName) && !empty($WhereColValue)) {
            $this->WhereColName($WhereColName)
                 ->WhereColValue($WhereColValue);    
        } else {
            $this->noWhere(1);
        }
        
        $this->doSelect();
    }
    
    public function doCachedSelect($AddSQL) {
        $this->Statement = $this->CachedStatement;
        $this->Statement .= $AddSQL;
        
        $Query = $this->Query($this->Statement, $this->Parameter);
        
        $this->Rows = $Query === true ? $this->CountRows() : $Query;
        $this->ClearPuffer();
        if ($this->SelectMethod == 0) {
            $this->SelectPuffer = $this->ObjQuery->fetch(\PDO::FETCH_ASSOC);
        } elseif ($this->SelectMethod == 1) {
            $this->SelectPuffer = $this->ObjQuery->fetchAll(\PDO::FETCH_ASSOC);
            
        } elseif ($this->SelectMethod == 2) {
            $this->SelectPuffer = $this->ObjQuery->rowCount();
        }
        $this->ClearAll();
    }
    
    public function doSelect($CacheStatement=false) {   
        
        $this->Statement = '';
        $this->Statement = "	SELECT " . $this->Select . "
                                FROM " . $this->TablePreName . $this->From . "
                                " . $this->Joins . "
                                " . $this->Where() . "
                                " . $this->And . "
                                " . $this->Group . " 
                                " . $this->Union . "
                                " . $this->Having . " 
                                " . $this->Order . "
                                " . $this->Limit . "";
        $this->CachedStatement = $CacheStatement === true ? $this->Statement : '';
        $Query = $this->Query($this->Statement, $this->Parameter);
        
        $this->Rows = $Query === true ? $this->CountRows() : $Query;
        $this->ClearPuffer();
        if ($this->SelectMethod == 0) {
            $this->SelectPuffer = $this->ObjQuery->fetch(\PDO::FETCH_ASSOC);
        } elseif ($this->SelectMethod == 1) {
            $this->SelectPuffer = $this->ObjQuery->fetchAll(\PDO::FETCH_ASSOC);       
        } elseif ($this->SelectMethod == 2) {
            $this->SelectPuffer = $this->ObjQuery->rowCount();
        }
        $this->ClearAll();
    }
    
    public function getOne($Col, $Table, $WhereColName, $WhereColValue, $Andd='', $Parameter=array()) {
        $this->Select($Col)
             ->From($Table)
             ->WhereColName($WhereColName)
             ->WhereColValue($WhereColValue)
             ->Andd($Andd)  
             ->Parameter($Parameter)
             ->doSelect();
        return $this->SelectPuffer[$Col];
    }
    
    public function doInsert() {
        $this->PrepareParameterForInsert();       
        $this->Statement = '';
        $this->Statement = "INSERT " . $this->Ignore . "INTO " . $this->TablePreName . $this->From . " " . $this->ColNameString . "VALUES " . $this->ValuesString;
        
        $Query = $this->Query($this->Statement, $this->Parameter);
        $this->LastInsertID = $this->lastInsertId();
        $this->ClearAll();
    }
    
    public function doUpdate() {
        $this->PrepareParameterForUpdate();
        $this->Statement = '';
        $this->Statement = "UPDATE " . $this->Ignore . " " . $this->TablePreName . $this->From . " SET " . $this->SetString . " " . $this->Where() . " " . $this->And;
        if(is_array($this->Parameter) && is_array($this->Set)) {
            $Parameter = array_merge($this->Parameter,$this->Set);
        } else {
            if(!is_array($this->Parameter) && is_array($this->Set)) {
                $Parameter = $this->Set;
            }
        }
        $Query = $this->Query($this->Statement, $Parameter);
        $this->ClearAll();
    }
    
    public function doDelete() {
        $this->Statement = '';
        $this->Statement = "DELETE FROM " . $this->TablePreName . $this->From . " " . $this->Where() . " " . $this->And;
        $Query = $this->Query($this->Statement, $this->Parameter);
        $this->ClearAll();
    }
    
    public function doTruncate() {
        $this->Statement = '';
        $this->Statement = $this->Truncate . $this->TablePreName . $this->From; 
        $Query = $this->Query($this->Statement, $this->Parameter);
        $this->ClearAll();
    }
    
    public function doAlter() {
        $this->Statement = '';
        $this->Statement = $this->Alter . $this->TablePreName . $this->From . " " . $this->setAlter;
        $Query = $this->Query($this->Statement, $this->Parameter);
        $this->ClearAll();
    }
    
    public function Import($sqlfile) {
        $parser = new SqlScriptParser();
        $sqlStatements = $parser->parse($sqlfile);
        foreach ($sqlStatements as $statement) {
            $distilled = $parser->removeComments($statement);
            if (!empty($distilled)) {        
                $Query = $this->Query($distilled, array());
            }
        }
        
        $this->ClearAll();
    }
    
    public function PrepareParameterForInsert() {
        if (is_array($this->Parameter) && count($this->Parameter) > 0) {
            $ko = 1;
            $ValuesArray = array();
            $ColNameArray = array();
            foreach ($this->Parameter as $key => $val) {
                $co = $ko == count($this->Parameter) ? "" : ", ";
                array_push($ValuesArray, ':'.$key.$co);
                array_push($ColNameArray, $key.$co);
                $ko++;
            }
          
            $this->ValuesString = "(" . implode($ValuesArray) . ")";
            $this->ColNameString = "(" . implode($ColNameArray) . ")";            
        }
    }
    
    public function PrepareParameterForUpdate() {      
        $this->SetString = '';
        $ko=1;
        $dp = $this->SetType === true ? ':' : '';
        $co = "";
        $SetCount = count($this->Set);
        foreach($this->Set as $ukey => $uval) {
            $co = $ko == $SetCount ? "" : ", ";
            $this->SetString .= $this->SetType === true ? ($uval != 'NOW()' ? $ukey.' = '.$dp.$ukey.$co : $ukey . ' = ' . $uval.$co) : $ukey.' = '.$uval.$co;
            if($uval == 'NOW()' && $this->SetType === true) {
                unset($this->Set[$ukey]);
            }
            $ko++;
        }
        if($this->SetType === false) {
            unset($this->Set);
            $this->Set(array());
        }
    }
    
    public function GetParameter() {
        return $this->Parameter;
    }
    
        
    public function ClearAll() {
        
        $this->Select('')->From('')->WhereColName('')->WhereColValue('')->Andd('')->Joins('')->Order('')->Group('')->Limit('')->Having('')->SelectMethod(0)->noWhere(0)->Operator('')->AddQuery('')->Parameter(array())->Set(array())->SetType(true)->Union('');
        $this->Show = '';
        $this->Describe = '';
        $this->Ignore = '';
        $this->Truncate = '';
        $this->Alter = '';
        $this->ValuesString = '';
        $this->ColNameString = '';
        $this->SetString = '';
        $this->setAlter = '';
        
        unset($this->Parameter);
        unset($this->Set);
        
    }

    public function ClearPuffer() {
        unset($this->SelectPuffer);
    }
    
}

\lib\Registry::setObj('db', new DBFunctions(DB_HOST, DB_NAME, DB_USER, DB_PASSWORD, DB_PORT));
$db = \lib\Registry::getObj('db');