<?php

namespace lib\database\pdo;

/* 
 * aribu system - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   http://aribu.systems
 * @date:   21.04.2018
 *  
 */

class Log {
    
    /**
     * Log path
     * @var string
     */
    private $path = '/logs/';
    
    public function __construct() {
        if(\lib\Functions::CheckIfDirectoryExists($this->path)) {
        }
        $this->path = DOC_ROOT . $this->path;
        
    }

    public function write($message, $fileSalt) {
        $date = new \DateTime();
        $log  = $this->path . $date->format('Y-m-d') . "-" . md5($date->format('Y-m-d') . $fileSalt) . ".txt";
        
        if (!file_exists($log)) {
            $fh = fopen($log, 'a+') or die("Fatal Error !");
            $logcontent = "Time : " . $date->format('H:i:s') . "\r\n" . $message . "\r\n";
            fwrite($fh, $logcontent);
            fclose($fh);
        } else {
            $this->edit($log, $date, $message);
        }
        
    }
    
    private function edit($log, $date, $message) {
        $logcontent = "Time : " . $date->format('H:i:s') . "\r\n" . $message . "\r\n\r\n";
        $logcontent = $logcontent . file_get_contents($log);
        file_put_contents($log, $logcontent);
    }
}