<?php

namespace lib\objects;

/* 
 * aribu system - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   21.04.2018
 *  
 */

class Loader {
    
    /**
     * Globals object e. g. POST, GET etc.
     * @var object
     */
    public $http;
    
    /**
     * Database object
     * @var object
     */
    public $db;
    
    /**
     * Template object engine
     * @var object
     */
    public $TT;
    
    public function __construct() {
        $this->TT   = \lib\Registry::getObj('TT');
        $this->db   = \lib\Registry::getObj('db');
        $this->http = \lib\Registry::getObj('http');
    }
    
    public function __toString() {
        $class_vars = get_class_vars(get_class($this));
        
        $string = '';
        $string .= '<script type="text/javascript">
	$(document).ready(function() {
	var winheight = $("html").innerHeight();
 	$("div#debug-div").css("height", winheight+"px");
	});
	</script>';
        $string .= '<pre style="display:block; position:absolute; z-index:1000; border:6px solid #efefef; background:#fcfcfc; padding:22px; top:0px; left:0px;">';
        $string .= '<div style="display:block; width:600px; height:500px; overflow:auto; background:#fcfcfc; text-align:left; font-size:11px; font-family:helvetica, verdana, sans-serif; line-height:14px; color:#666666;" id="debug-div">';
           
        $string .= "Class: \n";
        foreach($class_vars as $key => $val) {
            $values = !is_object($this->{$key}) ? print_r($this->{$key}, true) : 'Object';
            $string .= $key.': '.$values."\n";
        }
        $string .= '</div></pre>';
        return $string;
    }
}