<?php

namespace lib\session\frontend;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   26.10.2005 
 * @update: 30.04.2015
 * 
 */

class Session {

    public $setCookie = 0;
    
    public $SessionID = '';
    
    public $CookieName = 'aribuCookie';
    
    public $CookieImpCode = ARIBU_API_KEY;
    
    /**
     * Database
     * @var type object
     */
    protected $db;
    
    public $http;

    /**
     * Session starts here
     */
    public function __construct($db, $http) {

        session_start();

        $this->db = $db;
        $this->http = $http;

        if (isset($_COOKIE[$this->CookieName])) {
            if (strstr($_COOKIE[$this->CookieName], $this->CookieImpCode)) {
                $cookie_array = explode($this->CookieImpCode, $_COOKIE[$this->CookieName]);
                $_SESSION['sess_id'] = $cookie_array[3];
            } else {
                $_SESSION['sess_id'] = $_COOKIE[$this->CookieName];
            }
        } else {
            setcookie($this->CookieName, $_SESSION['sess_id'], 0, "/");
        }

        # Abfrage ob sich jemand eingeloggt hat
        if ($this->http->issetPost('login') === true) {

            # Login FE-User oder Community-Members
            if ($this->http->issetPost('password') === true && $this->http->issetPost('username') === true && $this->http->isEmpty('password') === false && $this->http->isEmpty('username') === false) {
                $username = trim(strip_tags($this->http->_post('username')));
                $password = trim($this->http->_post('password'));
                $password = md5($username . $password);
                $this->db->Select('user_id, '
                        . 'username, '
                        . 'user_password, '
                        . 'user_rights, '
                        . 'user_ban, '
                        . 'user_active, '
                        . 'user_tarif, '
                        . 'user_confirm, '
                        . 'user_last_visit, '
                        . 'user_email_code, '
                        . 'user_area, '
                        . 'user_land, '
                        . 'user_regdate, '
                        . 'user_gender, '
                        . 'user_image, '
                        . 'user_firstname, '
                        . 'user_lastname, '
                        . 'user_group')
                         ->From('user_accounts')
                         ->WhereColName('username')
                         ->WhereColValue($username)
                         ->Andd("AND (client_id = :client_id OR client_id = 0) ")
                         ->Parameter(array('client_id' => $GLOBALS['CLIENT_ID']))
                         ->doSelect();
                $num = $this->db->Rows;
                $userData = $this->db->SelectPuffer;
                if ($num) {
                    if ($userData['user_ban'] != 1) {
                        if ($userData['user_active'] == 1 && $userData['user_confirm'] == 1) {
                            if ($password == $userData['user_password']) {

                                $userCookieData[0]      = $userData['user_id'];
                                $userCookieData[1]      = $userData['username'];
                                $userCookieData[2]      = $userData['user_rights'];
                                $userCookieData[3]      = $_SESSION['sess_id'];
                                $userCookieData[4]      = $userData['user_tarif'];
                                $userCookieData[5]      = $userData['user_land'];
                                $userCookieData[6]      = $userData['user_group'];
                                $userCookieData[7]      = $userData['user_firstname'];
                                $userCookieData[8]      = $userData['user_lastname'];
                                
                                $cookieString = implode($this->CookieImpCode, $userCookieData);
                                setcookie($this->CookieName, $cookieString, 0, "/");
                                $login_session = $_SESSION['sess_id'];
                                $this->db->Select('*')
                                         ->From('session')
                                         ->WhereColName('session_id')
                                         ->WhereColValue($login_session)
                                         ->Andd("OR session_ip = session_ip ")
                                         ->Parameter(array('session_ip' => $_SERVER['REMOTE_ADDR']))
                                         ->doSelect();
                                $num_sess = $this->db->Rows;
                                if (!$num_sess) {
                                    $this->db->Insert('session')
                                             ->Parameter(array( 'session_id'        => $_SESSION['sess_id'],
                                                                'session_user_id'   => $userData['user_id'],
                                                                'session_date'      => 'NOW()',
                                                                'session_data'      => '',
                                                                'session_delete'    => '',
                                                                'session_ip'        => $_SERVER['REMOTE_ADDR']))
                                             ->doInsert();
                                } else {
                                    $this->db->Update('session')
                                             ->WhereColName('session_id')
                                             ->WhereColValue($login_session)
                                             ->Set(array(   'session_date' => 'NOW()',
                                                            'session_deleted' => 0,
                                                            'session_user_id' => $userData['user_id']))
                                             ->SetType(false)
                                             ->doUpdate();
                                }
                                $this->db->Update('user_accounts')
                                         ->WhereColName('user_id')
                                         ->WhereColValue($userData['user_id'])
                                         ->Set(array("user_last_visit" => CURRENT_TIME))
                                         ->doUpdate();

                                # Kundenarea
                                if ($userData['user_rights'] >= "256") {
                                    $jump_after_login = isset($GLOBALS['JUMP_AFTER_LOGIN']['URL']) ? $GLOBALS['JUMP_AFTER_LOGIN']['URL'] : "/";
                                    $user_area = $userData['user_area'] != "" ? $userData['user_area'] : $jump_after_login;
                                    if (!preg_match("#http#", $user_area, $areaTreff)) {
                                        if (!empty($user_area) && $user_area != "/") {
                                            $user_area = \lib\Functions::dotLink($user_area);
                                        } else {
                                            if (\lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['PASSWORD']) != $_SERVER['REQUEST_URI'] && \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['ACCOUNT']) != $_SERVER['REQUEST_URI'] && \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['USER_UNKNOWN']) != $_SERVER['REQUEST_URI'] && \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['E_MAIL']) != $_SERVER['REQUEST_URI'] && \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['PASSWORD_USERNAME_EMPTY']) != $_SERVER['REQUEST_URI']) {
                                                $user_area = $_SERVER['REQUEST_URI'];
                                            } else {
                                                if (isset($GLOBALS['LOGIN_ERROR_JUMP']['URL'])) {
                                                    $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_JUMP']['URL']);
                                                } else {
                                                    $user_area = $_SERVER['REQUEST_URI'];
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    $user_area = $_SERVER['REQUEST_URI'];
                                }

                                
                            } else {
                                # Exit - Passwortfehler
                                if (preg_match("#dotlink#", $GLOBALS['LOGIN_ERROR_PAGES']['PASSWORD'], $dotlink)) {
                                    $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['PASSWORD']);
                                } else {
                                    $user_area = "/";
                                }
                                header("Location: " . $user_area);
                                exit;
                            }
                        } else {
                            if ($userData['user_last_visit'] == 0) {
                                # Exit - Account nicht freigeschaltet
                                if (preg_match("#dotlink#", $GLOBALS['LOGIN_ERROR_PAGES']['ACCOUNT'], $dotlink)) {
                                    $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['ACCOUNT']);
                                } else {
                                    $user_area = "/";
                                }
                                header("Location: " . $user_area);
                                exit;
                            } elseif (empty($userData['user_email_code'])) {
                                # Exit - User unbekannt
                                if (preg_match("#dotlink#", $GLOBALS['LOGIN_ERROR_PAGES']['USER_UNKNOWN'], $dotlink)) {
                                    $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['USER_UNKNOWN']);
                                } else {
                                    $user_area = "/";
                                }
                                header("Location: " . $user_area);
                                exit;
                            } else {
                                # Exit - Account nicht freigeschaltet
                                if (preg_match("#dotlink#", $GLOBALS['LOGIN_ERROR_PAGES']['E_MAIL'], $dotlink)) {
                                    $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['E_MAIL']);
                                } else {
                                    $user_area = "/";
                                }
                                header("Location: " . $user_area);
                                exit;
                            }
                        }
                    } else {
                        # Exit - User wurde gesperrt
                        if (preg_match("#dotlink#", $GLOBALS['LOGIN_ERROR_PAGES']['USER_BAN'], $dotlink)) {
                            $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['USER_BAN']);
                        } else {
                            $user_area = "/";
                        }
                        header("Location: " . $user_area);
                        exit;
                    }
                } else {
                    # Exit - User unbekannt
                    if (preg_match("#dotlink#", $GLOBALS['LOGIN_ERROR_PAGES']['USER_UNKNOWN'], $dotlink)) {
                        $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['USER_UNKNOWN']);
                    } else {
                        $user_area = "/";
                    }
                    header("Location: " . $user_area);
                    exit;
                }
            } else {
                # Exit - Fehlerausgabe
                if (preg_match("#dotlink#", $GLOBALS['LOGIN_ERROR_PAGES']['PASSWORD_USERNAME_EMPTY'], $dotlink)) {
                    $user_area = \lib\Functions::dotLink($GLOBALS['LOGIN_ERROR_PAGES']['PASSWORD_USERNAME_EMPTY']);
                } else {
                    $user_area = "/";
                }
                header("Location: " . $user_area);
                exit;
            }
        } elseif ($this->http->issetPost('logout') === true) {
            if ($this->http->_post('logout') == 'true') {
                if ($this->http->issetPost('DOTSESSIONID') === false) {
                    $cookie_array = explode($this->CookieImpCode, $_COOKIE[$this->CookieName]);

                    $_SESSION['sess_user_id']           = $cookie_array[0];
                    $_SESSION['sess_username']          = $cookie_array[1];
                    $_SESSION['sess_user_rights']       = $cookie_array[2];
                    $_SESSION['sess_id']                = $cookie_array[3];
                    $_SESSION['sess_user_tarif']        = $cookie_array[4];
                    $_SESSION['sess_user_land']         = $cookie_array[5];
                    $_SESSION['sess_user_group'] 	= $cookie_array[6];
                    $_SESSION['sess_user_firstname'] 	= $cookie_array[7];
                    $_SESSION['sess_user_lastname'] 	= $cookie_array[8];                    

                    setcookie($this->CookieName, SESSION_ID, 0, "/");
                    $this->db->Delete('session')
                             ->WhereColName('session_id')
                             ->WhereColValue($_SESSION['sess_id'])
                             ->doDelete();
                    session_destroy();
                    unset($_SESSION);
                    $GLOBALS['DOTSESSION'] = 1;
                    $requri = explode("?", $_SERVER['REQUEST_URI']);
                    $query = $this->http->issetPost('lData') === true && $this->http->isEmpty('lData') === false ? '?' . $this->http->_post('lData') : "";
                    if(!preg_match('#(http|https)#ism', $GLOBALS['JUMP_AFTER_LOGOUT']['URL'], $hit)) {
                        $jumpurl = isset($GLOBALS['JUMP_AFTER_LOGOUT']['URL']) && $GLOBALS['JUMP_AFTER_LOGOUT']['URL'] != '' ? \lib\Functions::dotLink($GLOBALS['JUMP_AFTER_LOGOUT']['URL']) : $requri[0];
                    } else {
                        $jumpurl = $GLOBALS['JUMP_AFTER_LOGOUT']['URL'];
                    }
                    header("Location: " . $jumpurl . $query);
                    exit;
                } else {
                    $this->db->Delete('session')
                             ->WhereColName('session_id')
                             ->WhereColValue($this->http->_post('DOTSESSIONID'))
                             ->doDelete();
                    session_destroy();
                    unset($_SESSION);
                    $requri = explode("?", $_SERVER['REQUEST_URI']);
                    $jumpurl = isset($GLOBALS['JUMP_AFTER_LOGOUT']['URL']) && $GLOBALS['JUMP_AFTER_LOGOUT']['URL'] != '' ? \lib\Functions::dotLink($GLOBALS['JUMP_AFTER_LOGOUT']['URL']) : $requri[0];
                    header("Location: " . $jumpurl);
                    exit;
                }
            }
        } else {
            if (isset($_COOKIE[$this->CookieName])) {
                $this->db->Get('session', 'session_id', $_SESSION['sess_id']);
                $num = $this->db->Rows;
                if (!$num) {
                    $this->db->Insert('session')
                             ->Parameter(array( 'session_id'        => $_SESSION['sess_id'], 
                                                'session_user_id'   => '', 
                                                'session_date'      => 'NOW()', 
                                                'session_data'      => '', 
                                                'session_deleted'   => '', 
                                                'session_ip'        => $_SERVER['REMOTE_ADDR']))
                             ->doInsert();
                }
            } else {
                $_SESSION['sess_id'] = SESSION_ID;

                $this->db->Get('session', 'session_id', $_SESSION['sess_id']);
                $num = $this->db->Rows;
                if (!$num) {
                    if (!preg_match('/googlebot/i', $_SERVER['HTTP_USER_AGENT'], $agent)) {
                        $this->db->Insert('session')
                             ->Parameter(array( 'session_id'        => $_SESSION['sess_id'], 
                                                'session_user_id'   => '', 
                                                'session_date'      => 'NOW()', 
                                                'session_data'      => '', 
                                                'session_deleted'   => '', 
                                                'session_ip'        => $_SERVER['REMOTE_ADDR']))
                             ->doInsert();
                    }
                }
            }
        }
    }

    public function setSession($name, $value) {
        $name = trim($name);

        if (is_array($value)) {
            foreach ($value as $key => $val) {
                if (is_array($val)) {
                    $this->setSession($key, $val);
                } else {
                    $_SESSION[$name][$key] = $val;
                }
            }
        } else {
            $_SESSION[$name] = $value;
        }
    }

    /**
     * Handles a FE session and delete old sessions from db->
     */
    public function handleFESession() {
        
        $this->db->TablePreName = "fe_";
        $this->db->Delete('session')
                 ->noWhere(1)
                 ->Andd("WHERE DATE_SUB(NOW(), INTERVAL 15 MINUTE) > session_date AND session_deleted = 1")
                 ->doDelete();
        $this->db->Update('session')
                  ->noWhere(1)
                  ->Andd("AND DATE_SUB(NOW(), INTERVAL 14 MINUTE) > session_date")
                  ->Set(array('session_deleted' => 1))
                  ->doUpdate();

        # Cookie Session
        if (isset($_COOKIE[$this->CookieName]) && $this->http->issetPost('DOTSESSIONID') === false) {
            if (strstr($_COOKIE[$this->CookieName], $this->CookieImpCode)) {
                $cookie_array = explode($this->CookieImpCode, $_COOKIE[$this->CookieName]);

                $_SESSION['sess_user_id']               = $cookie_array[0];
                $_SESSION['sess_username']              = $cookie_array[1];
                $_SESSION['sess_user_rights']           = $cookie_array[2];
                $_SESSION['sess_id']                    = $cookie_array[3];
                $_SESSION['sess_user_tarif']            = $cookie_array[4];
                $_SESSION['sess_user_land']             = $cookie_array[5];
                $_SESSION['sess_user_group']            = $cookie_array[6];
                $_SESSION['sess_user_firstname'] 	= $cookie_array[7];
                $_SESSION['sess_user_lastname'] 	= $cookie_array[8];
                #$_SESSION['sess_user_gender'] 		= $cookie_array[9];
                #$_SESSION['sess_user_image'] 		= $cookie_array[10];
                

                $this->db->Select('user_tarif, user_ban, user_active')
                         ->From('user_accounts')
                         ->WhereColName('user_id')
                         ->WhereColValue($_SESSION['sess_user_id'])
                         ->doSelect();
                $row = $this->db->SelectPuffer;
                if ($row['user_ban'] == 1 || $row['user_active'] != 1) {
                    setcookie($this->CookieName, $_SESSION['sess_id'], 0, "/");
                    $this->db->Delete('session')
                             ->WhereColName('session_id')
                             ->WhereColValue($_SESSION['sess_id'])
                             ->doDelete();
                    unset($_SESSION);
                    $_SESSION['sess_id'] = $cookie_array[3];
                    $_SESSION['sess_user_rights'] = 0;
                }
                if ($row['user_tarif'] != $_SESSION['sess_user_tarif']) {
                    $_SESSION['sess_user_tarif'] = $row['user_tarif'];
                }

                $this->db->Update('session')
                         ->noWhere(1)
                         ->Andd("AND DATE_SUB(NOW(), INTERVAL 29 MINUTE) > session_date")
                         ->Set(array('session_deleted' => 1))
                         ->doUpdate();
            } else {
                $_SESSION['sess_id'] = $_COOKIE[$this->CookieName];
                $_SESSION['sess_user_rights'] = 0;
            }
        } else {
            if ($this->http->issetPost('DOTSESSIONID') === true) {
                $this->db->Get('session', 'session_id', $this->http->_post('DOTSESSIONID'));
                $num_sess = $this->db->Rows;
                $row_sess = $this->db->SelectPuffer;
                if ($num_sess) {
                    $this->db->Get('user_accounts', 'user_id', $row_sess['session_user_id']);
                    $row = $this->db->SelectPuffer;

                    $_SESSION['sess_user_id']           = $row['user_id'];
                    $_SESSION['sess_username']          = $row['username'];
                    $_SESSION['sess_user_rights']       = $row['user_rights'];
                    $_SESSION['sess_id']                = $this->http->_post('DOTSESSIONID');
                    $_SESSION['sess_user_tarif']        = $row['user_tarif'];
                    $_SESSION['sess_user_land']         = $row['user_land'];
                    $_SESSION['sess_user_group']        = $row['user_group'];
                    $_SESSION['sess_user_firstname']    = $row['user_firstname'];
                    $_SESSION['sess_user_lastname']     = $row['user_lastname'];
                                        

                    if ($row['user_ban'] == 1 || $row['user_active'] != 1) {
                        $this->db->Delete('session')
                                  ->WhereColName('session_id')
                                  ->WhereColValue($_SESSION['sess_id'])
                                  ->doDelete();
                        unset($_SESSION);
                        $_SESSION['sess_id'] = SESSION_ID;
                        $_SESSION['sess_user_rights'] = 0;
                    }
                    if ($row['user_tarif'] != $_SESSION['sess_user_tarif']) {
                        $_SESSION['sess_user_tarif'] = $row['user_tarif'];
                    }
                } else {
                    $_SESSION['sess_id'] = SESSION_ID;
                    $_SESSION['sess_user_rights'] = 0;
                }
            } else {
                $_SESSION['sess_id'] = SESSION_ID;
                $_SESSION['sess_user_rights'] = 0;
            }
        }

        $this->db->Get('session', 'session_id', $_SESSION['sess_id']);
        if (!$this->db->Rows) {
            return false;
        } else {
            $this->db->Update('session')
                     ->WhereColName('session_id')
                     ->WhereColValue($_SESSION['sess_id'])
                     ->Set(array(   'session_date'      => 'NOW()', 
                                    'session_deleted'   => 0, 
                                    "session_user_id"   => empty($_SESSION['sess_user_id']) ? 0 : $_SESSION['sess_user_id']))
                     ->SetType(false)
                     ->doUpdate();
            return true;
        }
    }

    /**
     * Delete a login-session
     */
    public function deleteSession($session_user_id, $TablePreName) {
        
        $this->db->TablePreName = $TablePreName;
        $this->db->Delete('session')
                 ->WhereColName('session_user_id')
                 ->WhereColValue($session_user_id)
                 ->doDelete();
        $this->db->Update('user')
                 ->WhereColName('uid')
                 ->WhereColValue($session_user_id)
                 ->Set(array('last_login' => time()))
                 ->doUpdate();
        setcookie($this->CookieName, '', time() - 3600, "/");
        @session_destroy();
        unset($_SESSION);
    }
}