<?php

namespace plugins\img\lib;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 *
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   28.06.2013
 * @update: 28.05.2015
 */

class IMG extends \lib\objects\Loader {

    
    /**
     * Global variable
     * @var type array
     */
    public $GlobalVars;

    public function __construct() {
        parent::__construct();
    }

    public function buildIMG() {
        $imgHandle = new \lib\Image();

        # Content medien holen
        $this->db->Select('*')
                 ->From('content_media')
                 ->WhereColName('cid')
                 ->WhereColValue($this->GlobalVars['CID'])
                 ->Andd("AND lang = :lang ")
                 ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                 ->SelectMethod(1)
                 ->doSelect();
        $numm = $this->db->Rows;
        if ($numm) {
            $rowm = $this->db->SelectPuffer;
            $width_set = array();
            for ($i = 0; $i < $numm; $i++) {
                if (preg_match("#(jpg|png|gif)#ism", $rowm[$i]['file'], $treffm)) {
                    $width = $rowm[$i]['width'] != "" ? 'width:' . $rowm[$i]['width'] . '; ' : '';
                    $width_set[] = $rowm[$i]['width'] != "" ? $rowm[$i]['width'] : 0;
                    $height = $rowm[$i]['height'] != "" ? 'height:' . $rowm[$i]['height'] . '; ' : '';
                    $alt = $rowm[$i]['alt'] != "" ? ' alt="' . $rowm[$i]['alt'] . '"' : ' alt="Picture"';
                    $zoom = $this->GlobalVars['zoom'] == 1 ? 1 : 0;
                    $title = $rowm[$i]['title'] != "" ? ' title="' . $rowm[$i]['title'] . '"' : '';

                    $imgHandle->loadImage(DOC_ROOT . $rowm[$i]['file']);
                    $width_old = $imgHandle->width_old;
                    $height_old = $imgHandle->height_old;

                    if ($rowm[$i]['description'] != "") {
                        switch ($rowm[$i]['description_position']) {
                            case '1': $text_align = " text-align:left; ";
                                break;
                            case '2': $text_align = " text-align:center; ";
                                break;
                            case '3': $text_align = " text-align:right; ";
                                break;
                        }
                    }

                    if ($this->GlobalVars['image_direction'] == '1') {
                        $image_float = "float:left; display:inline-block;";
                    }

                    $image_capture_start = '';
                    $image_capture_end = '';
                    if ($rowm[$i]['description'] != "") {
                        $width_image = $width != "" ? $width : 'width:' . $width_old . 'px';
                        $image_capture_start = '<div style="' . $image_float . '">';
                        $image_capture_end = '<div class="dor-img-capture" style="' . $width_image . ';' . $text_align . '">' . $rowm[$i]['description'] . '</div><div style="clear:both;"></div></div>';
                    }

                    $url_start = '';
                    $url_end = '';
                    $image_path = '';
                    if ($rowm[$i]['url'] != "") {
                        if (preg_match("#(www|https|http|mailto|javascript|\#\#\#dotlink)#ism", $rowm[$i]['url'], $url_arr)) {
                            $url = preg_match("#(\#\#\#dotlink)#ism", $rowm[$i]['url'], $url_arr_treff) ? \lib\Functions::dotLink($rowm[$i]['url'], $GLOBALS['LANGUAGE']) : $rowm[$i]['url'];
                            $url_start = '<a href="' . $url . '" target="_blank">';
                            $url_end = '</a>';
                            $href = $url;
                            $image_path = $rowm[$i]['file'];
                        } else {
                            $url_start = '<a href="' . \lib\Functions::dotLink($rowm[$i]['url'], $GLOBALS['LANGUAGE']) . '" target="_blank">';
                            $url_end = '</a>';
                            $href = 'javascript:void(0);';
                            if (preg_match("#(jpg|png|gif)#ism", $rowm[$i]['url'], $url_img_arr)) {
                                $image_path = $rowm[$i]['url'];
                                $imgHandle->loadImage(DOC_ROOT . $rowm[$i]['url']);
                                $width_old = $imgHandle->width_old;
                                $height_old = $imgHandle->height_old;
                            } else {
                                $image_path = "";
                            }
                        }
                    } else {
                        $image_path = $rowm[$i]['file'];
                    }

                    $padding = $rowm[$i]['padding'] != "" ? ' padding:' . $rowm[$i]['padding'] . ';' : '';
                    $margin = $rowm[$i]['margin'] != "" ? ' margin:' . $rowm[$i]['margin'] . ';' : '';
                    if ($this->GlobalVars['zoom_lightbox'] == 1) {
                        $zoom_js = ' class="dor-zoom"';
                        $href = $image_path;
                        $zoom = 1;
                    } else {
                        $zoom_js = ' onclick="window.open(\'' . $image_path . '\',\'_blank\',\'width=' . $width_old . ',height=' . $height_old . ',top=0,left=0,location=no\');"';
                    }

                    $plugin_content_media .= $zoom != 1 ? $image_capture_start . $url_start . '<img src="' . $rowm[$i]['file'] . '" border="0" class="dottxti" style="' . $width . $height . $image_float . $padding . $margin . '"' . $alt . $title . ' />' . $url_end . $image_capture_end : $image_capture_start . '<a href="' . $href . '"' . $zoom_js . '  title="' . htmlentities($rowm[$i]['title'], ENT_QUOTES, 'UTF-8') . '"><img src="' . $rowm[$i]['file'] . '" border="0" class="dottxti" style="' . $width . $height . $image_float . $padding . $margin . '"' . $alt . $title . ' /></a>' . $image_capture_end;
                }
            }
        }



        $block_style = "";
        $clear = '<br style="clear:both;" />';
        if ($this->GlobalVars['block_position'] != "") {
            switch ($this->GlobalVars['block_position']) {
                case "1":
                    $block_style .= "float:left; ";
                    $clear = '';
                    break;

                case "2":
                    $block_start = '<div style="margin:auto; display:inline-block;">';
                    $block_end = '</div>';
                    $block_style .= "margin:auto; text-align:center;";
                    break;

                case "3":
                    $block_style .= "float:right;";
                    $clear = '';
                    break;
            }
        }

        $block_style .= $this->GlobalVars['block_width'] != "" ? "width:" . $this->GlobalVars['block_width'] . "; " : "";
        $block_style .= $this->GlobalVars['block_height'] != "" ? "height:" . $this->GlobalVars['block_height'] . "; " : "";

        $border_width = $this->GlobalVars['border_width'] != "" ? $this->GlobalVars['border_width'] : '1';
        $border_color = $this->GlobalVars['border_color'] != "" ? '' . $this->GlobalVars['border_color'] . '' : '';
        $border_style = $this->GlobalVars['border_style'] != "" ? '' . $this->GlobalVars['border_style'] . ' ' : '';

        if (isset($this->GlobalVars['border'])) {
            switch ($this->GlobalVars['border']) {
                case "1": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "2": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "3": $block_style .= 'border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "4": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "5": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "6": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "7": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "8": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "9": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "10": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "11": $block_style .= 'border:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
            }
        }

        $block_style .= $this->GlobalVars['block_padding'] != "" ? "padding:" . $this->GlobalVars['block_padding'] . "; " : "";
        $block_style .= $this->GlobalVars['block_margin'] != "" ? "margin:" . $this->GlobalVars['block_margin'] . "; " : "";
        
        $block_id = $this->GlobalVars['block_id'] != '' ? 'id="'.$this->GlobalVars['block_id'].'" ' : '';
        
        unset($imgHandle);

        return '<div '.$block_id.'class="dor-img-block '. $this->GlobalVars['block_class'] .'" style="' . $block_style . '">' . $block_start . $plugin_content_media . '<br style="clear:both;" />' . $block_end . '</div>' . $clear;
    }

}