<?php

namespace plugins\line\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   28.06.2013
 * @update: 20.04.2015 
 */

class Line {

    public $GlobalVars;

    function __construct() {
        
    }

    function buildLine() {

        $line_style = $this->GlobalVars['line_style'] != "" ? '' . $this->GlobalVars['line_style'] . ' ' : 'solid';
        $line_custom_style = $this->GlobalVars['line_color'] != "" ? 'border-top:' . $this->GlobalVars['line_width'] . 'px ' . $line_style . ' ' . $this->GlobalVars['line_color'] . '; ' : '';
        $plugin_content = '<hr class="dor-hr" style="' . $line_custom_style . $this->GlobalVars['line_css'] . '">';

        $block_style = "";
        $clear = '<div style="clear:both;"></div>';

        $block_style .= $this->GlobalVars['block_width'] != "" ? "width:" . $this->GlobalVars['block_width'] . "; " : "";
        $block_style .= $this->GlobalVars['block_height'] != "" ? "height:" . $this->GlobalVars['block_height'] . "; " : "";

        $border_width = $this->GlobalVars['border_width'] != "" ? $this->GlobalVars['border_width'] : '1';
        $border_color = $this->GlobalVars['border_color'] != "" ? '' . $this->GlobalVars['border_color'] . '' : '';
        $border_style = $this->GlobalVars['border_style'] != "" ? '' . $this->GlobalVars['border_style'] . ' ' : '';

        if (isset($this->GlobalVars['border'])) {
            switch ($this->GlobalVars['border']) {
                case "1": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "2": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "3": $block_style .= 'border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "4": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "5": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "6": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "7": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "8": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "9": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "10": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "11": $block_style .= 'border:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
            }
        }

        $block_style .= $this->GlobalVars['block_padding'] != "" ? "padding:" . $this->GlobalVars['block_padding'] . "; " : "";
        $block_style .= $this->GlobalVars['block_margin'] != "" ? "margin:" . $this->GlobalVars['block_margin'] . "; " : "";

        if ($this->GlobalVars['block_position'] != "") {
            switch ($this->GlobalVars['block_position']) {
                case "1":
                    $block_style .= "float:left; ";
                    $block_start = '<div class="dor-line-block" style="' . $block_style . '">';
                    $block_end = '<br style="clear:both;" /></div>';
                    break;

                case "2":
                    $block_style .= "text-align:center; clear:both;";
                    $block_start = '<div class="dor-line-block" style="' . $block_style . '"><div style="margin:auto; display:block;">';
                    $block_end = '</div></div>' . $clear;
                    break;

                case "3":
                    $block_style .= "float:right;";
                    $block_start = '<div class="dor-line-block" style="' . $block_style . '">';
                    $block_end = '<br style="clear:both;" /></div>';
                    break;

                default:
                    $block_start = '<div class="dor-line-block" style="' . $block_style . '">';
                    $block_end = '<br style="clear:both;" /></div>';
            }
        }

        return '<br style="clear:both;" />' . $block_start . $plugin_content . $block_end;
    }

}