<?php

namespace plugins\txti\lib;

/* 
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 

 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   28.06.2013
 * @update: 27.05.2015 
 */

class Txti {
    
    /**
     * Tiny Template Engine object
     * @var type object 
     */
    private $TTT;

    /**
     * DFE object
     * @var type object
     */
    private $DFE;

    /**
     * Global variable
     * @var type array
     */
    public $GlobalVars;

    
    function __construct($DFE) {
        $this->DFE = $DFE;
        $this->TTT = clone $this->DFE->TT;
    }

    function getTxti() {
        
        # Image Object
        
        $imgHandle = new \lib\Image();
        
        # Content medien holen
        $this->DFE->db->Select('*')
                      ->From('content_media')
                      ->WhereColName('cid')
                      ->WhereColValue($this->GlobalVars['CID'])
                      ->Andd("AND lang = :lang")
                      ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                      ->SelectMethod(1)
                      ->doSelect();
        $numm = $this->DFE->db->Rows;
        if ($numm) {
            $rowm = $this->DFE->db->SelectPuffer;
            $width_set = array();
            for ($i = 0; $i < $numm; $i++) {
                if (preg_match("#(jpg|png|gif)#ism", $rowm[$i]['file'], $treffm)) {
                    if(preg_match('/%/ism', $rowm[$i]['width'], $hit)) {
                        $width = $rowm[$i]['width'] != "" ? 'width:100%; ' : '';
                        $width_prozent = 'width:'.stripslashes($rowm[$i]['width']).'; ';
                    } else {
                        $width = $rowm[$i]['width'] != "" ? 'width:' . stripslashes($rowm[$i]['width']) . '; ' : '';
                        $width_prozent = '';
                    }
                    $width_set[] = $rowm[$i]['width'] != "" ? stripslashes($rowm[$i]['width']) : 0;
                    $height = $rowm[$i]['height'] != "" ? 'height:' . $rowm[$i]['height'] . '; ' : '';
                    $alt = $rowm[$i]['alt'] != "" ? ' alt="' . $rowm[$i]['alt'] . '"' : ' alt="Picture"';
                    $zoom = $this->GlobalVars['zoom'] == 1 ? 1 : 0;
                    $title = $rowm[$i]['title'] != "" ? ' title="' . $rowm[$i]['title'] . '"' : '';
                    $css = $rowm[$i]['css'];
                    
                    $imgHandle->loadImage(DOC_ROOT . $rowm[$i]['file']);
                    $width_old = $imgHandle->width_old;
                    $height_old = $imgHandle->height_old;
                    
                    $padding = $rowm[$i]['padding'] != "" ? ' padding:' . stripslashes($rowm[$i]['padding']) . ';' : '';
                    $margin = $rowm[$i]['margin'] != "" ? ' margin:' . stripslashes($rowm[$i]['margin']) . ';' : '';

                    if ($rowm[$i]['description'] != "") {
                        $plugin_content_media .= '<div style="###style### '.$width_prozent.$margin.'">';
                        switch ($rowm[$i]['description_position']) {
                            case '1': $text_align = " text-align:left; ";
                                break;
                            case '2': $text_align = " text-align:center; ";
                                break;
                            case '3': $text_align = " text-align:right; ";
                                break;
                        }
                    }

                    if ($this->GlobalVars['image_float'] == '1') {
                        $image_float = "float:left; ";
                    } elseif ($this->GlobalVars['image_float'] == '3') {
                        $image_float = "float:right; ";
                    }

                    $url_start = '';
                    $url_end = '';
                    $image_path = '';
                    $n = "\n";
                    if ($rowm[$i]['url'] != "") {
                        if (preg_match("#(www|https|http|mailto|javascript|\#\#\#dotlink)#ism", $rowm[$i]['url'], $url_arr)) {
                            $url = preg_match("#(\#\#\#dotlink)#ism", $rowm[$i]['url'], $url_arr_treff) ? \lib\Functions::dotLink($rowm[$i]['url'], $GLOBALS['LANGUAGE']) : $rowm[$i]['url'];
                            $url_start = $n . '<a href="' . $url . '" target="_blank">';
                            $url_end = '</a>' . $n;
                            $href = $url;
                            $image_path = $rowm[$i]['file'];
                        } else {
                            $url_start = $n . '<a href="' . $rowm[$i]['url'] . '">';
                            $url_end = '</a>' . $n;
                            $href = 'javascript:void(0);';
                            if (preg_match("#(jpg|png|gif)#ism", $rowm[$i]['url'], $url_img_arr)) {
                                $image_path = $rowm[$i]['url'];
                                $imgHandle->loadImage(DOC_ROOT . $rowm[$i]['url']);
                                $width_old = $imgHandle->width_old;
                                $height_old = $imgHandle->height_old;
                            } else {
                                $image_path = "";
                            }
                        }
                    } else {
                        $image_path = $rowm[$i]['file'];
                    }

                    
                    if ($this->GlobalVars['zoom_lightbox'] == 1) {
                        $zoom_js = ' class="aribu-zoom"';
                        $href = $image_path;
                        $zoom = 1;
                    } else {
                        $zoom_js = ' onclick="window.open(\'' . $image_path . '\',\'_blank\',\'width=' . $width_old . ',height=' . $height_old . ',top=0,left=0,location=no\');"';
                    }

                    if (!isset($this->GlobalVars['background_image']) || $this->GlobalVars['background_image'] != 1) {
                        $plugin_content_media .= $zoom != 1 ? $url_start . '<img src="' . $rowm[$i]['file'] . '" border="0" class="aribu-txti" style="###style### ' . $width . $height . $image_float . $padding . $margin . $css . '"' . $alt . $title . ' />' . $url_end : '<a href="' . $href . '"' . $zoom_js . '><img src="' . $rowm[$i]['file'] . '" border="0" class="aribu-txti" style="###style### ' . $width . $height . $image_float . $padding . $margin . $css . '"' . $alt . $title . ' /></a>';
                    } else {
                        $background_position = $this->GlobalVars['background_position'] != "" ? $this->GlobalVars['background_position'] . " " : "";
                        $background_repeat = $this->GlobalVars['background_repeat'] != "" ? $this->GlobalVars['background_repeat'] : "";
                        $plugin_content_media .= '<div style="background:url(' . $rowm[$i]['file'] . ') ' . $background_position . $background_repeat . '; ###style### ' . $width . $height . $image_float . $padding . $margin . $css . '"></div>';
                    }
                    if ($rowm[$i]['description'] != "") {
                        $width_image = $width != "" ? $width : 'width:' . $width_old . 'px';
                        $plugin_content_media .= '<div class="aribu-txti-capture" style="' . $text_align . '">' . $rowm[$i]['description'] . '</div><br style="clear:both;"/></div>';
                    }
                }
            }
        }

        $h1 = isset($GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][1]) ? $GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][1] : 'h1';
        $h2 = isset($GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][2]) ? $GLOBALS['CONTENT_MOD_TXTI_HEADLINES'][2] : 'h2';
        $plugin_content_h = $this->GlobalVars['Headline'] != "" ? '<' . $h1 . '>' . $this->GlobalVars['Headline'] . '</' . $h1 . '>' : "";
        $plugin_content_h .= $this->GlobalVars['Subline'] != "" ? '<' . $h2 . '>' . $this->GlobalVars['Subline'] . '</' . $h2 . '>' : "";
        $plugin_content_text = '<div class="aribu-txti">' . \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '</div>';

        switch ($this->GlobalVars['position']) {
            case '1':
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= str_replace("###style###", 'display:inline-block; float:left; ', $plugin_content_media);
                $plugin_content .= $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '';
                break;

            case '2':
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= '<div style="display:inline-block; width:100%; text-align:center;">' . str_replace("###style###", 'display:inline-block; margin:auto; ', $plugin_content_media) . '</div>';
                $plugin_content .= $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= $this->GlobalVars['Content'] . '';
                break;

            case '3':
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= str_replace("###style###", 'display:inline-block; float:right; ', $plugin_content_media);
                $plugin_content .= $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '';
                break;

            case '4':
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '';
                $plugin_content .= str_replace("###style###", 'display:inline-block; float:left; ', $plugin_content_media);
                break;

            case '5':
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '';
                $plugin_content .= '<div style="display:inline-block; width:100%; text-align:center;">' . str_replace("###style###", 'display:block; margin:auto; ', $plugin_content_media) . '</div>';
                break;

            case '6':
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '';
                $plugin_content .= str_replace("###style###", 'display:inline-block; float:right; ', $plugin_content_media);
                break;

            case '7':
                $width_txti = stripslashes($this->GlobalVars['textblock_width']);
                $width_txti_tb = 'width:' . stripslashes($this->GlobalVars['imgblock_width']);
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= '<div style="float:left; display:inline-block; ' . $width_txti_tb . '">' . str_replace("###style###", 'display:inline-block; ', $plugin_content_media) . '</div>';
                $plugin_content_hc = $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= '<div style="display:inline-block; float:right; width:' . $width_txti . ';">' . $plugin_content_hc . \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '</div>';
                break;

            case '8':
                $width_txti = stripslashes($this->GlobalVars['textblock_width']);
                $width_txti_tb = 'width:' . stripslashes($this->GlobalVars['imgblock_width']);
                $plugin_content .= $this->GlobalVars['headline_direction'] == 1 ? $plugin_content_h : "";
                $plugin_content .= '<div style="float:right; display:inline-block; ' . $width_txti_tb . ';">' . str_replace("###style###", 'display:block; ', $plugin_content_media) . '</div>';
                $plugin_content_hc = $this->GlobalVars['headline_direction'] == 2 ? $plugin_content_h : "";
                $plugin_content .= '<div style="display:inline-block; float:left; width:' . $width_txti . ';">' . $plugin_content_hc . \lib\Functions::replaceLinks($this->GlobalVars['Content']) . '</div>';
                break;
        }

        $block_style = "";
        $clear = '';
        if ($this->GlobalVars['block_position'] != "") {
            switch ($this->GlobalVars['block_position']) {
                case "1":
                    $block_style .= "float:left; ";
                    $clear = '';
                    break;

                case "2":
                    $block_start = '<div style="width:100%; text-align:center;">';
                    $block_end = '</div>';
                    $block_style .= "margin:auto;";
                    $clear = '<br style="clear:both;" />';
                    break;

                case "3":
                    $block_style .= "float:right;";
                    $clear = '';
                    break;
            }
        }

        $block_style .= $this->GlobalVars['block_width'] != "" ? "width:" . $this->GlobalVars['block_width'] . "; " : "";
        $block_style .= $this->GlobalVars['block_height'] != "" ? "height:" . $this->GlobalVars['block_height'] . "; " : "";

        $border_width = $this->GlobalVars['border_width'] != "" ? $this->GlobalVars['border_width'] : '1';
        $border_color = $this->GlobalVars['border_color'] != "" ? '' . $this->GlobalVars['border_color'] . '' : '';
        $border_style = $this->GlobalVars['border_style'] != "" ? '' . $this->GlobalVars['border_style'] . ' ' : '';

        if (isset($this->GlobalVars['border'])) {
            switch ($this->GlobalVars['border']) {
                case "1": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "2": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "3": $block_style .= 'border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "4": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "5": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "6": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "7": $block_style .= 'border-top:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "8": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-right:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "9": $block_style .= 'border-bottom:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "10": $block_style .= 'border-right:' . $border_width . 'px ' . $border_style . $border_color . '; border-left:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
                case "11": $block_style .= 'border:' . $border_width . 'px ' . $border_style . $border_color . '; ';
                    break;
            }
        }

        $block_style .= $this->GlobalVars['block_padding'] != "" ? "padding:" . $this->GlobalVars['block_padding'] . "; " : "";
        $block_style .= $this->GlobalVars['block_margin'] != "" ? "margin:" . $this->GlobalVars['block_margin'] . "; " : "";
        
        $block_id = $this->GlobalVars['block_id'] != '' ? 'id="'.$this->GlobalVars['block_id'].'" ' : '';
        
        unset($imgHandle);

        return $block_start . '<div '.$block_id.'class="aribu-txti-block ' . $this->GlobalVars['css_class'] . $this->GlobalVars['block_class']. '" style="' . $block_style . '">' . $n . $plugin_content . '<div style="clear:both;"></div></div>' . $block_end . '' . $clear;
    }

}