<?php

/* 
 * aribu systems - Version 1.0.1
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   21.04.2006
 * @update: 01.05.2018
 */

# Constants 
define('DOC_ROOT',              $_SERVER['DOCUMENT_ROOT']);

# Pathes and URL's
define('ROOT',                  $_SERVER['HTTP_HOST']);
define('INDEX_URI',             'index.html');
define('FILEADMIN_ROOT',        DOC_ROOT . '/fileadmin/');
define('FILEADMIN',             '/fileadmin/');
define('CSS',                   '/fileadmin/css/');
define('CSS_ROOT',              DOC_ROOT . CSS);
define('BUTTONS',               FILEADMIN_ROOT . 'buttons/');
define('BUTTON',                FILEADMIN . 'buttons');
define('BUTTON_PATH',           '/fileadmin/buttons/');
define('IMAGES',                FILEADMIN . 'img/');
define('IMAGES_ROOT',           FILEADMIN_ROOT . 'img');
define('ELEMENTS',              DOC_ROOT . '/elements/');

# Template constants
define('TEMPLATE_PATH',         '/_templates/');
define('NOTEMPLATE',            TEMPLATE_PATH . "notemp.tpl");

# Other constants
define('SESSION_ID',            md5(uniqid(rand())));
define('CURRENT_TIME',          time());
define('CURRENT_DATETIME',      date("d.m.Y - H:i", time()));
define('IMAGE_SIZE',            300);
define('YEAR',                  date("Y", CURRENT_TIME));


# DB library for MySQL or other databases
define('DB_CLASS',              DOC_ROOT . '/lib/database/pdo/class.db.php');
define('DB_FUNCTION',           DOC_ROOT . '/lib/database/pdo/class.dbfunctions.php'); 

# Core library
define('REGISTRY',              DOC_ROOT . '/lib/class.registry.php');
define('FE_MENU',               DOC_ROOT . '/lib/class.fe_menu.php');
define('BE_MENU',               DOC_ROOT . '/lib/class.be_menu.php');
define('FE_SESSIONS',           DOC_ROOT . '/lib/session/frontend/class.session.php');
define('BE_SESSIONS',           DOC_ROOT . '/lib/session/backend/class.session.php');
define('SYS_FUNCTION',          DOC_ROOT . '/lib/class.functions.php');
define('TEMPLATE',              DOC_ROOT . '/lib/class.template.php');
define('IMAGE',                 DOC_ROOT . '/lib/class.image.php');
define('PHPMAILER',             DOC_ROOT . '/lib/class.phpmailer.php');
define('SMTP',                  DOC_ROOT . '/lib/class.smtp.php');
define('TT',                    DOC_ROOT . '/lib/class.TT.php');


# Security
define('SECURITY_DELETE_BE_PAGES',      false);
define('SECURITY_DELETE_BE_SITEMAP',    false);
define('SECURITY_DELETE_FILES',         false);
define('SECURITY_UPLOAD_FILES',         false);
define('SECURITY_EDIT_BE_STYLESHEET',   false);
define('SECURITY_EDIT_CLIENT',          false);
define('SECURITY_DELETE_CLIENT',        false);
define('SECURITY_SET_STATUS_CLIENT',    false);
define('SECURITY_EDIT_BE_USER',         false);
define('SECURITY_DELETE_BE_USER',       false);
define('SECURITY_SET_STATUS_BE_USERT',  false);


# Copyrights: after here do nothing change!
define('ARIBU_SYSTEMS_FOLDER',  'aribu.systems/');
define('ARIBU_SYSTEMS_SFOLDER', '/aribu.systems');
define('ARIBU_SYSTEMS',         'aribu.sys/');
define('ARIBU_SYSTEMS_URL',     '/aribu.sys');

include DOC_ROOT. '/sys/license.inc';

