<?php

namespace aribu\scripts\pages\lib;

/*
 * aribus systems - Version 7.0.0
 * 
 * Copyright (C) 2018  Sascha Momcilovic
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 3 of the License, or (at your option) 
 * any later version. This program is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, see <http://www.gnu.org/licenses/>. 
 * 
 * @author: Sascha Momcilovic
 * @e-Mail: info@aribu.systems
 * @link:   https://aribu.systems
 * @date:   04.05.2005
 * @update: 27.04.2018
 */


class Pages extends \aribu\scripts\abstracts\Abstracts {

    public $chields = array();
    public $RGT = array();
    public $BL = array();
    public $CLevel = array();
    public $sorting = array();
    
    public $jid;
    
    public $SQL;
    public $dbg;
    
    /**
     * Errors
     * @var array
     */
    public $Error = array();
    
    /**
     * DFE object
     * @var object
     */
    public $DFE;
    
    public $be_language = array();
    
    public $FB = "fe_";
    public $FBup = 'FE';
    public $BE = '';

        
    /**
     * Add new page
     * @return string
     */
    public function NewPage() {
        if($this->FB == 'fe_') {
            require_once FE_MENU;
        } else {
            require_once BE_MENU;
        }
        
        $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
        
        if ($this->DFE->http->issetPost('save_page_close') === false && $this->DFE->http->issetPost('save_page_new') === false) {
            
            
            # Seiten-Typen holen Dyn-Block!
            $m = 0;
            foreach ($GLOBALS['INSTALLED_MODULES'] as $key => $val) {
                $cm = "251_" . $key;   
                if ($_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][$cm] == 1 || $_SESSION['BE_Rights'] == 1) {
                    $this->DFE->TT->setIMC($m, 'page_property_title', $val)
                                  ->setIMC($m, 'page_property_icon', $GLOBALS['INSTALLED_MODULES_ICONS'][$key])
                                  ->setIMC($m, 'page_property_id', $key);
                }
                $m++;
            }  
            
            # Installed Content Module
            $module = $this->DFE->http->issetPost('plugin') === true ? $this->DFE->http->_post('plugin') : $row['module'];
            $this->DFE->db->TablePreName = "fe_";
            foreach ($GLOBALS['INSTALLED_MODULES'] as $key => $val) {
                
                $this->DFE->db->Select('config_description')
                          ->From("system_config")
                          ->WhereColName('config_title')
                          ->WhereColValue('INSTALLED_MODULES')
                          ->Andd("AND config_key = '" . $key . "' AND config_value = '" . $val . "' AND config_lang = :lang ")
                          ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                          ->doSelect();
                
                $num = $this->DFE->db->Rows;

                if (strtolower($module) == $key) {
                    $module_options .= "<option value=\"" . $key . "\" selected>" . $val . "</option>\n";
                    if ($this->DFE->db->SelectPuffer['config_description'] != "") {
                        $plugin_setup_name = '<li><a href="#' . $key . '">' . ucfirst($key) . '</a></li>';
                        if (file_exists($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems" . $this->DFE->db->SelectPuffer['config_description'])) {
                            include($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems" . $this->DFE->db->SelectPuffer['config_description']);
                        }
                    }
                } else {
                    $module_options .= "<option value=\"" . $key . "\">" . $val . "</option>\n";
                }
            }
            
            
            $this->DFE->db->Select('*')
                      ->From('user_accounts')
                      ->WhereColName('user_rights')
                      ->WhereColValue('256')
                      ->SelectMethod(1)
                      ->doSelect();
            $num_c = $this->DFE->db->Rows;
            if ($num_c) {
                $row_c = $this->DFE->db->SelectPuffer;
                for ($a = 0; $a < $num_c; $a++) {
                    $selected = $row['perms_userid'] == $row_c[$a]['user_id'] ? " selected" : "";
                    $fe_rights_customers .= "<option value=\"" . $row_c[$a]['user_id'] . "\"" . $selected . ">" . $row_c[$a]['user_lastname'] . "</option>";
                }
            }

            # Seiten-Rechte BE-User-Group
            $this->DFE->db->TablePreName = "be_";
            $this->DFE->db->Select('*')
                      ->From('user_groups')
                      ->noWhere(1)
                      ->SelectMethod(1)
                      ->doSelect();
            $numg = $this->DFE->db->Rows;
            $rowg = $this->DFE->db->SelectPuffer;
            for ($i = 0; $i < $numg; $i++) {
                $selected = $pageSettings['be_rights'] == $rowg[$i]['id'] ? " selected" : "";
                $bek_rights .= "<option value=\"" . $rowg[$i]['id'] . "\"" . $selected . ">" . $rowg[$i]['name'] . "</option>";
            }
            
            # Seiten-Rechte BE-User
            $this->DFE->db->Select('*')
                          ->From('user')
                          ->NoWhere(1)
                          ->SelectMethod(1)
                          ->doSelect();
            $numu = $this->DFE->db->Rows;
            $rowu = $this->DFE->db->SelectPuffer;
            for ($i = 0; $i < $numu; $i++) {
                $selected = $this->DFE->http->_post('perms_be_userid') == $rowu[$i]['uid'] ? " selected" : "";
                $bek_user_rights .= "<option value=\"" . $rowu[$i]['uid'] . "\"" . $selected . ">" . $rowu[$i]['full_name'] . "</option>";
            }
            $this->DFE->db->TablePreName = "fe_";
            
            if ($this->DFE->http->_post('lastUID') != "x") {
                $last_uid = '<option value="' . $this->DFE->http->_post('lastUID') . '" selected="selected">' . \lib\Functions::breadcrumb($this->DFE->http->_post('lastUID'), 'dot'.$this->FBup.'Menu', $GLOBALS['LANGUAGE']) . '</option>';
            }
            
            # Templates holen
            $tpl = $this->getFileTreeArray(DOC_ROOT . "/_templates");
            
            $pageSettings = $this->DFE->http->_post('pageSettings'); 
            $pageSettings = $pageSettings['pageSettings'];
            
            # Set marker
            $this->DFE->TT->setMC('module_options',                 $module_options)
                          ->setMC('doctype',                        \lib\Functions::getOptions($GLOBALS['BE_DOCTYPES_NAMES'], $this->DFE->http->_post('docType'), '', '64'))
                          ->setMC('urltypes',                       \lib\Functions::getOptions($GLOBALS['BE_URL_TYPES'], $this->DFE->http->_post('urltype')))
                          ->setMC('expire_cache',                   \lib\Functions::getOptions($GLOBALS['EXPIRE_CACHE_TIME'], $this->DFE->http->_post('expireCache')))
                          ->setMC('fe_rights',                      \lib\Functions::getOptions($GLOBALS['FE_USER_RIGHTS'], $this->DFE->http->_post('perms_groupid')))
                          ->setMC('templates',                      $this->getTemplateOptions($tpl, '', $this->DFE->http->_post('sitetpl')))
                          ->setMC('template_not_logged_in',         $this->getTemplateOptions($tpl, '', $pageSettings['Template_Not_Logged_In']))
                          ->setMC('pagecache',                      $this->DFE->http->issetPost('pageCache') === true ? ' checked="checked"' : '')
                          ->setMC('display_customers',              $this->DFE->http->_post('perms_groupid') == "256" ? '' : 'display:none;')
                          ->setMC('index1',                         $this->DFE->http->_post('Index') == 1 ? 'checked="checked"' : ($this->DFE->http->_post('Index') === true ? '' : 'checked="checked"'))
                          ->setMC('index2',                         $this->DFE->http->_post('Index') == 2 ? 'checked="checked"' : '')
                          ->setMC('page_search0',                   $this->DFE->http->_post('search') == 0 &&  $this->DFE->http->issetPost('search') === true ? 'checked="checked"' : '')
                          ->setMC('page_search1',                   $this->DFE->http->_post('search') == 1 ? 'checked="checked"' : ($this->DFE->http->issetPost('search') === false ? 'checked="checked"' : ''))
                          ->setMC('use_css',                        $this->DFE->http->_post('this_css') == 1 ? 'checked="checked"' : '')
                          ->setMC('content_from_pid_option',        $this->DFE->http->_post('content_from_pid') != 0 ? '<option selected value="' . $this->DFE->http->_post('content_from_pid') . '">' . \lib\Functions::breadcrumb($this->DFE->http->_post('content_from_pid'), 'dot'.$this->FBup.'Menu', $GLOBALS['LANGUAGE']). '</option>' : '')
                          ->setMC('isroot',                         $this->DFE->http->_post('spid') == 0 ? '' : 'checked="checked"')
                          ->setMC('navi_title',                     htmlspecialchars(stripslashes($this->DFE->http->_post('nav_title'))))
                          ->setMC('external_url',                   htmlentities(stripslashes($this->DFE->http->_post('url'))))
                          ->setMC('description',                    stripslashes($this->DFE->http->_post('description')))
                          ->setMC('url_target',                     $row['target'])
                          ->setMC('backlink',                       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                          ->setMC('sout',                           ' selected="selected"')
                          ->setMC('urltypes',                       \lib\Functions::getOptions($GLOBALS['BE_URL_TYPES'], $this->DFE->http->_post('urltype')))
                          ->setMC('lang',                           $GLOBALS['LANGUAGE'])
                          ->setMC('sid',                            $_SESSION['session_id'])
                          ->setMC('ref_page',                       $_SERVER['HTTP_REFERER'])
                          ->setMC('messenger',                      $this->DFE->http->issetPost('saved') === true ? $Widget->Messenger($message, 'messenger-on-top messenger-on-right', $type) : '')
                          ->setMC('be_rights',                      $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][2] == 1 ? '' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['rights_lock_group'].'"')
                          ->setMC('site_uid',                       $this->DFE->http->_post('uid'))
                          ->setMC('BrowserTitle',                   stripslashes($this->DFE->http->_post('BrowserTitle')))
                          ->setMC('keywords',                       stripslashes($this->DFE->http->_post('keywords')))
                          ->setMC('link_title',                     stripslashes($this->DFE->http->_post('link_title')))
                          ->setMC('sid',                            $_SESSION['session_id'])
                          ->setMC('syslang',                        $GLOBALS['LANGUAGE'])
                          ->setMC('pid',                            $this->DFE->http->_post('pid'))
                          ->setMC('js',                             stripslashes($this->DFE->http->_post('Javascript')))
                          ->setMC('stylesheet',                     stripslashes($this->DFE->http->_post('Stylesheet')))
                          ->setMC('link_icon_path',                 preg_match("#<#ism", $this->DFE->http->_post('LinkIcon'), $hit) || !strstr($this->DFE->http->_post('LinkIcon'), '/') ? htmlentities(stripslashes(base64_decode($this->DFE->http->_post('LinkIcon'))), ENT_QUOTES, "UTF-8") : $this->DFE->http->_post('LinkIcon'))
                          ->setMC('link_css',                       $this->DFE->http->_post('LinkCSS'))
                          ->setMC('copy_attributes_link',           "?ac=CopyPageAttributes&uid=" . $this->DFE->http->_post('uid'))
                          ->setMC('copy_attributes_tmp_link',       "?ac=CopyPageAttributes&attr=tmp&uid=" . $this->DFE->http->_post('uid'))
                          ->setMC('copy_attributes_doctype_link',   "?ac=CopyPageAttributes&attr=doctype&uid=" . $this->DFE->http->_post('uid'))
                          ->setMC('copy_attributes_search_link',    "?ac=CopyPageAttributes&attr=search&uid=" . $this->DFE->http->_post('uid'))
                          ->setMC('pages',                          $this->DFE->Pages)
                          ->setMC('bek_rights',                     $bek_rights)
                          ->setMC('bek_user_rights',                $bek_user_rights)
                          ->setMC('fe_rights_customers',            $fe_rights_customers)
                          ->setMC('last_uid',                       $last_uid)
                          ->setMC('fb',                             $this->FB == 'be_' ? '&FB=be_' : ''); 
            
            $this->DFE->TT->BlockMarker['error'] = 1;
            if ($this->DFE->http->issetPost('saved') === true) {
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_savepageok'), 'messenger-on-top messenger-on-right', 'success'));
            } elseif(isset($this->Error['Validation'])) {
                $this->DFE->TT->BlockMarker['error'] = 0;
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            }
    
        } else {

            if ($this->DFE->http->isEmpty('nav_title') === true) {
                $err = 1;
                $this->Error['Validation'] = "Bitte geben Sie einen Seitennamen ein!";
            }

            if ($this->DFE->http->_post('lastUID') == "x") {
                $err = 1;
                $this->Error['Validation'] = "Bitte wählen Sie eine Seite aus unter der Sie die neue Seite einfügen möchten!";
            } else {
                # Seiten vergleichen
                if ($this->DFE->http->_post('join') == "out" || $this->DFE->http->_post('join') == "over") {
                    $this->DFE->db->Select('pid')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('lastUID'))
                                  ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doSelect();
                    $row = $this->DFE->db->SelectPuffer;
                    $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                    $this->DFE->db->Select('uid')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($row['pid'])
                                  ->Andd("AND pagename = :pagename ". str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Parameter($this->DFE->and_lang != '' ? array('pagename' => $new_pagename, 'lang' => $GLOBALS['LANGUAGE']) : array('pagename' => $new_pagename))
                                  ->doSelect();
                    
                    $num = $this->DFE->db->Rows;
                } else {
                    $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                    $this->DFE->db->Select('uid')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($this->DFE->http->_post('lastUID'))
                                  ->Andd("AND pagename = :pagename ". str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Parameter($this->DFE->and_lang != '' ? array('pagename' => $new_pagename, 'lang' => $GLOBALS['LANGUAGE']) : array('pagename' => $new_pagename))
                                  ->doSelect();
                    
                    $num = $this->DFE->db->Rows;
                }

                if ($num) {
                    $err = 1;
                    $this->Error['Validation'] = "Die Seite mit dem Namen existiert bereits. Bitte wählen Sie einen anderen Namen.";
                }
            }

            if ($err == 1) {
                $this->DFE->http->unsetPost('save_page_close')->unsetPost('save_page_new');
                $this->NewPage();
            } else {
                # Save
                $this->SavePage();
            }
        }

        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/new_page.html', NULL, 1);
    }
    
    /**
     * Save page datas to database
     */
    public function SavePage() {
        # New datas will saved
        $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
        
        $LinkIcon = preg_match("#<#ism", $this->DFE->http->_post('LinkIcon'), $hit) ? base64_encode($this->DFE->http->_post('LinkIcon')) : $this->DFE->http->_post('LinkIcon');

        $pageSettings = $this->PreparePageSettings($LinkIcon);
        $this->DFE->db->TablePreName = $this->FB;
        $this->DFE->db->Select('uid, pid, rgt, lft, sorting, nav_title')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('lastUID'))
                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
        $num = $this->DFE->db->Rows;

        if ($num) {
            $row = $this->DFE->db->SelectPuffer;

            switch ($this->DFE->http->_post('join')) {
                case 'in': # In a page
                    $this->DFE->db->Select('sorting')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($this->DFE->http->_post('lastUID'))
                                  ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Order('ORDER BY sorting DESC')
                                  ->SelectMethod(1)
                                  ->doSelect();
                    $num_s = $this->DFE->db->Rows;
                    $sorting = $num_s > 0 ? $num_s + 1 : 1;
                    $pid = $row['uid'];

                    # Nested Sets Modell
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lft" => "lft+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE rgt >= " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("rgt" => "rgt+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    $lft = $row['rgt'];
                    $rgt = $row['rgt'] + 1;
                    
                    break;

                case 'out': # After a page
                    $sorting = $row['sorting'] + 1;
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($row['pid'])
                                  ->Andd("AND sorting > " . $row['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array(  "sorting"       => "sorting+1", 
                                                "lastUpdated"   => time()))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $pid = $row['pid'];

                    # Nested Sets Modell
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lft" => "lft+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE rgt > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("rgt" => "rgt+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    $lft = $row['rgt'] + 1;
                    $rgt = $row['rgt'] + 2;
                    break;

                case 'over': # Over a page
                    $sorting = $row['sorting'];
                    if ($sorting == 0) {
                        $sorting = 1;
                    }
                    $pid = $row['pid'];
                    # Update der Seite
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($row['pid'])
                                  ->Andd("AND sorting >= " . $sorting . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array(  "sorting"       => "sorting+1", 
                                                "lastUpdated"   => time()))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    # Nested Sets Modell
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE rgt > " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("rgt" => "rgt+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->noWhere(1)
                                  ->Andd("WHERE lft >= " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Set(array("lft" => "lft+2"))
                                  ->SetType(false)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doUpdate();

                    $lft = $row['lft'];
                    $rgt = $row['lft'] + 1;
                    break;
            }

            $DataArray = $this->PrepareDataArray($pid, $lft, $rgt, $sorting, $new_pagename, $pageSettings);
            
            # Save new page
            if ($GLOBALS['LANGUAGE'] != SYS_LANGUAGE) {
                $DataArray_rid  = \lib\Functions::InsertValueIntoArrayPosition($DataArray, 1, $this->DFE->http->_post('rid'));
                $DataArray      = \lib\Functions::InsertValueIntoArrayPosition($DataArray_rid, 44, $GLOBALS['LANGUAGE']);
            }
            $this->AddPage($DataArray);
            $last_insert_id = $this->DFE->db->LastInsertID;

            # Page hash 
            $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($last_insert_id, '', 0, 0, 1, '', '', true) : \lib\fe_menu::getTreePathNames($last_insert_id, '', 0, 0, 1, '', '');     
            $page_Hash = md5($page_Hash);

            # Update page hash
            $this->DFE->db->Update($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($last_insert_id)
                          ->Set(array("page_Hash" => $page_Hash))
                          ->doUpdate();

            # Level update
            $this->DFE->db->Select("COUNT(*)-1 AS level")
                          ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                          ->noWhere(1)
                          ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                          ->Group("GROUP BY n.lft")
                          ->Order("ORDER BY n.lft") 
                          ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                          ->doSelect();
            $row3 = $this->DFE->db->SelectPuffer;
            $this->DFE->db->Update($this->DFE->Pages)
                          ->noWhere(1)
                          ->Andd("WHERE uid = :uid " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Set(array("level" => $row3['level']))
                          ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                          ->doUpdate();
            
            if ($this->DFE->http->issetPost('save_page_new') === true) {
                header("Location: " . ARIBU_SYSTEMS_URL . $this->DFE->RequestURI . "?saved=ok");
            } else {
                header("Location: " . $this->DFE->http->_post('ref_page'));
            }
            exit;
        } else {
            $this->DFE->db->Select('uid, pid, sorting, nav_title')
                          ->From($this->DFE->Pages)
                          ->WhereColName('pid')
                          ->WhereColValue(0)
                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Order("ORDER BY sorting DESC")
                          ->SelectMethod(1)
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            if ($num) {
                # Don't use the root folder to save the new page
                $this->Error['Validation'] = $this->be_language['_save_root_error'];
                $this->NewPage();
            } else {
                $sorting = 1;
                $pid = 0;
                $lft = 1;
                $rgt = 2;

                # Neue Seite speichern
                $DataArray = $this->PrepareDataArray($pid, $lft, $rgt, $sorting, $new_pagename, $pageSettings);
                
                if ($GLOBALS['LANGUAGE'] != SYS_LANGUAGE) {
                    $DataArray_rid  = \lib\Functions::InsertValueIntoArrayPosition($DataArray, 1, array('rid' => $this->DFE->http->_post('rid')));
                    $DataArray      = \lib\Functions::InsertValueIntoArrayPosition($DataArray_rid, 44, array('lang' => $GLOBALS['LANGUAGE']));                 
                }
                
                $this->AddPage($DataArray);

                $last_insert_id = $this->DFE->db->LastInsertID;

                # Page hash 
                $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 0, 1, '', '', true) : \lib\fe_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 0, 1, '');
                $page_Hash = md5($page_Hash);

                # Update page hash
                $this->DFE->db->Update($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($last_insert_id)
                          ->Set(array("page_Hash" => $page_Hash))
                          ->doUpdate();

                # Level update
                $this->DFE->db->Select("COUNT(*)-1 AS level")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                              ->noWhere(1)
                              ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                              ->Group("GROUP BY n.lft")
                              ->Order("ORDER BY n.lft") 
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                              ->doSelect();
                $row3 = $this->DFE->db->SelectPuffer;
                $this->DFE->db->Update($this->DFE->Pages)
                              ->noWhere(1)
                              ->Andd("WHERE uid = :uid " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Set(array("level" => $row3['level']))
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $last_insert_id))
                              ->doUpdate();

                if ($this->DFE->http->issetPost('save_page_new') === true) {
                    header("Location: " . ARIBU_SYSTEMS_URL . $this->DFE->RequestURI . "?saved=ok");
                } else {
                    header("Location: " . $this->DFE->http->_post('ref_page'));
                }
                exit;
            }
        }
    }
    
    public function PrepareDataArray($pid, $lft, $rgt, $sorting, $new_pagename, $pageSettings) {
        return array(   'uid'                   => '',                                                                                         
                        'pid'                   => $pid,                                                                                       
                        'lft'                   => $lft,                                                                                      
                        'rgt'                   => $rgt,                                                                                       
                        'docType'               => $this->DFE->http->_post('docType'),                                                         
                        'spid'                  => $this->DFE->http->_post('spid'),                                                            
                        'tstamp'                => time(),                                                                   
                        'sorting'               => $sorting,                                                                                  
                        'deleted'               => 0,                                                                                        
                        'perms_userid'          => $this->DFE->http->_post('perms_userid'),                                                       
                        'perms_groupid'         => $this->DFE->http->_post('perms_groupid'),                                                   
                        'perms_be_userid'       => $this->DFE->http->_post('perms_be_userid'),                                                
                        'perms_be_groupid'      => $this->DFE->http->_post('perms_be_groupid'),                                                
                        'crdate'                => time(),                                                                                    
                        'cruser_id'             => $_SESSION['sess_uid'],                                                                   
                        'pagename'              => $new_pagename,                                                                              
                        'url'                   => $this->DFE->http->_post('url'),                                                          
                        'hidden'                => 0,                                                                                             
                        'starttime'             => 0,                                                                                         
                        'endtime'               => 0,                                                                                         
                        'urltype'               => $this->DFE->http->_post('urltype'),                                                         
                        'pageSettings'          => $pageSettings,                                                                             
                        'target'                => $this->DFE->http->_post('target'),                                                         
                        'lastUpdated'            => 0,                                                                                         
                        'description'           => $this->DFE->http->_post('description'),                                                     
                        'author'                => $_SESSION['sess_username'],                                                                 
                        'author_email'          => $_SESSION['sess_user_email'],                                                               
                        'nav_title'             => \lib\Functions::removeCriticSigns($this->DFE->http->_post('nav_title')),                    
                        'content_from_pid'      => $this->DFE->http->_post('content_from_pid'),                                               
                        'button'                => '',                                                                                        
                        'button_path'           => '',                                                                                         
                        'button_act_path'       => '',                                                                                         
                        'sitetpl'               => $this->DFE->http->_post('sitetpl'),                                                         
                        'module'                => $this->DFE->http->_post('module'),                                                         
                        'BrowserTitle'          => $this->DFE->http->_post('BrowserTitle'),                                                   
                        'keywords'              => $this->DFE->http->_post('keywords'),                                                        
                        'page_Hash'             => '',                                                                                         
                        'link_title'            => $this->DFE->http->_post('link_title'),                                                      
                        'move_update'           => 0,                                                                                         
                        'Javascript'            => $this->DFE->http->_post('Javascript'),                                                         
                        'Stylesheet'            => $this->DFE->http->_post('Stylesheet'),                                                      
                        'this_css'              => $this->DFE->http->_post('this_css'),                                                        
                        'level'                 => '',                                                                                         
                        'search'                => $this->DFE->http->_post('search'));                                                        
    }

    public function PreparePageSettings($LinkIcon) {
        $pageSettings = array(  "pageCache"         => $this->DFE->http->_post('pageCache'),
                                "expireCache"       => $this->DFE->http->_post('expireCache'),
                                "Index"             => $this->DFE->http->_post('Index'),
                                "be_rights"         => $this->DFE->http->_post('be_rights'),
                                "LinkIcon"          => $LinkIcon,
                                "LinkCSS"           => $this->DFE->http->_post('LinkCSS'));

        if (is_array($this->DFE->http->_post('pageSettings')) && $this->DFE->http->issetPost('pageSettings') === true) {
            $psettings = $this->DFE->http->_post('pageSettings');
            foreach ($psettings['PageSettings'] as $key => $val) {
                $installed_modules[$key] = $val;
            }
            $pageSettings = array_merge($pageSettings, $installed_modules);
        }

        return serialize($pageSettings);
    }
    
    public function AddPage(array $DataArray) {
        $this->DFE->db->Insert($this->DFE->Pages)
                      ->Parameter($DataArray)
                      ->doInsert();
    }

    /*
     * Get tree files array
     *
     */

    public function getFileTreeArray($dir) {
        static $level = 0;
        $fp = opendir($dir);
        while ($datei = readdir($fp)) {
            if (is_dir("$dir/$datei") && $datei != "." && $datei != "..") {
                $level++;
                if ($tmp = $this->getFileTreeArray($dir . "/" . $datei)) {
                    $tree_arr[$datei] = $tmp;
                    $tree_arr2[$datei . "-"] = $tmp;
                } else {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                    $tree_arr2[] = $datei;
                }
                $level--;
            } else {
                if ($datei != "." && $datei != "..") {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                    $tree_arr2[] = $datei;
                }
            }
        }
        closedir($fp);

        return $tree_arr;
    }

    /*
     * Get template options
     *
     */

    public function getTemplateOptions($tpl_array, $folder = "", $select = "") {
        foreach ($tpl_array as $key => $val) {
            if (is_array($val)) {
                $template_options .= $this->getTemplateOptions($val, $folder . $key . "/", $select);
            } else {
                if (!preg_match('#(\.LCK|\.DS_Store)#', $key, $match)) {
                    $selected = $folder . $key == $select ? " selected=\"selected\"" : "";
                    $template_options .= "<option value=\"" . $folder . $key . "\"" . $selected . ">" . $folder . $key . "</option>\n";
                }
            }
        }
        return $template_options;
    }

    /*
     * Page move
     *
     */

    public function MovePage($template="/aribu.systems/_templates/pages/move_page.html") {
        
        $this->DFE->TT->BlockMarker['save'] = 0;

        
        if ($this->DFE->http->issetPost('save_move') === true) {
            if ($this->DFE->http->_post('nuid') != "x") {

                $this->DFE->db->Select('lft, rgt, sorting, pid')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                $row_mp = $this->DFE->db->SelectPuffer;

                $this->DFE->db->Select('uid, pid, lft, rgt, sorting')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('nuid'))
                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                $row = $this->DFE->db->SelectPuffer;

                switch ($this->DFE->http->_post('join')) {

                    case 'in': # in
                        $this->DFE->db->Select('sorting')
                                      ->From($this->DFE->Pages)
                                      ->WhereColName('pid')
                                      ->WhereColValue($this->DFE->http->_post('nuid'))
                                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Order('ORDER BY sorting DESC')
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        $num_s = $this->DFE->db->Rows;
                        if ($num_s) {
                            $sorting = $num_s + 1;
                        } else {
                            $sorting = 1;
                        }
                        $pid = $row['uid'];

                        # Update der Seite
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->WhereColName('uid')
                                      ->WhereColValue($this->DFE->http->_post('muid'))
                                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array(  "pid"           => $pid, 
                                                    "lastUpdated"   => time(), 
                                                    "sorting"       => $sorting))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->WhereColName('pid')
                                      ->WhereColValue($row_mp['pid'])
                                      ->Andd("AND sorting > " . $row_mp['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array(  "lastUpdated" => time(), 
                                                    "sorting" => "sorting-1"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();

                        # Nested Sets Modell
                        # Löschen des Knoten und seiner Unterpunkte
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft BETWEEN " . $row_mp['lft'] . " AND " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array("move_update" => 1))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft > " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang)." AND move_update != 1")
                                      ->Set(array("lft" => "lft-ROUND(" . $row_mp['rgt'] . "-" . $row_mp['lft'] . "+1)"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate(); 
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE rgt > " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang)." AND move_update != 1")
                                      ->Set(array("rgt" => "rgt-ROUND(" . $row_mp['rgt'] . "-" . $row_mp['lft'] . "+1)"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();

                        $this->DFE->db->Select('uid, pid, lft, rgt, sorting')
                                      ->From($this->DFE->Pages)
                                      ->WhereColName('uid')
                                      ->WhereColValue($this->DFE->http->_post('nuid'))
                                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        $row = $this->DFE->db->SelectPuffer;

                        # Gelöschten Knoten und Unterpunkte auslesen
                        $this->DFE->db->Select('uid, pid, lft, rgt, sorting')
                              ->From($this->DFE->Pages)
                              ->noWhere(1)
                              ->Andd("WHERE lft BETWEEN " . $row_mp['lft'] . " AND " . $row_mp['rgt'] . " AND move_update = 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->Order("ORDER BY lft")
                              ->SelectMethod(1)
                              ->doSelect();
                        
                        $row2 = $this->DFE->db->SelectPuffer;
                        $num2 = $this->DFE->db->Rows;
                        for ($i = 0; $i < $num2; $i++) {
                            if ($i == 0) {
                                # Knoten wird in die Seite eingefügt
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt >= " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $lft = $row['rgt'];
                                $rgt = ($row['rgt'] + 1);
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE uid = " . $row2[$i]['uid'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => $rgt, "lft" => $lft))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                            } else {
                                # Alle anderen Unterpunkte werden mit "in" eingefügt
                                $this->DFE->db->Select('rgt')
                                              ->From($this->DFE->Pages)
                                              ->WhereColName('uid')
                                              ->WhereColValue($row2[$i]['pid'])
                                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Order("ORDER BY sorting ASC")
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doSelect();
                                $rows = $this->DFE->db->SelectPuffer;

                                # Nested Sets Modell
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft > " . $rows['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt >= " . $rows['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                

                                $lft = $rows['rgt'];
                                $rgt = ($rows['rgt'] + 1);
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE uid = " . $row2[$i]['uid'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => $rgt, "lft" => $lft))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                
                            }
                        }
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->Set(array("move_update" => 0))
                                      ->noWhere(1)
                                      ->doUpdate();

                        break;

                    case 'out': # nach
                        if ($row_mp['pid'] == $row['pid']) {
                            if ($row_mp['sorting'] < $row['sorting']) {
                                $sorting = $row['sorting'];
                                $pid = $row['pid'];
                                # alles was kleiner oder gleich $sorting um 1 reduzieren
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->WhereColName('pid')
                                              ->WhereColValue($pid)
                                              ->Set(array(  "lastUpdated" => time(), 
                                                            "sorting" => "sorting-1"))
                                              ->SetType(false)
                                              ->Andd("AND sorting >= " . $row_mp['sorting'] . " AND sorting <= " . $sorting . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                            } else {
                                $sorting = $row['sorting'] + 1;
                                $pid = $row['pid'];
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->WhereColName('pid')
                                              ->WhereColValue($pid)
                                              ->Set(array(  "lastUpdated" => time(), 
                                                            "sorting" => "sorting+1"))
                                              ->SetType(false)
                                              ->Andd("AND sorting > " . $row['sorting'] . " AND sorting < " . $row_mp['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                            }

                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($this->DFE->http->_post('muid'))
                                          ->Set(array(  "pid"           => $pid, 
                                                        "lastUpdated"   => time(), 
                                                        "sorting"       => $sorting))
                                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                        } else {
                            $sorting = $row['sorting'] + 1;
                            $pid = $row['pid'];
                            $this->DFE->db->Update($this->DFE->Pages)
                                      ->WhereColName('pid')
                                      ->WhereColValue($pid)
                                      ->Set(array(  "lastUpdated" => time(), 
                                                    "sorting" => "sorting+1"))
                                      ->SetType(false)
                                      ->Andd("AND sorting >= " . $sorting . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                            $this->DFE->db->Update($this->DFE->Pages)
                                      ->WhereColName('pid')
                                      ->WhereColValue($row_mp['pid'])
                                      ->Set(array(  "lastUpdated" => time(), 
                                                    "sorting" => "sorting-1"))
                                      ->SetType(false)
                                      ->Andd("AND sorting > " . $row_mp['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                            
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($this->DFE->http->_post('muid'))
                                          ->Set(array(  "pid"           => $pid, 
                                                        "lastUpdated"   => time(), 
                                                        "sorting"       => $sorting))
                                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            
                        }

                        # Nested Sets Modell
                        # Löschen des Knoten und seiner Unterpunkte
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft BETWEEN " . $row_mp['lft'] . " AND " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array("move_update" => 1))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft > " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang). " AND move_update != 1")
                                      ->Set(array("lft" => "lft-ROUND(" . $row_mp['rgt'] . "-" . $row_mp['lft'] . "+1)"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE rgt > " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang)." AND move_update != 1")
                                      ->Set(array("rgt" => "rgt-ROUND(" . $row_mp['rgt'] . "-" . $row_mp['lft'] . "+1)"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        
                        $this->DFE->db->Select('uid, pid, lft, rgt, sorting')
                                      ->From($this->DFE->Pages)
                                      ->WhereColName('uid')
                                      ->WhereColValue($this->DFE->http->_post('nuid'))
                                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        $row = $this->DFE->db->SelectPuffer;

                        # Gelöschten Knoten und Unterpunkte auslesen
                        $this->DFE->db->Select('uid, pid, lft, rgt, sorting')
                                      ->From($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft BETWEEN " . $row_mp['lft'] . " AND " . $row_mp['rgt'] . " AND move_update = 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Order('ORDER BY lft')
                                      ->SelectMethod(1)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();

                        $row2 = $this->DFE->db->SelectPuffer;
                        $num2 = $this->DFE->db->Rows;
                        for ($i = 0; $i < $num2; $i++) {
                            if ($i == 0) {
                                # Knoten wird nach der Seite eingefügt
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $lft = $row['rgt'] + 1;
                                $rgt = $row['rgt'] + 2;
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE uid = " . $row2[$i]['uid'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => $rgt, "lft" => $lft))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();             
                            } else {
                                # Alle anderen Unterpunkte werden mit "in" eingefügt
                                $this->DFE->db->Select('rgt')
                                              ->From($this->DFE->Pages)
                                              ->WhereColName('uid')
                                              ->WhereColValue($row2[$i]['pid'])
                                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Order("ORDER BY sorting ASC")
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doSelect();
                                $rows = $this->DFE->db->SelectPuffer;

                                # Nested Sets Modell
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft > " . $rows['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt >= " . $rows['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                

                                $lft = $rows['rgt'];
                                $rgt = ($rows['rgt'] + 1);
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE uid = " . $row2[$i]['uid'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => $rgt, "lft" => $lft))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                
                                
                            }
                        }
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->Set(array("move_update" => 0))
                                      ->noWhere(1)
                                      ->doUpdate();
                        break;

                    case 'over':
                        if ($row_mp['pid'] == $row['pid']) {
                            if ($row_mp['sorting'] < $row['sorting']) {
                                $sorting = $row['sorting'] - 1;
                                $pid = $row['pid'];
                                # alles was kleiner oder gleich $sorting um 1 reduzieren
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->WhereColName('pid')
                                              ->WhereColValue($pid)
                                              ->Andd("AND sorting < " . $row['sorting'] . " AND sorting > " . $row_mp['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array(  "lastUpdated"   => time(), 
                                                            "sorting"       => "sorting-1"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                            } else {
                                $sorting = $row['sorting'];
                                $pid = $row['pid'];
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->WhereColName('pid')
                                              ->WhereColValue($pid)
                                              ->Andd("AND sorting >= " . $row['sorting'] . " AND sorting < " . $row_mp['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array(  "lastUpdated"   => time(), 
                                                            "sorting"       => "sorting+1"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                            }

                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($this->DFE->http->_post('muid'))
                                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array(  "pid"           => $pid, 
                                                        "lastUpdated"   => time(), 
                                                        "sorting"       => $sorting))
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())              
                                          ->doUpdate();
                        } else {
                            $sorting = $row['sorting'];
                            $pid = $row['pid'];
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('pid')
                                          ->WhereColValue($pid)
                                          ->Andd("AND sorting >= " . $row['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array(  "lastUpdated"   => time(), 
                                                        "sorting"       => "sorting+1"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('pid')
                                          ->WhereColValue($row_mp['pid'])
                                          ->Andd("AND sorting > " . $row_mp['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array(  "lastUpdated"   => time(), 
                                                        "sorting"       => "sorting-1"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($this->DFE->http->_post('muid'))
                                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array(  "pid"           => $pid, 
                                                        "lastUpdated"   => time(), 
                                                        "sorting"       => $sorting))
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                        }

                        # Nested Sets Modell
                        # Löschen des Knoten und seiner Unterpunkte
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft BETWEEN " . $row_mp['lft'] . " AND " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Set(array("move_update" => 1))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate(); 
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft > " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang). " AND move_update != 1")
                                      ->Set(array("lft" => "lft-ROUND(" . $row_mp['rgt'] . "-" . $row_mp['lft'] . "+1)"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE rgt > " . $row_mp['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang)." AND move_update != 1")
                                      ->Set(array("rgt" => "rgt-ROUND(" . $row_mp['rgt'] . "-" . $row_mp['lft'] . "+1)"))
                                      ->SetType(false)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        
                        # Gelöschten Knoten und Unterpunkte auslesen
                        $this->DFE->db->Select('uid, pid, lft, rgt, sorting')
                                      ->From($this->DFE->Pages)
                                      ->noWhere(1)
                                      ->Andd("WHERE lft BETWEEN " . $row_mp['lft'] . " AND " . $row_mp['rgt'] . " AND move_update = 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Order('ORDER BY lft')
                                      ->SelectMethod(1)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        
                        $row2 = $this->DFE->db->SelectPuffer;
                        $num2 = $this->DFE->db->Rows;
                        for ($i = 0; $i < $num2; $i++) {
                            if ($i == 0) {
                                # Knoten wird über der Seite eingefügt                                
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt > " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft >= " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $lft = $row['lft'];
                                $rgt = $row['lft'] + 1;
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE uid = " . $row2[$i]['uid'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => $rgt, "lft" => $lft))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();                            
                            } else {
                                # Alle anderen Unterpunkte werden mit "in" eingefügt
                                $this->DFE->db->Select('rgt')
                                              ->From($this->DFE->Pages)
                                              ->WhereColName('uid')
                                              ->WhereColValue($row2[$i]['pid'])
                                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Order("ORDER BY sorting ASC")
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doSelect();
                                $rows = $this->DFE->db->SelectPuffer;

                                # Nested Sets Modell
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft > " . $rows['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt >= " . $rows['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                

                                $lft = $rows['rgt'];
                                $rgt = ($rows['rgt'] + 1);
                                
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE uid = " . $row2[$i]['uid'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => $rgt, "lft" => $lft))
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();                             
                            }
                        }
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->Set(array("move_update" => 0))
                                      ->noWhere(1)
                                      ->doUpdate();
                        break;
                }

                # Page hash berechnen
                $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 0, 1, '', '', true) : \lib\fe_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 0, 1, '', '');
                $page_Hash = md5($page_Hash);

                # Update page hash
                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Set(array("page_Hash" => $page_Hash))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doUpdate();

                # Level Updaten
                $this->DFE->db->Select("COUNT(*)-1 AS level")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                              ->noWhere(1)
                              ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                              ->Group("GROUP BY n.lft")
                              ->Order("ORDER BY n.lft") 
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                              ->doSelect();
                $row3 = $this->DFE->db->SelectPuffer;
                $this->DFE->db->Update($this->DFE->Pages)
                              ->noWhere(1)
                              ->Andd("WHERE uid = :uid " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Set(array("level" => $row3['level']))
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                              ->doUpdate();

                $this->setAbsolutePath(intval($this->DFE->http->_post('uid')));

                header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']));
                exit;
            } else {
                $save_message = "Bitte wählen Sie eine Seite über den Seiten-Browser aus!";
                $this->DFE->TT->BlockMarker['save'] = 1;
            }
        }

        $this->DFE->db->Select('uid, pid, lft, rgt, sorting, nav_title')
                      ->From($this->DFE->Pages)
                      ->WhereColName('uid')
                      ->WhereColValue($this->DFE->http->_post('uid'))
                      ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();
        $row = $this->DFE->db->SelectPuffer;
        
        # BE Rights Move Site
        $this->DFE->TT->setMC('be_rights',      $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][7] == 1 ? '' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_page_move'].'"')
                      ->setMC('nav_title',      stripslashes($row['nav_title']))
                      ->setMC('last_sorting',   $row['sorting'])
                      ->setMC('last_pid',       $row['pid'])
                      ->setMC('muid',           $row['uid'])
                      ->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                      ->setMC('lang',           $GLOBALS['LANGUAGE'])
                      ->setMC('fb',             $this->DFE->http->issetPost('FB') === true && $this->DFE->http->_post('FB') == 'be_' ? '&FB=be_' : '');
        
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    /*
     * absoluten Link Pfad updaten
     *
     */

    public function setAbsolutePath($pid = 0) {
        
        static $level = 0;

        $this->DFE->db->Select("uid")
                      ->From($this->DFE->Pages)
                      ->WhereColName("pid")
                      ->WhereColValue($pid)
                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->Order("ORDER BY sorting ASC")
                      ->SelectMethod(1)
                      ->doSelect();

        $num = $this->DFE->db->Rows;
        if ($num) {
            foreach ($this->DFE->db->SelectPuffer as $key => $row) {
                # Page hash berechnen
                $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($row['uid'], '', 0, 1, 1, '', '', true) : \lib\fe_menu::getTreePathNames($row['uid'], '', 0, 1, 1, '', ''); 
                $page_Hash = md5($page_Hash . ".html");

                # Update page hash
                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($row['uid'])
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Set(array("page_Hash" => $page_Hash, "lastUpdated" => CURRENT_TIME))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doUpdate();

                # Level Updaten
                $this->DFE->db->Select("COUNT(*)-1 AS level")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                              ->noWhere(1)
                              ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                              ->Group("GROUP BY n.lft")
                              ->Order("ORDER BY n.lft")
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $row['uid'], 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $row['uid']))
                              ->doSelect();
                $row3 = $this->DFE->db->SelectPuffer;
                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($row['uid'])
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Set(array("level" => $row3['level']))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doUpdate();
                $level++;
                $tmp = $this->setAbsolutePath($row['uid']);
            }
        }
    }

    /*
     * Edit page
     *
     */

    public function EditPage() {
        
        require_once BE_MENU;
        require_once FE_MENU;
        
        # Status wurde ausgeblendet, da die Hauptregel über den Browser läuft
        $this->DFE->TT->BlockMarker['status']   = 0;
        $this->DFE->TT->BlockMarker['sys_lang'] = SYS_LANGUAGE != $GLOBALS['LANGUAGE'] ? 1 : 0;
        $this->DFE->db->TablePreName = $this->FB;
        $this->DFE->db->Select('*')
                      ->From($this->DFE->Pages)
                      ->WhereColName('uid')
                      ->WhereColValue($this->DFE->http->_post('uid'))
                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();
        $row = $this->DFE->db->SelectPuffer;
        $aribu                  = $this->BE == "BE" ? '/aribu.systems' : '';
        $pageSettings           = unserialize($row['pageSettings']);
        $tpl                    = $this->getFileTreeArray(DOC_ROOT . $aribu . "/_templates");
        

        # Installed Content Module
        $module = $this->DFE->http->issetPost('plugin') === true ? $this->DFE->http->_post('plugin') : $row['module'];
        foreach ($GLOBALS['INSTALLED_MODULES'] as $key => $val) {
            $this->DFE->db->TablePreName = "fe_";
            $this->DFE->db->Select('config_description')
                          ->From("system_config")
                          ->WhereColName('config_title')
                          ->WhereColValue('INSTALLED_MODULES')
                          ->Andd("AND config_key = '" . $key . "' AND config_value = '" . $val . "' AND config_lang = :lang ")
                          ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                          ->doSelect();
            $num = $this->DFE->db->Rows;

            if (strtolower($module) == $key) {
                $module_options .= "<option value=\"" . $key . "\" selected>" . $val . "</option>\n";
                if ($this->DFE->db->SelectPuffer['config_description'] != "") {
                    $plugin_setup_name = '<li><a data-target="#' . $key . '" data-toggle="tab">' . ucfirst($key) . '</a></li>';
                    if (file_exists($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems" . $this->DFE->db->SelectPuffer['config_description'])) {
                        include($_SERVER['DOCUMENT_ROOT'] . "/aribu.systems" . $this->DFE->db->SelectPuffer['config_description']);
                    }
                }
            } else {
                $module_options .= "<option value=\"" . $key . "\">" . $val . "</option>\n";
            }
        }
        
        
        $this->DFE->db->TablePreName = "fe_";
        $this->DFE->db->Select('*')
                      ->From('user_accounts')
                      ->WhereColName('user_rights')
                      ->WhereColValue('256')
                      ->SelectMethod(1)
                      ->doSelect();
        $num_c = $this->DFE->db->Rows;
        if ($num_c) {
            $row_c = $this->DFE->db->SelectPuffer;
            for ($a = 0; $a < $num_c; $a++) {
                $selected = $row['perms_userid'] == $row_c[$a]['user_id'] ? " selected" : "";
                $fe_rights_customers .= "<option value=\"" . $row_c[$a]['user_id'] . "\"" . $selected . ">" . $row_c[$a]['user_lastname'] . "</option>";
            }
        }

        # Seiten-Rechte BE-User
        $this->DFE->db->TablePreName = "be_";
        $this->DFE->db->Select('*')
                      ->From('user_groups')
                      ->noWhere(1)
                      ->SelectMethod(1)
                      ->doSelect();
        $numg = $this->DFE->db->Rows;
        $rowg = $this->DFE->db->SelectPuffer;
        for ($i = 0; $i < $numg; $i++) {
            $selected = $pageSettings['be_rights'] == $rowg[$i]['id'] ? " selected" : "";
            $bek_rights .= "<option value=\"" . $rowg[$i]['id'] . "\"" . $selected . ">" . $rowg[$i]['name'] . "</option>";
        }
        
        # Seiten-Rechte BE-User
        $this->DFE->db->Select('*')
                      ->From('user')
                      ->NoWhere(1)
                      ->SelectMethod(1)
                      ->doSelect();
        $numu = $this->DFE->db->Rows;
        $rowu = $this->DFE->db->SelectPuffer;
        for ($i = 0; $i < $numu; $i++) {
            $selected = $this->DFE->http->_post('perms_be_userid') == $rowu[$i]['uid'] ? " selected" : "";
            $bek_user_rights .= "<option value=\"" . $rowu[$i]['uid'] . "\"" . $selected . ">" . $rowu[$i]['full_name'] . "</option>";
        }
        
        $this->DFE->db->TablePreName = $this->FB;
        $browser = \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']);
                   
        $this->DFE->TT->setMC('uid',                            $this->DFE->http->_post('uid'))
                      ->setMC('lang',                           $GLOBALS['LANGUAGE'])
                      ->setMC('plugin_setup_name',              $plugin_setup_name)
                      ->setMC('installed_plugin_setup',         $installed_plugin_setup)
                      ->setMC('be_rights',                      $_SESSION['sess_uid'] == $row['cruser_id'] || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][3] == 1 || $_SESSION['BE_Rights'] == 1 ? '' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['rights_lock_group'].'"')
                      ->setMC('page_search0',                   $row['search'] == 0 && isset($row['search']) ? "checked" : "")
                      ->setMC('page_search1',                   $row['search'] == 1 ? "checked" : "")
                      ->setMC('templates',                      $this->getTemplateOptions($tpl, '', $row['sitetpl']))
                      ->setMC('template_not_logged_in',         $this->getTemplateOptions($tpl, '', $pageSettings['Template_Not_Logged_In']))
                      ->setMC('module_options',                 $module_options)
                      ->setMC('doctype',                        \lib\Functions::getOptions($GLOBALS['BE_DOCTYPES_NAMES'], intval($row['docType'])))
                      ->setMC('urltypes',                       \lib\Functions::getOptions($GLOBALS['BE_URL_TYPES'], $row['urltype']))
                      ->setMC('expire_cache',                   \lib\Functions::getOptions($GLOBALS['EXPIRE_CACHE_TIME'], $pageSettings['expireCache']))
                      ->setMC('fe_rights',                      \lib\Functions::getOptions($GLOBALS['FE_USER_RIGHTS'], $row['perms_groupid']))
                      ->setMC('pagecache',                      isset($pageSettings['pageCache']) ? ' checked="checked"' : '')
                      ->setMC('display_customers',              $row['perms_groupid'] == "256" ? '' : 'display:none;')
                      ->setMC('index1',                         $pageSettings['Index'] == 1 ? 'checked="checked"' : (isset($pageSettings['Index']) ? '' : 'checked="checked"'))
                      ->setMC('index2',                         $pageSettings['Index'] == 2 ? 'checked="checked"' : '')
                      ->setMC('use_css',                        $row['this_css'] == 1 ? 'checked="checked"' : '')
                      ->setMC('content_from_pid_option',        $row['content_from_pid'] != 0 ? '<option selected value="' . $row['content_from_pid'] . '">' . \lib\Functions::breadcrumb($row['content_from_pid'], "dot".$this->FBup."Menu", $GLOBALS['LANGUAGE']). '</option>' : '')
                      ->setMC('backlink',                       $this->DFE->http->issetPost('jpid') === false ? $browser : \lib\Functions::dotLinkBE($this->DFE->http->_post('jpid'), $GLOBALS['LANGUAGE']) . '?ac=ContentOverview&uid=' . $this->DFE->http->_post('uid') . '&colP=0&jid=' . $GLOBALS['PageConfig']['UID'])
                      ->setMC('isroot',                         $row['spid'] == 0 ? '' : 'checked="checked"')
                      ->setMC('navi_title',                     htmlspecialchars(stripslashes($row['nav_title'])))
                      ->setMC('external_url',                   htmlentities(stripslashes($row['url'])))
                      ->setMC('description',                    stripslashes($row['description']))
                      ->setMC('url_target',                     $row['target'])
                      ->setMC('site_uid',                       $this->DFE->http->_post('uid'))
                      ->setMC('BrowserTitle',                   stripslashes($row['BrowserTitle']))
                      ->setMC('keywords',                       stripslashes($row['keywords']))
                      ->setMC('link_title',                     stripslashes($row['link_title']))
                      ->setMC('sid',                            $_SESSION['session_id'])
                      ->setMC('syslang',                        SYS_LANGUAGE)
                      ->setMC('pid',                            $row['pid'])
                      ->setMC('js',                             stripslashes($row['Javascript']))
                      ->setMC('stylesheet',                     stripslashes($row['Stylesheet']))
                      ->setMC('link_icon_path',                 preg_match("#<#ism", $pageSettings['LinkIcon'], $hit) || !strstr($pageSettings['LinkIcon'], '/') ? htmlentities(stripslashes(base64_decode($pageSettings['LinkIcon'])), ENT_QUOTES, "UTF-8") : $pageSettings['LinkIcon'])
                      ->setMC('link_css',                       $pageSettings['LinkCSS'])
                      ->setMC('copy_attributes_link',           "?ac=CopyPageAttributes&uid=" . $this->DFE->http->_post('uid'))
                      ->setMC('copy_attributes_tmp_link',       "?ac=CopyPageAttributes&attr=tmp&uid=" . $this->DFE->http->_post('uid'))
                      ->setMC('copy_attributes_doctype_link',   "?ac=CopyPageAttributes&attr=doctype&uid=" . $this->DFE->http->_post('uid'))
                      ->setMC('copy_attributes_type_link',      "?ac=CopyPageAttributes&attr=type&uid=" . $this->DFE->http->_post('uid'))
                      ->setMC('copy_attributes_search_link',    "?ac=CopyPageAttributes&attr=search&uid=" . $this->DFE->http->_post('uid'))
                      ->setMC('pages',                          $this->DFE->Pages)
                      ->setMC('bek_rights',                     $bek_rights)
                      ->setMC('bek_user_rights',                $bek_user_rights)
                      ->setMC('fe_rights_customers',            $fe_rights_customers)
                      ->setMC('fb',                             $this->FB == 'be_' ? "&FB=be_" : "");
            
        
        if ($this->DFE->http->issetPost('save_editsite') === false && $this->DFE->http->issetPost('save_editsite_close') === false) {
            if(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            } elseif($this->DFE->http->issetPost('saved') === true) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->DFE->TT->getMC('_savepageok'), 'messenger-on-top messenger-on-right', 'success'));
            }   
            
        } else {
            if ($this->DFE->http->isEmpty('nav_title') === false) {
                $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);

                $LinkIcon = preg_match("#<#ism", $this->DFE->http->_post('LinkIcon'), $hit) ? base64_encode($this->DFE->http->_post('LinkIcon')) : $this->DFE->http->_post('LinkIcon');

                $pageSettings = $this->PreparePageSettings($LinkIcon);
                $this->DFE->db->TablePreName = $this->FB;
                
                $update_array = array(  "pageSettings"      => $pageSettings, 
                                        "docType"           => $this->DFE->http->_post('docType'), 
                                        "spid"              => $this->DFE->http->_post('spid'), 
                                        "pagename"          => $new_pagename, 
                                        "url"               => $this->DFE->http->_post('url'), 
                                        "urltype"           => $this->DFE->http->_post('urltype'), 
                                        "target"            => $this->DFE->http->_post('target'), 
                                        "nav_title"         => $this->DFE->http->_post('nav_title'), 
                                        "lastUpdated"       => time(), 
                                        "description"       => $this->DFE->http->_post('description'), 
                                        "author"            => $_SESSION['sess_username'], 
                                        "author_email"      => $_SESSION['sess_user_email'], 
                                        "sitetpl"           => $this->DFE->http->_post('sitetpl'), 
                                        "module"            => $this->DFE->http->_post('module'), 
                                        "content_from_pid"  => $this->DFE->http->_post('content_from_pid'), 
                                        "BrowserTitle"      => $this->DFE->http->_post('BrowserTitle'), 
                                        "keywords"          => $this->DFE->http->_post('keywords'), 
                                        "perms_userid"      => $this->DFE->http->_post('perms_userid'), 
                                        "perms_groupid"     => $this->DFE->http->_post('perms_groupid'), 
                                        "link_title"        => $this->DFE->http->_post('link_title'), 
                                        "Javascript"        => $this->DFE->http->_post('Javascript'), 
                                        "Stylesheet"        => $this->DFE->http->_post('Stylesheet'), 
                                        "this_css"          => $this->DFE->http->_post('this_css'), 
                                        "perms_be_userid"   => $this->DFE->http->_post('perms_be_userid'), 
                                        "search"            => $this->DFE->http->_post('search'));
                
                if ($GLOBALS['LANGUAGE'] == SYS_LANGUAGE) {
                    $OldNavTitle =  $this->GetOneValueFromPages('nav_title', 'uid', $this->DFE->http->_post('uid'));
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Set($update_array)
                                  ->doUpdate();
                } else {
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Set(array_merge($update_array, array("rid" => $this->DFE->http->_post('rid'))))
                                  ->doUpdate();
                }

                # FE-Rights setzen: Gruppe
                if ($this->DFE->http->_post('site_rights') > 0) {
                    $this->DFE->db->Select("o.uid")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                                  ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                                  ->Group("GROUP BY o.lft")
                                  ->Order("ORDER BY o.lft")
                                  ->SelectMethod(1)
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    if ($num) {
                        $row = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num; $i++) {
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($row[$i]['uid'])
                                          ->Set(array(  "lastUpdated" => time(), 
                                                        "perms_groupid" => $this->DFE->http->_post('site_rights'), 
                                                        "perms_userid" => $this->DFE->http->_post('customers_rights')))
                                          ->doUpdate();
                        }
                    }
                }

                # BE-Rights setzen: User
                if ($this->DFE->http->_post('be_user_rights') > 0) {
                    $this->DFE->db->Select("o.uid")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                                  ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                                  ->Group("GROUP BY o.lft")
                                  ->Order("ORDER BY o.lft")
                                  ->SelectMethod(1)
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    if ($num) {
                        $row = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num; $i++) {
                             $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($row[$i]['uid'])
                                          ->Set(array(  "lastUpdated" => time(), 
                                                        "perms_be_userid" => $this->DFE->http->_post('be_user_rights')))
                                          ->doUpdate();
                            
                        }
                    }
                }

                # Page hash berechnen
                $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 0, 1, '', ' AND p.docType != 0 ', true) : \lib\fe_menu::getTreePathNames($this->DFE->http->_post('uid'), '', 0, 0, 1);
                $page_Hash = md5($page_Hash);

                # Update page hash
                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Set(array("page_Hash" => $page_Hash))
                              ->doUpdate();

                $this->setAbsolutePath($this->DFE->http->_post('uid'));
                $browser = \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']);    
                
                if($this->DFE->http->_post('docType') == 0 && $this->FB == 'fe_') {
                    $cssFolderArr = explode(".", $this->DFE->http->_post('nav_title'));
                    $cssFolderName = $cssFolderArr[1];
                    $newCssFolderPath = DOC_ROOT . "/fileadmin/css/" . $cssFolderName;
                    
                    $cssOldFolderArr = explode(".", $OldNavTitle);
                    $cssOldFolderName = $cssOldFolderArr[1];
                    $oldCssFolderPath = DOC_ROOT . "/fileadmin/css/" . $cssOldFolderName;
                    
                    if(!file_exists($newCssFolderPath)) {   
                        \lib\Functions::rcopy($oldCssFolderPath, $newCssFolderPath);  
                    }
                    
                }
                
                
                if ($this->DFE->http->issetPost('save_editsite') === true) {
                    
                    $query_string = $this->DFE->http->issetPost('jpid') === true ? '&jpid=' . $this->DFE->http->_post('jpid') : '';
                    header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Pages'], $GLOBALS['LANGUAGE']) . "?ac=EditPage&saved=ok&uid=" . $this->DFE->http->_post('uid') . $query_string);
                    exit;
                } else {
                    $jurl = $this->DFE->http->issetPost('jpid') === false ? $browser : \lib\Functions::dotLinkBE($this->DFE->http->_post('jpid'), $GLOBALS['LANGUAGE']) . '?ac=ContentOverview&uid=' . $this->DFE->http->_post('uid') . '&colP=0&jid=' . $GLOBALS['PageConfig']['UID'];
                    header("Location: " . $jurl);
                    exit;
                }
            } else {
                $this->DFE->http->unsetPost('save_editsite')->unsetPost('save_editsite_close');
                $this->Error['Validation'] = 'Speicher-Fehler! Bitte geben Sie einen Seitennamen ein';
                
                $this->EditPage();    
            }
        }

        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/edit_page.html');
    }


    /*
     * Page link
     *
     */

    public function PageLink($template="/aribu.systems/_templates/pages/edit_page_link.html") {
        
        $backend    = $this->FB == 'be_' ? ARIBU_SYSTEMS_SFOLDER : '';
        $imgHandle  = new \lib\Image();
        
        if ($this->DFE->http->issetPost('save_editlink') === false) {

            # Daten holen
            $this->DFE->db->Select("p.button, p.button_path, p.button_act_path, p.nav_title")
                          ->From($this->DFE->Pages . " p")
                          ->WhereColName('p.uid')
                          ->WhereColValue($this->DFE->http->_post('uid')) 
                          ->Andd("AND p.deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            
            $server_button = \lib\Functions::readDirectory(DOC_ROOT . $backend . '/fileadmin/buttons');
            
            # Normal button 
            foreach ($server_button as $key => $val) {
                if (!preg_match('#.LCK#', $val, $match)) {
                    $selectedButton = $val == $row['button_path'] ? "selected" : "";
                    $server_buttons .= "<option value=\"$val\" " . $selectedButton . ">" . $val . "</option>\n";
                }
            }

            # Active button
            foreach ($server_button as $key => $val) {
                if (!preg_match('#.LCK#', $val, $match)) {
                    $selectedButton = $val == $row['button_act_path'] ? "selected" : "";
                    $server_buttons_active .= "<option value=\"$val\" " . $selectedButton . ">" . $val . "</option>\n";
                }
            }
            
            
            if(\lib\Functions::CheckIfDirectoryExists(DOC_ROOT. $backend . '/fileadmin/buttons/')){}
            
            $this->DFE->TT->setMC('page_name',              stripslashes($row['nav_title']))
                          ->setMC('dpb',                    'block')
                          ->setMC('bal',                    $row['button'] == 0 ? "none" : "block")
                          ->setMC('bal1',                   $row['button'] == 0 ? '' : 'checked="checked"')
                          ->setMC('bal2',                   $row['button'] == 0 ? 'checked="checked"' : '')
                          ->setMC('server_buttons_path',    URL_PROTOCOL . '://' . URL_HOST . $backend . '/fileadmin/buttons/')
                          ->setMC('server_buttons',         $server_buttons)
                          ->setMC('server_buttons_active',  $server_buttons_active)
                          ->setMC('first_button_img',       !empty($row['button_path']) ? $backend . "/fileadmin/buttons/" . $row['button_path'] : $backend . "/fileadmin/img/empty.gif")
                          ->setMC('second_button_img',      !empty($row['button_act_path']) ? $backend . "/fileadmin/buttons/" . $row['button_act_path'] : $backend . "/fileadmin/img/empty.gif")
                          ->setMC('be_rights',              $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][9] == 1 ? '' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_page_links'].'"')
                          ->setMC('uid',                    $this->DFE->http->_post('uid'))
                          ->setMC('backlink',               \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']));
        } else {
            if ($this->DFE->http->issetPost('img_upload') === true && $this->DFE->http->_post('img_upload') == 1 && $this->DFE->http->_post('navi_hide') != 1 && $this->DFE->http->_post('sb') == 1 && $this->DFE->http->_post('sb2') == 1) {
                $imgHandle->HoldImageName = 1;
                $image = $imgHandle->imageUpload('', '', DOC_ROOT . $backend . '/fileadmin/buttons/');
                if ($image) {
                    # Update der neuen Daten
                    if ($this->DFE->http->_post('te') == 1) {
                        $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                        $UpdateNameArr = array("nav_title" => $this->DFE->http->_post('nav_title'), "pagename" => $new_pagename);
                    } else {
                        $UpdateNameArr = array();
                    }
                    if ($this->DFE->http->isEmpty('imagefiles') === false) {
                        $UpdateOthArr = array("button" => 1, "button_path" => $this->DFE->http->_post('imagefiles'), "button_act_path" => $image[1], "lastUpdated" => time());
                    } elseif ($this->DFE->http->isEmpty('imagefiles2') === false) {
                        $UpdateOthArr = array("button" => 1, "button_path" => $image[0], "button_act_path" => $this->DFE->http->_post('imagefiles2'), "lastUpdated" => time());
                    } else {
                        $UpdateOthArr = array("button" => 1, "button_path" => $image[0], "button_act_path" => $image[1], "lastUpdated" => time());
                    }
                    $SET = array_merge($UpdateNameArr, $UpdateOthArr);

                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Set($SET)
                                  ->doUpdate();

                    header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']));
                    exit;
                } else {
                    $this->DFE->http->unsetPost('save_editlink');
                    $this->PageLink();
                    
                }
            } else {
                # Update der neuen Daten
                if ($this->DFE->http->_post('te') == 1) {
                    $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                    $UpdateNameArr = array("nav_title" => $this->DFE->http->_post('nav_title'), "pagename" => $new_pagename);
                } else {
                    $UpdateNameArr = array();
                }

                if ($this->DFE->http->_post('img_upload') == 1) {
                    if ($this->DFE->http->isEmpty('imagefiles') === false || $this->DFE->http->isEmpty('imagefiles2') === false) {
                        $UpdateOthArr = array("button" => 1, "button_path" => $this->DFE->http->_post('imagefiles'), "button_act_path" => $this->DFE->http->_post('imagefiles2'), "lastUpdated" => time());
                    }
                } else {
                    $UpdateOthArr = array("button" => 0, "lastUpdated" => time());
                }
                $SET = array_merge($UpdateNameArr, $UpdateOthArr);

                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Set($SET)
                              ->doUpdate();

                header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']));
                exit;
            }
        }
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    /*
     * Set time
     *
     */

    public function PageTimeSet($template="/aribu.systems/_templates/pages/time_setup.html") {
        
                
        if ($this->DFE->http->issetPost('save_settime') === false ) {
            # Hole Zeiten
            $this->DFE->db->Select('uid, nav_title, starttime, endtime')
                          ->From($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            if ($row['starttime'] != 0 && $row['endtime'] != 0) {
                $starttime = date("H:i", $row['starttime']);
                $endtime = date("H:i", $row['endtime']);
                $startdate = strftime($GLOBALS['COUNTRY_SETTINGS']['dateformat'], $row['starttime']);
                $enddate = strftime($GLOBALS['COUNTRY_SETTINGS']['dateformat'], $row['endtime']);
            }

                        
            $this->DFE->TT->BlockMarker['save'] = 0;
            
            $this->DFE->TT->setMC('starttime',      $starttime)
                          ->setMC('endtime',        $endtime)
                          ->setMC('startdate',      $startdate)
                          ->setMC('enddate',        $enddate)
                          ->setMC('be_rights',      $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][8] == 1 ? '' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_time_setting'].'"')
                          ->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                          ->setMC('page_uid',       $this->DFE->http->_post('uid'))
                          ->setMC('page_name',      stripslashes($row['nav_title']));
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('timestart') != '') {
                $timestart = explode(":", $this->DFE->http->_post('timestart'));
                $timestop = explode(":", $this->DFE->http->_post('timestop'));
            } else {
                $timestart = array(0, 0);
                $timestop = array(0, 0);
            }

            $date_fh = explode($GLOBALS['COUNTRY_SETTINGS']['date_seperator'], $GLOBALS['COUNTRY_SETTINGS']['datepicker_dateformat']);
            $daykey = array_search("dd", $date_fh);
            $monthkey = array_search("mm", $date_fh);
            $yearkey = array_search("yy", $date_fh);

            $sd = explode($GLOBALS['COUNTRY_SETTINGS']['date_seperator'], $this->DFE->http->_post('startdate'));
            $ed = explode($GLOBALS['COUNTRY_SETTINGS']['date_seperator'], $this->DFE->http->_post('enddate'));

            $start = $this->DFE->http->_post('startdate') != "" ? mktime($timestart[0], $timestart[1], 0, $sd[$monthkey], $sd[$daykey], $sd[$yearkey]) : "";
            $stop = $this->DFE->http->_post('enddate') != "" ? mktime($timestop[0], $timestop[1], 0, $ed[$monthkey], $ed[$daykey], $ed[$yearkey]) : "";


            if ($start > $stop && $start != "" && $stop != "") {
                # Zeiten holen
                $this->DFE->db->Select('nav_title')
                          ->From($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->doSelect();
                
                $row = $this->DFE->db->SelectPuffer;
                
                
                $startdate = $this->DFE->http->_post('startdate');
                $enddate = $this->DFE->http->_post('enddate');
                $starttime = $this->DFE->http->_post('timestart');
                $endtime = $this->DFE->http->_post('timestop');
                                
                $this->DFE->TT->setMC('starttime',      $starttime)
                              ->setMC('endtime',        $endtime)
                              ->setMC('startdate',      $startdate)
                              ->setMC('enddate',        $enddate)
                              ->setMC('be_rights',      $_SESSION['BE_Rights'] == 1 || $_SESSION['sess_rights']['BE_SYSTEM_RIGHTS'][8] == 1 ? '' : 'data-toggle="tooltip" data-placement="top" title="'.$this->be_language['_rights_time_setting'].'"')
                              ->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                              ->setMC('page_uid',       $this->DFE->http->_post('uid'))
                              ->setMC('page_name',      stripslashes($row['nav_title']));
                
                
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($be_language['_time_setting_error'], 'messenger-on-top messenger-on-right', 'error'));
                 
            } else {
                if ($this->DFE->http->issetPost('setoff') === false) {
                    $this->DFE->db->Select("o.uid")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = " . $this->DFE->http->_post('uid') . " " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                                  ->Group('GROUP BY o.lft')
                                  ->Order('ORDER BY o.lft')
                                  ->SelectMethod(1)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    if ($num) {
                        $row = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num; $i++) {
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($row[$i]['uid'])
                                          ->Set(array(  "starttime"     => $start, 
                                                        "endtime"       => $stop, 
                                                        "lastUpdated"   => time()))
                                          ->doUpdate();
                        }
                    }
                } else {
                    $this->DFE->db->Select("o.uid")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = " . $this->DFE->http->_post('uid') . " " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                                  ->Group('GROUP BY o.lft')
                                  ->Order('ORDER BY o.lft')
                                  ->SelectMethod(1)
                                  ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                    if ($num) {
                        $row = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num; $i++) {
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($row[$i]['uid'])
                                          ->Set(array(  "starttime"     => 0, 
                                                        "endtime"       => 0, 
                                                        "lastUpdated"   => time()))
                                          ->doUpdate();
                            
                        }
                    }
                }
                header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']));
                exit;
            }
            
        }
        $this->DFE->TT->setMC('datepicker_lang', $GLOBALS['COUNTRY_SETTINGS']['datepicker']);
            
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    public function GetOneValueFromPages($name, $ColName, $ColValue) {
        $this->DFE->db->Select($name)
                      ->From($this->DFE->Pages)
                      ->WhereColName($ColName)
                      ->WhereColValue($ColValue)
                      ->doSelect();
        return $this->DFE->db->SelectPuffer[$name];
    }
    
    /**
     * Copy page
     * @return string
     */
    public function CopyPage() {
        
        if ($this->DFE->http->issetPost('save_site_copy') === false && $this->DFE->http->issetPost('save_site_copy_new') === false) {
                                   
            $this->DFE->TT->setMC('pagename',       stripslashes($this->GetOneValueFromPages('nav_title', 'uid', $this->DFE->http->_post('uid'))))
                          ->setMC('uid',            $this->DFE->http->_post('uid'))
                          ->setMC('sid',            $_SESSION['sess_id'])
                          ->setMC('lang',           $GLOBALS['LANGUAGE'])
                          ->setMC('sout',           'selected="selected"')
                          ->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                          ->setMC('copy_content1',  $this->DFE->http->_post('copy_content') == 1 ? 'checked="checked"' : '')
                          ->setMC('copy_content2',  $this->DFE->http->issetPost('copy_content') === true && $this->DFE->http->_post('copy_content') == 2 ? 'checked="checked"' : ($this->DFE->http->issetPost('copy_content') === false ? 'checked="checked"' : ''))
                          ->setMC('fb',             $this->FB == 'be_' ? '&FB=be_' : '');
            
            
            if ($this->DFE->http->issetPost('saved') === true) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger('Die Kopie wurde erfolgreich gespeichert.', 'messenger-on-top messenger-on-right', 'success'));
            } elseif(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));  
            }
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('lastUID') == 0) {
                $err = 1;
                $this->Error['Validation'] .= $this->be_language['_copy_page_error'].'<br>';
            }
            if ($this->DFE->http->isEmpty('nav_title') === true) {
                $err = 1;
                $this->Error['Validation'] .= $this->be_language['_copy_page_navtitle_error'].'<br>';
            }

            if ($this->DFE->http->_post('lastUID') == "x") {
                $err = 1;
                $this->Error['Validation'] .= "Bitte wählen Sie eine Seite aus unter der Sie die neue Seite einfügen möchten!<br>";
            } else {
                # Seiten vergleichen
                if ($this->DFE->http->_post('join') == "out" || $this->DFE->http->_post('join') == "over") {
                    $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                    $pid = $this->GetOneValueFromPages('pid', 'uid', $this->DFE->http->_post('lastUID'));
                    $this->DFE->db->Select('uid')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($pid)
                                  ->Andd("AND pagename = '" . $new_pagename . "'")
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                } else {
                    $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                    $this->DFE->db->Select('uid')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($this->DFE->http->_post('lastUID'))
                                  ->Andd("AND pagename = '" . $new_pagename . "'")
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                }
                if ($num) {
                    $err = 1;
                    $this->Error['Validation'] .= "Die Seite mit dem Namen existiert bereits. Bitte wählen Sie einen anderen Namen.<br>";
                }
            }


            if ($err == 1) {
                $this->DFE->http->unsetPost('save_site_copy')->unsetPost('save_site_copy_new');
                $this->CopyPage();
            } else {
                $this->DFE->db->Select('uid, pid, rgt, lft, sorting, nav_title')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('lastUID'))
                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    
                    switch ($this->DFE->http->_post('join')) {
                        case 'in': # in die Seite
                            $this->DFE->db->Select('sorting')
                                          ->From($this->DFE->Pages)
                                          ->WhereColName('pid')
                                          ->WhereColValue($this->DFE->http->_post('lastUID'))
                                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Order('ORDER BY sorting DESC')
                                          ->SelectMethod(1)
                                          ->doSelect();
                            $num_s = $this->DFE->db->Rows;
                            $sorting = $num_s > 0 ? $num_s + 1 : 1;
                            $pid = $row['uid'];

                            # Nested Sets Modell
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->noWhere(1)
                                          ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array("lft" => "lft+2"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->noWhere(1)
                                          ->Andd("WHERE rgt >= " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array("rgt" => "rgt+2"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            
                            $lft = $row['rgt'];
                            $rgt = $row['rgt'] + 1;
                            break;

                        case 'out': # nach einer Seite
                            $sorting = $row['sorting'] + 1;
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('pid')
                                          ->WhereColValue($row['pid'])
                                          ->Andd("AND sorting > " . $row['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array(  "sorting"       => "sorting+1", 
                                                        "lastUpdated"   => time()))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            $pid = $row['pid'];

                            # Nested Sets Modell
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->noWhere(1)
                                          ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array("lft" => "lft+2"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->noWhere(1)
                                          ->Andd("WHERE rgt > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array("rgt" => "rgt+2"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            
                            $lft = $row['rgt'] + 1;
                            $rgt = $row['rgt'] + 2;
                            break;

                        case 'over': # Über eine Seite
                            $sorting = $row['sorting'];
                            if ($sorting == 0) {
                                $sorting = 1;
                            }
                            $pid = $row['pid'];
                            # Update der Seite
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('pid')
                                          ->WhereColValue($row['pid'])
                                          ->Andd("AND sorting >= " . $sorting . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array(  "sorting"       => "sorting+1", 
                                                        "lastUpdated"   => time()))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            
                            # Nested Sets Modell
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->noWhere(1)
                                          ->Andd("WHERE rgt > " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array("rgt" => "rgt+2"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->noWhere(1)
                                          ->Andd("WHERE lft >= " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Set(array("lft" => "lft+2"))
                                          ->SetType(false)
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doUpdate();
                            
                            $lft = $row['lft'];
                            $rgt = $row['lft'] + 1;
                            break;
                    }
                } else {
                    $this->DFE->db->Select('uid, pid, sorting, nav_title')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('uid'))
                                  ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                  ->Order("ORDER BY sorting DESC")  
                                  ->doSelect();
                    $row = $this->DFE->db->SelectPuffer;
                    $num = $this->DFE->db->Rows;
                    if ($num) {
                        $sorting = $row['sorting'] + 1;
                        $pid = 0;
                    } else {
                        $sorting = 1;
                        $pid = 0;
                    }
                }

                # Daten der zu kopierenden Seite holen
                $this->DFE->db->Select('*')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($this->DFE->http->_post('uid'))
                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->doSelect();
                $cpr = $this->DFE->db->SelectPuffer;

                $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);

                if ($GLOBALS['LANGUAGE'] == SYS_LANGUAGE) {
                    $this->DFE->db->Insert($this->DFE->Pages)
                                  ->Parameter(array(    'uid'                   => '',
                                                        'pid'                   => $pid, 
                                                        'lft'                   => $lft, 
                                                        'rgt'                   => $rgt, 
                                                        'docType'               => $cpr['docType'], 
                                                        'spid'                  => $cpr['spid'], 
                                                        'tstamp'                => time(), 
                                                        'sorting'               => $sorting, 
                                                        'deleted'               => 0, 
                                                        'perms_userid'          => $cpr['perms_userid'], 
                                                        'perms_groupid'         => $cpr['perms_groupid'], 
                                                        'perms_be_userid'       => $cpr['perms_be_userid'], 
                                                        'perms_be_groupid'      => $cpr['perms_be_groupid'], 
                                                        'crdate'                => time(), 
                                                        'cruser_id'             => $_SESSION['sess_uid'], 
                                                        'pagename'              => $new_pagename, 
                                                        'url'                   => addslashes($cpr['url']), 
                                                        'hidden'                => $cpr['hidden'], 
                                                        'starttime'             => $cpr['starttime'], 
                                                        'endtime'               => $cpr['endtime'], 
                                                        'urltype'               => $cpr['urltype'], 
                                                        'pageSettings'          => $cpr['pageSettings'], 
                                                        'target'                => $cpr['target'], 
                                                        'lastUpdated'            => '', 
                                                        'description'           => addslashes($cpr['description']), 
                                                        'author'                => $_SESSION['sess_username'], 
                                                        'author_email'          => $_SESSION['sess_user_email'], 
                                                        'nav_title'             => \lib\Functions::removeCriticSigns($this->DFE->http->_post('nav_title')), 
                                                        'content_from_pid'      => $cpr['content_from_pid'], 
                                                        'button'                => $cpr['button'], 
                                                        'button_path'           => $cpr['button_path'], 
                                                        'button_act_path'       => $cpr['button_act_path'], 
                                                        'sitetpl'               => $cpr['sitetpl'], 
                                                        'module'                => $cpr['module'], 
                                                        'BrowserTitle'          => addslashes($cpr['BrowserTitle']), 
                                                        'keywords'              => addslashes($cpr['keywords']), 
                                                        'page_Hash'             => '', 
                                                        'link_title'            => addslashes($cpr['link_title']), 
                                                        'move_update'           => '', 
                                                        'Javascript'            => addslashes($cpr['Javascript']), 
                                                        'Stylesheet'            => addslashes($cpr['Stylesheet']), 
                                                        'this_css'              => $cpr['this_css'], 
                                                        'level'                 => '', 
                                                        'search'                => $cpr['search']))
                                  ->doInsert();
                } else {
                    $this->DFE->db->Insert($this->DFE->Pages)
                                  ->Parameter(array(    'uid'                   => '',
                                                        'rid'                   => 0,
                                                        'pid'                   => $pid, 
                                                        'lft'                   => $lft, 
                                                        'rgt'                   => $rgt, 
                                                        'docType'               => $cpr['docType'], 
                                                        'spid'                  => $cpr['spid'], 
                                                        'tstamp'                => time(), 
                                                        'sorting'               => $sorting, 
                                                        'deleted'               => 0, 
                                                        'perms_userid'          => $cpr['perms_userid'], 
                                                        'perms_groupid'         => $cpr['perms_groupid'], 
                                                        'perms_be_userid'       => $cpr['perms_be_userid'], 
                                                        'perms_be_groupid'      => $cpr['perms_be_groupid'], 
                                                        'crdate'                => time(), 
                                                        'cruser_id'             => $_SESSION['sess_uid'], 
                                                        'pagename'              => $new_pagename, 
                                                        'url'                   => addslashes($cpr['url']), 
                                                        'hidden'                => $cpr['hidden'], 
                                                        'starttime'             => $cpr['starttime'], 
                                                        'endtime'               => $cpr['endtime'], 
                                                        'urltype'               => $cpr['urltype'], 
                                                        'pageSettings'          => $cpr['pageSettings'], 
                                                        'target'                => $cpr['target'], 
                                                        'lastUpdated'           => '', 
                                                        'description'           => addslashes($cpr['description']), 
                                                        'author'                => $_SESSION['sess_username'], 
                                                        'author_email'          => $_SESSION['sess_user_email'], 
                                                        'nav_title'             => \lib\Functions::removeCriticSigns($this->DFE->http->_post('nav_title')), 
                                                        'content_from_pid'      => $cpr['content_from_pid'], 
                                                        'button'                => $cpr['button'], 
                                                        'button_path'           => $cpr['button_path'], 
                                                        'button_act_path'       => $cpr['button_act_path'], 
                                                        'sitetpl'               => $cpr['sitetpl'], 
                                                        'module'                => $cpr['module'], 
                                                        'BrowserTitle'          => addslashes($cpr['BrowserTitle']), 
                                                        'keywords'              => addslashes($cpr['keywords']), 
                                                        'page_Hash'             => '', 
                                                        'link_title'            => addslashes($cpr['link_title']), 
                                                        'move_update'           => '', 
                                                        'Javascript'            => addslashes($cpr['Javascript']), 
                                                        'Stylesheet'            => addslashes($cpr['Stylesheet']), 
                                                        'this_css'              => $cpr['this_css'], 
                                                        'level'                 => '', 
                                                        'lang'                  => $GLOBALS['LANGUAGE'],
                                                        'search'                => $cpr['search']))
                                  ->doInsert();
                }

                # Page hash berechnen
                $insertUID = $this->DFE->db->LastInsertID;
                $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($insertUID, '', 0, 0, 1, '', '', true) : \lib\fe_menu::getTreePathNames($insertUID, '', 0, 0, 1, '', '');
                
                $page_Hash = md5($page_Hash);

                # Update page hash
                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($insertUID)
                              ->Set(array("page_Hash" => $page_Hash))
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doUpdate();


                # Level Updaten
                $this->DFE->db->Select("COUNT(*)-1 AS level")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                              ->noWhere(1)
                              ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = '" . $insertUID . "' " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                              ->Group("GROUP BY n.lft") 
                              ->Order("ORDER BY n.lft")
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                $row3 = $this->DFE->db->SelectPuffer;
                $this->DFE->db->Update($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($insertUID)
                              ->Set(array("level" => $row3['level']))
                              ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doUpdate();

                # Content kopieren
                if ($this->DFE->http->_post('copy_content') == 1) {
                    foreach ($GLOBALS['CONTENT_MARKER'] as $key => $CMarkerval) {
                        $this->DFE->db->Select('*')
                                      ->From('content')
                                      ->WhereColName('pid')
                                      ->WhereColValue($this->DFE->http->_post('uid'))
                                      ->Andd("AND colP = '" . $key . "' AND lang = :lang ")
                                      ->Order("ORDER BY sorting")
                                      ->SelectMethod(1)
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        $rowcont = $this->DFE->db->SelectPuffer;
                        $numc = $this->DFE->db->Rows;
                        if ($numc) {
                            for ($ci = 0; $ci < $numc; $ci++) {
                                $this->DFE->db->Insert('content')
                                              ->Parameter(array(    'uid'               => '', 
                                                                    'pid'               => $insertUID, 
                                                                    'tstamp'            => $rowcont[$ci]['tstamp'], 
                                                                    'lastUpdated'       => $rowcont[$ci]['lastUpdated'], 
                                                                    'hidden'            => $rowcont[$ci]['hidden'], 
                                                                    'sorting'           => $rowcont[$ci]['sorting'], 
                                                                    'CType'             => $rowcont[$ci]['CType'], 
                                                                    'lang'              => $rowcont[$ci]['lang'], 
                                                                    'bodytext'          => $rowcont[$ci]['bodytext'], 
                                                                    'starttime'         => $rowcont[$ci]['starttime'], 
                                                                    'endtime'           => $rowcont[$ci]['endtime'], 
                                                                    'headline'          => $rowcont[$ci]['headline'], 
                                                                    'subline'           => $rowcont[$ci]['subline'], 
                                                                    'script_method'     => $rowcont[$ci]['script_method'], 
                                                                    'script_path'       => $rowcont[$ci]['script_path'], 
                                                                    'content_name'      => $rowcont[$ci]['content_name'], 
                                                                    'author'            => $rowcont[$ci]['author'], 
                                                                    'colP'              => $rowcont[$ci]['colP'], 
                                                                    'vid'               => 0, 
                                                                    'perms_userid'      => $rowcont[$ci]['perms_userid'], 
                                                                    'perms_groupid'     => $rowcont[$ci]['perms_groupid'], 
                                                                    'perms_be_userid'   => $rowcont[$ci]['perms_be_userid'], 
                                                                    'perms_be_groupid'  => $rowcont[$ci]['perms_be_groupid']))
                                              ->doInsert();
                                $lastID = $this->DFE->db->LastInsertID;

                                if ($rowcont[$ci]['CType'] == "TXTI" || $rowcont[$ci]['CType'] == "IMG") {
                                    $this->DFE->db->Select('*')
                                                  ->From('content_media')
                                                  ->WhereColName('cid')
                                                  ->WhereColValue($rowcont[$ci]['uid'])
                                                  ->Andd("AND lang = :lang ")
                                                  ->Order('ORDER BY sorting DESC')
                                                  ->Parameter(array('lang' => $rowcont[$ci]['lang']))
                                                  ->SelectMethod(1)
                                                  ->doSelect();
                                    $numcm = $this->DFE->db->Rows;
                                    if ($numcm) {
                                        $rowcm = $this->DFE->db->SelectPuffer;
                                        for ($a = 0; $a < $numcm; $a++) {
                                            $this->DFE->db->Insert('content_media')
                                                          ->Parameter(array(    'cid'                   => $lastID, 
                                                                                'file'                  => $rowcm[$a]['file'], 
                                                                                'size'                  => $rowcm[$a]['size'], 
                                                                                'type'                  => $rowcm[$a]['type'], 
                                                                                'title'                 => $rowcm[$a]['title'], 
                                                                                'alt'                   => $rowcm[$a]['alt'], 
                                                                                'headline'              => $rowcm[$a]['headline'], 
                                                                                'description'           => $rowcm[$a]['description'], 
                                                                                'description_position'  => $rowcm[$a]['description_position'], 
                                                                                'sorting'               => $rowcm[$a]['sorting'], 
                                                                                'width'                 => $rowcm[$a]['width'], 
                                                                                'height'                => $rowcm[$a]['height'], 
                                                                                'url'                   => $rowcm[$a]['url'], 
                                                                                'lang'                  => $GLOBALS['LANGUAGE'], 
                                                                                'padding'               => $rowcm[$a]['padding'], 
                                                                                'margin'                => $rowcm[$a]['margin'], 
                                                                                'css'                   => $rowcm[$a]['css']))
                                                           ->doInsert();
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                $browser = \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']);
                
                if ($this->DFE->http->issetPost('save_site_copy_new') === true) {    
                    header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['Pages'], $GLOBALS['LANGUAGE']) . "?ac=CopyPage&uid=" . $this->DFE->http->_post('uid') . "&saved=ok");
                } elseif ($this->DFE->http->issetPost('save_site_copy') === true) {
                    header("Location: " . $browser);
                }
                exit;
            }
        }
        
        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/copy_page.html');
    }

    /**
     * Copy page plus
     * @return string
     */
    public function CopyPagePlus($template="/aribu.systems/_templates/pages/copy_page_plus.html") {
              
        if ($this->DFE->http->issetPost('save_site_copy') === false && $this->DFE->http->issetPost('save_site_copy_new') === false) {
            $this->DFE->TT->setMC('pagename',       stripslashes($this->GetOneValueFromPages('nav_title', 'uid', $this->DFE->http->_post('uid'))))
                          ->setMC('uid',            $this->DFE->http->_post('uid'))
                          ->setMC('sid',            $_SESSION['sess_id'])
                          ->setMC('lang',           $GLOBALS['LANGUAGE'])
                          ->setMC('sout',           'selected="selected"')
                          ->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                          ->setMC('copy_content1',  $this->DFE->http->_post('copy_content') == 1 ? 'checked="checked"' : '')
                          ->setMC('copy_content2',  $this->DFE->http->issetPost('copy_content') === true && $this->DFE->http->_post('copy_content') == 2 ? 'checked="checked"' : ($this->DFE->http->issetPost('copy_content') === false ? 'checked="checked"' : ''));
            
            
            if ($this->DFE->http->issetPost('saved') === true) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger('Die Kopie wurde erfolgreich gespeichert.', 'messenger-on-top messenger-on-right', 'success'));
            } elseif(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));  
            }
           
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('lastUID') == 0) {
                $err = 1;
                $this->Error['Validation'] .= $this->be_language['_copy_page_error'].'<br>';
            }
            if ($this->DFE->http->isEmpty('nav_title') === true) {
                $err = 1;
                $this->Error['Validation'] .= $this->be_language['_copy_page_navtitle_error'].'<br>';
            }

            if ($this->DFE->http->_post('lastUID') == "x") {
                $err = 1;
                $this->Error['Validation'] .= $this->DFE->TT->getMC('_error_please_choose_a_page');
            } else {
                # Seiten vergleichen
                if ($this->DFE->http->_post('join') == "out" || $this->DFE->http->_post('join') == "over") {
                    $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                    $pid = $this->GetOneValueFromPages('pid', 'uid', $this->DFE->http->_post('lastUID'));
                    $this->DFE->db->Select('uid')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($pid)
                                  ->Andd("AND pagename = '" . $new_pagename . "'")
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                } else {
                    $new_pagename = \lib\Functions::updatePagename($this->DFE->http->_post('nav_title'), $GLOBALS['LANGUAGE']);
                    $this->DFE->db->Select('uid')
                                  ->From($this->DFE->Pages)
                                  ->WhereColName('pid')
                                  ->WhereColValue($this->DFE->http->_post('lastUID'))
                                  ->Andd("AND pagename = :pagename ")
                                  ->Parameter(array('pagename' => $new_pagename))
                                  ->doSelect();
                    $num = $this->DFE->db->Rows;
                }
                if ($num) {
                    $err = 1;
                    $this->Error['Validation'] .= $this->DFE->TT->getMC('_error_page_copy_plus_pagename_exists');
                }
            }

            if ($err == 1) {
                $this->DFE->http->unsetPost('save_site_copy')->unsetPost('save_site_copy_new');
                $this->CopyPagePlus();
            } else {
                $this->DFE->db->Select("o.uid, o.level")
                              ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                              ->noWhere(1)
                              ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                              ->Group('GROUP BY o.lft')
                              ->Order('ORDER BY o.lft')
                              ->SelectMethod(1)
                              ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                              ->doSelect();
                
                $num_rec = $this->DFE->db->Rows;
                if ($num_rec) {
                    $level = $this->DFE->db->SelectPuffer[0]['level'];
                    $row_rec = $this->DFE->db->SelectPuffer;
                    $last_uid = $this->DFE->http->_post('lastUID');
                    for ($i = 0; $i < $num_rec; $i++) {

                        if ($level < $row_rec[$i]['level']) {
                            $last_uid = $insertUID;
                        } elseif ($level > $row_rec[$i]['level']) {
                            $this->DFE->db->Select('pid')
                                          ->From($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($last_uid)
                                          ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                          ->doSelect();
                            $last_uid = $this->DFE->db->SelectPuffer['pid'];
                        } else {
                            $last_uid = $i == 0 ? $this->DFE->http->_post('lastUID') : $last_uid;
                        }
                        $this->DFE->db->Select('uid, pid, rgt, lft, sorting, nav_title')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($last_uid)
                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                        $num = $this->DFE->db->Rows;
                        if ($num) {
                            $row = $this->DFE->db->SelectPuffer;
                            
                            if($this->DFE->http->_post('join') == 'in') {
                                # in die Seite
                                $this->DFE->db->Select('sorting')
                                              ->From($this->DFE->Pages)
                                              ->WhereColName('pid')
                                              ->WhereColValue($last_uid)
                                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Order('ORDER BY sorting DESC')
                                              ->SelectMethod(1)
                                              ->doSelect();
                                $num_s = $this->DFE->db->Rows;
                                if ($num_s) {
                                    $sorting = $num_s + 1;
                                } else {
                                    $sorting = 1;
                                }
                                $pid = $row['uid'];

                                # Nested Sets Modell
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt >= " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();

                                $lft = $row['rgt'];
                                $rgt = $row['rgt'] + 1;
                            } elseif($this->DFE->http->_post('join') == 'out' && $i==0) {
                                # After a page
                                $sorting = $row['sorting'] + 1;
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->WhereColName('pid')
                                              ->WhereColValue($row['pid'])
                                              ->Andd("AND sorting > " . $row['sorting'] . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array(  "sorting"       => "sorting+1", 
                                                            "lastUpdated"   => time()))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $pid = $row['pid'];

                                # Nested Sets Modell
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt > " . $row['rgt'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();

                                $lft = $row['rgt'] + 1;
                                $rgt = $row['rgt'] + 2;
                                $this->DFE->http->setPostbyName('join', 'in');
                            } elseif($this->DFE->http->_post('join') == 'over' && $i==0) {    
                                # Over a page
                                $sorting = $row['sorting'];
                                if ($sorting == 0) {
                                    $sorting = 1;
                                }
                                $pid = $row['pid'];
                                # Update der Seite
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->WhereColName('pid')
                                              ->WhereColValue($row['pid'])
                                              ->Andd("AND sorting >= " . $sorting . " AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array(  "sorting"       => "sorting+1", 
                                                            "lastUpdated"   => time()))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();

                                # Nested Sets Modell
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE rgt > " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("rgt" => "rgt+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();
                                $this->DFE->db->Update($this->DFE->Pages)
                                              ->noWhere(1)
                                              ->Andd("WHERE lft >= " . $row['lft'] . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                              ->Set(array("lft" => "lft+2"))
                                              ->SetType(false)
                                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                              ->doUpdate();

                                $lft = $row['lft'];
                                $rgt = $row['lft'] + 1;
                                $this->DFE->http->setPostbyName('join', 'in');
                            }
                        }

                        # Daten der zu kopierenden Seite holen
                        $this->DFE->db->Select('*')
                              ->From($this->DFE->Pages)
                              ->WhereColName('uid')
                              ->WhereColValue($row_rec[$i]['uid'])
                              ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                        $cpr = $this->DFE->db->SelectPuffer;
                        
                        if ($GLOBALS['LANGUAGE'] == SYS_LANGUAGE) {
                            $this->DFE->db->Insert($this->DFE->Pages)
                                            ->Parameter(array(    'uid'                   => '',
                                                                  'pid'                   => $pid, 
                                                                  'lft'                   => $lft, 
                                                                  'rgt'                   => $rgt, 
                                                                  'docType'               => $cpr['docType'], 
                                                                  'spid'                  => $cpr['spid'], 
                                                                  'tstamp'                => time(), 
                                                                  'sorting'               => $sorting, 
                                                                  'deleted'               => 0, 
                                                                  'perms_userid'          => $cpr['perms_userid'], 
                                                                  'perms_groupid'         => $cpr['perms_groupid'], 
                                                                  'perms_be_userid'       => $cpr['perms_be_userid'], 
                                                                  'perms_be_groupid'      => $cpr['perms_be_groupid'], 
                                                                  'crdate'                => time(), 
                                                                  'cruser_id'             => $_SESSION['sess_uid'], 
                                                                  'pagename'              => $cpr['pagename'], 
                                                                  'url'                   => addslashes($cpr['url']), 
                                                                  'hidden'                => $cpr['hidden'], 
                                                                  'starttime'             => $cpr['starttime'], 
                                                                  'endtime'               => $cpr['endtime'], 
                                                                  'urltype'               => $cpr['urltype'], 
                                                                  'pageSettings'          => $cpr['pageSettings'], 
                                                                  'target'                => $cpr['target'], 
                                                                  'lastUpdated'           => 0, 
                                                                  'description'           => addslashes($cpr['description']), 
                                                                  'author'                => $_SESSION['sess_username'], 
                                                                  'author_email'          => $_SESSION['sess_user_email'], 
                                                                  'nav_title'             => $cpr['nav_title'], 
                                                                  'content_from_pid'      => $cpr['content_from_pid'], 
                                                                  'button'                => $cpr['button'], 
                                                                  'button_path'           => $cpr['button_path'], 
                                                                  'button_act_path'       => $cpr['button_act_path'], 
                                                                  'sitetpl'               => $cpr['sitetpl'], 
                                                                  'module'                => $cpr['module'], 
                                                                  'BrowserTitle'          => addslashes($cpr['BrowserTitle']), 
                                                                  'keywords'              => addslashes($cpr['keywords']), 
                                                                  'page_Hash'             => '', 
                                                                  'link_title'            => addslashes($cpr['link_title']), 
                                                                  'move_update'           => '', 
                                                                  'Javascript'            => addslashes($cpr['Javascript']), 
                                                                  'Stylesheet'            => addslashes($cpr['Stylesheet']), 
                                                                  'this_css'              => $cpr['this_css'], 
                                                                  'level'                 => '', 
                                                                  'search'                => $cpr['search']))
                                            ->doInsert();
                          } else {
                              $this->DFE->db->Insert($this->DFE->Pages)
                                            ->Parameter(array(    'uid'                   => '',
                                                                  'rid'                   => 0,
                                                                  'pid'                   => $pid, 
                                                                  'lft'                   => $lft, 
                                                                  'rgt'                   => $rgt, 
                                                                  'docType'               => $cpr['docType'], 
                                                                  'spid'                  => $cpr['spid'], 
                                                                  'tstamp'                => time(), 
                                                                  'sorting'               => $sorting, 
                                                                  'deleted'               => 0, 
                                                                  'perms_userid'          => $cpr['perms_userid'], 
                                                                  'perms_groupid'         => $cpr['perms_groupid'], 
                                                                  'perms_be_userid'       => $cpr['perms_be_userid'], 
                                                                  'perms_be_groupid'      => $cpr['perms_be_groupid'], 
                                                                  'crdate'                => time(), 
                                                                  'cruser_id'             => $_SESSION['sess_uid'], 
                                                                  'pagename'              => $cpr['pagename'], 
                                                                  'url'                   => addslashes($cpr['url']), 
                                                                  'hidden'                => $cpr['hidden'], 
                                                                  'starttime'             => $cpr['starttime'], 
                                                                  'endtime'               => $cpr['endtime'], 
                                                                  'urltype'               => $cpr['urltype'], 
                                                                  'pageSettings'          => $cpr['pageSettings'], 
                                                                  'target'                => $cpr['target'], 
                                                                  'lastUpdated'           => 0, 
                                                                  'description'           => addslashes($cpr['description']), 
                                                                  'author'                => $_SESSION['sess_username'], 
                                                                  'author_email'          => $_SESSION['sess_user_email'], 
                                                                  'nav_title'             => $cpr['nav_title'], 
                                                                  'content_from_pid'      => $cpr['content_from_pid'], 
                                                                  'button'                => $cpr['button'], 
                                                                  'button_path'           => $cpr['button_path'], 
                                                                  'button_act_path'       => $cpr['button_act_path'], 
                                                                  'sitetpl'               => $cpr['sitetpl'], 
                                                                  'module'                => $cpr['module'], 
                                                                  'BrowserTitle'          => addslashes($cpr['BrowserTitle']), 
                                                                  'keywords'              => addslashes($cpr['keywords']), 
                                                                  'page_Hash'             => '', 
                                                                  'link_title'            => addslashes($cpr['link_title']), 
                                                                  'move_update'           => '', 
                                                                  'Javascript'            => addslashes($cpr['Javascript']), 
                                                                  'Stylesheet'            => addslashes($cpr['Stylesheet']), 
                                                                  'this_css'              => $cpr['this_css'], 
                                                                  'level'                 => '', 
                                                                  'lang'                  => $GLOBALS['LANGUAGE'],
                                                                  'search'                => $cpr['search']))
                                            ->doInsert();
                        }

                        # Page hash berechnen
                        $insertUID = $this->DFE->db->LastInsertID;
                        $page_Hash = $this->FB == 'be_' ? \lib\be_menu::getTreePathNames($insertUID, '', 0, 0, 1, '', '', true) : \lib\fe_menu::getTreePathNames($insertUID, '', 0, 0, 1, '', '');
                
                        $page_Hash = md5($page_Hash);

                        # Update page hash
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->WhereColName('uid')
                                      ->WhereColValue($insertUID)
                                      ->Set(array("page_Hash" => $page_Hash))
                                      ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();


                        # Level Updaten
                        $this->DFE->db->Select("COUNT(*)-1 AS level")
                                      ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p")
                                      ->noWhere(1)
                                      ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = '" . $insertUID . "' " . str_replace("%%%n%%%", "p.", $this->DFE->and_lang))
                                      ->Group("GROUP BY n.lft") 
                                      ->Order("ORDER BY n.lft")
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doSelect();
                        $row3 = $this->DFE->db->SelectPuffer;
                        $this->DFE->db->Update($this->DFE->Pages)
                                      ->WhereColName('uid')
                                      ->WhereColValue($insertUID)
                                      ->Set(array("level" => $row3['level']))
                                      ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                                      ->doUpdate();
                        
                        
                        # Content kopieren
                        if ($this->DFE->http->_post('copy_content') == 1) {
                            foreach ($GLOBALS['CONTENT_MARKER'] as $key => $CMarkerval) {
                                $this->DFE->db->Select('*')
                                              ->From('content')
                                              ->WhereColName('pid')
                                              ->WhereColValue($row_rec[$i]['uid'])
                                              ->Andd("AND colP = :colp AND lang = :lang ")
                                              ->Order("ORDER BY sorting")
                                              ->SelectMethod(1)
                                              ->Parameter(array('lang' => $GLOBALS['LANGUAGE'], 'colp' => $key))
                                              ->doSelect();
                                $rowcont = $this->DFE->db->SelectPuffer;
                                $num = $this->DFE->db->Rows;
                                if ($num) {
                                    for ($ci = 0; $ci < $num; $ci++) {
                                        $this->DFE->db->Insert('content')
                                                      ->Parameter(array(    'uid'               => '', 
                                                                            'pid'               => $insertUID, 
                                                                            'tstamp'            => $rowcont[$ci]['tstamp'], 
                                                                            'lastUpdated'       => $rowcont[$ci]['lastUpdated'], 
                                                                            'hidden'            => $rowcont[$ci]['hidden'], 
                                                                            'sorting'           => $rowcont[$ci]['sorting'], 
                                                                            'CType'             => $rowcont[$ci]['CType'], 
                                                                            'lang'              => $rowcont[$ci]['lang'], 
                                                                            'bodytext'          => $rowcont[$ci]['bodytext'], 
                                                                            'starttime'         => $rowcont[$ci]['starttime'], 
                                                                            'endtime'           => $rowcont[$ci]['endtime'], 
                                                                            'headline'          => $rowcont[$ci]['headline'], 
                                                                            'subline'           => $rowcont[$ci]['subline'], 
                                                                            'script_method'     => $rowcont[$ci]['script_method'], 
                                                                            'script_path'       => $rowcont[$ci]['script_path'], 
                                                                            'content_name'      => $rowcont[$ci]['content_name'], 
                                                                            'author'            => $rowcont[$ci]['author'], 
                                                                            'colP'              => $rowcont[$ci]['colP'], 
                                                                            'vid'               => 0, 
                                                                            'perms_userid'      => $rowcont[$ci]['perms_userid'], 
                                                                            'perms_groupid'     => $rowcont[$ci]['perms_groupid'], 
                                                                            'perms_be_userid'   => $rowcont[$ci]['perms_be_userid'], 
                                                                            'perms_be_groupid'  => $rowcont[$ci]['perms_be_groupid']))
                                                      ->doInsert();
                                        $lastID = $this->DFE->db->LastInsertID;

                                        if ($rowcont[$ci]['CType'] == "TXTI" || $rowcont[$ci]['CType'] == "IMG") {
                                            $this->DFE->db->Select('*')
                                                          ->From('content_media')
                                                          ->WhereColName('cid')
                                                          ->WhereColValue($rowcont[$ci]['uid'])
                                                          ->Andd("AND lang = :lang ")
                                                          ->Order('ORDER BY sorting DESC')
                                                          ->Parameter(array('lang' => $rowcont[$ci]['lang']))
                                                          ->SelectMethod(1)
                                                          ->doSelect();
                                            $numcm = $this->DFE->db->Rows;
                                            if ($numcm) {
                                                $rowcm = $this->DFE->db->SelectPuffer;
                                                for ($a = 0; $a < $numcm; $a++) {
                                                    $this->DFE->db->Insert('content_media')
                                                                  ->Parameter(array(    'cid'                   => $lastID, 
                                                                                        'file'                  => $rowcm[$a]['file'], 
                                                                                        'size'                  => $rowcm[$a]['size'], 
                                                                                        'type'                  => $rowcm[$a]['type'], 
                                                                                        'title'                 => $rowcm[$a]['title'], 
                                                                                        'alt'                   => $rowcm[$a]['alt'], 
                                                                                        'headline'              => $rowcm[$a]['headline'], 
                                                                                        'description'           => $rowcm[$a]['description'], 
                                                                                        'description_position'  => $rowcm[$a]['description_position'], 
                                                                                        'sorting'               => $rowcm[$a]['sorting'], 
                                                                                        'width'                 => $rowcm[$a]['width'], 
                                                                                        'height'                => $rowcm[$a]['height'], 
                                                                                        'url'                   => $rowcm[$a]['url'], 
                                                                                        'lang'                  => $GLOBALS['LANGUAGE'], 
                                                                                        'padding'               => $rowcm[$a]['padding'], 
                                                                                        'margin'                => $rowcm[$a]['margin'], 
                                                                                        'css'                   => $rowcm[$a]['css']))
                                                                   ->doInsert();
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        $level = $row_rec[$i]['level'];
                    }
                }    
                $browser = \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']);
                
                if ($this->DFE->http->issetPost('save_site_copy_new') === true) {    
                    header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS']['Pages'], $GLOBALS['LANGUAGE']) . "?ac=CopyPagePlus&uid=" . $this->DFE->http->_post('uid') . "&saved=ok");
                } elseif ($this->DFE->http->issetPost('save_site_copy') === true) {
                    header("Location: " . $browser);
                }
                exit;
            }
        }
        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    
    
    /* Plugins */

    /*
     * Plugin PageBrowser
     *
     */

    public function PageBrowser($template='/aribu.systems/_templates/pages/plugin_PageBrowser.html') {
        $template = $this->DFE->http->issetPost('template') === true ? $this->DFE->http->_post('template') : $template;
        
        $STree = $this->getPageBrowserTree();
        if($this->DFE->http->issetPost('options') === true && $this->DFE->http->_post('options') == 'AllBrowsers') {
            $this->DFE->TT->setMC('file_browser', $this->FileBrowser("/aribu.systems/_templates/pages/fileBrowser.html"));
        }
        
        # Root
        $root_TS .= $RootIconS . CLIENT . '-Server';
        $browser = $STree;
        
        $this->DFE->TT->setMC('jid',          $this->DFE->http->_post('jid'))
                      ->setMC('lang',         $GLOBALS['LANGUAGE'])
                      ->setMC('sid',          $_SESSION['sess_id'])
                      ->setMC('plugin',       $this->DFE->http->issetPost('plugin_container') === true ? "2" : "")
                      ->setMC('plugin_id',    $this->DFE->http->issetPost('plugin_container') === true ? "plugin_container=2&" : "")
                      ->setMC('RootIconS',    '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_server.gif" align="absmiddle" style="margin-left:4px;" border="0"> ')
                      ->setMC('root_TS',      $this->DFE->TT->getMC('RootIconS').$root_TS)
                      ->setMC('browser',      $this->DFE->TT->getMC('root_TS').$browser)
                      ->setMC('fb',           $this->DFE->http->issetPost('FB') === true && $this->DFE->http->_post('FB') == 'be_' ? '&FB=be_' : '');
        $this->DFE->TT->BlockMarker['javascript'] = $this->DFE->http->issetPost('plugin_container') === true ? 1 : 0;

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    /*
     * Get page browser tree
     *
     */

    public function getPageBrowserTree() {
        if($this->DFE->http->issetPost('FB') === true && $this->DFE->http->_post('FB') == 'fe_') {
            require_once FE_MENU;
            $this->DFE->db->TablePreName = 'fe_';
        } elseif($this->DFE->http->issetPost('FB') === true && $this->DFE->http->_post('FB') == 'be_') {
            require_once BE_MENU;
            $this->DFE->db->TablePreName = 'be_';
            $this->FB = "be_";
            $this->FBup = "BE";
        } else {
            require_once FE_MENU;
            $this->DFE->db->TablePreName = 'fe_';
        }
        
        static $nr = 1;
        $level = 0;
        
        $jsmethod = $this->DFE->http->issetPost('jsmethod') === true ? $this->DFE->http->_post('jsmethod') : 'menupoint';
        
        if ($this->DFE->http->issetPost('lft') === true) {
            $this->DFE->db->Select('uid')
                               ->From($this->DFE->Pages)
                               ->noWhere(1)
                               ->Andd("WHERE lft BETWEEN " . $this->DFE->http->_post('lft') . " AND " . $this->DFE->http->_post('rgt') . " " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                               ->Order("ORDER BY lft")
                               ->SelectMethod(1)
                               ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                               ->doSelect();
            $num_btw = $this->DFE->db->Rows;
            $row_btw = $this->DFE->db->SelectPuffer;
            if ($num_btw) {
                for ($i = 0; $i < $num_btw; $i++) {
                    $breadcrumb[$i] = $row_btw[$i]['uid'];
                }
            } else {
                $breadcrumb = array();
            }
        } else {
            $breadcrumb = array();
        }

        if ($this->DFE->http->issetPost('urltype') === true) {
            $urltype = $this->DFE->http->_post('urltype');
            $zusatz = "&urltype=" . $urltype;
        } else {
            $urltype = false;
        }

        if ($this->DFE->http->issetPost('colP') === true) {
            $zusatz .= "&colP=" . $this->DFE->http->_post('colP');
        }

        if ($this->DFE->http->issetPost('module') === true) {
            $zusatz .= "&module=" . $this->DFE->http->_post('module');
        }

        if ($this->DFE->http->issetPost('css_class') === true) {
            $class = $this->DFE->http->_post('css_class');
            $zusatz .= "&class=" . $this->DFE->http->_post('css_class');
        }

        if ($this->DFE->http->issetPost('select_id') === true) {
            $select_id = $this->DFE->http->_post('select_id');
            $zusatz .= "&select_id=" . $this->DFE->http->_post('select_id');
        } else {
            $select_id = "mp";
        }

        if ($this->DFE->http->issetPost('js') === true) {
            $zusatz .= "&js=" . $this->DFE->http->_post('js');
        }

        if ($this->DFE->http->issetPost('js_script') === true) {
            $zusatz .= "&js_script=" . $this->DFE->http->_post('js_script');
        }
        
        if($this->DFE->http->issetPost('has') === true) {
            $zusatz .= "&has=" . $this->DFE->http->_post('has');
        }

        $this->DFE->db->Select('uid')
                      ->From($this->DFE->Pages)
                      ->WhereColName('pid')
                      ->WhereColValue(0)
                      ->Andd("AND deleted != 1 " . str_replace("%%%n%%%", "", $this->DFE->and_lang))
                      ->SelectMethod(1)
                      ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                      ->doSelect();
        $maxRoot = $this->DFE->db->Rows;

        if ($this->DFE->http->issetPost('uid') === true) {
            $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $this->DFE->http->_post('uid')] = 1;
        }


        if (isset($_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']])) {
            foreach ($_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']] as $key => $val) {
                if ($val == 1) {
                    $or .= "OR n.pid = '" . str_replace("level-", "", $key) . "' ";
                }
            }
        }

        $this->DFE->db->Select("n.nav_title, 
                                n.lft, n.rgt, 
                                n.uid, n.pid, 
                                n.docType, 
                                n.sorting, 
                                n.hidden, 
                                n.author, 
                                n.pagename, 
                                n.starttime, 
                                n.endtime, 
                                n.module, 
                                n.level, 
                                ROUND( (n.rgt - n.lft -1)/2) AS chields ")
                       ->From($this->DFE->Pages . " AS n")
                       ->WhereColName('n.pid')
                       ->WhereColValue(0)
                       ->Andd($or.str_replace("%%%n%%%", "n.", $this->DFE->and_lang))
                       ->Order("ORDER BY n.lft")
                       ->SelectMethod(1)
                       ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                       ->doSelect();
        
        
        $tmp_tree = ''; # Cont Buffer;
        $num = $this->DFE->db->Rows;
        $x = 1;
        $mnr = 0;
        if($num) {
            foreach($this->DFE->db->SelectPuffer as $key => $row) {
                $BLCode = implode("", $this->BL);

                if ($row['level'] == 0) {
                    $BLCode = "";
                    $this->BL = array();
                    $span_ende = "";
                }

                if ($row['chields'] != 0) {
                    $this->ANTest[] = $this->RGT[$row['pid']] .'-'. $row['rgt'] . ' == 1 || '. $row['pid'].' == 0 && '.$row['sorting'].' == '.$maxRoot;
                    $this->chields[$row['uid']] = $row['chields'];
                    $this->RGT[$row['uid']] = $row['rgt'];
                    if ($this->RGT[$row['pid']] - $row['rgt'] == 1 || ($row['pid'] == 0 && $row['sorting'] == $maxRoot)) {
                        $this->BL[$row['level']] = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif" align="absmiddle" border="0">';
                    } else {
                        $this->BL[$row['level']] = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_line.gif" align="absmiddle" border="0">';
                    }
                } else {
                    $this->BL[$row['level']] = "";
                }

                if ($row['level'] < $level) {
                    $a++;
                    $a = $a - $level != 0 ? $a - $level : $a;
                    $span_ende = str_repeat("</span>", $level - $row['level']);
                }
                if ($row['level'] > $level) {
                    $a = 1;
                    $span_ende = "";
                }
                if ($row['level'] == $level) {
                    $a++;
                    $span_ende = "";
                }


                if ($num == $x || ($this->chields[$row['pid']] == $a && isset($this->chields[$row['pid']])) || $this->RGT[$row['pid']] - $row['rgt'] == 1 || ($row['pid'] == 0 && $row['sorting'] == $maxRoot)) {
                    $join = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif" align="absmiddle">'; # Joinbottom
                    if ($row['chields'] != 0) {
                        $ocImg = $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || $row['uid'] == $this->DFE->http->_post('uid') ? "close_end" : "open_end";
                        $join = '<a href="javascript:void(0);" onclick="'.$jsmethod.'(\'level-' . $row['uid'] . '\',\'_end\',\'level=level-' . $row['uid'] . '&uid=' . $row['uid'] . $zusatz . '\');" onfocus="blur();">'
                              . '<img class="' . $ocImg . '" src="/aribu.systems/fileadmin/img/icons/tiny/site_' . $ocImg . '.gif" align="absmiddle" border="0" id="level-' . $row['uid'] . '_img"></a>';
                    }
                } else {
                    $join = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_j.gif" align="absmiddle">';  # Join
                    if ($row['chields'] != 0) {
                        $ocImg = $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || $row['uid'] == $this->DFE->http->_post('uid') ? "toclose" : "open";
                        $join = '<a href="javascript:void(0);" onclick="'.$jsmethod.'(\'level-' . $row['uid'] . '\', \'\', \'level=level-' . $row['uid'] . '&uid=' . $row['uid'] . $zusatz . '\');" onfocus="blur();">'
                              . '<img class="' . $ocImg . '" src="/aribu.systems/fileadmin/img/icons/tiny/site_' . str_replace("to", "", $ocImg) . '.gif" align="absmiddle" border="0" id="level-' . $row['uid'] . '_img"></a>';
                    }
                }

                $BLCode = "";
                for ($i = 0; $i < $row['level']; $i++) {
                    $BLCode .= $this->BL[$i] . "";
                }

                $blank = $BLCode . $join;

                # Language setting
                $nav_title = stripslashes($row['nav_title']);

                $siteIC = '<img src="/aribu.systems/fileadmin/img/icons/tiny/' . $GLOBALS['BE_DOCTYPES'][$row['docType']] . '" align="absmiddle" border="0">&nbsp;';


                if ($this->DFE->http->issetPost('module') === false) {
                    if ($urltype === false) {
                        $breadcrumb_title = \lib\Functions::breadcrumb($row['uid'], 'dot'.$this->FBup.'Menu', $GLOBALS['LANGUAGE']);
                        $breadcrumb_name = $breadcrumb_title != '' ? $breadcrumb_title : $nav_title;
                        $site_name_link = in_array($row['uid'], $breadcrumb) == false ? '<a class="pba" ref="' . $row['uid'] . '" href="javascript:void(0);" onclick="javascript: addPageOpt(\'' . $breadcrumb_name . '\', \'' . $row['uid'] . '\', \'' . $class . '\', \'' . $select_id . '\');">' . $nav_title . '</a>' : $nav_title;
                    } elseif ($urltype == 1) {
                        $page_Hash = "###dotlink-" . $row['uid'] . "###";
                        $inputid = $select_id != 'mp' ? $select_id : '#url_type';
                        $obj = $this->DFE->http->issetPost('tinymce') === true ? "input.mce-textbox:first" : $inputid;
                        $site_name_link = '<a class="pba" ref="' . $row['uid'] . '" href="javascript:void(0);" onclick="javascript: $(\''.$obj.'\').val(\'' . $page_Hash . '\');">' . $nav_title . '</a>';
                    } elseif ($urltype == 2) {
                        $site_name_link = '<a class="pba" ref="' . $row['uid'] . '" href="?ac=ContentOverview&uid=' . $row['uid'] . '&colP=' . $this->DFE->http->_post('colP') . '&jid=' . $this->DFE->http->_post('jid') . '">' . $nav_title . '</a>';
                    }
                } else {
                    if (strtolower($this->DFE->http->_post('module')) == strtolower($row['module']) || ($this->DFE->http->issetPost('module') === true && $this->DFE->http->issetPost('elmc') === true)) {
                        if ($this->DFE->http->issetPost('js') === true) {
                            switch ($this->DFE->http->_post('js')) {
                                case 1: $js = $this->DFE->http->_post('js_script') . "();";
                                    break;

                                default:
                                    $js = "document.order.submit();";
                            }
                        }

                        $onclick = $this->DFE->http->issetPost('plugin_container') === true ? '' : 'onclick="javascript: addPageOpt(\'' . \lib\Functions::breadcrumb($row['uid'], 'dot'.$this->FBup.'Menu', $GLOBALS['LANGUAGE']) . '\', \'' . $row['uid'] . '\', \'' . $class . '\', \'' . $select_id . '\'); ' . $js . '"';
                        $site_name_link = in_array($row['uid'], $breadcrumb) == false ? '<a class="pba" ref="' . $row['uid'] . '" href="javascript:void(0);" ' . $onclick . '>' . $nav_title . '</a>' : $nav_title;
                        $mnr++;
                    } else {
                        $site_name_link = $nav_title;
                    }
                }

                # Tree table
                $display = $_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || $this->DFE->http->_post('uid') == $row['uid'] ? "block" : "none";
                $span_anfang = $row['chields'] != 0 && ($_SESSION['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]['level-' . $row['uid']] == 1 || $this->DFE->http->_post('uid') == $row['uid']) ? '<span style="display:' . $display . ';" id="level-' . $row['uid'] . '">' : '';
                $span_ende_ab = $x == $num && $row['level'] > 0 ? str_repeat("</span>", $row['level']) : "";
                $tmp_tree .= $span_ende . '<ul style="width:400px; list-style-type:none; clear:both;">';
                $tmp_tree .= '<li style="width:400px; padding-left:4px; height:20px;" class="pbli">' . $blank . $siteIC . $site_name_link . '</li>';
                $tmp_tree .= '</ul>' . $span_anfang . $span_ende_ab;
                $nr++;
                $x++;
                $level = $row['level'];
            }
        }

        return $tmp_tree;
    }

    
    public function SetMenuToSession() {
        if($this->DFE->http->issetPost('FB') === true && $this->DFE->http->_post('FB') == 'be_') {
            $this->FB = "be_";
            $this->FBup = "BE";
        }
        
        # Menu in die Session aufnehmen
        $this->DFE->db->TablePreName = "be_";
        $this->DFE->db->Select('*')
                      ->From('session')
                      ->WhereColName('session_id')
                      ->WhereColValue($_SESSION['sess_id'])
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        $row = $this->DFE->db->SelectPuffer;
        $this->DFE->db->TablePreName = $this->FB;
        if ($num) {
            $sess_userdata = unserialize($this->DFE->db->SelectPuffer['session_data']);

            foreach ($sess_userdata as $key => $val) {
                $session[$key] = $val;
            }
            if (isset($session['sess_menu'])) {

                foreach ($session['sess_menu'] as $mkey => $mval) {
                    $session['sess_menu'][$mkey] = $mval;
                }
                if ($this->DFE->http->_post('levelSetting') == 0) {
                    $this->DFE->db->Select("o.uid, o.level, ROUND( (o.rgt - o.lft -1) /2 ) AS chields")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "n.", $this->DFE->and_lang))
                                  ->Group("GROUP BY o.lft")
                                  ->Having("HAVING chields > 0")
                                  ->Order("ORDER BY o.lft")
                                  ->SelectMethod(1)
                                  ->Parameter($this->DFE->and_lang != '' ? array('uid' => str_replace("level-", "", $this->DFE->http->_post('level')), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => str_replace("level-", "", $this->DFE->http->_post('level'))))#
                                  ->doSelect();
                    echo $this->DFE->db->Statement;
                    $numr = $this->DFE->db->Rows;
                    if($numr) {
                        foreach($this->DFE->db->SelectPuffer as $rkey => $rrow) {
                            $session['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]["level-" . $rrow['uid']] = 0;
                        }
                        $session['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]["level-" . $this->DFE->http->_post('uid')] = 0;
                    }
                } else {
                    $session['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']][$this->DFE->http->_post('level')] = $this->DFE->http->_post('levelSetting');
                }
            } else {
                $this->DFE->db->Select("n.uid, n.level, ROUND( (n.rgt - n.lft -1)/2) AS chields")
                              ->From($this->DFE->Pages . " AS n")
                              ->noWhere(1)
                              ->Andd("WHERE n.deleted != 1 " . str_replace("%%%n%%%", "n.", $this->DFE->and_lang))
                              ->Having("HAVING chields > 0")
                              ->Order("ORDER BY n.lft")
                              ->SelectMethod(1)
                              ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                              ->doSelect();
                echo $this->DFE->db->Statement;
                
                $numr = $this->DFE->db->Rows;
                if($numr) {
                    foreach($this->DFE->db->SelectPuffer as $rkey => $rrow) {
                        if ($rrow['uid'] == $this->DFE->http->_post('uid')) {
                            $session['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]["level-" . $rrow['uid']] = $this->DFE->http->_post('levelSetting');
                        } else {
                            $session['sess_menu'][$this->FBup][$GLOBALS['LANGUAGE']]["level-" . $rrow['uid']] = 0;
                        }
                    }
                }
            }
            $sess_userdata = serialize($session);
            $this->DFE->db->TablePreName = "be_";
            $this->DFE->db->Update('session')
                          ->WhereColName('session_id')
                          ->WhereColValue($_SESSION['sess_id'])
                          ->Set(array('session_data' => $sess_userdata))
                          ->doUpdate();
            $this->DFE->db->TablePreName = $this->FB;
            return "true";
        } else {
            $this->DFE->db->TablePreName = $this->FB;
            return "false";
        }
        
    }
    
    /*
     * Plugin FileBrowser
     *
     */

    public function FileBrowser($template='/aribu.systems/_templates/pages/plugin_FileBrowser.html') {
        
        $template = $this->DFE->http->issetPost('template') === true && $this->DFE->http->issetPost('options') === false ? $this->DFE->http->_post('template') : $template;
       
        if ($this->DFE->http->issetPost('element') === true) {
            $zusatz = "&element=" . $this->DFE->http->_post('element');
        }

        if ($this->DFE->http->issetPost('element_id') === true) {
            $zusatz .= "&element_id=" . $this->DFE->http->_post('element_id');
        }

        if ($this->DFE->http->issetPost('option') === true) {
            $zusatz .= "&option=" . $this->DFE->http->_post('option');
        }
        
        if($this->DFE->http->issetPost('filefolder') === true) {
            $file_folder = $this->DFE->http->_post('filefolder');
        } else {
            $fb = $this->FB == 'be_' ? ARIBU_SYSTEMS_SFOLDER : ''; 
            $file_folder = $fb.'/fileadmin';
        }
        
        if($this->DFE->http->issetPost('replace') === true) {
            $zusatz .= '&replace='.$this->DFE->http->_post('replace');
        }
        
        if($this->DFE->http->issetPost('FB') === true) {
            $zusatz .= '&FB=be_';
        }

        # File Links
        $tree_Array = $this->getFileTreeArrayPl(DOC_ROOT . $file_folder);
        if (array_key_exists(".DS_Store", $tree_Array)) {
            $count = count($tree_Array) - 1;
        } else {
            $count = count($tree_Array);
        }
        ksort($tree_Array);
        reset($tree_Array);
        $FTree = $this->getFileTreePl(DOC_ROOT . $file_folder, $tree_Array, '', $count);

        # Root Files
        $RootIconF = '<img src="/aribu.systems/fileadmin/img/icons/tiny/site_root.png" align="absmiddle">';
        $root_TF .= '<ul style="list-style-type:none; width:400px; clear:both; padding-left:0px; padding-top:0px; margin-top:0px;">';
        $root_TF .= '<li style="float:left; padding-left:4px; width:400px; height:20px;">' . $RootIconF .' '. $file_folder.'/</li>';
        $root_TF .= '</ul>';
        $browser = $root_TF . $FTree;

        
        $this->DFE->TT->setMC('browser',    $browser)
                      ->setMC('sid',        $_SESSION['sess_id'])
                      ->setMC('lang',       $GLOBALS['LANGUAGE'])
                      ->setMC('zusatz',     $zusatz);

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }
    
    public function PluginFileBrowser() {
        $dir = $this->DFE->http->_post('folder');
        $tree_Array = $this->getFileTreeArrayPl(DOC_ROOT . $dir);
        if (array_key_exists(".DS_Store", $tree_Array)) {
            $count = count($tree_Array) - 1;
        } else {
            $count = count($tree_Array);
        }
        @ksort($tree_Array);
        @reset($tree_Array);
        $level = explode("/", $this->DFE->http->_post('folder'));
        $level = count($level);
        $GLOBALS['FileBrowser_ActivePoint'] = $this->DFE->http->_post('cssid') . "-act";
        return $this->getFileTreePl(DOC_ROOT . $dir, $tree_Array, "", $count, $level - 2, $this->DFE->http->_post('bl'));
    }

    public function getFileTreeArrayPl($dir) {
        $fp = opendir($dir);
        static $level = 0;
        while ($datei = readdir($fp)) {
            if (is_dir("$dir/$datei") && $datei != "." && $datei != ".." && $level == 0) {
                $level++;
                if ($tmp = $this->getFileTreeArrayPl($dir . "/" . $datei)) {
                    $tree_arr[$datei] = $tmp;
                } else {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                }
                $level--;
            } else {
                if ($datei != "." && $datei != "..") {
                    $file_perm = fileperms($dir . "/" . $datei);
                    $tree_arr[$datei] = $file_perm;
                }
            }
        }
        closedir($fp);
        return $tree_arr;
    }

    public function getFileTreePl($dir, $TreeArray, $BLCode = '', $count = 0, $exLevel = 0, $bl = 0) {
        $x = 0;
        static $level = 0;
        $countA = count($TreeArray);
        foreach ($TreeArray as $key => $val) {
            if (is_array($val)) {
                ksort($val);

                $cArr = count($val);
                $file_ext = explode(".", $key);
                if (!$file_ext[1]) {
                    $file_ext[1] = "folder";
                }
                $x++;

                $LN = ($countA == $x) ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";

                $tmp = ''; # Buffer
                $blevel = $exLevel > 0 ? $bl . "-" : "";
                $folder_dir = str_replace(DOC_ROOT, "", $dir);
                if ($count == $x || $countA == $x) {
                    $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif\" align=\"absmiddle\">"; # Joinbottom
                    if (is_array($val)) {
                        $join = "<a href=\"javascript:void(0);\" onclick=\"menupoint('" . str_replace("aribu.systems-", "", str_replace("/", "-", substr($folder_dir, 1))) . "-" . str_replace("-", "_", $key) . "','_end','" . $blevel . "1','" . $folder_dir . "/" . $key . "'); return false;\" onfocus=\"blur()\"><img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_open_end.gif\" align=\"absmiddle\" border=\"0\" id=\"" . str_replace("aribu.systems-", "", str_replace("/", "-", substr($folder_dir, 1))) . "-" . str_replace("-", "_", $key) . "_img\" alt=\"plusminus\" /></a>";
                    }
                } else {
                    $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_j.gif\" align=\"absmiddle\">";  # Join
                    if (is_array($val)) {
                        $join = "<a href=\"javascript:void(0);\" onclick=\"menupoint('" . str_replace("aribu.systems-", "", str_replace("/", "-", substr($folder_dir, 1))) . "-" . str_replace("-", "_", $key) . "','','" . $blevel . "0','" . $folder_dir . "/" . $key . "'); return false;\" onfocus=\"blur()\"><img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_open.gif\" align=\"absmiddle\" border=\"0\" id=\"" . str_replace("aribu.systems-", "", str_replace("/", "-", substr($folder_dir, 1))) . "-" . str_replace("-", "_", $key) . "_img\" alt=\"plusminus\" /></a>";
                    }
                }

                $siteIC = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/" . $GLOBALS['BE_FILETYPES'][$file_ext[1]] . "\" align=\"absmiddle\">&nbsp;";

                if ($exLevel > 0) {
                    $LN = ($count == $x) && $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                    if (!preg_match('#-#', $bl, $res)) {
                        $zLN = $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : $LN;
                    } else {
                        $zLN = '';
                        $bl_arr = explode("-", $bl);
                        foreach ($bl_arr as $blkey => $blval) {
                            $zLN .= $blval == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                        }
                    }
                }
                $blank = $zLN . $join;

                # Tree
                if ($level == 0) {
                    $span_anfang = $exLevel > 0 && $x == 1 ? "<span class=\"" . $GLOBALS['FileBrowser_ActivePoint'] . "\">" : "";
                    $span_ende = $exLevel > 0 && ($count == $x || $countA == $x) ? "</span>" : "";
                    $tmp_tree .= $span_anfang . "<ul style=\"list-style-type:none; width:400px; clear:both; padding-left:0px;\" class=\"" . str_replace("aribu.systems-", "", str_replace("/", "-", substr($folder_dir, 1))) . "-" . str_replace("-", "_", $key) . "\">\n";
                    $tmp_tree .= "<li style=\"float:left; padding-left:4px; width:400px; height:20px;\">" . $blank . $siteIC . $key . "</li>";
                    $tmp_tree .= "</ul>" . $span_ende . "\n\n";
                }

                $level++;
                if ($tmp = $this->getFileTreePl($dir . "/" . $key, $val, $BLCode . $LN, $cArr, $exLevel, $bl)) {
                    $tmp_tree .= $tmp;
                }
                $level--;
            } else {
                if ($level == 0) {

                    if (preg_match('#\.#', $key, $treffer)) {
                        $file_ext = explode(".", $key);
                        $file_ext_end = end($file_ext);
                    } else {
                        $file_ext_end = "";
                    }

                    if (empty($file_ext_end)) {
                        $file_ext[1] = "folder";
                        $file_title = $this->be_language['_del_folder'];
                    } elseif ($file_ext[1] == '0') {
                        $file_title = $this->be_language['_del_file'];
                    } else {
                        $file_title = $this->be_language['_del_file'];
                    }

                    $FType = count($file_ext) - 1;

                    $x++;
                    $LN = ($count == $x) ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                    $tmp = ''; # Buffer

                    if ($count == $x || $countA == $x) {
                        $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_jb.gif\" align=\"absmiddle\">"; # Joinbottom
                    } else {
                        $join = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_j.gif\" align=\"absmiddle\">";  # Join
                    }
                    if ($FType > 0) {
                        $siteIC = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/" . $GLOBALS['BE_FILETYPES'][$file_ext[$FType]] . "\" align=\"absmiddle\">&nbsp;";
                    } else {
                        $siteIC = "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/" . $GLOBALS['BE_FILETYPES'][$file_ext[1]] . "\" align=\"absmiddle\">&nbsp;";
                    }


                    if ($exLevel > 0) {
                        $LN = ($count == $x) && $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                        if (!preg_match('#-#', $bl, $res)) {
                            $zLN = $bl == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : $LN;
                        } else {
                            $zLN = '';
                            $bl_arr = explode("-", $bl);
                            foreach ($bl_arr as $blkey => $blval) {
                                $zLN .= $blval == 1 ? "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_blank.gif\" align=\"absmiddle\">" : "<img src=\"/aribu.systems/fileadmin/img/icons/tiny/site_line.gif\" align=\"absmiddle\">";
                            }
                        }
                    }
                    $blank = $zLN . $join;

                    # Tree table
                    if ($file_ext[1] != "folder") {
                        if ($file_ext_end == "jpg" || $file_ext_end == "gif" || $file_ext_end == "png" || $file_ext_end == "tiff" || $file_ext_end == "JPG" || $file_ext_end == "GIF" || $file_ext_end == "PNG" || $file_ext_end == "TIFF" || $file_ext_end == "bmp" || $file_ext_end == "BMP") {
                            $omo = "";
                        } else {
                            $omo = "";
                        }
                        if ($this->DFE->http->issetPost('element') === true) {
                            $element = '#'.$this->DFE->http->_post('element');
                        } else {
                            if ($this->DFE->http->issetPost('element_id') === true) {
                                $element = '#'.$this->DFE->http->_post('element_id');
                            } else {
                                $element = "#lIcon";
                            }
                        }
                        if ($this->DFE->http->issetPost('option') === true) {
                            
                        } 


                        switch ($this->DFE->http->_post('option')) {
                            case "select":
                                $filename = '<a href="javascript:void(0);" ' . $omo . ' onclick="javascript: $(\'<option/>\').attr(\'selected\', \'selected\').val(\'' . str_replace(DOC_ROOT, "", $dir) . '/' . $key . '\').text(\'' . str_replace(DOC_ROOT, "", $dir) . '/' . $key . '\').appendTo(\'' . $element . '\'); $(\'.selectpicker\').selectpicker(\'refresh\'); buildThumbs(\'' . str_replace(DOC_ROOT, "", $dir) . '/' . $key . '\');">' . $key . '</a>';
                                break;

                            default:
                                
                                $filename = '<a href="javascript:void(0);"' . $omo . ' onclick="javascript:$(\'' . $element . '\').val(\'' . str_replace(DOC_ROOT.$this->DFE->http->_post('replace'), "", $dir. "/")  . $key . '\');">' . $key . '</a>';
                        }
                    } else {
                        $filename = $key;
                    }

                    if ($key != ".DS_Store") {
                        $span_anfang = $exLevel > 0 && $x == 1 ? "<span class=\"" . $GLOBALS['FileBrowser_ActivePoint'] . "\">" : "";
                        $span_ende = $exLevel > 0 && ($count == $x || $countA == $x) ? "</span>" : "";
                        $tmp_tree .= $span_anfang . "<ul style=\"list-style-type:none; width:400px; clear:both; padding-left:0px;\">\n";
                        $tmp_tree .= "<li style=\"float:left; padding-left:4px; width:400px; height:20px;\">" . $blank . $siteIC . $filename . "</li>";
                        $tmp_tree .= "</ul>" . $span_ende . "\n\n";
                    } else {
                        $x--;
                    }
                }
            }
        }
        return $tmp_tree;
    }

    /*
     * FE-Rights
     *
     */

    public function feRights() {
        $and_lang = $GLOBALS['LANGUAGE'] != SYS_LANGUAGE ? "AND %%%n%%%lang = '" . $GLOBALS['LANGUAGE'] . "'" : "";

        # FE-Rights setzen: Gruppe
        $this->DFE->db->Select("o.uid")
                      ->From($this->DFE->http->_post('pages') . " AS n, " . $this->FB . $this->DFE->http->_post('pages') . " AS p, " . $this->FB . $this->DFE->http->_post('pages') . " AS o")
                      ->noWhere(1)
                      ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $and_lang))
                      ->Group("GROUP BY o.lft")
                      ->Order("ORDER BY o.lft")
                      ->SelectMethod(1)
                      ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('uid'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('uid')))
                      ->doSelect();
        $num = $this->DFE->db->Rows;
        if ($num) {
            $row = $this->DFE->db->SelectPuffer;
            for ($i = 0; $i < $num; $i++) {
                $this->DFE->db->Update($this->DFE->http->_post('pages'))
                              ->WhereColName('uid')
                              ->WhereColValue($row[$i]['uid'])
                              ->Set(array(  "lastUpdated" => time(), 
                                            "perms_groupid" => 0))
                              ->doUpdate();
            }
        }
    }

    public function CopyPageAttributes() {
        
        if($this->DFE->http->issetPost('saved') === true) {
            $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
            $this->DFE->TT->setMC('messenger', $Widget->Messenger($this->DFE->TT->getMC('_copy_page_attributes_success'), 'messenger-on-top messenger-on-right', 'success'));
        }   
        
        if ($this->DFE->http->issetPost('save_attributes') === false) {
            
            # Seite
            $this->DFE->db->Select('nav_title')
                          ->From($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doSelect();
            $row = $this->DFE->db->SelectPuffer;
            
            $this->DFE->TT->setMC('backlink', \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Pages'], $GLOBALS['LANGUAGE']).'?ac=EditPage&uid='.$this->DFE->http->_post('uid'))
                          ->setMC('pagename', stripslashes($row['nav_title']))
                          ->setMC('uid', $this->DFE->http->_post('uid'))
                          ->setMC('lang', $GLOBALS['LANGUAGE'])
                          ->setMC('fb', $this->FB == 'be_' ? '&FB=be_' : '');
        } else {
            $this->DFE->db->Select('Javascript, Stylesheet, this_css, sitetpl, docType, search')
                          ->From($this->DFE->Pages)
                          ->WhereColName('uid')
                          ->WhereColValue($this->DFE->http->_post('uid'))
                          ->Andd(str_replace("%%%n%%%", "", $this->DFE->and_lang))
                          ->Parameter($this->DFE->and_lang != '' ? array('lang' => $GLOBALS['LANGUAGE']) : array())
                          ->doSelect();
            $num = $this->DFE->db->Rows;
            if ($num) {
                $row = $this->DFE->db->SelectPuffer;

                if ($this->DFE->http->_post('recursiv') == 1) {
                    $this->DFE->db->Select("o.uid")
                                  ->From($this->DFE->Pages . " AS n, " . $this->FB . $this->DFE->Pages . " AS p, " . $this->FB . $this->DFE->Pages . " AS o")
                                  ->noWhere(1)
                                  ->Andd("WHERE o.lft BETWEEN p.lft AND p.rgt AND o.lft BETWEEN n.lft AND n.rgt AND n.uid = :uid " . str_replace("%%%n%%%", "o.", $this->DFE->and_lang))
                                  ->Group('GROUP BY o.lft')
                                  ->Order('ORDER BY o.lft')
                                  ->SelectMethod(1)
                                  ->Parameter($this->DFE->and_lang != '' ? array('uid' => $this->DFE->http->_post('lastUID'), 'lang' => $GLOBALS['LANGUAGE']) : array('uid' => $this->DFE->http->_post('lastUID')))
                                  ->doSelect();
                    $num_re = $this->DFE->db->Rows;
                    if ($num_re) {
                        $row_re = $this->DFE->db->SelectPuffer;
                        for ($i = 0; $i < $num_re; $i++) {
                            unset($UpdateArray);
                            
                            if ($this->DFE->http->issetPost('attr') === false) {
                                $UpdateArray = array(   "Javascript"    => $row['Javascript'], 
                                                        "Stylesheet"    => $row['Stylesheet'], 
                                                        "this_css"      => $row['this_css']);
                            } elseif ($this->DFE->http->_post('attr') == "tmp") {
                                $UpdateArray = array("sitetpl" => $row['sitetpl']);
                            } elseif ($this->DFE->http->_post('attr') == "doctype") {
                                $UpdateArray = array("docType" => $row['docType']);
                            } elseif ($this->DFE->http->_post('attr') == "search") {
                                $UpdateArray = array("search" => $row['search']);
                            } elseif ($this->DFE->http->_post('attr') == "type") {
                                $UpdateArray = array("module" => $row['module']);
                            }
                            $this->DFE->db->Update($this->DFE->Pages)
                                          ->WhereColName('uid')
                                          ->WhereColValue($row_re[$i]['uid'])
                                          ->Set($UpdateArray)
                                          ->doUpdate();
                        }
                    }
                } else {
                    if ($this->DFE->http->issetPost('attr') === false) {
                        $UpdateArray = array(   "Javascript"    => $row['Javascript'], 
                                                "Stylesheet"    => $row['Stylesheet'], 
                                                "this_css"      => $row['this_css']);
                    } elseif ($this->DFE->http->_post('attr') == "tmp") {
                        $UpdateArray = array("sitetpl" => $row['sitetpl']);
                    } elseif ($this->DFE->http->_post('attr') == "doctype") {
                        $UpdateArray = array("docType" => $row['docType']);
                    } elseif ($this->DFE->http->_post('attr') == "search") {
                        $UpdateArray = array("search" => $row['search']);
                    } elseif ($this->DFE->http->_post('attr') == "type") {
                        $UpdateArray = array("module" => $row['module']);
                    }
                    $this->DFE->db->Update($this->DFE->Pages)
                                  ->WhereColName('uid')
                                  ->WhereColValue($this->DFE->http->_post('lastUID'))
                                  ->Set($UpdateArray)
                                  ->doUpdate();
                }
            }

            header("Location: ".$this->DFE->http->addQS('saved', 'ok')->returnQS());
            exit;
        }

        return $this->DFE->TT->getFilledTemplate('/aribu.systems/_templates/pages/copy_page_attributes.html');
    }

    public function CopySitemap($template="/aribu.systems/_templates/pages/copy_sitemap.html") {
      
        
        if ($this->DFE->http->issetPost('save_sitemap') === false) {
            
            if(isset($this->Error['Validation'])) {
                $Widget = new \aribu\scripts\widget\lib\Widget($this->DFE);
                $this->DFE->TT->setMC('messenger',              $Widget->Messenger($this->Error['Validation'], 'messenger-on-top messenger-on-right', 'error'));
            } 
        } else {
            # Fehlerbehandlung
            if ($this->DFE->http->_post('lang') == SYS_LANGUAGE) {
                $error = 1;
                $this->Error['Validation'] = $this->DFE->TT->getMC('_error_copy_sitemap');
                
            }
            $this->DFE->db->Select('*')
                          ->From('pages_language')
                          ->WhereColName('lang')
                          ->WhereColValue($this->DFE->http->_post('lang'))
                          ->Order("ORDER BY uid")
                          ->SelectMethod(1)
                          ->doSelect();
            $nume = $this->DFE->db->Rows;
            if ($nume) {
                $error = 1;
                $this->Error['Validation'] = $this->DFE->TT->getMC('_error_copy_sitemap_language');
            }

            if ($error != 1) {
                $this->DFE->db->Select('*')
                              ->From("pages")
                              ->noWhere(1)
                              ->Order("ORDER BY uid")
                              ->SelectMethod(1)
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    for ($i = 0; $i < $num; $i++) {

                        $this->DFE->db->Insert('pages_language')
                                      ->Parameter(array(    'uid'                   => '',
                                                            'rid'                   => $row[$i]['uid'],
                                                            'pid'                   => $row[$i]['pid'], 
                                                            'lft'                   => $row[$i]['lft'], 
                                                            'rgt'                   => $row[$i]['rgt'], 
                                                            'docType'               => $row[$i]['docType'], 
                                                            'spid'                  => $row[$i]['spid'], 
                                                            'tstamp'                => time(), 
                                                            'sorting'               => $row[$i]['sorting'], 
                                                            'deleted'               => 0, 
                                                            'perms_userid'          => $row[$i]['perms_userid'], 
                                                            'perms_groupid'         => $row[$i]['perms_groupid'], 
                                                            'perms_be_userid'       => $row[$i]['perms_be_userid'], 
                                                            'perms_be_groupid'      => $row[$i]['perms_be_groupid'], 
                                                            'crdate'                => time(), 
                                                            'cruser_id'             => $_SESSION['sess_uid'], 
                                                            'pagename'              => $row[$i]['pagename'], 
                                                            'url'                   => $row[$i]['url'], 
                                                            'hidden'                => $row[$i]['hidden'], 
                                                            'starttime'             => $row[$i]['starttime'], 
                                                            'endtime'               => $row[$i]['endtime'], 
                                                            'urltype'               => $row[$i]['urltype'], 
                                                            'pageSettings'          => $row[$i]['pageSettings'], 
                                                            'target'                => $row[$i]['target'], 
                                                            'lastUpdated'           => 0, 
                                                            'description'           => $row[$i]['description'], 
                                                            'author'                => $_SESSION['sess_username'], 
                                                            'author_email'          => $_SESSION['sess_user_email'], 
                                                            'nav_title'             => \lib\Functions::removeCriticSigns($this->DFE->http->_post('nav_title')), 
                                                            'content_from_pid'      => $row[$i]['content_from_pid'], 
                                                            'button'                => $row[$i]['button'], 
                                                            'button_path'           => $row[$i]['button_path'], 
                                                            'button_act_path'       => $row[$i]['button_act_path'], 
                                                            'sitetpl'               => $row[$i]['sitetpl'], 
                                                            'module'                => $row[$i]['module'], 
                                                            'BrowserTitle'          => $row[$i]['BrowserTitle'], 
                                                            'keywords'              => $row[$i]['keywords'], 
                                                            'page_Hash'             => '', 
                                                            'link_title'            => $row[$i]['link_title'], 
                                                            'move_update'           => 0, 
                                                            'Javascript'            => $row[$i]['Javascript'], 
                                                            'Stylesheet'            => $row[$i]['Stylesheet'], 
                                                            'this_css'              => $row[$i]['this_css'], 
                                                            'level'                 => $row[$i]['level'], 
                                                            'lang'                  => $this->DFE->http->_post('lang'),
                                                            'search'                => $row[$i]['search']))
                                      
                                      ->doInsert();

                        $insertUID = $this->DFE->db->LastInsertID;

                        # Content kopieren
                        if ($this->DFE->http->_post('copy_content') == 1) {
                            $this->DFE->db->Select('*')
                                          ->From('content')
                                          ->WhereColName('pid')
                                          ->WhereColValue($row[$i]['uid'])
                                          ->Andd("AND lang = :lang")
                                          ->Parameter(array('lang' => $GLOBALS['LANGUAGE']))
                                          ->SelectMethod(1)
                                          ->doSelect();
                                         
                            $numc = $this->DFE->db->Rows;
                            if ($numc) {
                                $rowc = $this->DFE->db->SelectPuffer;
                                for ($a = 0; $a < $numc; $a++) {
                                    $this->DFE->db->Insert('content')
                                                  ->Parameter(array(    'uid'               => '', 
                                                                        'pid'               => $insertUID, 
                                                                        'tstamp'            => $rowc[$a]['tstamp'], 
                                                                        'lastUpdated'       => $rowc[$a]['lastUpdated'], 
                                                                        'hidden'            => $rowc[$a]['hidden'], 
                                                                        'sorting'           => $rowc[$a]['sorting'], 
                                                                        'CType'             => $rowc[$a]['CType'], 
                                                                        'lang'              => $rowc[$a]['lang'], 
                                                                        'bodytext'          => $rowc[$a]['bodytext'], 
                                                                        'starttime'         => $rowc[$a]['starttime'], 
                                                                        'endtime'           => $rowc[$a]['endtime'], 
                                                                        'headline'          => $rowc[$a]['headline'], 
                                                                        'subline'           => $rowc[$a]['subline'], 
                                                                        'script_method'     => $rowc[$a]['script_method'], 
                                                                        'script_path'       => $rowc[$a]['script_path'], 
                                                                        'content_name'      => $rowc[$a]['content_name'], 
                                                                        'author'            => $rowc[$a]['author'], 
                                                                        'colP'              => $rowc[$a]['colP'], 
                                                                        'vid'               => 0, 
                                                                        'perms_userid'      => $rowc[$a]['perms_userid'], 
                                                                        'perms_groupid'     => $rowc[$a]['perms_groupid'], 
                                                                        'perms_be_userid'   => $rowc[$a]['perms_be_userid'], 
                                                                        'perms_be_groupid'  => $rowc[$a]['perms_be_groupid']))
                                                  ->doInsert();
                                                  

                                    $lastID = $this->DFE->db->LastInsertID;

                                    if ($rowc[$a]['CType'] == "TXTI" || $rowc[$a]['CType'] == "IMG") {
                                        $this->DFE->db->Select('*')
                                                      ->From('content_media')
                                                      ->WhereColName('cid')
                                                      ->WhereColValue($rowc[$a]['uid'])
                                                      ->Andd("AND lang = :lang ")
                                                      ->Order('ORDER BY sorting DESC')
                                                      ->Parameter(array('lang' => $this->DFE->http->_post('lang')))
                                                      ->SelectMethod(1)
                                                      ->doSelect();
                                        $numcm = $this->DFE->db->Rows;
                                        
                                        if ($numcm) {
                                            $rowcm = $this->DFE->db->SelectPuffer;
                                            for ($am = 0; $am < $numcm; $am++) {
                                                $this->DFE->db->Insert('content_media')
                                                              ->Parameter(array(    'cid'                   => $lastID, 
                                                                                    'file'                  => $rowcm[$am]['file'], 
                                                                                    'size'                  => $rowcm[$am]['size'], 
                                                                                    'type'                  => $rowcm[$am]['type'], 
                                                                                    'title'                 => $rowcm[$am]['title'], 
                                                                                    'alt'                   => $rowcm[$am]['alt'], 
                                                                                    'headline'              => $rowcm[$am]['headline'], 
                                                                                    'description'           => $rowcm[$am]['description'], 
                                                                                    'description_position'  => $rowcm[$am]['description_position'], 
                                                                                    'sorting'               => $rowcm[$am]['sorting'], 
                                                                                    'width'                 => $rowcm[$am]['width'], 
                                                                                    'height'                => $rowcm[$am]['height'], 
                                                                                    'url'                   => $rowcm[$am]['url'], 
                                                                                    'lang'                  => $GLOBALS['LANGUAGE'], 
                                                                                    'padding'               => $rowcm[$am]['padding'], 
                                                                                    'margin'                => $rowcm[$am]['margin'], 
                                                                                    'css'                   => $rowcm[$am]['css']))
                                                               ->doInsert();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                # pid patchen
                $this->DFE->db->Select('uid')
                              ->From('pages_language')
                              ->WhereColName('lang')
                              ->WhereColValue($this->DFE->http->_post('lang'))
                              ->SelectMethod(1)
                              ->doSelect();
                $num = $this->DFE->db->Rows;
                if ($num) {
                    $row = $this->DFE->db->SelectPuffer;
                    for ($i = 0; $i < $num; $i++) {
                        $this->DFE->db->Select('p.uid')
                                      ->From('pages_language AS n, fe_pages_language AS p')
                                      ->noWhere(1)
                                      ->Andd("WHERE n.lft BETWEEN p.lft AND p.rgt AND n.uid = :uid AND p.lang = :lang")
                                      ->Order('ORDER BY p.lft')
                                      ->SelectMethod(1)
                                      ->Parameter(array('lang' => $this->DFE->http->_post('lang'), 'uid' => $row[$i]['uid']))
                                      ->doSelect();
                        $num_p = $this->DFE->db->Rows;
                        if ($num_p > 1) {
                            $row_p = $this->DFE->db->SelectPuffer;
                            $this->DFE->db->Update('pages_language')
                                          ->WhereColName('uid')
                                          ->WhereColValue($row[$i]['uid'])
                                          ->Set(array("pid" => $row_p[$num_p - 2]['uid']))
                                          ->doUpdate();
                        }
                    }
                }


                # Exit und Jump to folder page
                header("Location: " . \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']));
                exit;
            } else {
                $this->DFE->http->unsetPost('save_sitemap');
                $this->CopySitemap();
            }
        }
        
        $this->DFE->TT->setMC('backlink',       \lib\Functions::dotLinkBE($GLOBALS['BE_STATIC_URLS'][$this->BE.'Browser'], $GLOBALS['LANGUAGE']))
                      ->setMC('lang_options',   \lib\Functions::getOptions($GLOBALS['BE_LANGUAGES'], $GLOBALS['LANGUAGE']));

        return $this->DFE->TT->getFilledTemplate($template, 1);
    }

    public function dmethod() {}
      
}